EditPad Pro Help

Welcome to the documentation for EditPad Pro. This documentation is bundled with both EditPad Pro and EditPad Lite. All of EditPad Lite's features are also available in EditPad Pro. Features only available in EditPad Pro have an "available in EditPad Pro only" indicator at the top of the their help topics.

EditPad Pro is very configurable. Almost every aspect can be adjusted to your own tastes and habits. Many settings can be made separately for each file type. To do so, select Options|Configure File Types in the menu. To edit general preferences, use Options|Preferences .

You can access all of EditPad Pro's functionality through the main menu. Once you get used to working with EditPad Pro, you'll mostly rely on the fully configurable toolbar and keyboard shortcuts .

EditPad Pro's menus are:

  • File
  • Edit
  • Project
  • Search
  • Block
  • Mark
  • Fold
  • Tools
  • Macros
  • Extra
  • Convert
  • Options
  • View
  • Help

Some functionality can be accessed through panels that dock to the sides of EditPad Pro's window:

  • Search and Replace
  • Spell Check
  • Character Map
  • Byte Value Editor
  • File Panel
  • Explorer Panel
  • FTP
  • File History
  • Clip Collection
  • File Navigator


EditPad Pro Specific Features

Since this help file is included with both EditPad Lite and Pro, the most important differences between both versions are listed here:

  • Integrated spell checker. You can easily check the spelling of a single file or even all files currently open. The spell checker works together with the syntax coloring. If, for example, you are spell checking a Java source code file, it will only check words in strings and comments as these are likely to contain natural language. Anything else is very unlikely to be natural language and therefore skipped. The dictionaries are separate downloads so they do not waste disk space if you do not intend to use them.
  • Syntax coloring for many popular file types. HTML, XML, CSS, Delphi, Java, C#, C++, VB, Perl, PHP, Python, Ruby, Eiffel, SQL, etc. are supported out of the box. User-contributed syntax coloring schemes support a variety of file formats. You create and edit syntax coloring schemes with the JGsoft Syntax Coloring Scheme Editor .
  • File navigation for many popular file types. HTML, XML, CSS, Delphi, Java, C#, VB, Perl, PHP, etc. are supported out of the box. User-contributed file navigation schemes support a variety of file formats. You create and edit file navigation schemes with the JGsoft File Navigation Scheme Editor .
  • Clip Collections: Store common blocks of text and templates for quick repeated reuse. Temporarily hold multiple chunks of text while editing complex documents. Jot down notes and ideas. Keep important information at your fingertips.
  • Hexadecimal editor and byte value editor . EditPad Pro is perfectly suited for editing binary files. You can quickly switch between text and hexadecimal mode.
  • File Panel to make it easy to work with hundreds or even thousands of files at the same time.
  • Explorer Panel to easily open files and for basic file management directly in EditPad Pro.
  • Built-in FTP client for conveniently editing your web site via FTP, and for uploading and downloading files from any FTP server. EditPad Pro can connect to as many FTP servers as you want simultaneously, which makes it very easy to manage multiple web sites.
  • Extensive backup options and convenient File History for managing backup files.
  • Built-in difference tool for comparing two files. Very useful for making you see the differences between two revisions of the same document. Since the difference function creates a new file showing the differences and similarities, you can merge two versions of a document easily by deleting what you do not want.
  • Project functionality allows you to quickly open and save sets of related files, such as all the HTML files that are part of your web site, all the chapters of your next book, or the source code file of the application you're developing.
  • Flexible and powerful editing with persistent selections and rectangular selections .
  • Record and play back keystroke macros to easily automate otherwise tedious and time-consuming editing tasks.
  • Controlling external tools. You can add any external application to EditPad Pro's Tools menu. You can make the tools listed in the menu depend on the type of file currently active (it makes no sense to run a Java compiler on a C++ file). You can have EditPad Pro send the active file as a command line parameter or through standard input. EditPad Pro can catch the standard output and error into their own tabs so you can see what your tool is doing and save the output for later use or edit it. You can also continue to work with EditPad Pro normally while the tool is running in the background, perhaps peeking at the output every now and then.
  • Bookmarks: you can use them to mark a spot and then quickly jump from one spot to another in a file. When you save a project, bookmarks are saved into it.
  • Built-in character map that you can use to quickly enter special characters into your texts. You can resize it to make the characters it shows as large as necessary for your eyes.
  • Built-in email functionality so you can quickly send out texts to others.
  • More extensive search commands such as highlighting search matches , incremental search and folding lines without search matches .
  • Regular expressions: If you are familiar with regular expressions, you will appreciate you can now use their full power from within EditPad Pro. You can apply them to the current selection, the current file or all open files, just like doing a search/replace with ordinary text. You can (of course) use back-references in the replacement text. The regex syntax is the same as used in Perl 5, including Perl 5's extensions such as ungreedy operators and non-back-referencing brackets. If you are not familiar with regular expressions, read the regular expression tutorial in this help file.
  • Sort function for putting the selected lines or the entire file in alphabetic order. The sort takes notice of the current Windows locale setting and lines containing special characters will be sorted appropriately.
  • You can configure EditPad Pro's toolbar and statusbar to your own taste and habits.
  • Comment block function. You can use it to prepend one or more characters you specify to each paragraph in the selected block (which can be rectangular), which is most useful for commenting out pieces of code in a language that does not support multi-line comments.
  • If the first 4 characters of a file are .LOG, the current time and date will be appended to the end of the file when it is opened or refreshed, simulating Notepad's .LOG function


Available in EditPad Pro Only

This functionality is only available in EditPad Pro. It is not available in EditPad Lite.

  • EditPad Pro Specific Features
  • EditPad Pro buying information is available at http://www.editpadpro.com/buynow.html


EditPad Main Menu

File Menu

Edit Menu

Project Menu (Available in EditPad Pro only)

Search Menu

Block Menu

Mark Menu (Available in EditPad Pro only)

Fold Menu (Available in EditPad Pro only)

Tools Menu (Available in EditPad Pro only)

Macros Menu (Available in EditPad Pro only)

Extra Menu (Available in EditPad Pro only)

Convert Menu

Options Menu

View Menu

Help Menu


Download License Key

If EditPad Pro cannot find its license key when you start it, EditPad Pro will prompt you to download the license key. This key is a small digital file storing your encrypted license details, which EditPad Pro takes as proof that you've legally purchased the software. You don't deal with this key directly. EditPad Pro automatically takes care of it.

Normally, EditPad Pro's installation program automatically puts your license key in the proper place. If you manually copy EditPad Pro onto a different disk or different computer, the key won't be copied along. Then, EditPad Pro will prompt you to download it.

Download Your Fully Licensed Copy

There are two ways to get your license key in place. The first method is to download your fully licensed copy of EditPad Pro from the JGsoft web site using your web browser. The download will contain EditPad Pro's installation program along with the complete software, documentation and your own license key all in one handy package. After downloading, run the SetupEditPad ProYourName.exe file that you've downloaded to reinstall EditPad Pro.

The advantage of this method is that you can use your regular web browser. EditPad Pro itself doesn't need to connect to the Internet. You can download EditPad Pro on one computer, and install it on another, even if the other computer doesn't have any kind of Internet access. You can make a backup copy of the SetupEditPad ProYourName.exe file onto a CD or other disk for safekeeping.

Have EditPad Pro Fetch Your License Key

If you're in a hurry, and you're running EditPad Pro on a computer that's connected to the Internet, you can have EditPad Pro fetch your license key automatically. To do so, enter your EditPad Pro user ID and the email address associated with your EditPad Pro license and click the "Let EditPad Pro fetch the license key" button. EditPad Pro will connect to the JGsoft web server, and fetch your license key. This procedure is fully automatic and takes only a few seconds.

If you lost your EditPad Pro user ID, enter your email address without any user ID. Click the "Let EditPad Pro fetch the license key" button and EditPad Pro will tell the JGsoft web server to email you your user ID. This email is sent out instantly, and should take only a few minutes to arrive in your mailbox.

EditPad Pro does not transmit any information to the JGsoft web server, other than the email address and user ID that you've entered.

The advantage of the second method is that it takes only a few seconds to fetch your license key. You don't need to re-download or re-install EditPad Pro. However, it is possible that a (corporate) firewall blocks EditPad Pro from accessing the Internet. In that case, the second method won't be available to you, but you can still use the first method.


File Menu

File|New

File|Open

File|Reopen

File|Favorites (Available in EditPad Pro only)

File|Templates (Available in EditPad Pro only)

File|Save

File|Save As

File|Save All

File|Print

File|Mail (Available in EditPad Pro only)

File|Mail as Attachment (Available in EditPad Pro only)

File|Reload from disk

File|Save Copy As (Available in EditPad Pro only)

File|Rename and Move

File|Delete

File|Close

File|Close All

File|Close All but Current

File|Exit

See also:

  • EditPad Pro Main Menu


Keyboard Navigation and Editing Shortcuts

The shortcuts in this list are the shortcuts that are recognized by every full text editor control in EditPad, such as the main editor, the search box , the replace box , the clip editor , etc.

Some of these shortcuts are also used by menu items. If you select the command from the menu, it will always work on the main editor. If you select the command by pressing the shortcut key combination, it will work on the editor that has input focus. This is the editor that shows the text cursor, the blinking vertical bar. This is true for all menu items listed below, but not for any other menu items.

All shortcuts that are used by menu items can be configured in Options|Configure Toolbar and Menus, Keyboard . All other shortcuts cannot be changed.

When a key combination only works in text mode, this is indicated by [text]. If it only works in hexadecimal mode , the indication is [hex].

Cursor movement keys

Key combination Action

Arrow key Moves the text cursor (blinking vertical bar).

Ctrl+Left arrow [text] Moves the text cursor to the start of the previous word or the end of the previous line, whichever is closer.

Ctrl+Right arrow [text] Moves the text cursor to the start of the next word or the end of the current line, whichever is closer.

Ctrl+Up/Down arrow Scrolls the text one line up or down, or jump to the next paragraph ( your preference ). When scrolling, the cursor moves along unless it's at the top or bottom ( configurable ).

Ctrl+Alt+Up/Down Moves the text cursor to the previous or next occurrence of the word under the text cursor.

Page up/down Moves the text cursor up or down an entire screen.

Ctrl+Page up/down Scrolls the text one screen up or down.

Home Moves the text cursor to the beginning of the line ( configurable ).

Ctrl+Home Moves the text cursor to the start of the entire text.

End Moves the text cursor to the end of the line.

Ctrl+End Moves the text cursor to the end of the entire text.

Shift+Movement key Moves the text cursor and expand or shrink the selection towards the new text cursor position. If there was no selection, one is started. Pressing Ctrl as well, will move the text cursor correspondingly.

Alt+Shift+Movement [text] The same as when Alt is not pressed, except that the selection will be rectangular instead of flowing along with the text.

Any of the above key combinations that does not select part of the text will remove the current selection (the selection, not the selected text) unless selections are persistent . Any key combination that moves the text cursor will also cause the text to scroll to keep the text cursor in view, if the move makes the text cursor invisible. Any key combination that scrolls the text will let the text cursor keep its position relative to the text, unless you chose to keep the text cursor in view while scrolling .

Editing commands

Key combination Action

Enter In the main editor: inserts a line break.

In the search or replace box: search for the next occurrence.

Shift+Enter Inserts a line break.

Ctrl+Enter Edit|Insert Page Break

Delete Deletes the current selection if there is one and selections are not persistent . Otherwise, the character to the right of the text cursor is deleted.

Ctrl+Delete Deletes the current selection if there is one. Otherwise, the part of the current word to the right of the text cursor is deleted. If the cursor is not on a word, all characters to the right of the cursor up to the start of the next word are deleted. [text]

Deletes the current selection [hex].

Shift+Ctrl+Delete All the text on the current line to the right of the text cursor is deleted [text].

Deletes the current selection [hex].

Backspace Deletes the current selection if there is one and selections are not persistent . Otherwise, the character to the left of the text cursor is deleted.

Ctrl+Backspace Deletes the current selection if there is one and selections are not persistent. Otherwise, the part of the current word to the left of the text cursor is deleted. If the cursor is not on a word, all characters to the left of the cursor up to the start of the next word are deleted. [text]

Deletes the current selection [hex].

Shift+Ctrl+Backspace Deletes the current selection if there is one and selections are not persistent. Otherwise, all the text on the current line to the left of the text cursor is deleted [text].

Deletes the current selection [hex].

Alt+Backspace Alternative shortcut for Edit|Undo

Alt+Shift+Backspace Alternative shortcut for Edit|Redo

Ctrl+Z Edit|Undo

Ctrl+R Edit|Redo

Insert Toggles between insert and overwrite mode.

Tab [text] If there is a selection, the entire selection is indented. Otherwise, a tab is inserted.

Tab [hex] Makes the text cursor switch between the hexadecimal side and text side.

Shift+Tab [text] If there is a selection, the entire selection is unindented (outdented). Otherwise, if there is a tab, or a series of spaces the size of a tab, to the left of the text cursor, that tab or spaces are deleted.

Ctrl+A Edit|Select All

Shift+F5 Edit|Go to Previous Editing Position

Ctrl+Y Edit|Delete Line

Shift+Ctrl+Y Edit|Duplicate Line

Shift+Ctrl+B Block|Begin Selection

Shift+Ctrl+E Block|End Selection

Shift+Ctrl+D Block|Expand Selection

Ctrl+D Block|Duplicate

Ctrl+M Block|Move

Ctrl+Alt+B Block|Go to Beginning

Ctrl+Alt+E Block|Go to End

Clipboard commands

Key combination Action

Ctrl+X Edit|Cut

Shift+Ctrl+X Edit|Cut Append

Ctrl+C Edit|Copy

Shift+Ctrl+C Edit|Copy Append

Ctrl+V Edit|Paste

Shift+Ctrl+V Edit|Swap with Clipboard

Shift+Delete Alternative shortcut for Edit|Cut

Ctrl+Insert Alternative shortcut for Edit|Copy

Shift+Insert Alternative shortcut for Edit|Paste

Search panel

The controls on the search panel do not have Alt+Letter shortcuts because those would conflict with the main menu. To invoke any search command with the keyboard, press Alt+S to open the Search menu . Then press the letter of the command you want. To set search options with the keyboard, press Ctrl+Shift+F to open the search options screen . Press the letter keys of the options you want to toggle, and press Enter.

You can assign direct keyboard shortcuts to any of the search commands and search options Options|Configure Toolbar and Menus, Keyboard . Most search commands have direct key combinations by default. The search options do not.


Wordstar Navigation Keys

EditPad Pro supports the classic for people who are used to them. WordStar is an old word processor that used Ctrl+Letter key combinations to navigate through the document. WordStar was created at a time when most keyboards did not yet have separate arrow key blocks. Note that many of these navigation keys conflict with standard Windows shortcut keys. E.g. Ctrl+S is the standard Windows shortcut for File|Save . In WordStar, Ctrl+S moves the text cursor one position to the left, just like the left arrow key.

You can enable the WordStar navigation keys in the Keyboard Preferences . When enabled, they are recognized by every full text editor control in EditPad, such as the main editor, the search box , the replace box , the clip editor , etc.

The shortcuts with Ctrl+Q are two-key combinations. First, press Ctrl+Q. Then release the Q key and press the second letter in the key combination. Whether you press Ctrl along with the second key or not makes no difference.

Cursor movement keys

Key combination Action

Ctrl+S Moves the text cursor one position to the left.

Ctrl+D Moves the text cursor one position to the right.

Ctrl+E Moves the text cursor one line upward.

Ctrl+X Moves the text cursor one line downward.

Ctrl+A Moves the text cursor to the start of the previous word or the end of the previous line, whichever is closer.

Ctrl+F Moves the text cursor to the start of the next line or the end of the current line, whichever is closer.

Ctrl+R Moves the text cursor up an entire screen.

Ctrl+C Moves the text cursor down an entire screen.

Ctrl+W Scroll down one line. Cursor moves up one line unless it is already at the top ( configurable ).

Ctrl+Z Scroll up one line. Cursor moves down one line unless it is already at the top ( configurable ).

Ctrl+Q, S Moves the text cursor to the beginning of the line ( configurable ).

Ctrl+Q, D Moves the text cursor to the end of the line.

Ctrl+Q, E Moves the text cursor to the top of the screen.

Ctrl+Q, X Moves the text cursor to the bottom of the screen.

Ctrl+Q, R Moves the text cursor to the start of the file.

Ctrl+Q, C Moves the text cursor to the end of the file.

Editing commands

Key combination Action

Ctrl+I Insert a tab character.

Ctrl+N Inserts a line break.

Ctrl+G Deletes the character to the right of the text cursor.

Ctrl+H Deletes the character to the left of the text cursor.

Ctrl+T Deletes the part of the current word to the right of the text cursor. If the cursor is not on a word, all characters to the right of the cursor up to the start of the next word are deleted.

Ctrl+Q, Y All the text on the current line to the right of the text cursor is deleted.

Ctrl+Q, T All the text on the current line to the left of the text cursor is deleted.

Ctrl+V Toggles between insert and overwrite mode.


Mouse Actions

Below you can find a list of action you can carry out in the editor using the mouse.

Dragging means to move the mouse before releasing the mouse button you pressed. If you move the mouse pointer to the edge of the editor space while dragging, the text will start to scroll automatically.

Modifier keys like shift or control must be pressed before pressing the mouse button and kept depressed until the mouse button is released.

Mouse Action Result

Left click Moves the text cursor to the spot where you clicked. Any text that was previously selected becomes unselected, unless you enabled persistent selections and clicked outside the selection.

Shift+Left click Moves the text cursor and expands or shrinks the selection. If there is no selection, the text between the old and new cursor positions becomes selected. If you click outside of the selection, the selection plus the text between the selection and the new cursor position becomes selected. If you click inside the selection, the new selection is the text between the original start of the selection and the new cursor position.

Ctrl+Left click Moves the text cursor to the spot where you clicked. Selects the line that you clicked on entirely, unless there already is a selection and you enabled persistent selections .

Ctrl+Shift+Left click Moves the text cursor and expands the selection just like Shift+Left click does. In addition, if the selection starts and/or ends in the middle of a line, the selection will be expanded to include the partially selected lines entirely.

Left click+drag When clicking outside the selection, a new selection is created from the point where you press the mouse button until the point where you release it.

When clicking inside the selection, the selected text deleted and inserted again at the spot (outside the selection) where you release the mouse button.

Shift+Left click+drag Expands or shrinks the selection like Shift+Left click, but then the text cursor is moved and the selection adjusted until you release the mouse button.

If you press Alt while changing the selection with any of the above left click methods, the selection becomes rectangular. If Block|Rectangular Selections is active, pressing Alt makes the selection linear.

Left double click Moves the text cursor to the spot where you clicked. If you double-clicked on a word, the word becomes selected. If you didn't double click on a word, any text that was previously selected becomes unselected.

Shift+Left double click Moves the text cursor and expands or shrinks the selection just like Shift+Left single click does. In addition, if the selection starts and/or ends in the middle of a word, the selection will be expanded to include the words at the start and/or end entirely.

Left double click+drag A new selection is created from the point where you double-clicked until the point where you release it. If the selection starts and/or ends in the middle of a word, the selection will be expanded to include the words at the start and/or end entirely.

Shift+Double click+drag Expands or shrinks the selection like Shift+Left double click, but then the text cursor is moved and the selection adjusted until you release the mouse button. Words at the edge of the adjusted selection will be selected entirely.

Left triple click Moves the text cursor to the spot where you clicked. Selects the line that you clicked on entirely (even when selections are persistent).

Shift+Left triple click Moves the text cursor and expands or shrinks the selection just like Shift+Left single click does. In addition, if the selection starts and/or ends in the middle of a line, the selection will be expanded to include the partially selected lines entirely.

Left triple click+drag A new selection is created from the point where you triple-clicked until the point where you release it. If the selection starts and/or ends in the middle of a line, the selection will be expanded to include the partially selected lines entirely.

Shift+Triple click+drag Expands or shrinks the selection like Shift+Left triple click, but then the text cursor is moved and the selection adjusted until you release the mouse button. Lines part of the adjusted selection will be selected entirely.

Rotate wheel Scrolls the text a single line up or down.

Shift+Wheel Moves the text cursor a line up or down, like pressing the up or down arrow keys on the keyboard.

Ctrl+Wheel Scrolls the text an entire screen up or down.

Shift+Ctrl+Wheel Moves the text cursor a screen up or down, like pressing page up or down on the keyboard.

Scrolling the text with the wheel, the text cursor keeps its position relative to the text. This may cause the text cursor to be scrolled off screen and become invisible. If you do not like this, select "always keep the text cursor in view" in the Editor Preferences . Then, scrolling with the wheel will also move the text cursor if needed to keep it visible.


Command Line Parameters

You can specify as many files as you want on the command line. EditPad will open all files. You should put double quotes around file names that contain spaces. Putting double quotes around file names without spaces makes no difference. If you specify a file that does not exist on the command line, EditPad will create a blank tab with that file name. The file itself will not be created until you save it.

Example: EditPadPro.exe "C:\My Documents\text.txt" C:\Development\source.c

If you start EditPad while another copy of EditPad is already running, the newly run copy will send the command line parameters to the existing copy. The newly run copy will close itself as soon as the existing copy as processed the command line parameters and opened all files.

Forcing a New Instance

If you want to force a second EditPad window to appear, specify the /newinstance parameter on the command line. This parameter can appear anywhere on the command line, and can be used in combination with any other command line parameter.

When using /newinstance, you can also specify the location of the new EditPad window. /brl100t200r300b400 sets the window's bounding rectangle to left 100, top 200, right 300 and bottom 400, counting pixels from the top left corner of the screen.

Additional EditPad Pro Parameters

The parameters described above are supported by both EditPad Lite and Pro. EditPad Pro supports several additional parameters. All of the parameters below require a single file to be specified on the command line. Each of them can appear only once on the command line. EditPad Pro will not show any error messages if you do not respect these rules, but the result will not be what you expected. The order of the parameters does not matter.

/hex tells EditPad Pro to open the file in hexadecimal mode, regardless of whether you set this option in the file type configuration or not.

/readonly tells EditPad Pro to open the file in read only mode. Use this parameter if you want to make sure you don't accidentally modify the file in EditPad Pro.

/l123 (slash el one two three) tells EditPad Pro to place the text cursor on line 123 of the file. The first line in the file is number one. The lines are counted as if word wrap were off. /l-1 (slash el minus one) will place the text cursor at the very end of the file.

/c45 tells EditPad Pro to place the text cursor on character 45 of the file, counting characters from the start of the file. The first character is number zero.

If you use /c in combination with /l, then the meaning of /c changes. /c7 will then place the text cursor on the 7th character on the line indicated by /l, counting only characters on that line, rather than counting all characters from the beginning of the file. The first character on the line is number one.

Finally, /s123-145 will select characters 123 through 144, and place the text cursor at character 145. Like /c, /s counts characters from the start of the file, with the first character being number zero.

In combination with /l, /s4-7 will select characters 4 through 6, and put the text cursor on the 7th column on the line indicated by /l. Again, the first character on the line is number one. /c and /s cannot be used in combination with each other.


Colors Preferences

On the Colors tab in the Preferences , you can choose the colors EditPad's editor control will use.

Color Configuration

At the top of the tab, you can select one of the preconfigured color palettes. Selecting one of the preset configurations will change all of the individual colors.

  • Default: The default EditPad color palette. This palette has distinct colors for almost all of the items. Choose this configuration if you like very detailed syntax coloring .
  • White on black: White text on a black background, with colorful syntax highlighting.
  • JGsoft classic: The color scheme used by EditPad Pro 4 and 5, using more saturated colors.
  • Borland: Emulates the colors used by recent versions of Borland development tools.
  • Borland classic: Emulates the colors used by old Borland development tools for DOS, with yellow text on a blue background.
  • Visual studio: Emulates the colors used by Microsoft's Visual Studio.
  • Custom configuration: Selecting this item does nothing. However, if you change one of the individual colors, this item will automatically become selected to indicate you did not choose one of the presets.

Configure Individual Colors

To change an individual colors, simply click on its name. Click on the Background Color or Text Color button to pick a different color. Either pick a color, or click on the "default" item in the bottom right corner of the color picker. The default color depends on the color item. E.g. the default background color for "plain text" is the default window background color in the current Windows color configuration. The default background color for "link" and other syntax colors is whatever background color you selected for "plain text".

  • Plain text: The default text colors. EditPad's background is filled with this color, and text that is not syntax colored is drawn in this text color.
  • Selected text: Text and highlight colors of the selected text.
  • Link through Alternate highlighted text: These colors are used by the syntax coloring schemes . Their actual meaning depends on the syntax coloring scheme you are using.
  • Search range: When you start a search with the selection only option turned on, and a match is found, the match will become selected and selection searched through will be highlighted in the search range color.
  • Highlight active line: When you turn on the option to highlight the active line , the line containing the text cursor will be highlighted in this color.
  • Page break: Color of the horizontal line indicating a page break. (Press Ctrl+Enter to insert one.)
  • Matching brackets: Color used to highlight matching brackets . This color is also used to highlight the current byte in hexadecimal mode .
  • Margin and line numbers: Color used for the left and top margins in which line and column numbers are displayed.
  • Column leader: Color used for vertical rulers marking columns .
  • Folding icons: Color used to draw text folding buttons and lines.
  • Paragraph symbols: Color used to draw paragraph symbols when you've turned on the option to show paragraph symbols .
  • Whitespace: Color used to draw whitespace. The background color is always used if you set it to anything other than "default". The text color is used to draw the space and tab symbols when you turn on the option to visualize spaces .
  • Misspelled word: When using live spell checking , misspelled colors will be indicated using these colors and font style.
  • Highlighted search match: Color and font style used for highlighting search matches .
  • Compare files: added line: When using Extra|Compare Files , lines present in the second file but not in the first file will be highlighted using this color.
  • Compare files: deleted line: When using Extra|Compare Files , lines present in the first file but not in the second file will be highlighted using this color.
  • Regex token through Regex nesting level 5: These colors are used by the search-and-replace panel to highlight regular expressions .

The colors of the tabs can be configured on the Tabs page in the preferences (EditPad Pro only).

Example

When configuring syntax highlighting colors, you can select one of the available colorings schemes to see an example. Each coloring scheme has its own example text that shows the most important color elements of the scheme.


Cursors Preferences

On the Cursors tab in the Preferences screen, you can configure EditPad's text cursor and mouse pointer.

Text Cursor Blinking Style

The text cursor is the typical blinking vertical bar that indicates the position in the document where the text you type will be inserted. In EditPad Pro, you can configure its blinking style. If you select "do not blink", then the cursor will be a solid bar using the "regular" color.. "Blinking on-off" is the standard blinking style. The text cursor will alternate several times per second between being visible in the "regular" color, and being invisible. The final style, "alternating colors", causes the text cursor to be permanently visible, but alternate between the "regular" and "alternate" colors several times per second.

The regular color is used to draw the text cursor for all three blinking styles. The alternate color is only used for the "alternating colors" style. The dragging color is used to draw a second temporary text cursor to indicate the insertion position when dragging text with the mouse.

Text Cursor Shape

The shape of the text cursor can be a vertical bar displayed to the left of the character the cursor currently points to, or a rectangle that sits on top of the character. You can choose to permanently use either mode, or to let the shape depend on insert/overwrite mode. You can toggle between insert and overwrite mode by pressing the Insert key on the keyboard, or by clicking the Insert or Overwrite indicator in the status bar . In insert mode, the text cursor will be a vertical bar, in overwrite mode it will be a rectangle.

Keep Text Cursor in View While Scrolling

"Keep text cursor in view while scrolling" determines what happens to the text cursor when you scroll the text. Normally, the text cursor will keep its position relative to the text when you scroll the text. This may cause the text cursor to be scrolled off-screen. Depending on your text editing habits, this may be desirable or undesirable. If you allow the text cursor to be scrolled off-screen, it will keep its position relative to the text. After scrolling, you can immediately continue typing at the same position. When you do so, the text will be scrolled automatically to make the cursor visible again. If you choose to keep the text cursor visible, it will be moved to the topmost or bottommost visible line when scrolling would otherwise have made it invisible. This way, you can always see exactly where the text cursor is pointing to.

By default, EditPad Pro will keep the text cursor visible when you scroll with the keyboard (by pressing Ctrl+Arrow Up/Down or Ctrl+Page Up/Down), but not when you scroll with the scroll bars or by rotating the mouse wheel. This is how most text editors for programmers work. EditPad Pro gives you the choice. Most general-purpose text editors do not allow keyboard scrolling at all.

Text Cursor Options

If you turn on "allow text cursor to be moved beyond the end of a line", you can position the text cursor after the last character of the line. If you press the right arrow key when the cursor is at the end of the line, it will move one position to the right. If you click with the mouse beyond the end of the line, the cursor will be placed where you clicked. If you start typing when the cursor is beyond the end of the line, EditPad will automatically fill up the line with spaces up to the position where you started typing.

When you do not allow the cursor to be moved beyond the end of a line, pressing the right arrow key when the cursor is at the end of a line will move it to the start of the next line. When you click the mouse beyond the end of the line, the cursor will be placed after the last character on the line.

If you turn on "use arrow keys when the Scroll Lock key is active", then you can push the Scroll Lock key on the keyboard to scroll with the arrow keys. Pressing any of the arrow keys will then scroll the view instead of moving the text cursor. The Home and End keys will scroll to the top and the end of the file. Press Scroll Lock again to restore the normal arrow key behavior. If this option is on, then EditPad Pro ignores the state of the Scroll Lock key.

Mouse Pointer Shape and Style

EditPad Pro also allows you to select the mouse pointer shape and style. "Standard I-beam" is the standard mouse pointer for text editing controls, typically an I-shaped beam. "Thin I-beam", "thick I-beam" and "dual-color I-beam" are custom EditPad cursors for which you can pick your own colors. By choosing colors that contrast well with the background color you've chosen for the editor, you can make the mouse pointer highly visible. "Standard arrow" is the regular Windows mouse pointer. "Dual color arrow" is another custom EditPad cursor in the shape of an arrow.

EditPad's custom pointers may not work in all situations. E.g. some remote desktop software cannot handle them. The mouse pointer may either be incorrectly displayed, or simply be invisible. In that case, simply select one of the standard pointers, which will always work.


Editor Preferences

On the Editor tab of the Preferences you can set the options that affect basic editing tasks that are not file type specific .

Editing Options

In "date and time format" you can specify the format that should be used by the Edit|Insert Date and Time function. You will need to use special character sequences that function as placeholders for the actual date and time values .

If the date and time format is left empty, Edit|Insert Date and Time will enter the date in short format followed by the time in long format as specified in the regional settings in the Windows Control Panel.

You can change the encoding for the ASCII section in the hex editor if you work with binary files that also store text in a particular code page. This setting changes the way bytes are translated into characters in the right hand section of the text editor, and how characters that you type in are translated into bytes. You can only select 8-bit code pages, as the hex editor displays one character per byte.

Highlighting the active line makes it easier to keep track of where you are in the file, particularly when switching between EditPad and other applications. The active line is the line the text cursor is on. Just like the text cursor itself, the active line is only highlighted when the editor has keyboard focus. You can configure the color of the active line on the Colors tab in the preferences. Click on "highlighted active line" in the list, and click the Background Color button to change the highlight color. Do not confuse the "highlight active line" color with the "highlighted text" color. The "highlighted text" color is used by syntax coloring schemes that want to highlight something.

By default, pressing the home key will move the text cursor to the very start of the line it is on. This is how the Home key works traditionally. In some modern editors, pressing the home key will move it to the left of the first non-whitespace character of the line it is on. Pressing the home key a second time moves it to the very start of the line. You can make the home key work this way in EditPad Pro by turning on "Home key moves cursor to first non-whitespace character on the line".

In Windows text editors, pressing the Arrow Up or Down keys on the keyboard keeps the text cursor on the same column. E.g. if you put the cursor on line 1, column 1 of an existing text file, type "abc", and then press Arrow Down, then the cursor will be on line 2, column 4. If you type "abc" on the 2nd line, it will be "stair-stepped" relative to the "abc" on the first line. If you turn on the option "Arrow Up and Down move the cursor back to the column where you started editing", then in the previous example, pressing Arrow Down will move the cursor to line 2, column 1. The horizontal movement caused by typing "abc" is undone by pressing Arrow Down. If you type "abc" on the second line, it will appear just below the "abc" on the first line. The result is that turning on this option makes it much easier to edit data arranged in columns.

You can also choose what happens when you press Control+Arrow Up or Down on the keyboard. By default, this will scroll the text one line up or down without moving the text cursor, as if you had clicked on the up or down arrow button on the scroll bar, or as if you had rotated the mouse wheel. Ctrl+Up/Down works this way in most programmer's text editors. If you prefer to use the mouse rather than the keyboard for scrolling, you can configure the Ctrl+Up/Down keys to make the text cursor jump to the next or previous paragraph. Ctrl+Up/Down works this way in some word processors like Microsoft Word.

The "persistent selections" option changes how selections behave in EditPad Pro. By default, this option is off and selections in EditPad Pro will behave like in most other Windows applications. When you move the text cursor, by pressing a key on the keyboard or clicking somewhere with the mouse, the selection will disappear. When typing in some text or pasting from the clipboard, the selected text will be replaced by the text you typed in or pasted.

When selections are persistent, moving the text cursor will not cause the selection to disappear. Also, typing in text or pasting text will not delete the selected text. The typed or pasted text will be inserted at the position of the text cursor, whether that is outside the selection, at the edge of the selection, or inside the selection. If it is inside the selection, the selection will be expanded to include both the text originally selected and the newly entered text.

Turn on "zero-based line and column numbers" if you want EditPad Pro to start counting lines and columns from zero instead of one. This option affects the status bar , as well as Options|Line Numbers and Options|Column Numbers .

Launching a New EditPad Instance

You can configure how the View|New Editor command launches the new EditPad instance. You can choose how both instances are positioned relative to each other, and whether the new instance should open the file you have open in the current instance.

Search

When a search action fails, EditPad Pro does nothing except flash the icon of the button you clicked on the Search panel. If this is not obvious enough for you, you can turn on the option "beep when search fails". A standard "error" beep will then sound when a search fails. If the "loop automatically" search option is on and EditPad Pro finds a match after restarting from the beginning, then a standard "notification" beep will sound.

By default, EditPad will automatically copy the selected text into the search panel when you open the search panel , if the selection does not span multiple lines. If no text was selected, EditPad will copy the word under the text cursor. If the selection spans more than one line when you open the search panel, EditPad will automatically turn on the " selection only " option.

You can disable this behavior by turning off the option to use the selected text as the search text. Then, opening the search panel will show it unchanged. The last search term you entered will still be there, and the state of the "selection only" option will be unchanged.

Turn on "give the main editor keyboard focus when a search match is found" if you want to be able to immediately edit the search match after doing a Find First or Find Next. You can press F3 on the keyboard to continue to the next search match, even when the editor has keyboard focus and even after the search panel has been closed. However, if you prefer to be able to continue editing the text you're searching for rather than the text found, turn this option off.

Unintended spaces and line breaks may cause EditPad to apparently not find search terms that do occur in the text, when the spurious spaces and line breaks don't occur in the text. To avoid this, you can turn on the option to always visualize spaces and tabs in the search panel. When this option is off, the search panels only visualizes these characters when you've turned on the option to visualize spaces and line breaks in the file you're editing.

Appearance

When you use the Fold|Fold command to fold a range of lines, EditPad Pro indicates those with a "plus" button in the left margin. When you use Fold|Unfold , the "plus" will change into a "minus", and a vertical line will appear next to the range of lines. Automatic folding points also appear this way. If you find the vertical lines distracting, you can disable them. Then only the "plus" or "minus" buttons will appear. You may prefer this style if you only work with automatic folding ranges that span logical blocks that are obvious from the file's content.


Date and Time Format Specifiers

These are the date and time placeholders that you can use in the Date and Time Format setting in the Editor tab of the Preferences window .

Format specifiers may be written in upper case as well as in lower case letters. Both produce the same result.

Specifier Displays

c Displays the date in short format followed by the time in long format as specified in the regional settings in the Windows Control Panel.

d Displays the day as a number without a leading zero (1-31).

dd Displays the day as a number with a leading zero (01-31).

ddd Displays the day as an abbreviation (Sun-Sat) in the language of the current Windows locale.

dddd Displays the day as a full name (Sunday-Saturday) in the language of the current Windows locale.

ddddd Displays the date using the short date format specified in the regional settings in the Windows Control Panel.

dddddd Displays the date using the long date format specified in the regional settings in the Windows Control Panel.

m Displays the month as a number without a leading zero (1-12). If the m specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.

mm Displays the month as a number with a leading zero (01-12). If the mm specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.

mmm Displays the month as an abbreviation (Jan-Dec) in the language of the current Windows locale.

mmmm Displays the month as a full name (January-December) in the language of the current Windows locale.

yy Displays the year as a two-digit number (00-99).

yyyy Displays the year as a four-digit number (0000-9999).

h Displays the hour without a leading zero (0-23).

hh Displays the hour with a leading zero (00-23).

n Displays the minute without a leading zero (0-59).

nn Displays the minute with a leading zero (00-59).

s Displays the second without a leading zero (0-59).

ss Displays the second with a leading zero (00-59).

z Displays the millisecond without a leading zero (0-999).

zzz Displays the millisecond with a leading zero (000-999).

t Displays the time using the short time format specified in the regional settings in the Windows Control Panel.

tt Displays the time using the long time format specified in the regional settings in the Windows Control Panel.

am/pm Uses the 12-hour clock for the preceding h or hh specifier, and displays 'am' for any hour before noon, and 'pm' for any hour after noon. The am/pm specifier can use lower, upper, or mixed case, and the result is displayed accordingly.

a/p Uses the 12-hour clock for the preceding h or hh specifier, and displays 'a' for any hour before noon, and 'p' for any hour after noon. The a/p specifier can use lower, upper, or mixed case, and the result is displayed accordingly.

/ Displays the date separator character specified in the regional settings in the Windows Control Panel.

: Displays the time separator character specified in the regional settings in the Windows Control Panel.

'xx'/"xx" Characters enclosed in single or double quotes are displayed as-is, and do not affect formatting.


Files Preferences

On the Files tab in the Preferences screen, you can configure how EditPad should handle files.

Folder to Use for Open and Save Dialog Boxes

You can select if the file selection dialog boxes that appear when you want to open or save a file. First, you can choose which folder is the default when you do not have any file or project open in EditPad, or when the active file or project is untitled. The default folder can either be the last folder you opened a file from or saved a file into, or it can be the folder into which you installed EditPad, or it can be a specific folder such as your "My Documents" folder.

In addition to specifying the default folder, you can choose if the folder containing the active project or file should be used instead of the default. If you turn on the active file option, the folder containing the active file will be used for opening or saving a file when you have a file open. If you turn on the active project option, and the active file option is off or the active file is untitled, the folder containing the active project will be used instead. The default folder is only used if you turned off both options, or the active file and project are both untitled.

Closing Unsaved Files

The "closing unsaved files" option gives You have three choices as to what EditPad should do when you instruct it to close a file to which you have made changes that were not yet saved to disk:

  • Show a warning message and give you one last opportunity to decide if the file should be saved or not. This is the default since most other software behaves this way too.
  • EditPad can automatically save the file without asking you first. This is the best way to make sure you will not lose any work. For safety, you should also select one of the options to make multiple backup copies.
  • The last option will make EditPad close the file without warning. Any unsaved work will be lost, so use with caution.

Locking and Reloading Files

By default, EditPad does not keep a lock on files. This means that other applications or users can modify files that you have open in EditPad. If you don't want this to happen, turn on "lock open files".

The option whether or not to lock files only applies to files smaller than the huge file treshold (see below). Files larger than the huge file treshold are always locked. EditPad Pro doesn't read those files into memory entirely, so it needs to keep access to the original file on disk.

When not locking files, EditPad can automatically reload files that have been modified on disk by another application or user. If you turn on this option, EditPad will check whether a file's modification date has changed each time you switch between files in EditPad, and each time you switch between EditPad and another application. This check may cause a noticeable delay when editing files on a slow medium like a floppy disk or over a slow network link.

When automatically reloading, EditPad will prompt when you've modified the file in EditPad, but not when you haven't modified the file in EditPad. Turn on "always prompt before reloading files from disk" to make EditPad prompt to reload the file even when you haven't modified it in EditPad.

Backup Copies

To make sure you never lose any data in case you change your mind after saving a file, you should turn on one of the options to create backup copies. The "single backup" options will keep one backup copy of each file in the same folder as the original. The "multi backup" options will keep multiple backup copies in the same folder, while "hidden history" will create a hidden "__history" folder below each folder, and put the backup copies there. The "multi backup" and "hidden history" options work best with EditPad Pro's File History . The File History lets you easily compare, delete and revert to backup copies.

EditPad can automatically limit the number of backup copies for each file to a certain number. When the number of backup copies is exceeded, EditPad will automatically delete the oldest ones. EditPad can also limit backup copies by age. When you save the file, backup copies older than the specified age will be automatically deleted. You should turn on at least one of the backup limitations when choosing "multi backup" or "hidden history" to prevent an ever-increasing number of backup files from taking up too much disk space.

Automatic Save and Reopen

If you want EditPad Pro to automatically save your work regularly, select to save working copies. EditPad Pro will then save a copy of all modified files every couple of minutes. When working on document.txt, a file Working copy of document.txt will be saved into the same folder as document.txt. When you save document.txt or close document.txt without saving, the working copy will be automatically deleted.

If the document is not properly closed, because of a power loss or software crash, the working copy will not be deleted. When you open document.txt next time, EditPad Pro will automatically open both document.txt and its working copy. You can then choose which file you want to keep and which you want to delete, possibly after using Extra|Compare Files to assist with your choice.

Note: If you have both "document.txt" and "working copy of document.txt" open in EditPad Pro, and you start editing the former, the latter will be automatically overwritten after a few minutes. So if you want to keep the working copy, you should use File|Save As before editing the base document.

If you want to continue working with the same set of files the next time you start EditPad Pro, turn on "automatically save and reopen workspace". You can also choose the file into which EditPad Pro should have its workspace. The workspace will contain a list of project and files that you have open. The next time you start EditPad Pro, those projects and files will be automatically reopened.

Huge Files

EditPad Pro is capable of handing files up to 2 gigabytes (about two billion characters) in size. However, loading such large files entirely into memory would quickly exhaust the available memory of most computers, slowing down the system to a crawl.

Therefore, you can set an upper limit on the size of files that EditPad Pro will read into memory entirely. The default is 20 megabytes. Larger files will be swapped out to disk. This slightly slows down EditPad, but makes sure your computer keeps running smoothly. To be able to read files as needed, EditPad Pro needs to keep a lock on those files. This means that EditPad Pro will lock files larger than the huge file treshold, even when you've turned off the option to keep a lock on open files.

EditPad Pro also won't apply syntax coloring to huge files, unless you've selected a "fast" syntax coloring schemes. Fast syntax coloring schemes are schemes that don't require the whole file to be processed. Fast schemes included with EditPad Pro are "clickable URLs", "INI files" and "MySQL (fast)".

Preserve File Status

By default, EditPad Pro remembers a whole bunch of status information for the files that you edit. This information is stored for all the files in the File|Reopen and File|Favorites menus. It is also saved into .epp project files whenever you save a project. This way, each file will appear the next time you open it in EditPad Pro the way it did last time. With "preserve file settings" turned on, EditPad Pro will store the settings from the Options menu that you've changed from their defaults in the file type configuration. With "preserve cursor position and folding" turned on, EditPad Pro will remember the position of the text cursor in the file, which part of the file was selected, bookmarks and folding . Opening large files may take a bit longer when preserving the cursor position, as EditPad Pro then has to scan the file for line breaks up to the cursor position before it can show the file.


Tabs Preferences

Tabs Preferences ( Available in EditPad Pro only )

On the Files tab in the Preferences screen, you can configure how tab pages work in EditPad Pro. Tabs enable you to quickly switch between files and projects. You can also quickly open and close files via the tabs .

Tabs for Files and Projects

EditPad Pro can display up to two rows of tabs. One row for files, and another row for projects. The file tabs will only show the files in the active project. Switching between project tabs also switches between the files active in those projects.

Tabs are very convenient when working with a relatively small sets of files. When working with hundreds or even thousands of files, EditPad Pro's File Panel is a more appropriate tool. If you prefer to use the File Panel, you can disable the tabs to save screen space.

Appearance

By default, EditPad will show images on tabs. These images indicate the kind of file the tab holds. Project tabs will show an EditPad icon.

The tab of the active file has a different color than the other tabs. If this distinction is not clear enough, you can either change the tab colors as explained above or turn on "active tab is taller than other tabs". When this option is selected, the active tab will have a larger height and a piece of background will be visible above all the other tabs. Turning off this option gives the tab control a much more compact look.

Tab Colors

You can configure the colors of the tabs. Select an item in the list and click the Color and Text Color buttons to change the background and text colors of the selected tab style.

  • Tab: Regular tab
  • Active Tab: The tab of the file you are currently viewing
  • Hot Tab: The tab underneath the mouse pointer
  • Tab - modified: Tab of a modified file
  • Active Tab - modified: The tab of the file you are currently editing
  • Hot Tab - modified: The tab of a modified file underneath the mouse pointer
  • Tab - read only: Tab of a read only file
  • Active Tab - read only: The tab of the read only file you are currently viewing
  • Hot Tab - read only: The tab of a read only file underneath the mouse pointer
  • Tab background: The empty space above and to the right of the tabs
  • Tab button: Color of the X and other buttons at the right end of the tab row
  • Pressed tab button: Color of the X or other button when you've clicked on it with the mouse
  • Hot tab button: Color of the X or other button underneath the mouse pointer
  • Disabled tab button: Color of disabled buttons at the right end of the tab row. The scrolling buttons will become disabled when you can't scroll further.


Tab Actions

You can do more with the tabs in EditPad, beyond activating a file by clicking on its tab.

To quickly close a tab, move the mouse pointer over it and push down the wheel button on your mouse. If the file didn't have any unsaved changes, EditPad will close it instantly, without even activating it.

You can access other common file-related commands such as File|Save and File|Close All but Current quickly by clicking on one of the tabs with the right hand button of your mouse. If the tab you right-clicked on isn't the active tab, EditPad will activate the file first. If a command you often use isn't available in the right-click menu, you can add it via Configure Toolbar and Menus .

To quickly start with a blank, untitled file, double-click on the empty space after the last tab. Other common commands for opening files and commands affecting all files are available in the context menu that appears when you right-click on the empty space after the last tab. This menu is also configurable.


Statusbar Preferences

Statusbar Preferences ( Available in EditPad Pro only )

While both EditPad Lite and Pro have a statusbar, it is only configurable in EditPad Pro. EditPad Pro can show many more items on the statusbar. You may not want to clutter the screen with all of them. Select Options| Preferences in the menu, and click on the Statusbar tab.

You can show or hide items on the statusbar by marking or clearing the checkboxes at the left of the items in the list. You can also hide the statusbar altogether by turning off "show statusbar".

You can change the order in which the items are shown on the statusbar by dragging and dropping them in the list. Click on an item, hold the mouse button down and drag it to the spot where you want it and release the mouse button. The topmost item in the list will become the leftmost item on the statusbar.


Shortcuts Preferences

Create Shortcuts to EditPad

This page in the Preferences window makes it easy for you to create shortcut icons to EditPad. Select the various places where you want a shortcut icon and click the "Create/Remove Shortcuts Now" button. To remove a shortcut, clear the appropriate checkboxes and press the same button.

If you place a shortcut in the "Startup menu (submenu of Programs menu)", the green EditPad icon will automatically appear next to the system clock whenever you turn on your computer.

Put a shortcut in the "Send To menu" so you can quickly open any file in EditPad from within Windows Explorer by right-clicking on the file, selecting Sent To from the context menu and then selecting EditPad.

The "Quick Launch Toolbar" is not available in Windows 95 and NT4.

Right-Click Explorer Action

EditPad Pro can also add itself to the context menu of every file and/or every folder in Windows Explorer. The context menu is the menu that appears when you click on an item with the right hand mouse button. Select the context menus in which you want EditPad Pro to appear, and click "Create/Remove EditPad Actions Now".


Email Preferences

Select Options|Preferences in the menu and click on the Email tab to configure EditPad Pro for sending email.

Double-Clicking Highlighted Email Addresses

When you double-click a highlighted email address in a text file, EditPad Pro can do one of three things:

  • Compose a new email in EditPad Pro. This is the same as selecting File|Mail in the menu and entering the email address.
  • Launch default email client. EditPad Pro will attempt to launch the application associated with the mailto: URL protocol on your computer.
  • Launch a specific email client. Click on the (...) button to select the .exe file of the email software you want EditPad Pro to launch. You can also type in the command line directly and specify command line parameters. If you enter %EMAIL% on the command line, EditPad Pro will substitute that placeholder with the actual email address. If you don't enter %EMAIL% on the command line, EditPad Pro will launch the .exe with the email address as the sole command line parameter.

Email Queue

If you turn on "automatically send email messages placed into the email queue", EditPad Pro will start sending email right away when you click the Send button in the email composition panel . This way you do not have to click on the Send button in the mail queue . You should turn on this option if you have a permanent Internet connection.

Turn on "close email queue automatically after all messages have been sent" to make the mail queue disappear automatically when all emails have been sent successfully. If there was a problem sending some or all of the messages in the queue, then the queue will remain visible, so you can see which messages were not sent.

Email Server Settings

Before you can use File|Mail , you need to specify the mail server EditPad Pro should use to send email. EditPad Pro only supports the SMTP protocol, which is the de facto standard for sending email on the Internet. If you connect to the internet through a public dial-up or broadband ISP, you can use your ISP's SMTP server. Typical names for the SMTP server are mail.isp.com, relay.isp.com and smtp.isp.com, where isp.com is your internet provider's domain name. The standard port for SMTP connections is 25. If you connect to the Internet through a corporate network, you will have to ask your network administrator which server you can use. MS Exchange and other proprietary protocols are not supported by EditPad Pro.

Email Server Authentication

Many SMTP servers only allow you to send email after logging in with your email username and email password. Often, the requirement is that you check incoming your email before you can send email. This is called "POP-before-SMTP authentication". When you mark this option, you can type in your email username and email password, as well as the server from which you retrieve incoming mail. EditPad Pro supports the POP3 protocol, which is the de facto standard for receiving email on the Internet. Typical server names are mail.isp.com, pop.isp.com and pop3.isp.com. The standard port is 110. Note that EditPad Pro will not actually download any of your email. It will only log onto the server, and then disconnect, for the purpose of authenticating you so you can send email using EditPad Pro.

If your ISP requires a username and password to send email, but do not require you to check your incoming email before sending email, the ISP is using "SMTP authentication". When you mark this option, you can type in your email username and email password that EditPad Pro can use to connect to the SMTP server.


System Preferences

On the System page in Options|Preferences , you can make some choices how EditPad Pro interacts with the rest of your computer and network.

System Tray Icon

If "Show EditPad icon in the system tray" is activated, a green EditPad icon will be visible next to the system clock (this area is called the "system tray") when EditPad is running. When you close EditPad in this situation, it will not really close but only hide itself so the system tray icon remains visible. You can then make EditPad quickly reappear by clicking on the system tray icon. You can right-click on it to quickly start with a new file or open an existing one. To completely shut down EditPad, select File|Exit from the menu.

Turn off this option to make EditPad behave like a regular Windows program.

When the "Show EditPad icon in the system tray" option is activated, you can choose if you want EditPad's button on the taskbar to hide or not when you minimize EditPad by marking or clearing "Hide taskbar button when minimizing EditPad". Note that the taskbar button will always hide when you close EditPad.

Saving Preferences and History

You can have EditPad keep the registry clean and store its settings in an .ini file. This is most useful if you are carrying EditPad with you on a floppy disk and want to run it on other people's computers. If you activate this option, EditPad will remove all its settings from the registry and store them in an .ini file. The next time you run EditPad, it will detect the .ini file and continue to use that instead of the registry. The .ini file is saved in c:\Documents and Settings\User\Application Data\JGsoft\EditPad Pro 6 on Windows 2000 and XP, and in c:\Users\User\AppData\Roaming\JGsoft\EditPad Pro 6 on Windows Vista. On Windows 98 and ME, and when running EditPad Pro from a removable drive on any operating system, the .ini file is saved in the same folder as EditPadPro.exe. If you click the ellipsis (...) button, EditPad Pro will launch Windows Explorer to open that folder.

The option "erase all history lists that may be remembering private information when quitting EditPad Pro" can be useful if you share your computer with other people and you don't want them to figure out which files you have been working on in EditPad Pro. Every time you close EditPad Pro using File|Exit when this option is active, EditPad Pro will clear history lists such as File|Reopen , Project|Reopen and the search and replace history lists (which you can access by right-clicking in the search or edit boxes). If these lists were previously saved to the registry or to the .ini file, they will be deleted.

View in Web Browser

If the View|Browser doesn't properly detect your web browser, you can specify a specific application to be used as the web browser. Click the (...) button to browse for the .exe file of the application you want to use. You can also manually enter a command line. If you include %URL% as part of the command line parameters, that placeholder will be substituted with an http:// or file:// URL to the file to be opened. If you don't enter %URL% on the command line, EditPad Pro will launch the .exe with the URL as the sole command line parameter.

Double-Clicking Highlighted FTP Links

EditPad Lite will always open FTP links in your computer's default FTP client. EditPad Pro provides three choices. The default is to use EditPad's built-in FTP . This is the most comfortable option to edit files stored on FTP servers. The "launch default FTP client" runs whichever application is configured on your computer to handle ftp: URLs.

Finally, you can specify a specific application to be used as the web browser. Click the (...) button to browse for the .exe file of the application you want to use. You can also manually enter a command line. If you include %URL% as part of the command line parameters, that placeholder will be substituted with an ftp:// URL to the file to be opened. If you don't enter %URL% on the command line, EditPad Pro will launch the .exe with the URL as the sole command line parameter.


Configure Toolbar

On the Toolbar tab in the Configure Toolbar and Menus screen, you can select which items from EditPad Pro's main menu appear as buttons on the toolbar.

Toolbar Visibility

If you don't use certain toolbars, you can save screen space by hiding those. The main toolbar is the one that sits below the main menu. This is also the toolbar that you can populate with the commands that you use most often. The search toolbar is the one on the search-and-replace panel . This toolbar provides quick access to the commands in the Search menu when the search-and-replace panel is visible. You can place these commands on the main toolbar if you like, and use that instead of the search toolbar.

Some side panels like the File Panel , Explorer Panel , FTP Panel and Clip Collection have their own toolbars. The buttons on these toolbars perform actions that are only relevant in the context of the side panel they're on. These buttons cannot be placed on the main toolbar. If you hide the side panel toolbars, you can access the toolbar commands by right-clicking with the mouse. The side panel context menus offer the same commands as the side panel toolbar, plus a few more rarely used ones.

Toolbar Options

Many toolbar buttons have drop-down menus with extra items. E.g. the File|New button has a drop-down menu listing all available file types allowing you to quickly create a new file of a specific type. When the option "show drop-down arrows" is on, these buttons will have a small arrow next to them that you can click on to open the drop-down menu. These arrows take up space. You can fit more buttons on the toolbar by turning off "show drop-down arrows". When you do so, you can still access the drop-down menus by right-clicking on the toolbar buttons that have them.

If you have a high resolution screen, you can turn on "large toolbar icons" to make the toolbar buttons 50% larger.

If you find that the toolbar's gradient background makes the icons hard to distinguish, or if it simply doesn't suit your taste, you can turn off the gradient toolbar background. The toolbar will then use a solid background color.

Toolbar Position

You can choose to have the main toolbar positioned near the top or the bottom of EditPad Pro's screen. When positioned at the top, the toolbar will sit below the main menu bar and above the row of tabs or the editor. When positioned at the bottom, the toolbar will sit below the row of tabs or the editor, and above the status bar .

Commands on the Toolbar

The list at the left contains all the menu items you've added to the main toolbar. You can rearrange them by dragging and dropping them with the mouse, or via the Up and Down buttons. You can remove items by double-clicking on them or via the Remove button. Click the Add Separator button to add a separator. Separators are useful for grouping toolbar buttons.

Available Commands

The list at the right shows all of EditPad Pro's main menu items that have a graphical icon. Menu items without icons cannot be added to the toolbar. To add an item to the main toolbar, simply double-click on it.


Configure Context Menus

On the Context Menus tab in the Configure Toolbar and Menus screen, you can select which items from EditPad Pro's main menu appear on various right-click menus.

Menu to Configure

In the list at the top left corner, you can select which one of the six context menus you want to configure.

  • Editor, outside selection: This menu appears when you right-click on the text you are editing, outside the selected part (if any) of the text. This menu is a good spot to add editing commands that don't require a selection.
  • Editor, inside selection: This menu appears when you right-click on the selected part of the text you are editing. This menu is a good spot for editing commands that modify the selected text.
  • File tab: This menu appears when you right-click on a tab holding a file in EditPad. This menu is a good spot for commands that affect one file.
  • File tab background: This menu appears when you right-click on the empty space to the right of the row of tabs holding the files. This menu is a good spot for commands that affect all files.
  • Project tab: This menu appears when you right-click on a tab holding a project in EditPad. This menu is a good spot for commands that affect one project.
  • File tab background: This menu appears when you right-click on the empty space to the right of the row of tabs holding the projects. This menu is a good spot for commands that affect all projects.

Commands on the Menu

The list at the lower left contains all the menu items you've added to the context menu. You can rearrange them by dragging and dropping them with the mouse, or via the Up and Down buttons. You can remove items by double-clicking on them or via the Remove button. Click the Add Separator button to add a separator. Separators are useful for grouping related menu items.

Available Commands

The list at the right shows all of EditPad Pro's menu items. To add an item to the context, simply double-click on it.


Configure Keyboard Shortcuts

Configure Keyboard Shortcuts ( Available in EditPad Pro only )

On the Keyboard Shortcuts tab in the Configure Toolbar and Menus screen, you can change the shortcut key combination for each item in EditPad Pro's main menu.

Configure Individual Keyboard Shortcuts

To assign a new shortcut key combination to a menu item, select the menu item from the list. Then click on the box labeled "shortcut key". Press the key combination you want on the keyboard. To remove a key combination from an item, click on the "shortcut key" box and press the delete or backspace key on the keyboard.

Each shortcut key combination can be used by only one menu item. If the shortcut key combination you assigned to the currently selected menu item is already used for one or more other menu items, those other menu items will be listed in the box labeled "conflicts with".

You can also assign shortcuts keys to tools and to macros when configuring tools and recording macros. You cannot assign the same shortcut key to both a menu item and a tool or macro.

If you run out of key combinations, EditPad Pro also supports two-key keyboard shortcuts. When you press the first key combination of a two-key shortcut, EditPad Pro will do nothing except remember that you pressed that key. The next key you press is then taken as the second key. If it forms a valid two-key shortcut, the corresponding action is executed. If not, neither key press will have any effect.

To configure a two-key shortcut, click on the "two-key shortcut" radio button. Then click on the "shortcut key" box and press the first key combination. The first key must either be a Ctrl+Letter combination (possibly including Shift and/or Alt), or a function key (possibly including Ctrl, Shift and/or Alt). Up to 15 different key combinations can be used as the first key in a two-key pair. Then click on the "2nd key" box and press the second key combination in the two-key shortcut. The second key combination can be any key, including a letter without a modifier (Ctrl, Shift or Alt). If you specify a letter without a modifier, both the letter without the modifier and the letter with the same modifiers as the first key will work. E.g. if you assign Ctrl+K, B to the Begin Selection command, you can begin a selection by pressing Ctrl+K followed by B, or Ctrl+K followed by Ctrl+B to begin a selection. Specifying a letter without modifiers as the second key makes it easier to quickly press both keys, since it doesn't matter if you release the Ctrl key before the second key (the letter B in the example) or after it.

When using two-key keyboard shortcuts, it is a good idea to add the keyboard status indicator to the status bar . When you press the first key in a two-key combination, the keyboard indicator will show that key. That way you know the next key you press will be interpreted as the second key in the combination. After you press the second key, the indicator reverts to showing num lock, caps lock and scroll lock.

General Keyboard Shortcut Settings

EditPad Pro supports the classic Wordstar navigation keys for people who are used to them. WordStar is an old word processor that used Ctrl+Letter key combinations to navigate through the document. WordStar was created at a time when most keyboards did not yet have separate arrow key blocks. The checkbox only enables the navigation keys. It does not change any of the key combinations that you assigned to EditPad Pro's menu items. Note that many of these navigation keys conflict with standard Windows shortcut keys. E.g. Ctrl+S is the standard Windows shortcut for File|Save . In WordStar, Ctrl+S moves the text cursor one position to the left, just like the left arrow key.

Click the "Apply WordStar Shortcut Keys" button to assign WordStar key combinations to various menu items. E.g. Ctrl+K, S will be assigned to File|Save . Shortcut keys assigned to EditPad menu items that don't have a WordStar equivalent will not be changed. The assignment is a one-time event. You can freely reconfigure any of the changed keys.

Click the "Restore All Default Shortcut Keys" button will restore the default EditPad shortcuts for all menu items. It will also turn off the option to use WordStar navigation keys, since many of those conflict with EditPad's default shortcuts.

The keyboard navigation keys cannot be configured. They are always available, even when you've enabled WordStar navigation keys.


Configure File Types

One of the most powerful aspects about the way EditPad Lite and Pro work with preferences , is that many settings can be made for each specific file type that you regularly edit or view with EditPad. For example: you may want to use word wrapping at the window border for plain text files, but no word wrapping for source code. Once you make the correct settings for each file type, you won't have to change them each time you open a file.

When you open or save a file, EditPad will compare its name against the file mask for each known file type and will apply the settings made for that file type. If the file name doesn't match any file type, the settings for "Any file" will be used.

EditPad also uses the list of file types to build the "Files of type" drop-down list at the bottom of the file selection windows for opening and saving files. The filters in the Explorer Panel , the FTP Panel and the Open Folder command also allow you to select files based on their file types.

To configure file types, select Configure File Types in the Options menu. The file type configuration screen will appear. The screen is divided into two parts. At the left hand, you'll see a list of currently defined file types. At the right hand are four tabs that hold the settings for the file type that's currently selected in the list at the left.

To change a file type's settings, simply click on it in the list and make the changes you want. To create a new file type, click the New button below the list and set the options as you want them. To delete a file type, click on it and click the Delete button.

The order of the file types matters. The order you give them in the configuration screen is the order they'll have in any drop-down list showing the available file types. If a file matches the file mask of more than one file type, EditPad will use the bottommost file type in the list with a matching mask for that file. Place file types with more specific file masks below those with more general file masks. The "any file" file type is the most general one, and always sits at the top of the list. The first four file types, "any file", "text document", "HTML document" and "XML file" have special meanings in EditPad. They are always the first four file types in the list.

You can save individual file type configurations into a file that you can share with other people. To save a file type, click on it in the list and click the Export button below the list. To load a file type configuration file you've received from somebody, click the Import button. The loaded file type will be added to the list.

For each file type, you can specify four sets of options:

  • Definition and Associations
  • Encoding
  • Editor Options
  • Syntax & Navigation


File Type Definition

On the Definition tab in the file types configuration screen , you can indicate how the file type should be identified and which files it applies to.

The description is used whenever you need to make a choice between file types, such as the "files of type" list in open and save windows or the Options|File Type command. You cannot change the description of the first few file types. These file types have a special meaning in EditPad. You cannot delete these file types or change their position in the list, but you can adjust all the settings to your own tastes and habits as you can do for all the other file types.

The file masks you assign to a file type are particularly important. When you open a file, EditPad compare's the file's name against the file masks for each file type. If it finds a file type with a mask that matches the file name, that file type's settings will be used for the file being opened. If more than one file type's mask matches, the bottommost matching file type is used. Therefore, file types with more specific masks should be placed below file types with more general masks. The "any file" file type has a mask of "*.*", which matches all file names. If there's no other file type with a matching mask, the "any file" file type will be used. The "any file" file type always sits at the top of the list, and is thus the last and most generic file type.

In a file mask, the asterisk (*) represents any number (including none) of any character. The question mark (?) represents one single character. On the Windows platform, the type of a file is usually determined by its name's extension. The extension consists of a dot followed by (usually) three letters. E.g. text files have a .txt extension. The file mask *.txt will match all text files with a .txt extension. You can delimit multiple file masks with semicolons. The file mask *.c;*.h matches all C source and header files (with a .c and .h extension respectively). If you specify a semicolon-delimited list of file masks, a file's name needs to match only one of them for the file type to be applied to that file.

File masks also support a simple character class notation, which matches one character from a list or a range of characters. E.g. a file mask such as www.200509[0123][0-9].log or www.200509??.log could be used to match all web logs from September 2005.

Sometimes, a file's type cannot be easily derived from its name. While file name extensions are common on the Windows platform, they're not on other platforms like UNIX. For such file types, you can specify a magic value regular expression . A magic value is simply some text or data at the start of a file that reveals the file's type. A regular expression is a pattern for matching text.

When EditPad has finished comparing the file's name against the file masks of all file types, and the only matching file type is "any file", EditPad will try to match the magic value regular expression of each file type at the start of the file. The regex is only attempted at the very start of the file, as if the regular expression started with the anchor \A. Again, should more than one file type have a matching regular expression, the bottommost file type will be used.

Out of the box, EditPad ships with two file types with magic value regular expressions. The "Perl script" file type has #![-_.\\/a-zA-Z0-9]*perl which matches the "shebang" at the start of a Perl script. On the UNIX platform, Perl scripts usually don't have an extension, but do have the shebang. On the Windows platform, the shebang is typically missing, but Perl scripts are given a .pl extension. EditPad will recognize the file either way, first trying the file masks to look for the .pl extension, and then trying the regular expression to match the shebang.

The other file type is the XML type which uses the very simple regular expression <\?xml to match the <?xml header at the start of an XML file. XML files often have an extension that indicates the application that saved the file, rather than the fact that it's in XML format. E.g. PowerGREP uses the .pgf, .pga, .pgr and .pgl extensions for PowerGREP file selections, actions, results and libraries, rather than the generic .xml extension.


File Type Associations

Using the three buttons on the Definition tab in the file types configuration screen , you can quickly create or remove file associations to the current file type. The associations will be made with or removed from each of the extensions listed in the file type's file mask .

Windows itself determines file types by file name extension only. Therefore, associations will only be made with file masks in the style of *.ext. Other file masks are ignored when making Windows file associations.

If you click the button "Always "Open" this file type with EditPad", EditPad will associate itself with the "open" action. This means that whenever you double-click on a file of this type in Windows Explorer, it will be opened in EditPad.

If you click the button "Always "Edit" this file type with EditPad", EditPad will associate itself with the "edit" action. This means that you can then right-click on files of this type in Windows Explorer and select "Edit" from the context menu to open the file in EditPad. If you do this for HTML files, you will be able to view the source for any web page by clicking on the Edit button in the toolbar of Microsoft Internet Explorer.

If you click "Associate EditPad's green icon with this file type", then Windows Explorer will indicate files of this type with the green notebook icon that represents EditPad itself. You can use this button to make files that you edit exclusively with EditPad stand out in Windows Explorer or other file management applications. EditPad itself also uses the icon associated with a file type to indicate file types on tabs and file management side panels.

Click the button "Remove EditPad's association with this file type" to remove the associations made by clicking on one or more of the three previous buttons. Associations made in another way will not be removed.

With the "check if EditPad is the default text editor at startup", you can make EditPad auto-repair the "open" association with the .txt extension. This extension is the default for text files. The option only becomes active when you've selected the "text document" file type in the list.


File Type Encoding

On the Encoding tab in the file types configuration screen , you can indicate how EditPad should encode and decode files of a particular type.

Computers deal with numbers, not with characters. When you save a text file, each character is mapped to a number, and the numbers are stored on disk. When you open a text file, the numbers are read and mapped back to characters. When saving a file in one application, and opening the that file in another application, both applications need to use the same character mappings.

Traditional character mappings or code pages use only 8 bits per character. This means that only 256 characters can be represented in any text file. As a result, different character mappings are used for different language and scripts. Since different computer manufacturers had different ideas about how to create character mappings, there's a wide variety of legacy character mappings. EditPad supports a wide range of these.

In addition to conversion problems, the main problem with using traditional character mappings is that it is impossible to create text files written in multiple languages using multiple scripts. You can't mix Chinese, Russian and French in a text file, unless you use Unicode. Unicode is a standard that aims to encompass all traditional character mappings, and all scripts used by current and historical human languages.

If you only edit files created on your own Windows computer, or on other Windows computers using the same regional settings, there's not much to configure. Simply leave the "default text encoding" set to the default Windows code page, e.g. Windows 1252 for English and other Western European languages. If you edit files created on Windows computers with different regional settings, you may need to select a different Windows code page. You can either change the default for the file type, or use Convert|Text Encoding for a one-time change.

Unicode

On the Windows platform, Unicode files should start with a byte order marker (BOM). The byte order marker is a special code that indicates the Unicode encoding (UTF-8, UTF-16 or UTF-32) used by the file. EditPad will always detect the byte order marker, and treat the file with the corresponding Unicode encoding.

Unfortunately, some applications cannot deal with files starting with a byte order marker. XML parsers are a notorious example. If an application that claims to support Unicode fails to read Unicode files saved by EditPad, try turning on the option not to write the byte order marker.

If you turn on the option "preserve precense or absence of the byte order marker in existing files", then EditPad will keep the BOM in files that already have it, and never add it to Unicode files previously saved without a BOM. When preserving the BOM or its absence, the "write a byte order marker at the start of Unicode files" is only used for files you newly create with EditPad, and for files that you convert from a non-Unicode encoding to Unicode. (Non-Unicode files never have a BOM, so there's no presense or absence of it to maintain.)

If you want EditPad to open Unicode files saved without a byte order marker, you'll either need to set the default encoding for the file type to the proper Unicod encoding, or turn on the option to auto-detect UTF-8 and UTF-16 files without a byte order marker.

To auto-detect UTF-8 files, EditPad Pro checks if the file contains any bytes with the high order bit set (values 0x80 through 0xFF). If it does, and all the values define valid UTF-8 sequences, the file is treated as a UTF-8 file. The chances of a normal text document written in a Windows code page being incorrectly detected as UTF-8 are practically zero. Note that files containing only English text are indistinguishable from UTF-8 when encoded in any Windows, DOS or ISO-8859 code page. This is one of the design goals of UTF-8. These files contain no bytes with the high order bit set. EditPad Pro will use the file type's default code page for such files. This makes no difference as long as you don't add text in a language that doesn't use the English alphabet.

Reading a UTF-16 file as if it was encoded with a Windows code page will cause every other character in the file to appear as a NULL character. These will show up as squares or spaces in EditPad. EditPad can detect this situation in many cases and read the file as UTF-16. However, for files containing genuine NULL characters, you may need to turn off the option to detect UTF-8 and UTF-16 files without the byte order marker.

Line Break Style

If the differences in character mappings weren't enough, different operating systems also use different characters to end lines. EditPad automatically and transparently handles all three line break styles. If you open a file, EditPad will maintain that file's line break style when you edit it. EditPad will only change the line break style if you tell it to using the Convert menu .

Unfortunately, many other applications are not as versatile as EditPad. Most applications expect a file to use the line break style of the host operating system. E.g. the Notepad applet included with Windows will display all text on one long line if a file uses UNIX line breaks. The Linux shell won't properly recognize the shebang of Perl scripts saved in Windows format (causing CGI scripts to break "mysteriously").

In such situations, you will need to set a default line break style for the affected file types. When you create a new file by selecting a file type from the drop-down menu of the new file button on the toolbar, EditPad will give that file the default line break style of the chosen file type.

Note that EditPad will never silently convert line breaks to a different style. If you set the default line break style for Perl scripts to UNIX, and then open a Perl script using Windows line breaks, EditPad will save that script with Windows line breaks unless you use Convert|To UNIX .

If you need to deal with different line break styles, you should turn on the line break style status bar indicator. EditPad will indicate the line break style being used by the current file.

Binary Files

EditPad Pro can edit binary files in hexadecimal mode. If you know that files of a certain type don't contain (much) human-readable content, select "always open files of this type in hexadecimal mode". If you know files of a certain type to be text files, select "never open files of this type in hexadecimal mode" to prevent stray NULL characters from making EditPad think the file is binary.

If you're not sure, select "open files detected as being binary in hexadecimal mode". Then EditPad Pro will check if the file contains any NULL characters. Text files should not contain NULL characters, though improperly created text files might. Binary files frequently contain NULL characters.

Making the wrong choice here causes no harm. You can instantly switch between text and hexadecimal mode by picking View|Hexadecimal in the menu. Unlike many other editors, EditPad Pro will preserve the exact contents of binary files even when you view them in text mode. Even files with NULL characters will be properly displayed in text mode. (Many applications truncate text files at the first NULL, since that character is often used as an end-of-data signal.)


File Type Editor Options

On the Editor Options tab in the file types configuration screen , you indicate the default editor options for each file type. Most of these options can be changed for individual files via the Options menu . The Options menu only affects a single file. The file type configuration sets the default.

Line and Column Numbers

Turn on "show line numbers" to have EditPad display a number before each line in the left margin. In that case, you need to indicate if you want visible lines or physical lines to be numbered. This only makes a difference when word wrapping is on. When numbering visible lines, each line is counted, including lines created by the word wrapping. When numbering physical lines, the lines are numbered as if word wrapping would be off. You can toggle this option for a single file with Options|Line Numbers .

Turn on "show column numbers" if EditPad should display a horizontal ruler above the file indicating column numbers. You can toggle this for a single file with Options|Column Numbers . Column numbers are only displayed when using a fixed-width font .

In the box labeled "vertical rulers to the left of specific columns" you can enter a comma-delimited list of column numbers. EditPad will draw a vertical line to the left of the columns you enter. This makes it easier to work with files that use a columnar layout. You can put a + before a number to make that column relative to the previous column. E.g.: 10,+5,+5,37,+7,+12 would be equivalent to 10,15,20,37,44,56.

Word Wrap

The word wrap setting determines what happens with lines that are too long to fit inside EditPad's window. If you don't want long lines to wrap, they will extend beyond EditPad's window and be partially invisible. A horizontal scroll bar will appear.

You can make long lines wrap either at the edge of EditPad's window, or at a specific line length. When wrapping at the window edge, lines will be automatically re-wrapped when you resize EditPad. When wrapping at a specific line length, horizontal scrolling may still be needed if the specified length doesn't fit inside EditPad's width.

It is usually convenient to wrap at the window edge, as it eliminates the need for horizontal scrolling. You'll probably want to turn it off for files that use a line-based structure such as software source code, so the word wrapping doesn't confuse your view of the lines. Note that EditPad's word wrapping is fully dynamic. Line breaks introduced by the word wrapping are not saved into the file at all, unless you use Convert|Wrapping -> Line Breaks . So there's no risk at data loss when turning on word wrap for line-based files.

If you turn on "wrapped lines should maintain indentation", lines created by the word wrapping will be indented by the same amount as the line they were broken off from. If you turn it off, wrapped lines will start at the first column regardless of the indentation of the original line. Turning on this option is useful when turning on word wrap for files using nested block structures, such as XML files and various programming languages.

Word wrap can be toggled for individual files with Options|Word Wrap and Options|Indent Wrapped Lines .

Tabs and Indentation

Normally, pressing the Tab key on the keyboard inserts a special tab character that has a variable width. If you turn on "pressing Tab inserts spaces", then EditPad Pro will insert the equivalent number of spaces, which have a fixed width.

When you turn on "automatically indent new lines when pressing Enter", EditPad will automatically put the same number of spaces and/or tabs at the start of the new line as the previous line starts with. This option can be toggled for individual files with Options|Auto Indent .

"Tab size in spaces" is the maximum width of a tab character expressed in an equivalent number of spaces. A typical value is 8 spaces, which means there will be a tab stop at every 8th column. This option also determines the number of spaces that is inserted if you turn on "pressing Tab inserts spaces".

You can also place tab stops at specific columns by entering a comma-delimited list of column numbers. Pressing Tab will then make the cursor jump to the next tab stop column, either by inserting a single tab character or the number of spaces needed to reach the next tab stop (depending on the "pressing Tab inserts spaces" option). After the last specific column, there will be additional tab stops spaced according to the "tab size in spaces" setting. You can put a + before a number to make that tab stop relative to the previous tab stop. E.g.: 10,+5,+5,37,+7,+12 would be equivalent to 10,15,20,37,44,56.

"Indentation size in spaces" is the number of spaces that the Block|Indent and Block|Outdent will use to indent or outdent the current selection. If the indentation size is an integer multiple of the tab size, and the option to make Tab insert spaces is off, the Indent and Outdent functions will use tab characters.

Visualization

Select "show spaces and tabs" if you want spaces and tabs to be visualized. Spaces will be indicated by a vertically centered dot. Tabs are indicated by a » character. This option is useful when working with files where extraneous whitespace can lead to problems, or where the difference between tabs and spaces matters. You can quickly toggle it by picking Options|Visualize Spaces from the menu.

Turn on "show paragraph markers" if you always want to see a ¶ character at the end of each paragraph, indicating the invisible line break character(s). Note that if line break characters are selected, the paragraph symbol will always appear to show you that they have indeed been selected. You can quickly change this option by picking Options|Paragraph Symbol from the menu.


File Type Syntax & Navigation

On the Syntax & Navigation page in the file types configuration screen , you can configure the syntax coloring, file navigation and line folding text editing aids.

Syntax Coloring

Syntax coloring highlights different parts of a file in different colors. This makes it easier to edit text files that need to adhere to a certain syntax or formatting, such as programming source code or markup files. The different colors help guide your eyes through the structure of the file.

EditPad Pro ships with many syntax coloring schemes for a variety of file formats and programming languages. Simply select the one you want to use from the "syntax coloring scheme" drop-down list.

If no coloring scheme is available for the file type you are defining, click the download button. EditPad Pro will then connect to the Internet and allow you to download many custom syntax color schemes created and shared by other EditPad Pro users. To create your own syntax coloring schemes, use the JGsoft Custom Syntax Coloring Scheme Editor . After editing a scheme or creating new ones, click the Refresh button to make EditPad Pro read in the new and edited schemes.

Most syntax coloring schemes can highlight matching brackets. If this highlight distracts you, turn it off here. Note that for some schemes, such as "clickable URLs", there will be no difference whether this option is on or off, as these schemes are not capable of highlighting matching brackets.

EditPad Pro can also apply live spell checking. When you activate the "live syntax-aware spell checking" option, EditPad Pro will mark misspelled words as you type. By default, misspelled words are marked in red and underlined. You can change the look in Colors Preferences . The live spell checking is syntax-aware. This means that the spell checker will work together with the syntax coloring scheme, and only check parts of the file that are likely to contain text in a human language (English). E.g. if you are programming in C# or Java, the spell checker will only check the text in comments and strings. Comments and strings are likely to contain human language, while the rest of the file is in the C# or Java programming language.

The spell checker will only work if you have previously downloaded and installed JGsoft spell checker dictionaries. Click the Download Spell Checker Dictionaries button to download some or all of the spell check dictionaries free of charge.

File Navigator

You can access the File Navigator by selecting View|File Navigator in the menu. The File Navigator displays the structure of the file in a collapsible tree. By clicking on items in the tree, you can quickly navigate to various parts of the file.

The File Navigator requires a file navigation scheme to do its job. You can select a predefined scheme from the file "navigation scheme" drop-down list.

If no file navigation scheme is available for the file type you are defining, click the download button. EditPad Pro will then connect to the Internet and allow you to download file navigation schemes created and shared by other EditPad Pro users. To create your own file navigation schemes, use the JGsoft File Navigation Scheme Editor . After editing a scheme or creating new ones, click the Refresh button to make EditPad Pro read in the new and edited schemes.

Automatic Folding Points

Automatic folding points appear as small squares in the left margin, with a vertical line extending down from the square to indicate the range. These allow you to quickly fold logical parts of the text to get a better overview of the overall structure. When EditPad Pro adds automatic folding points, any unused (i.e. expanded) folding points you created with Fold|Fold and Fold|Unfold are removed.

EditPad Pro can obtain automatic folding points from two sources. Many, but not all, file navigation schemes also define foldable ranges when they associate different parts of the file with various nodes in the file navigation tree . These ranges usually follow the syntax of the file.

Alternatively, EditPad Pro can use a file's indentation as the basis for folding points. Whenever a line is followed by one or more lines that are indented further than itself, that line will become a folding point. Its range will stop before the next line with the same or a smaller indentation than the foldable line. EditPad Pro will nest folding points this way up to three levels deep. Further levels down will only be added if the foldable range is longer than half the number of lines that EditPad Pro can display at a time.

Note that when enabling automatic folding points, you can still use the Fold|Fold to fold different blocks of text. They just won't persist when you unfold them and edit the file.

Clip Collection

You can specify a default Clip Collection to be used for each file type. If you activate a file that has a Clip Collection associated with its file type, that collection is automatically opened. By using different collections for each file type, you always have the appropriate text snippets at your fingertips. E.g. you could associate the HTML file type with a collection with HTML tags, and the Java source code file type with your favorite Java code snippets.

EditPad Pro automatically saves modified collections. If you already have a collection open when activate a file that has a Clip Collection associated with its file type, the collection that was already open is automatically saved before opening the file type's collection.


Download Custom Syntax Coloring Schemes

When you click on the button to download custom syntax coloring schemes in the Syntax & Navigation file type settings , EditPad Pro will connect to the Internet. It will download a list of custom syntax coloring schemes that have been created and generously shared by other EditPad Pro users. This list is then displayed in the window shown below.

Note: Any schemes you download are not automatically put to use. You will need to create or edit a file type to use a scheme that you downloaded .

The list presents you the following information about the available schemes:

  • Scheme: The name of the scheme. It is possible that more than one scheme with the same name is available. If so, you can install all of them or only one, as you prefer.
  • Extensions: The extensions typically used for the files that the scheme provides syntax coloring for. They are only shown for your information. You can apply any scheme to any file type, as you see fit.
  • Author: The author of the scheme. If you have comments or suggestions about a particular coloring scheme, you should contact this person.
  • Added: The date the scheme was first added to the list of available schemes.
  • Updated: The date the scheme was last updated.
  • Installed: Indicates whether this scheme is installed on your computer or not.

If you click the Install button, EditPad Pro will immediately download the scheme and save it into the same folder as its executable file EditPadPro.exe.

Click the Update button to download a scheme that you already installed again.

If you click the Uninstall button, EditPad Pro will delete the scheme from your computer when you close the window for downloading custom syntax coloring schemes.

If you are behind a proxy server, and EditPad Pro is unable to detect your proxy settings, you can change them by clicking the Settings button.


Using Custom Syntax Coloring Schemes

After downloading a custom syntax coloring scheme , it is not automatically put to use.

All the schemes that you downloaded, will be listed in the Syntax Coloring drop-down list in the Syntax & Navigation file type settings . They will appear in alphabetic order among the schemes that ship with EditPad Pro. This drop-down list is shown in the screen shot below.

To use one of the schemes, create or edit a file type , and select the coloring scheme you want from the Syntax Coloring drop-down list.


JGsoft Syntax Coloring Scheme Editor

With the JGsoft Syntax Coloring Scheme Editor, you can create your own syntax coloring schemes for use with EditPad Pro. You can also edit the schemes included with EditPad Pro, and those you've downloaded . The syntax coloring schemes files have a .jgcscs extension. You can't edit them with any program except the JGsoft Syntax Coloring Scheme Editor. You can download the scheme editor at http://www.editpadpro.com/cscs.html . The editor is a free download for all licensed EditPad Pro users. Full documentation is included.

The syntax coloring schemes included with EditPad Pro are stored in the folder where you have EditPad Pro installed, typically c:\Program Files\JGsoft\EditPadPro 6. On Windows Vista and Windows 7, the default security settings do not allow normal users to modify files under c:\Program Files. Therefore, schemes that you download and schemes that you edit are saved under your Windows user profile, typically c:\Users\yourname\AppData\Roaming\JGsoft\EditPadPro 6. If a scheme with the same file name exists in both the user profile folder and the program files folder, only the scheme in the user profile folder will be available in EditPad.


Download File Navigation Schemes

When you click on the button to download file navigation schemes in the Syntax & Navigation file type settings , EditPad Pro will connect to the Internet. It will download a list of custom syntax coloring schemes that have been created and generously shared by other EditPad Pro users. This list is then displayed in the window shown below.

Note: Any schemes you download are not automatically put to use. You will need to create or edit a file type to use a scheme that you downloaded .

The list presents you the following information about the available schemes:

  • Scheme: The name of the scheme. It is possible that more than one scheme with the same name is available. If so, you can install all of them or only one, as you prefer.
  • Extensions: The extensions typically used for the files that the scheme provides syntax coloring for. They are only shown for your information. You can apply any scheme to any file type, as you see fit.
  • Author: The author of the scheme. If you have comments or suggestions about a particular file navigation scheme, you should contact this person.
  • Added: The date the scheme was first added to the list of available schemes.
  • Updated: The date the scheme was last updated.
  • Installed: Indicates whether this scheme is installed on your computer or not.

If you click the Install button, EditPad Pro will immediately download the scheme and save it into the same folder as its executable file EditPadPro.exe.

Click the Update button to download a scheme that you already installed again.

If you click the Uninstall button, EditPad Pro will delete the scheme from your computer when you close the window for downloading custom syntax coloring schemes.

If you are behind a proxy server, and EditPad Pro is unable to detect your proxy settings, you can change them by clicking the Settings button.


Using File Navigation Schemes

After downloading a file navigation scheme , it is not automatically put to use.

All the schemes that you downloaded, will be listed in the File Navigation Scheme drop-down list in the Syntax & Navigation file type settings . They will appear in alphabetic order among the schemes that ship with EditPad Pro. This drop-down list is shown in the screen shot below.

To use one of the schemes, create or edit a file type , and select the coloring scheme you want from the File Navigation Scheme drop-down list.


JGsoft File Navigation Scheme Editor

With the JGsoft File Navigation Scheme Editor, you can create your own file navigation schemes for use with EditPad Pro. You can also edit the schemes included with EditPad Pro, and those you've downloaded . The file navigation schemes files have a .jgfns extension. You can't edit them with any program except the JGsoft File Navigation Scheme Editor. You can download the scheme editor at http://www.editpadpro.com/fns.html . The editor is a free download for all licensed EditPad Pro users. Full documentation is included.

The file navigation schemes included with EditPad Pro are stored in the folder where you have EditPad Pro installed, typically c:\Program Files\JGsoft\EditPadPro 6. On Windows Vista and Windows 7, the default security settings do not allow normal users to modify files under c:\Program Files. Therefore, schemes that you download and schemes that you edit are saved under your Windows user profile, typically c:\Users\yourname\AppData\Roaming\JGsoft\EditPadPro 6. If a scheme with the same file name exists in both the user profile folder and the program files folder, only the scheme in the user profile folder will be available in EditPad.


Configure Toolbar and Menus

Configure Toolbar and Menus ( Available in EditPad Pro only )

Via the Configure Toolbar and Menus item in the Options menu you can configure which items from the main menu appear on the toolbar and which items appear on various right-click menus. You can also configure the keyboard shortcuts for all items in the main menu.

  • Configure Toolbar
  • Configure Context Menus
  • Configure Keyboard Shortcuts


Configure Tools

Configure Tools ( Available in EditPad Pro only )

EditPad Pro has the capability to run any external command or tool. A tool can be any executable program or application, a script run by an interpreter, or even an URL.

To configure tools, select Configure Tools in the Tools menu. The tool configuration screen will appear. The screen is divided into two parts. At the left hand, you'll see a list of currently defined tools. If you haven't defined any tools yet, this list will be empty. At the right hand are three tabs that hold the settings for the tool that's currently selected in the list at the left. The tabs don't appear until you've added at least one tool.

To change a tool's settings, simply click on it in the list and make the changes you want. To create a new tool, click the New button below the list and set the options as you want them. To delete a tool, click on it and click the Delete button.

The order of the tools in the list is the order in which they will be shown in the Tools menu. Select a tool and click the Up or Down button to move it.

You can save individual tool configurations into a file that you can share with other people. To save a tool, click on it in the list and click the Export button below the list. To load a tool configuration file you've received from somebody, click the Import button. The loaded tool will be added to the list.

For each tool, you can specify three sets of options.

  • Definition: Basic settings you need to make for every tool, so EditPad Pro knows which tool to run.
  • Files: Options for opening and saving files to be passed on the tool's command line.
  • Standard I/O: Options for transferring text to and from console applications. Console applications are applications that use a textual interface rather than a graphical interface like EditPad Pro.


Tool Definition

When adding a tool to EditPad Pro's Tools menu, there are three pages of settings that you can make for each tool. On the "Definition" page you can set the basic options needed to add any application to EditPad Pro's Tools menu.

"Caption" is the caption that this tool's menu item in the Tools menu will have. If you want to make a certain character a hotkey in the menu, precede it with an ampersand (&). The character that follows the ampersand will be shown underlined in the menu (unless you disabled the underlining of hotkeys in Windows).

"Hint" is the text that will be shown in the status bar when the mouse is pointing that this tool's menu item in the Tools menu. You may leave this blank if the caption is descriptive enough.

If you will use the tool often, you can assign a keyboard shortcut key combination to it. Click on the "shortcut key" field, and then press the shortcut key combination you want on the keyboard. E.g. if you press F2 on the keyboard, the "shortcut key" field will display F2. The menu item for the tool in the Tools menu will also indicate F2. When you press F2 on the keyboard while working with EditPad Pro, the tool will be run. To remove the shortcut from the tool, click in the "shortcut key" field and press the backspace key on the keyboard.

For the "Command Line", you need to type in what you would type in if you would launch the tool from the Run item in the Windows Start menu. It is best to include the full path to the executable and any file parameters. Note that you must not use <, > or | characters for file redirection. If you need file redirection, use the Standard I/O page. If the path to the tool's executable has spaces in it, you must enclose it in double quotes. Click the Browse button to browse for the executable file.

If you specify a document file instead of an executable file as the command line, then EditPad Pro will launch the document's associated application, and pass the document file as a parameter. Windows Explorer does the same when you double-click on a document.

"Working Folder" is the folder that will appear to be the current one to the tool when it is run by EditPad Pro.

You can use special path placeholders to use the full path to the file you are currently editing, or parts of the file name or path in the command line or in the working folder. If you have marked any of the four temporary file options (see below), you can also use placeholders for the path and file name of the temporary file. Note that many applications cannot handle file names with spaces in them on the command line, unless they are enclosed by double quotes. So it is best to always put double quotes around paths you compose using path placeholders, like I did in the above screen shot.

Click the Placeholders button to get a screen listing all path placeholders, making it easy to use them on the command line. The screen will use the file and project you currently have open in EditPad as example paths. If the active file or project are untitled, the example will be a dummy path. The temporary file placeholders will only be available if you've turned on at least one of the options to open or save a temporary file .

When running EditPad Pro from a removable drive, the drive will get a different drive letter each time it is inserted into another computer. In that situation, you should reference other applications stored on the same device using the %EPPDRIVE% and %EPPPATH% path placeholders. Then your tools will always reference the files on your drive, regardless of the drive letter it gets.

In addition to the path placeholders, EditPad Pro also supports several placeholders that you can use to pass the position of the text cursor on the tool's command line. %LINE% is the placeholder for the line the cursor is on, while %COL% is a placeholder for the cursor's column position. The %POS% placeholder indicates the number of bytes in the file before the position of the text cursor. If the cursor is at the very start of the file, %POS% is substituted with zero. Note that depending on the file's encoding , the number of bytes may not equal the number of characters.

Since most tools will only make sense when used on a file of a certain type, you can select the file types this tool applies to in the list at the right. Do this by marking the appropriate checkboxes. Not marking any checkbox has the same effect as marking all of them. The Tools menu will show all the tools that apply to the type of file you are currently editing.


Path Placeholders

You can use path placeholders to use part or all of the path and the file name of the file you are currently editing. You can use them in the command line and working folder for tools. This way, you can have a tool work with the file you are editing in EditPad Pro. In the examples below, the file being edited is C:\data\files\web\log\foo.bar.txt. If the current file is untitled, all the placeholders below will be replaced with nothingness.

If you want to use the path or name of the temporary file that EditPad Pro can open or save when running a tool, simply prepend TEMP to the name of the placeholder. E.g. %TEMPFILE% is the full path and filename to the temporary file. %TEMPPATH% is the folder the temporary file is in.

Placeholder Meaning and example

%FILE% The entire path plus filename to the file

C:\data\files\web\log\foo.bar.txt

%FILENAME% The file name without path

foo.bar.txt

%FILENAMENOEXT% The file name without the extension

foo.bar

%FILENAMENODOT% The file name cut off at the first dot

foo

%FILEEXT% The extension of the file name without the dot

txt

%FILELONGEXT% Everything in the file name after the first dot

bar.txt

%PATH% The full path without trailing delimiter to the file

C:\data\files\web\log

%DRIVE% The drive the file is on, without trailing delimiter

C: for DOS paths; \\server for UNC paths; blank for UNIX paths

%FOLDER% The full path without the drive and without leading or trailing delimiters

data\files\web\log

%FOLDER1% First folder in the path

data

%FOLDER2% Second folder in the path

files

(...etc...)

%FOLDER99% 99th folder in the path.

In this example, this tag will be replaced with nothingness, because there are less than 99 folders.

%FOLDER<1% Last folder in the path

log

%FOLDER<2% Second folder from the end in the path

web

(...etc...)

%FOLDER<99% 99th folder from the end in the path.

In this example, this tag will be replaced with nothingness.

%PATH1% First folder in the path, without delimiters

data

%PATH2% First two folders in the path, without leading or trailing delimiters

data\files

(...etc...)

%PATH99% First 99 folders in the path, without leading or trailing delimiters

data\files\web\log

%PATH<1% Last folder in the path, without delimiters

log

%PATH<2% Last two folders in the path, without leading or trailing delimiters

web\log

(...etc...)

%PATH<99% Last 99 folders in the path, without leading or trailing delimiters

data\files\web\log

%PATH-1% Path without the drive or the first folder

files\web\log

%PATH-2% Path without the drive or the first two folders

web\log

(...etc...)

%PATH-99% Path without the drive or the first 99 folders.

In this example, this tag will be replaced with nothingness.

%PATH<-1% Path without the drive or the last folder

data\files\web

%PATH<-2% Path without the drive or the last two folders

data\files

(...etc...)

%PATH<-99% Path without the drive or the last 99 folders.

In this example, this tag will be replaced with nothingness.

Combining Path Placeholders


Combining Path Placeholders

You can string several path placeholders together to form a complete path. If you have a file c:\data\test\file.txt then d:\%FOLDER2%\%FILENAME% will be substituted with d:\test\file.txt However, if the original file is c:\more\file.txt then the same path will be replaced with d:\\file.txt because %FOLDER2% is empty. The result is an invalid path.

The solution is to use combined path placeholders, like this: d:\%FOLDER2\FILENAME%. The first example will be substituted with d:\test\file.txt just the same, and the second will be substituted with d:\file.txt, a valid path. You can combine any number of path placeholders into a single path placeholder, separating them either with backslashes (\) or forward slashes (/). Place the entire combined placeholder between two percentage signs.

A slash between two placeholders inside the combined placeholder is only added if there is actually something to separate inside the placeholder. Slashes between two placeholders will never cause a slash to be put at the start or the end of the entire resulting path. In the above example, the backslash inside the placeholder is only included in the final path if %FOLDER2% is not empty.

A slash right after the first percentage sign makes sure that the resulting path starts with a slash. If the entire resulting path is empty, or if it already starts with a slash, then the slash is not added.

A slash right before the final percentage sign makes sure that the resulting path ends with a slash. If the entire resulting path is empty, or if it already ends with a slash, then the slash is not added.

Mixing backslashes and forward slashes is not permitted. Using a forward slash inside a combined placeholder, will convert all backslashes in the resulting path to forward slashes. This is useful when creating URLs based on file names, as URLs use forward slashes, but Windows file names use backslashes.

Example: If the original path is c:\data\files\web\log\foo.bar.txt

%\FOLDER1\% => \data\

%\FOLDER5\% => (nothing)

%PATH-2\FILENAME% => web\log\foo.bar.txt

%PATH-2/FILENAME% => web/log/foo.bar.txt

%PATH-4\FILENAME% => foo.bar.txt

%DRIVE\PATH-2\FILENAME% => c:\web\log\foo.bar.txt

%DRIVE\PATH-4\FILENAME% => c:\foo.bar.txt

%\FOLDER1\FOLDER4\% => \data\log\

%\FOLDER1\FOLDER5\% => \data\


Tool Files

When adding a tool to EditPad Pro's Tools menu, there are three pages of settings that you can make for each tool. On the "Files" page you can choose if EditPad Pro should save the current file or selection, or open files modified by the tool.

Mark "Save current file before executing command" if EditPad Pro should automatically do a File|Save before the tool is run. If the file is untitled, you will be prompted for a file name. You can use the %FILE% path placeholder to pass the file on the tool's command line .

Mark "Save the current file into a new temporary file before executing command" if EditPad Pro should automatically do a File|Save Copy As and save the file under a new, temporary name before the tool is run. This is useful if the tool will modify the file's contents but you do not want to lose the original, or if you want to test changes you made to a file with a tool without having to save those changes first. The temporary file will be deleted after the tool has finished running.

Turn on "Reload the current file" to force EditPad Pro to reload the file that was active when you invoked the tool as soon as the tool has finished running. You should do so if the tool will modify the current file, even if you've turned on the option to reload modified files in the Files Preferences . Otherwise, EditPad Pro may not notice the file has changed until you switch between tabs in EditPad or between EditPad and another application.

Mark "Open temporary file after executing command" if the tool will create or modify the temporary file and you want to see the changes in EditPad. If this option is checked, EditPad will open the file into a new tab and then delete the temporary file from disk. If you want to save the tool's result, use File|Save As .

Mark "Save the selected portion of the current file into a new temporary file before executing" if EditPad Pro should automatically do a Block|Write to save the selected text into a temporary file before the tool is run. The temporary file will be deleted after the tool has finished running. You cannot use this option in combination with saving the entire file into a temporary file, but you can use it in combination with both "open temporary file" (see above) and "replace selection" (see below).

Mark "Replace the selected portion of the current file with the contents of the temporary file after executing" if EditPad Pro should automatically delete the current selection and do a Block|Insert File using the temporary file, after the tool has finished running. Together with the above option, you can add a tool to EditPad Pro's menu that modifies the current selection. You could write a script in a language like Perl to add special functionality EditPad Pro does not provide.

If you've turned on at least one of the options to either open or save a temporary file, you can use the %TEMPFILE% path placeholder to pass the temporary file's name on the tool's command line . All of the options will work on a single temporary file for each tool.


Tool Standard I/O

When adding a tool to EditPad Pro's Tools menu, there are three pages of settings that you can make for each tool. If you are adding a console or text mode application to EditPad Pro's Tools menu, then you can instruct EditPad Pro to communicate with the application via the options on the "Standard I/O" page.

By default, console applications read input from the keyboard and write output to the screen. On the DOS and Windows command line, you can use the less than and greater than symbols to redirect standard input and output. The command line "sometool <input.txt >output.txt" will cause sometool to read from input.txt and write to output.txt.

You cannot use these symbols on the command line when configuring EditPad Pro to run a console application. However, you do have a variety of options for redirecting standard I/O on the "Standard I/O" page.

What to Send to Standard Input

If a tool expects data via standard input (i.e. it expects a DOS/Windows command line like "sometool <input.txt"), EditPad Pro is capable of sending either the current file entirely, or only the selected part of the current file. The current file is whichever file you're editing at the moment you run the tool by selecting it in the Tools menu.

If the tool is a text-based console application that accepts input from the keyboard, anything EditPad sends to the tool's standard input will be processed by the tool as if you typed it on the keyboard. This does not work with graphical applications, since those do not use standard input to retrieve keyboard input.

Before running the tool, EditPad Pro makes an internal copy of the text it needs to send to standard input. If the tool takes a long time to run, editing or closing the file EditPad is sending to the tool will not affect the tool's execution.

How to Capture Standard Output

If a text-based console application writes its output to the screen, or if an application outputs data to a file with a command line like "sometool >output.txt", EditPad Pro can capture that output in various ways:

  • Ignore: The tool's standard output will be lost. Select this option if the tool doesn't output anything useful to the screen, or if it's a graphical application that doesn't support standard output.
  • Replace selected text: EditPad will replace the selected part of the file that was active when you invoked the tool with the tool's output. If there is no selection, the tool's output will be inserted at the text cursor position. This option is particularly useful in combination with the option to send the selected text to standard input. That way, an external tool can provide text processing functions not provided by EditPad Pro itself.
  • Into message pane: EditPad will capture the tool's output into a separate pane. Since EditPad Pro has only one message pane, the output of any previous tools that was captured into the message pane will be lost. Choose this option when a tool outputs status or error messages that you want to inspect but not keep. The message pane supports syntax coloring. EditPad Pro ships with a few "Tool Errors" and "Tool Output" syntax coloring schemes that make the output of some popular tools a bit more readable. You can use the JGsoft Syntax Coloring Scheme Editor to create your own schemes, or you can download schemes in the Syntax & Navigation tab in the File Type Configuration .
  • Into new tab: EditPad will create a new file tab to capture the tool's output. If you run the tool more than once, a new tab will be created each time. Select this option if the tool outputs a lot of data or a complete file. You can edit, save and close the new tab like any other file you'd edit in EditPad.
  • Append to existing tab: EditPad will create a new tab to capture the tool's output, and continue using that tab each time you run that tool, appending additional data each time. Choose this option if you want to save the results of multiple invocations of a tool into a single file.
  • Replace existing tab: EditPad will create a new tab to capture the tool's output, and replace that tab's contents whenever you run the tool again. Make this choice if the tool outputs too much information to neatly fit into the message pane, and you only want to keep the results of the last invocation of the tool.

If you choose one of the three options to capture the output into a tab, you can make three additional settings for that tab:

  • Mark the tab as "modified" if it contains data: Turn on this option if you usually want to save the captured output into a file. If you close the file without saving, EditPad Pro will prompt just like when you close an unsaved file. Turn off this option if you usually want to discard the output. Note that if you edit the output, the tab will still become marked as modified.
  • Close the tab if it remains empty: This option is particularly handy when you've chosen the "into new tab" capturing option. It automatically closes the tab if nothing was captured, so your workspace doesn't get cluttered with empty tabs.
  • File type for tab: Since standard output doesn't have a file name, EditPad Pro cannot use the file masks from the file type configuration to determine the output's file type. Therefore, you can select one of the file types from the list. Choose the "same as current file" option for text processing tools that return a modified version of the file you're editing.

If you close the tab EditPad Pro is using to capture standard output while the tool is still running, the tool's output will be lost. However, the tool will keep running until normal completion. EditPad Pro will keep clearing the tool's standard output without saving it anywhere.

How to Capture Standard Error

Standard error works just like standard output. While standard output is intended for console applications to produce their output, standard error is intended for their error messages. Not all console applications respect this distinction. Some may send error messages to standard output. When the application is run from a command prompt with output appearing on the screen, standard output and error are automatically combined onto the single screen. This makes some programmers forget to make their console applications distinguish between standard output and error.

Therefore, EditPad Pro offers the "combine with output" option. EditPad Pro will then mingle standard error with standard output, just like a console screen would. The combined output will end up in whichever location (tab or message pane) you selected for standard output.

All the other choices for standard error are identical to those for standard output. If you select one of the three tab options for both standard output and standard error, you will get two new tabs: one for standard output, and one for standard error.

Since EditPad Pro has only one message pane, the only way to capture both standard output and standard error into the message pane is by selecting the "message pane" option for standard output, and the "combine with output" option for standard error.


Regular Expression Tutorial - Learn How to Use Regular Expressions

Regular Expression Tutorial

In this tutorial, I will teach you all you need to know to be able to craft powerful time-saving regular expressions. I will start with the most basic concepts, so that you can follow this tutorial even if you know nothing at all about regular expressions yet.

But I will not stop there. I will also explain how a regular expression engine works on the inside, and alert you at the consequences. This will help you to understand quickly why a particular regex does not do what you initially expected. It will save you lots of guesswork and head scratching when you need to write more complex regexes.

What Regular Expressions Are Exactly - Terminology

Basically, a regular expression is a pattern describing a certain amount of text. Their name comes from the mathematical theory on which they are based. But we will not dig into that. Since most people including myself are lazy to type, you will usually find the name abbreviated to regex or regexp. I prefer regex, because it is easy to pronounce the plural "regexes".In this help file, regular expressions are printed as "regex".

This first example is actually a perfectly valid regex. It is the most basic pattern, simply matching the literal text "regex". A "match" is the piece of text, or sequence of bytes or characters that pattern was found to correspond to by the regex processing software.Matches are highlighted in blue in this help file.

"\b[A-Z0-9._%-]+@[A-Z0-9._%-]+\.[A-Z]{2,4}\b" is a more complex pattern. It describes a series of letters, digits, dots, percentage signs and underscores, followed by an at sign, followed by another series of letters, digits, dots, percentage signs and underscores, finally followed by a single dot and between two and four letters. In other words: this pattern describes an email address.

With the above regular expression pattern, you can search through a text file to find email addresses, or verify if a given string looks like an email address. In this tutorial, I will use the term "string" to indicate the text that I am applying the regular expression to.I will highlight them in "green".The term "string" or "character string" is used by programmers to indicate a sequence of characters. In practice, you can use regular expressions with whatever data you can access using the application or programming language you are working with.

Different Regular Expression Engines

A regular expression "engine" is a piece of software that can process regular expressions, trying to match the pattern to the given string. Usually, the engine is part of a larger application and you do not access the engine directly. Rather, the application will invoke it for you when needed, making sure the right regular expression is applied to the right file or data.

As usual in the software world, different regular expression engines are not fully compatible with each other. It is not possible to describe every kind of engine and regular expression syntax (or "flavor") in this tutorial. I will focus on the regex flavor used by Perl 5, for the simple reason that this regex flavor is the most popular one, and deservedly so. Many more recent regex engines are very similar, but not identical, to the one of Perl 5. Examples are the open source PCRE engine (used in many tools and languages like PHP), the .NET regular expression library, and the regular expression package included with version 1.4 and later of the Java JDK. I will point out to you whenever differences in regex flavors are important, and which features are specific to the Perl-derivatives mentioned above.

Give Regexes a First Try

You can easily try the following yourself in a text editor that supports regular expressions, such as EditPad Pro. If you do not have such an editor, you can download the free evaluation version of EditPad Pro to try this out. EditPad Pro's regex engine is fully functional in the demo version. As a quick test, copy and paste the text of this page into EditPad Pro. Then select Edit|Search and Replace from the menu. In the search pane that appears near the bottom, type in "regex" in the box labeled "Search Text". Mark the "Regular expression" checkbox, unmark "All open documents" and mark "Start from beginning". Then click the Search button and see how EditPad Pro's regex engine finds the first match. When "Start from beginning" is checked, EditPad Pro uses the entire file as the string to try to match the regex to.

When the regex has been matched, EditPad Pro will automatically turn off "Start from beginning". When you click the Search button again, the remainder of the file, after the highlighted match, is used as the string. When the regex can no longer match the remaining text, you will be notified, and "Start from beginning" is automatically turned on again.

Now try to search using the regex "reg(ular expressions?|ex(p|es)?)" . This regex will find all names, singular and plural, I have used on this page to say "regex". If we only had plain text search, we would have needed 5 searches. With regexes, we need just one search. Regexes save you time when using a tool like EditPad Pro.

If you are a programmer, your software will run faster since even a simple regex engine applying the above regex once will outperform a state of the art plain text search algorithm searching through the data five times. Regular expressions also reduce development time. With a regex engine, it takes only one line (e.g. in Perl, PHP, Java or .NET) or a couple of lines (e.g. in C using PCRE) of code to, say, check if the user's input looks like a valid email address.


Regular Expressions Tutorial Table of Contents

Regex Tutorial Table of Contents

This regular expression tutorial teaches you every aspect of regular expressions. Each topic assumes you have read and understood all previous topics. So if you are new to regular expressions, I recommend you read the topics in the order presented.

Introduction

The introduction indicates the scope of the tutorial and which regex flavors will be discussed. It also introduces basic terminology.

Literal Characters and Special Characters

The simplest regex consists of only literal characters. Certain characters have special meanings in a regex and have to be escaped. Escaping rules may get a bit complicated when using regexes in software source code. How to enter non-printable characters.

How a Regex Engine Works Internally

First look at the internals of the regular expression engine's internals. Later topics will build on this information. Knowing the engine's internals will greatly help you to craft regexes that match what you intended, and not match what you do not want.

Character Classes or Character Sets

A character class or character set matches a single character out of several possible characters, consisting of individual characters and/or ranges of characters. A negated character class matches a single character not in the character class. Shorthand character classes allow you to use common sets quickly.

The Dot

The dot matches any character, though usually not line break characters unless you change an option.

Start of String and End of String Anchors

Anchors are zero-width. They do not match any characters, but rather a position. The caret and the dollar sign match at the start and the end of the string. Depending on your regex flavor and its options, they can match at the start and the end of a line as well.

Word Boundaries

Word boundaries are like anchors, but match at the start of a word and the end of a word. However, most regex flavors define the concept of a "word" differently than your English teacher in grade school.

Alternation

By separating different sub-regexes with vertical bars, you can tell the regex engine to attempt them from left to right, and return success as soon as one of them can be matched.

Optional Items

Putting a question mark after an item tells the regex engine to match the item if possible, but continue anyway (rather than admit defeat) if it cannot be matched.

Repetition Using Various Quantifiers

Three styles of operators, the star, the plus, and curly braces, allow you to repeat an item zero or more times, once or more, or an arbitrary number of times. It is important to understand that these quantifiers are "greedy" by default, unless you explicitly make them "lazy".

Grouping and Backreferences

By placing round brackets around part of the regex, you tell the engine to treat that part as a single item when applying operators such as quantifiers. With round brackets, you can also create backreferences that allow you to reuse the text matched by part of the regex inside the regular expression, or later in the replacement text of a search and replace operation. Backreferences are also very useful for extracting parts from a string in a programming language.

Unicode Characters and Properties

If your regular expression flavor supports Unicode, then you can use special Unicode regex tokens to match specific Unicode characters, or to match any character that has a certain Unicode property.

Mode Modifiers

Change matching modes such as "case insensitive" for specific parts of the regular expression.

Atomic Grouping and Possessive Quantifiers

Nested quantifiers can cause an exponentially increasing amount of backtracking that brings the regex engine to a grinding halt. Atomic grouping and possessive quantifiers provide a solution.

Lookaround with Zero-Width Assertions, part 1 and part 2

Lookahead and lookbehind (collectively lookaround) are zero-width. With positive lookaround, you can specify multiple requirements (sub-regexes) to be applied to the same part of the string. With negative lookaround, you can invert the result of a regex match (i.e. match something that does not match something else).

Continuing from The Previous Match Attempt

Forcing a regex match to start at the end of a previous match provides an efficient way to parse text data.

Combining Positive and Negative Lookaround with Conditionals

A conditional is a special construct that will first evaluate a lookaround, and then execute one sub-regex if the lookaround succeeds, and another sub-regex if the lookaround fails.

Adding Comments

Some regex flavors allow you to add comments to make complex regular expressions easier to understand.


File|New

Creates a new tab with a blank, untitled file.

The file type for the new file is the "text document" file type. This is second file type from above in the file type configuration .

When you use File|Save As and give the file a name with an extension other than .txt, the file's file type will be changed to the file type associated with that extension. The file will then also use the settings defined for that file type.

In EditPad Pro, if you put the File|New button on the toolbar (it is on the toolbar by default), it will receive a drop-down menu listing all available file types. If you select an item from that menu, a new tab will be created with a blank, untitled file which uses the settings for the file type you just selected, instead of the "Text Document" file type which is used if you pick File|New from the menu or left-click the New button on the toolbar.

See also:

  • EditPad Pro Main Menu
  • File Menu


File|Open

The File|Open command will show an open file common dialog box and allows you to open one or more files from the folder of your choice. To select more than one file, hold down the Shift or Control key on the keyboard while you click with the mouse. You can configure the initial folder of the open dialog in the Files Preferences .

Files opened with File|Open are added to the top of the File|Reopen menu. If the file was already on the Reopen menu, it will be moved into the top position.

If the active file is an empty one, it will be replaced by the one you open. This ensures EditPad does not get cluttered with empty tabs. If the file you selected was already open in EditPad, EditPad will simply activate the copy that was already open, even if that file is open in another project . EditPad will not open a second copy of the file.

If you're opening multiple files, some of which are already open in another project, EditPad Pro will switch to that project and open the other files in that project. If two or more files are already open, but in different projects, all files will be moved into the current project.

See also:

  • EditPad Pro Main Menu
  • File Menu
  • File|Reopen
  • File|Favorites
  • Read-Only Files
  • Project|Open Project


Read-Only Files

If a file is in use by an application, another application cannot modify it. Files stored on read-only media such as CD-ROMs or files which have the read-only attribute set, can also not be modified by an application.

If you use EditPad to open a file that is already in use by another application, EditPad will open that file in "read only" mode. This is indicated on the statusbar. Where you normally see if the current file has been modified or not (the indicator shows "Modified" or shows nothing), you will then see "Read Only". A file that is in read only mode cannot be edited in EditPad.

You can turn off "read only" mode by clicking on the "Read Only" indicator on the status bar. However, since the file is in use, you will still not be able to save it even if you can edit it in EditPad. To save your changes, either close the other application that is using the file and then use File|Save , or save your changes to a new file with File|Save As .

If you open a file that is stored on a CD-ROM or another medium that cannot be written to, you can edit it by turning off the "read only" mode as explained above. You will need to use File|Save As to save it somewhere else, since you cannot save files on a CD-ROM.


File|Reopen

A list of up to 16 recently opened files is available in the Reopen submenu of the File menu. If you click on one of these items, that file will be opened. The Reopen menu is also available as the drop-down menu of the File|Open button on the toolbar .

At the bottom of the menu, you will see the "Remove Obsolete Files" and "Remove All Files" items. The former will remove all files from the reopen menu that no longer exist, the latter will clear the entire reopen menu.

Though the menu can display only 16 files, EditPad Pro will actually remember the last 100 files. To access the complete list, select Maintain Reopen List from the Reopen menu.

See also:

  • Maintain Reopen List
  • EditPad Pro Main Menu
  • File Menu
  • File|Open
  • File|Favorites


Maintain Reopen List

Maintain Reopen List ( Available in EditPad Pro only )

A list of up to 16 recently opened files is available in the Reopen submenu of the File menu . However, EditPad Pro remembers the last 100 files you opened. You can access the complete list by clicking on the "Maintain List" item in the Reopen menu.

The same is true for Project|Reopen . The menu will show up to 16 items, while EditPad Pro remembers up to 100 items.

To open many files again at once, select all of them and click the Open button. You can also select them in bunches and click the Open button several times.

To remove files from the history, select them and click the Remove button. This will only remove files from the list. It will not delete any files. If you want to delete all files that no longer exist, you can do so by selecting "Remove Obsolete Files" in the Reopen menu itself, rather than selecting "Maintain List" to open the above screen.

Using the Up and Down buttons, you can change the order of the files in the history list. Press the Control key on the keyboard while clicking the Up or Down button to move a file all the way to the top or the bottom. Only the first 16 items will be visible directly in the Reopen menu.

See also:

  • EditPad Pro Main Menu
  • File|Reopen
  • Project|Reopen
  • File|Favorites


File|Favorites

File|Favorites ( Available in EditPad Pro only )

In the Favorites submenu of the File menu , you can keep lists of files that you often work with. This way you can quickly open them to continue working on them.

To add a file to your favorites list, first open the file in EditPad. Then select File|Favorites|Add Current File from the menu. The next time you open the File|Favorites menu, you will see the file listed there. The file are sorted alphabetically by their complete path names.

If you have many favorite files, you can organize them into folders. Select Organize Favorites from the Favorites menu to create folders and move files between folders. To add a file to one of the folders, select the "Add Current File" item from the folder's menu.

To purge files that no longer exist from the list of favorites, select "Remove Obsolete Files" from the Favorites menu. If you have created folders, non-existent files will be purged from those folders as well. To remove only certain files, whether they still exist or not, pick Organize Favorites from the Favorites menu.

To open one of your favorite files, simply choose it from the Favorites menu. To open many of your favorite files, use Organize Favorites .

You can also use the list of favorite files as a template system. First, create the template file and save it. Then add it to the favorites. Whenever you want to create a new file based on the template, open the template from the favorites and use File|Save As to save the new file. You can then start editing the new file. Using File|Save As or File|Rename and Move will not update the file's entry in the favorites.

While EditPad Pro does not impose a limit on the number of files and folders you can add to your favorites, you should not add too many files. Otherwise, the favorites menu will become difficult to navigate.

See also:

  • EditPad Pro Main Menu
  • Organize Favorites
  • File|Templates


Organize Favorites

Organize Favorites ( Available in EditPad Pro only )

Select Organize Favorites from the Favorites submenu in the File menu to organize the list of your favorite files, or to open many of those files quickly.

To open one or more files, select them and click on the Open button. Note that when selecting more than one file, all the files must be in the same folder. You cannot select multiple files across folders. If you want to open files from several folders, open them folder by folder. You can click the Open button as many times as you want to open as many files as you want.

To remove one or more files from the favorites, select them and click on the Remove button. This will not delete the files, but only remove them from the list of favorites. If you want to remove all files that no longer exist, select Remove Obsolete Files instead of Organize Favorites from the Favorites menu .

To add files to the favorites, first select the folder to which you want to add them. If you select a file, the files will be added to the folder which contains the selected file. Then click the Add Files button and choose one or more files. If you want to add files without putting them inside a folder, click on a file in the favorites that is not inside a folder either. Then click the Add Files button.

Use the New Folder button to create a new folder to which you can add favorites. You can change the caption of a folder by clicking on the folder and then clicking on the Rename Folder button. Creating folders is useful if you have more than twenty favorite files. If you add more than 20 files directly to the favorites menu, or to one of the folders, then the menu listing your favorites will become very long and difficult to use. Note that creating a folder here to hold your favorites does not actually create a folder on your hard disk. It simply adds a hierarchical structure to the list of favorites stored in your EditPad Pro preferences.

You can move files between folders by dragging and dropping them with the mouse. Note that EditPad Pro will automatically sort the list of favorites alphabetically. So you cannot rearrange files inside a folder.


File|Templates

The Templates submenu of the File Menu works just like the Favorites submenu, with one small but important difference. When you select a file from the Favorites menu, EditPad simply opens that file. If you select a file from the Templates menu, however, EditPad will create a new, untitled file with the content of the file you selected.

If you often edit a particular file, saving the changes back into the same file, you should add it to the Favorites. If you often create new files based on the contents of a particular file, you should ad that file to the Templates menu. Using templates, you won't accidentally save the changes over the original file.

The Favorites and Templates menus are completely independent. You can add the same file to both.

See also:

  • EditPad Pro Main Menu
  • Organize Favorites
  • File|Favorites


File|Save

Saves the active file to disk, overwriting the original, if any, without warning.

In Files Preferences you can specify if and how backup copies should be created.

If the active file is untitled, File|Save will invoke File|Save As .

See also:

  • File Menu
  • File|Save As
  • File|Save All


File|Save As

Saves the active file under a new name. If the active file has previously been saved, the original copy will remain available. If you later use File|Save after using File|Save As, it will save under the new name as well. This is indicated by the filename on the tab which changes after you use File|Save As.

When you select File|Save As, a save file common dialog box will appear. You can select the folder in which you want to save and type in a filename. You can configure the initial folder of the save dialog in the Files Preferences .

If you do not specify an extension for the filename, EditPad will add one depending on the selection you made in the filters (the bottommost drop-down list) in the Save As dialog box. If the active filter is "any file" (*.*), no extension will be added. If any other filter is active, the default extension for that file type will be added to the filename. The default extension is the first extension listed in the Extensions setting of the file type's settings .

If you do specify an extension, EditPad will save the file with that extension. If the extension is part of another file type, all the file type dependent settings such as auto indent, number lines and word wrap will be changed to match the settings for that new file type as made in the file type configuration .

See also:

  • File Menu
  • File|Save
  • File|Save All
  • File|Rename and Move
  • File|Save Copy As


File|Save All

Rapidly performs a File|Save for each open file, in each project.

For untitled files, File|Save As is invoked. If you click on Cancel in the save as dialog box, the save all function will not save any further files either.

See also:

  • File Menu
  • File|Save
  • File|Save As
  • Project|Save All Files in Project


File|Print

Prints the entire active file. A preview of the printout will be shown first. It will allow you to make some changes like which font to print with, which pages should be printed, and if you want to print headers or footers with page numbers, etc. You can also access the printer setup through the preview window.

See also:

  • EditPad Pro Main Menu
  • File Menu
  • Block|Print
  • Print Preview
  • Print Headers


Print Preview

This window is shown when you select File|Print or Block|Print .

With the blue arrow buttons at the top, you can browse through the pages that will be printed. You can also press the Page Up and Page Down keys on the keyboard.

The green plus and red minus buttons zoom the preview in and out respectively. You can also press the plus and minus keys on the numeric keypad on your keyboard. Zooming does not affect the printout, only the preview.

If you want to print with a different font, select it from the drop-down list. You can also change the font size by selecting one of the common sizes from the drop-down list below the font selection, or by typing in any size between 5 and 99 in that field instead of selecting from the list. If you change the font or the size, EditPad will remember the new font together with the font that you are editing the file in (the font you selected in Options|Font ). If you are editing a file in "Arial 10" and print it in "Verdana 12", EditPad will remember that combination. The next time you print a file you are editing in "Arial 10", "Verdana 12" will automatically be selected as the print font. You can change it at any time, of course. However, if you would use Options|Font to change the editor font to "Courier New 10" before using File|Print, the default printer font would be "Courier New 10" and not "Verdana 12". If you change the editor font back to "Arial 10", the default printer font will again be "Verdana 12".

Press the Setup button to access your printer's setup screen or to select a different printer than the default printer.

"From page" and "to page" determine the range of pages that will be printed. The value of "from page" must be smaller than or equal to that of "to page", even if you want to print in reversed order (see below). "Copies" is the number of copies that should be printed of each page.

Activating "All pages" will print all pages in the range specified by "from page" and "to page", while "odd pages" will print only the odd-numbered (1, 3, 5, ...) pages in the range, and "even pages" only the even-numbered (2, 4, 6, ...) ones. If the page range is only one page ("from page" equals "to page") and that page is odd-numbered while "even pages" is activated, or the other way around, nothing will happen when you click the Print button. You will not get an error message.

If you mark "Reversed", the pages will be printed from last to first instead of from first to last. This can be useful if you have an inkjet printer that puts pages in reversed order in the out tray.

Click the "Headers & Footers" button to change the headers and footers on the printout. You can include page numbers, the name or modification date of the file, etc. in the headers and footers, or choose not to print any headers or footers at all.

If you opened the print preview with File|Print , you can mark the "selection only" box to print only those lines that are selected in EditPad. The "selection only" checkbox works at the level of a single line. If a line is partially selected, it will be printed. If you only want to print exactly what you selected, select Block|Print in the menu instead.

If you have a monochrome printer or you do not want to waste expensive color ink cartridges, turn off "syntax coloring" to print without syntax coloring. When printing only the selection, syntax coloring may be applied differently when you use Block|Print to print the exactly selection, or use File|Print and turn on "selection only" to print selected lines. With Block|Print, the syntax coloring will color the block as it were the whole file, while File|Print applies syntax coloring to the whole file, even with "selection only" turned on. ( Available in EditPad Pro only )

If you used the Fold|Fold command to hide certain lines, then you can turn on the "hide folded lines" option to exclude those lines from the printout. Note that the printout will not indicate folding ranges with "plus" or "minus" buttons.

You can change the line spacing to any value between 0.8 to 5.0 by typing it into the appropriate field. A few common spacing can be selected from the drop-down list. 1.0 is normal spacing, 1.2 makes the text more readable, 1.5 provides a half line of extra space and 2.0 results in double-spaced text. Line spacing is the amount of space between the top of a line and the top of the next line, expressed in times the total height of the font. ( Available in EditPad Pro only )

The margins can be changed by moving the mouse over one of the dotted blue margin lines. The mouse pointer will change to indicate that you can move the margin, and a hint box will indicate the size of the margin in centimeters and inches. Click on the line, hold the mouse button down and drag the line until it indicates the desired margin position.

Click the "Print" button to start printing. Then click the "Close" button or press Escape on the keyboard to close the print preview.

See also:

  • File|Print
  • Block|Print
  • Print Headers


Print Headers

Click the "Headers & Footers" button in the Print Preview window to change the headers and footers to be printed, if any.

The headers and footers are printed inside the margins specified on the print preview. If no headers or footers are specified, their space will be claimed by the text body.

A few special placeholders are available in the headers and footers:

%P Page number of the current page

%N Total number of pages

%D Current date, printed using the short date format specified in the regional settings of the Control Panel

%T Current time, printed using the short time format specified in the regional settings of the Control Panel

%FD Date the file was last modified, again printed in short date format.

%FT Time of the day the file was last modified, again printed in short time format.

%FP Full path to the file being printed: folder + filename

%FN Filename (without folder name) of the file being printed

See also:

  • File|Print
  • Block|Print
  • Print Preview


File|Mail

File|Mail ( Available in EditPad Pro only )

Select File|Mail from the menu to send the current file to somebody via email. Before you can use this feature, you need to specify the outgoing mail server that EditPad Pro should use in the System Preferences .

The email composition pane, which you can see in the screen shot below, will be shown.

Type in your full name followed by your own email address in the field labeled "From". If you have previously used the email function, you can quickly select your email address from the drop-down list.

Then type in the recipient's email address in the "To" field. You can either enter the recipient's full name followed by his or her email address, or you can enter only the email address.

If you want to send your message to more than one recipient, click the Add button next to the "To" field to add the first email address to the list. Then type in the second email address into the "To" field, and click the Add button again. Do so for all recipients. If you make a mistake, you can remove a recipient by selecting his or her email address from the list and clicking the Remove button.

In the "Subject" field, type in the subject of the email message.

If you want to attach files to the email message, click the Attach button. Select the file you want to send. You can attach more than one file if you want to. If you change your mind about attaching a file, click on it in the list and click the Remove button below the list of attachments.

After typing in your email address, the recipients and the subject, the Send or Enqueue button will be enabled. When you click the Send button, the email is placed in the mail queue and sent out immediately. When you the Enqueue button, the email will be added to the mail queue , but will not be sent until you click the Send button in the mail queue. Which of the two buttons appears depends on the option to send out email immediately in the Email Preferences .

See also:

  • EditPad Pro Main Menu
  • File Menu
  • File|Mail as Attachment
  • Mail Queue
  • Email Preferences


File|Mail as Attachment

File|Mail as Attachment ( Available in EditPad Pro only )

Select "Mail as Attachment" from the File menu to start with a blank email message and attach the current file to the email. The mail composition pane will appear to allow you to further prepare the email message.

See also:

  • EditPad Pro Main Menu
  • File Menu
  • File|Mail
  • Mail Queue
  • Email Preferences


Mail Queue

Mail Queue ( Available in EditPad Pro only )

The mail queue pane will appear after you click on the Enqueue button in the mail composition pane . Each time you click on the Enqueue button, another email message will be added to the bottom of the mail queue. The messages will be marked as "queued".

Click the Send button to start sending the messages in the queue. EditPad Pro will start sending the first message in the queue marked as "queued". EditPad Pro will always start sending the first message, no matter which message you selected in the queue before clicking the Send button. When the first message has been sent, EditPad Pro will continue with the next, until all queued messages have been sent. The message that is being sent will be marked as "sending". After is has been sent, it will either be marked as "sent" in case of success, or "failed" in case the message could not be sent. While email is being sent, EditPad Pro will tell you what is happening in the caption bar below the queue. The caption indicates "Email Queue" if you have not sent anything yet.

To remove a message from the queue, select it and click the Delete button. You can delete any message, even while EditPad Pro is sending email . Only the message that is currently being sent (if any) cannot be deleted from the queue. If you want to delete all successfully sent messages from the queue, click the Close button.

If EditPad Pro could not send a particular message, it will be marked as "failed". If you want to try the message again without making any changes to it, select it and click the Retry button. This will mark the message as "queued". You can do this whether EditPad Pro is sending messages or not. Alternatively, you can cancel sending the message by deleting it from the queue. EditPad Pro will not automatically retry failed messages. You have to mark them again as "queued".

To move a message up or down in the queue, select it and click the Move Up or Move Down button. You can move any message, regardless of its status. However, the order of the messages only matters for those marked as "queued". The first one in the list is the one that will be sent next, regardless of which message is currently being sent (if any).

Click the Close button to close the mail queue pane. This will also delete all successfully sent messages from the pane. The only way to make the mail queue appear again after closing it, is to add another message to the queue through the mail composition pane . Therefore, you cannot close the mail queue while email is being sent. If the pane takes up too much space, click on the minimize button on the caption bar below the queue. This will hide the list of messages and the buttons, but not the caption bar. This allows you to continue monitoring the progress in the caption bar, and to see the queue again by clicking the minimize button turned restore button again.

Note that the email queue will send email in the background. This means that you can continue using EditPad Pro as usual, including composing new emails, while email is being sent. This is particularly useful when sending large attachments over a slow connection. The only function you cannot use is File|Exit .

See also:

  • EditPad Pro Main Menu
  • File Menu
  • File|Mail
  • File|Mail as Attachment
  • Email Preferences


File|Reload from Disk

Press F5 or select File|Reload from Disk from the menu to revert the active file to the status it had when it was last saved. This can be useful if you are viewing a file that is being written to by another program.

Note that if you switch tabs within EditPad or if you switch to another application and then back to EditPad, it will automatically check if the file on disk has been changed. If so, and you have not modified the file in EditPad, it will be automatically reloaded. If you did modify the file in EditPad, you will be asked if you want to keep the changes made in EditPad or reload from disk. In the Files Preferences , you can disable the automatic reload, or make EditPad always prompt before reloading.

If you click Keep Changes, EditPad will not reload the file, and will not overwrite the file on disk unless you use File|Save . If you want to keep both the changes you've made in EditPad and the modified copy of the file on disk, click the Keep Changes button, and then use File|Save As to save the changes in EditPad into a new file.

In addition, EditPad Pro gives you the option to see the difference between the file in EditPad and the file on disk. If you click the See Difference button, EditPad Pro invokes Extra|Compare with File on Disk . EditPad Pro will not reload the file, and will not ask you again to reload the file, until is is changed on disk again. If you want to reload the file from disk after looking at the differences, use the File|Reload from Disk menu item.

See also:

  • EditPad Pro Main Menu
  • File Menu


File|Save Copy As

File|Save Copy As ( Available in EditPad Pro only )

The Save Copy As command in the File menu works just like File|Save As . The only difference is that File|Save will continue to save the file using the original filename. The file name indicated by the tab does not change.

This command is very useful if you want to keep a backup copy or a milestone copy of a file. You can revert to this milestone copy if the changes you are about to make to the file turn out to be unfortunate. While EditPad can undo all changes you make to a file, even after you save the file, the undo information is lost when you close the file in EditPad, or close EditPad itself. Saving milestones is a wise precaution when editing important files.

See File|Save As for more information on how EditPad saves files.


File|Rename and Move

Use this function to move the active file into a different folder, and/or to change its filename.

This feature is similar to File|Save As , except that the original file will be deleted after the file has been saved under the new name, effectively "moving" the file.

See also:

  • EditPad Pro Main Menu
  • File Menu
  • File|Save As


File|Delete

After you confirm the warning message, File|Delete closes the active file and also deletes it from disk.

If Windows keeps a Recycle Bin for the drive the active file is on, it will be moved into the Recycle Bin awaiting its final fate.

See also:

  • EditPad Pro Main Menu
  • File Menu


File|Close

Closes the active file. If the file has unsaved modifications, depending on the choice you made in Files Preferences , EditPad will ask if you want to save, automatically save or automatically discard the changes.

If you closed the last file in the project, EditPad will automatically start with a new, blank file.

To close EditPad itself, click on the X button in the upper right of the Window.

See also:

  • EditPad Pro Main Menu
  • File Menu
  • File|Close All
  • File|Close All but Current


File|Close All

Select Close All in the File menu to close all open project and all open files. If any files have unsaved modifications, depending on the choice you made in Files Preferences , EditPad will ask if you want to save or not, automatically save or automatically discard the changes.

EditPad will start with a new untitled project , with one blank untitled file.

To close all files in the current project only, close the project itself with Project|Close Project . To close EditPad itself, click on the X button in the upper right of the Window.

See also:

  • File Menu
  • File|Close
  • File|Close All but Current
  • File|Exit
  • Project|Close Project


File|Close All but Current

Closes all files in the current project , except the one you're currently viewing. If any files have unsaved modifications, depending on the choice you made in Files Preferences , EditPad will ask if you want to save or not, automatically save or automatically discard the changes.

To close all files in all projects, except the current file, use Project|Close All but Current to close all other projects, and then File|Close All but Current to close all other files.

See also:

  • File Menu
  • File|Close
  • Project|Close Project
  • Project|Close All but Current


File|Exit

Closes all files and terminates EditPad. This will also remove the EditPad icon that is visible next to the system clock.

If you may be using EditPad again shortly, do not use File|Exit to close it, but click the X button in the upper right corner. This will also close all files and hide EditPad, but EditPad will stay active in the background and continue to show its icon next to the system clock.

See also:

  • EditPad Pro Main Menu
  • File Menu


Edit Menu

Edit|Undo

Edit|Redo

Edit|Cut

Edit|Cut Append

Edit|Copy

Edit|Copy Append

Edit|Paste

Edit|Swap with Clipboard (Available in EditPad Pro only)

Edit|Select All

Edit|Delete

Edit|Delete Line

Edit|Duplicate Line (Available in EditPad Pro only)

Edit|Insert Page Break (Available in EditPad Pro only)

Edit|Go to Line or Offset

Edit|Go to Previous Editing Position

Edit|Go to Matching Bracket

Edit|Insert Date & Time

See also:

  • EditPad Pro Main Menu


Edit|Undo

Use Edit|Undo to undo the last editing action. Repeat to undo more actions.

You can undo the undo with Edit|Redo if you do so right away. If you take any other action that is remembered by the undo function, the redo list will be cleared. (Unless it is a trivial action such as moving the cursor.)

If you put the undo button on the toolbar, you can undo several actions in one go via the drop-down menu of the undo button on the toolbar. When you select an action, that action and all actions listed above it in the drop-down menu will be undone at once. They will all be added to the redo list too.

The undo feature of EditPad Lite and Pro remembers all changes you made to any file since you opened it in EditPad. Saving a file does not clear the undo list.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Redo


Edit|Redo

If you change your mind after undoing an action with Edit|Undo , use Edit|Redo to redo it.

The redo function works exactly the same like the undo function, except that making any change to a file in any way except through Edit|Undo or Edit|Redo, will clear the redo list.

In contrast with other text editors, EditPad Lite and Pro will not clear the redo list when you take a trivial action such as moving the text cursor or making a selection. This gives you more opportunity to change your mind and redo undone actions.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Undo


Edit|Cut

Deletes the current selection and places it on the Windows clipboard. Use Edit|Copy to put the selection on the clipboard without deleting it. The text is always copied in Windows format, regardless of the format the active file has. If there is no current selection, the entire current paragraph is deleted and placed onto the clipboard.

Any data previously held by the clipboard is removed from it. Use Edit|Cut Append instead if you do not want this.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

If you're editing a file in hexadecimal mode , and you cut something from that file, and you paste that into another application or into a file you're editing in text mode in EditPad, the result will differ depending on whether the cursor was in the hexadecimal section or the ASCII section when you used Edit|Cut. If you cut from the hexadecimal section, and paste into another application, the other application will see the hexadecimal representation on the clipboard, e.g.: "74657374". If you cut from the ASCII section, the other application will see the actual bytes, e.g.: "test".

If you cut and paste between EditPad and another hex editing application, you may need to switch EditPad to hexadecimal mode an place the cursor in the hexadecimal or ASCII section of the editor to get the results you expect.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Cut Append
  • Edit|Copy
  • Edit|Paste
  • Edit|Swap with Clipboard
  • Block|Move
  • Block|Rectangular Selections


Edit|Cut Append

Deletes the current selection and places it on the Windows clipboard. Use Edit|Copy Append to do this without deleting the selection from EditPad. The text is always copied in Windows format , regardless of the format the active file has. If there is no current selection, the entire current paragraph is deleted and placed onto the clipboard.

If the clipboard holds text data, the selection is appended to the text already on the clipboard. Edit|Paste will then paste both the original text plus the selection appended to it.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Cut
  • Edit|Copy Append
  • Edit|Paste
  • Block|Rectangular Selections


Edit|Copy

Places the current selection on the Windows clipboard. The text is always copied in Windows format , regardless of the format the active file has. If there is no current selection, the entire current paragraph is placed onto the clipboard.

Any data previously held by the clipboard is removed from it. Use Edit|Copy Append instead if you do not want this.

If you select a block that includes one or more folded sections and copy the block to the clipboard, all selected lines, including lines hidden by folding, will be copied to the clipboard. Use Fold|Copy Visible Lines if you don't want to copy the hidden lines.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

If you're editing a file in hexadecimal mode , and you copy something from that file, and you paste that into another application or into a file you're editing in text mode in EditPad, the result will differ depending on whether the cursor was in the hexadecimal section or the ASCII section when you used Edit|Copy. If you copy from the hexadecimal section, and paste into another application, the other application will see the hexadecimal representation on the clipboard, e.g.: "74657374". If you copy from the ASCII section, the other application will see the actual bytes, e.g.: "test".

If you copy and paste between EditPad and another hex editing application, you may need to switch EditPad to hexadecimal mode an place the cursor in the hexadecimal or ASCII section of the editor to get the results you expect.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Cut
  • Edit|Copy Append
  • Edit|Paste
  • Block|Duplicate
  • Block|Rectangular Selections
  • Fold|Copy Visible Lines


Edit|Copy Append

Places the current selection on the Windows clipboard. The text is always copied in Windows format , regardless of the format the active file has. If there is no current selection, the entire current paragraph is placed onto the clipboard.

If the clipboard holds text data, the selection is appended to the text already on the clipboard. Edit|Paste will then paste both the original text plus the selection appended to it.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Cut
  • Edit|Copy
  • Edit|Paste
  • Block|Rectangular Selections


Edit|Paste

If you select Edit|Paste when the Window clipboard holds textual data, it will be inserted into the active file at the current position of the text cursor. If the active file is not in Windows format , the text on the clipboard will be automatically converted before it is inserted. The text that stays on the clipboard remains untouched.

If you want to paste a block of text from another application as a rectangular selection, first make a rectangular selection in EditPad, and then paste. EditPad will then interpret the text on the clipboard as a rectangular block and replace the selection with it. Text copied from EditPad Pro is always pasted in the way (linear or rectangular) you had it selected when you cut or copied it.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

In hexadecimal mode , if the clipboard contains a hexadecimal representation of characters, the effect of the Paste command depends on whether the text cursor is in the hexadecimal section at the left, or the ASCII section at the right. If you paste into the hexadecimal section, EditPad will paste the bytes represented by the text on the clipboard. If you paste into the ASCII section, EditPad will paste the text on the clipboard "as is". E.g. if the clipboard holds "74657374", pasting into the hex section inserts "test", while pasting into the ASCII section inserts "74657374" into the file.

If the text on the clipboard is not text with hexadecimal values, EditPad pastes the text regardless of whether the cursor is in the text or hexadecimal section. If the clipboard holds something you copied in hexadecimal mode in EditPad, EditPad will always paste the bytes that you copied, even if you moved the cursor from the ASCII to hex section or vice versa. If you copied text from a file in EditPad that you're editing in text mode, then the hex interpretation does take place.

If you copy and paste between EditPad and another hex editing application, you may need to switch EditPad to hexadecimal mode an place the cursor in the hexadecimal or ASCII section of the editor to get the results you expect.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Cut
  • Edit|Copy
  • Edit|Swap with Clipboard
  • Block|Rectangular Selections


Edit|Swap with Clipboard

Edit|Swap with Clipboard ( Available in EditPad Pro only )

If you select Edit|Swap with Clipboard when the Window clipboard holds textual data, it will be swapped with the current selection in the active file. That is, the selection is put on the clipboard as happens when you use Edit|Cut and then the text previously held by the clipboard is pasted into the text like Edit|Paste does.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Cut
  • Edit|Copy
  • Edit|Paste
  • Block|Rectangular Selections


Edit|Select All

Selects all the text in the current file.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu


Edit|Delete

Deletes the selected part of the current file.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Block|Rectangular Selections
  • Block|Move
  • Fold|Delete Folded Lines


Edit|Delete Line

Selects the line the text cursor is currently on, and deletes it. If the cursor is on the first line of a folded block of lines, indicated by a square with a + in it in the left margin, then all the lines folded underneath the current line are also deleted.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Edit|Delete


Edit|Duplicate Line

Edit|Duplicate Line ( Available in EditPad Pro only )

Duplicates the line the text cursor is on.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Block|Duplicate


Edit|Insert Page Break

Edit|Insert Page Break ( Available in EditPad Pro only )

Select Insert Page Break from the Edit menu or press Ctrl+Enter to insert a page break into the current file at the current position of the text cursor.

A page break will show up as a horizontal line while you edit the file in EditPad Pro. When you print the file, a new page will be started at the page break. The first paragraph below the horizontal line indicating the page break, will be the first paragraph on the new page.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • File|Print
  • Block|Print


Edit|Go to Line or Offset

When editing a text file, the Go to Line item in the Edit menu will ask you for a line number, and then move the text cursor to that line. You can enter the line number as a decimal number (just enter the number itself) or as a hexadecimal number (as 0xFF or FFh).

When editing a file in hexadecimal mode , the Go to Offset item in the Edit menu will ask you for a file offset, counting the number of bytes from the start of the file. You can enter the offset in hexadecimal, decimal, octal or binary notation. You don't need to format the number in any way (e.g. just enter FF for a hexadecimal offset). Just click the radio button with the notation you're using.

Whether going to a line or offset, you can prefix the line or offset number with a plus or minus sign. The sign makes the move relative to the current line or offset. If the cursor is at line 150, and you go to "100", the cursor is moved to line 100. If you enter "-100" it is moved to line 50, while +100 moves it to line 250. You can prefix numbers in any of the four notations with a sign. E.g. entering a hexadecimal offset "-F" moves the cursor fifteen bytes to the left.

See also:

  • Edit Menu
  • Edit|Go to Previous Editing Position


Edit|Go to Previous Editing Position

Select Go to Previous Editing Position in the Edit Menu to move the text cursor to the position in the current file where you last inserted or deleted some text. If the text cursor is already at that position, it will be moved to the position where you made the previous change. This makes it very comfortable to scroll through a file to look something up while editing, since you can always jump back to the editing position where you left off to continue editing.

If you use the Go to Previous Editing Position command a second time right after the first time, the cursor will be moved to the editing position before the previous one. If you use it a third time, the cursor will be moved to the editing position before that. This way you can quickly jump back to the last three spots where you edited something.

The fourth time, Go to Previous Editing Position will move the cursor back to the spot it was on when you first used the Go to Previous Editing Position command. It will do so even if you didn't edit anything at that location.

After that, the circle will repeat itself.

When working with multiple files, use View|Previously Edited File to cycle through the last files you've edited in a similar fashion. The Go to Previous Editing Position remembers the last three editing spots for each file independently, as long as you keep the file open in EditPad.

See also:

  • Edit Menu
  • View|Previously Edited File


Edit|Go to Matching Bracket

Edit|Go to Matching Bracket ( Available in EditPad Pro only )

On the Syntax & Navigation tab in the file type configuration , you can make EditPad Pro highlight matching brackets such as ( and ) for certain file types. When the text cursor is on a character that is considered a bracket by the syntax coloring scheme, then both that bracket and its matching counterpart are highlighted. In that situation, you can select Go to Matching Bracket from the Edit menu to move the text cursor to the matching bracket.

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • File Types Preferences, Syntax Coloring


Edit|Insert Date & Time

Inserts the current date and time at the position of the text cursor.

You can specify which format to use in the Editor Preferences .

See also:

  • EditPad Pro Main Menu
  • Edit Menu
  • Editor Preferences


Project Menu

Project Menu ( Available in EditPad Pro only )

Project|New Project

Project|Open Project

Project|Reopen

Project|Save Project

Project|Save All Files in Project

Project|Save Copy of Project As

Project|Rename and Move Project

Project|Close Project

Project|Close All but Current

Project|Open Folder

Project|Reopen Folder

See also:

  • EditPad Pro Main Menu
  • About EditPad Pro Projects


About EditPad Pro Projects

About EditPad Pro Projects ( Available in EditPad Pro only )

An EditPad Pro Project is a series of files that you can open all at once through Project|Open Project .

If you regularly work with a set of related files, it is convenient if you create a project file for them. You could have a project for your web site, for the source code of an application you are working on, the chapters of your next book, etc.

To create a project, first select Project|New Project from the menu. Then open all the files that should be in the project, and save the project with Project|Save Project As . From that point on, EditPad Pro will automatically maintain the project. Whenever you open new files into the project, or close files, the project's file list is updated.

EditPad Pro projects are intended as dynamic, virtual editing spaces, rather than a rigid list of files. Project files also keep track of the last editing position, bookmarks and editing options for each file in the project. When you reopen a project the next time you start EditPad Pro, it will be in exactly the same state as it was in when you last closed the project. EditPad Pro will not bother you with prompts to save the project.

You can have as many projects open at the same time as you want. Creating a new project or opening an existing one does not close the files or projects that you already have open. By default, once you have two or more projects open, a second row of tabs will appear above the row of tabs for files. The new row of tabs allows you to switch between open projects. The tabs for files will list only those files that are part of the active project. Tabs can be configured in the Tabs Preferences .

See also:

  • Project Menu
  • Project|New Project
  • Project|Open Project
  • Project|Save Project As
  • View|File Panel


Project|New Project

Select New Project in the Project menu to start with an untitled project containing a blank, untitled file.

An untitled project is simply a holding space for files. When working with lots of files at the same time, it's often handier to create a bunch of untitled, temporary projects to hold different sets of files. Instead of having one long row of tabs for all the files, you'll have one row of tabs for the projects, and one row of tabs showing only the files in the active project. It's often faster to switch between files by clicking on one project tab and on one file tab, than to scroll through a long list of file tabs.

If you regularly work with the same set of files,

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Open Project
  • Project|Save Project As
  • View|File Panel


Project|Open Project

Project|Open Project ( Available in EditPad Pro only )

Opens an EditPad Pro Project saved with Project|Save Project . The opened project will be added to the Project|Reopen menu.

Opening a project does not affect any files that you already have open. The opened project will sit side by side with the project holding the files you already have open. If you did not create or open a project yet, any files that you opened will be held by a temporary, untitled project.

If the project you're opening holds files that you've already opened in EditPad, their tabs will be moved into the newly opened project. The files themselves will otherwise remain untouched.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Save Project As
  • Project|Reopen


Project|Reopen Project

Project|Reopen Project ( Available in EditPad Pro only )

The Reopen submenu of the Project menu shows a list of EditPad Pro Projects recently saved with Project|Save Project , allowing you to reopen them quickly. If you add the Project|Open Project button to the toolbar , the reopen project menu is available as a drop-down menu to the open project button.

At the bottom of the menu, you will see the "Remove Obsolete" and "Remove All" items. The former will remove all files from the reopen menu that no longer exist, the latter will clear the entire reopen menu. To delete specific items, or to rearrange them, select Maintain Reopen List .

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Open Project
  • Project|Save Project
  • Maintain Reopen List


Project|Favorite Projects

Project|Favorite Projects ( Available in EditPad Pro only )

The Project|Favorite Projects menu works just like the File|Favorites menu, except that it will reference EditPad Pro project files rather than text files. You have to save a project before you can add it to the favorites.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Save Project As
  • File|Favorites


Project|Save Project As

Project|Save Project As ( Available in EditPad Pro only )

Select Save Project from the Project menu to save the current project under a different name. From that point on, EditPad Pro will automatically maintain the project, updating the file you saved it into. Whenever you open new files into the project, or close files, the project is updated. If the project was previously saved under another name, the old project file will not be updated unless you reopen the old file.

Therefore, you only need to use Save Project As when you want to save an untitled project, or you want to create a new copy of an already saved project. There is no need to repeatedly save projects under the same name to prevent losing changes like you would do with files.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Open Project
  • Project|Reopen
  • Project|Save Copy of Project As
  • Project|Rename and Move Project


Project|Save All Files in Project

Rapidly performs a File|Save for each open file in the current project.

For untitled files, File|Save As is invoked. If you click on Cancel in the save as dialog box, the save all function will not save any further files either.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • File|Save
  • File|Save As
  • File|Save All


Project|Save Copy of Project As

Select Save Copy of Project As to save the project under a new name, but continue updating the project under its original name. Use this command if you want to save a milestone copy of the project that you can go back to later. EditPad Pro will not keep the copy of the project updated along with the original. The new copy will stay as it is, until you open it or overwrite it when saving another project. By opening the copy of the project, you can go back to the project in the state it was in when you saved the copy.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Open Project
  • Project|Reopen
  • Project|Save Project As
  • Project|Rename and Move Project


Project|Rename and Move Project

Select Rename/Move Project in the Project menu to save the project under a new name, and delete the original project, effectively moving the project to a new location on disk.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Open Project
  • Project|Reopen
  • Project|Save Project As
  • Project|Save Copy of Project As


Project|Close Project

Closes the current project and all the files in the project. If any files in the project have unsaved modifications, depending on the choice you made in Files Preferences , EditPad will ask if you want to save or not, automatically save or automatically discard the changes.

When you close the last project, EditPad will automatically start with a new untitled project, with one blank untitled file.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Close All but Current


Project|Close All but Current

Closes all projects and all the files in them, except for the current project.. If any files in the projects being closed have unsaved modifications, depending on the choice you made in Files Preferences , EditPad will ask if you want to save or not, automatically save or automatically discard the changes.

See also:

  • About EditPad Pro Projects
  • Project Menu
  • Project|Close Project


Project|Open Folder

Project|Open Folder ( Available in EditPad Pro only )

Select Open Folder from the Project menu to open all files or files of a certain type from a particular folder.

You can type in the folder containing the files you want to open into the drop-down list at the top. If you have recently opened files from this folder, you can select it from the drop-down list. EditPad Pro will remember the last 16 folders. Another way to select the folder is to browse for it using the folder tree. The drop-down list and folder tree are automatically kept in sync.

Mark the option "recurse through subfolders" if you also want to open files contained in subfolders of the folder you selected.

If you want to open all files in the folder (and optionally its subfolders), select the "all files option". If you want to open only files from a certain type, you can select "files of type" and pick one of the file types from the drop-down list. The list will contain all the file types you defined in File Types Preferences . This will open all files that have an extension that matches one of the extensions you specified for the file type in the preferences.

To open files matching another list of extensions, select "file mask" and type in the list of extensions, separated by semicolons, into the "file mask" drop-down list. You can also select a recently used list from the drop-down list.

Note that Project|Open Folder does not create a new project. It will open all the files from the folder into the current project. If you want the files to get their own project tab , first use Project|New Project and then use Project|Open Folder.

See also:

  • EditPad Pro Main Menu
  • Project Menu
  • Project|Reopen Folder


Project|Reopen Folder

Project|Reopen Folder ( Available in EditPad Pro only )

The Reopen Folder submenu of the Project menu shows a list of folders from which you recently opened files through Project|Open Folder . When you select one of the folders from the Reopen Folder menu, EditPad Pro will open the files contained by that folder, using the same file mask and recurse option as you used in Project|Open Folder. If you have opened files from this folder more than once, the folder will appear only once in the Reopen Folder menu. The file mask and recurse option you used last time will be used again.

If you want to see the recurse option and file mask associated with each folder in the Reopen Folders menu, select " Maintain List " from the menu. You can then see the list of folders with their recurse options and file masks. You can open one of the folders as well as remove certain folders or rearrange them in the menu.

"Remove Obsolete Folders" will remove all folders that no longer exist from the Reopen Folders menu. EditPad Pro does not check whether the folders still contain any files matching the file mask. EditPad Pro only checks whether the folders themselves still exist. "Remove All Folders" will clear the Reopen Folders menu.

See also:

  • EditPad Pro Main Menu
  • Project Menu
  • Project|Open Folder


Search Menu

Search|Show Search Panel

Search Options

Search|Find First

Search|Find Next

Search|Find Previous

Search|Find Last

Search|Replace Current

Search|Replace and Find Next

Search|Replace and Find Previous

Search|Replace All

Search|Incremental Search (Available in EditPad Pro only)

Search|Instant Find Next (Available in EditPad Pro only)

Search|Instant Find Previous (Available in EditPad Pro only)

Search|Highlight All (Available in EditPad Pro only)

Search|Count Matches (Available in EditPad Pro only)

Search|Fold Lines (Available in EditPad Pro only)

Search|History

Search|Favorites (Available in EditPad Pro only)

Search|RegexBuddy (Available in EditPad Pro only)

Search|RegexMagic (Available in EditPad Pro only)

All of the commands in the Search menu can be used even when the search panel is invisible. This way you can close the search panel after you've entered the search term, to maximize the available editing space while searching.


Search|Show Search Panel

The Show Search Panel in the Search menu makes the search panel visible. It will also set the search text to whatever text is selected in the file you're editing. If the selected text is very long or spans multiple lines, it isn't used as the search term. In that case, the selection only option is turned on. If there is no selection, the word under the text cursor is used as the search term.

If you don't want the Show Search Panel command to change the search term or options, you can make that choice in the Editor Preferences .

After showing the search panel, you can adjust its size by dragging the splitter bar above the search panel. You can minimize or close the panel with the mouse by clicking the minimize or close button in the panel's upper right corner. To close the search panel with the keyboard, press the Escape key. This key is the default shortcut for View|Close All Panes .

Both the search and replace edit boxes are full-blown multi-line edit controls, just like EditPad's main editor. Press Shift+Enter on the keyboard to type in and search for or replace with a newline. To type in a tab, press Shift+Tab. To switch from search to replace and back, press Tab. Ctrl+Tab will activate the next file, as usual.

If you right-click on the search or replace edit box, you will see a list of the last 16 search or replace texts you used. Click on one to use it again.

The controls on the search panel do not have Alt+Letter shortcuts because those would conflict with the main menu. To invoke any search command with the keyboard, press Alt+S to open the Search menu . Then press the letter of the command you want. To set search options with the keyboard, press Ctrl+Shift+F to open the search options screen . Press the letter keys of the options you want to toggle, and press Enter.


Search Options

You can toggle EditPad's various search options in three ways:

  • Via the Search Options submenu of the Search menu , using either the mouse or Alt+Letter keyboard shortcuts.
  • Via the Search Options keyboard shortcut, Shift+Ctrl+F by default. A search options screen will pop up. Press the keys corresponding with the underlined letters in the search options. Press Enter to confirm or Escape to cancel the changes you made.
  • Via the checkboxes on the search and replace pane , by clicking on them with the mouse.

While EditPad has only one set of search options, it offers three ways to toggle them. Which way suits you depends mostly on whether you like to work with the keyboard or the mouse. Clicking with the mouse on the checkboxes is the most direct way, while the Search Options keyboard shortcut and screen allow you to keep your hands on the keyboard. The Search Menu can be accessed with the mouse or keyboard at any time, without sacrificing screen space for the search panel.

EditPad offers the following search options:

  • Regular Expression (Available in EditPad Pro only)
  • Dot Matches Newline (Available in EditPad Pro only)
  • Case Sensitive
  • Adapt Case (Available in EditPad Pro only)
  • Whole Words Only
  • All Files
  • All Projects (Available in EditPad Pro only)
  • Selection Only
  • Loop Automatically


Search|Find First

Click the Find First button on the search panel or select the Find First item in the Search menu to find the first search match. If the " selection only " option is on, Find First starts searching from the start of the search range. If " all files " is on, Find First starts searching from the start of the first file in the current project . If " all projects " is on, Find First starts searching from the start of the first file in the first project. If none of these three options are on, Find First starts searching from the start of the current file.

If the search term can be found, EditPad will switch to the file it was found in, and select the matched text. If the search term cannot be found, nothing will happen, except that the Find First button will briefly flash its icon to indicate it failed.

In EditPad Pro, the Find First button on the search panel has a drop-down menu. This drop-down menu has three items that you can use to find a specific search match, counting search matches from the start. The Find 10th item will find the 10th search match. It start searching from the beginning to find the first search match, and immediately continues to find the second, third etc. until it arrives at the 10th match. The 10th match will then become selected. If there are less than 10 search matches, nothing will happen, and the Find First button will briefly flash its icon to indicate the search failed. Similarly, the Find 100th item will skip the first 99 search matches and select match #100.

The Find Nth item will ask you for the number of the match you want to find. If you enter 42, EditPad will skip the first 41 search matches, and highlight the 42nd.

See also:

  • Search Menu
  • Search|Show Search Panel


Search|Find Next

Click the Next button on the search panel or select the Find Next item in the Search menu to find the next search match. Find Next starts searching from the current position of the text cursor in the current file. If the " selection only " option is on, Find Next searches until the end of the search range. If " all files " is on, Find Next searches until the end of the file and then continues at the start of the next file until a search match is found. If " all projects " is on, and Find Next reaches the last file in the current project, Find Next will continue with the next project.

If the search term can be found, EditPad will switch to the file it was found in, and select the matched text. If the search term cannot be found, nothing will happen, except that the Next button will briefly flash its icon to indicate it failed.

In EditPad Pro, the Next button on the search panel has a drop-down menu. The first item in the drop-down menu is Find in Next File. When you select this item, EditPad will start searching from the start of the next file. You can use Find in Next File even when the " all files " option is off. If the search term cannot be found in the next file, and one or more of the " all files ", " all projects " and " loop automatically " options are on, EditPad will continue the search just like the Find Next command itself.

The drop-down menu also has three items that you can use to find a specific search match, counting search matches from the start. The Find 10th Next item will skip over the next 9 search matches and highlight the 10th. The result is the same as if you had clicked the Next button 10 times. If there are no further 10 search matches, the result is slightly different. Find Next 10th will then not do anything, except flash the Next button to indicate failure. Similarly, the Find 100th Next item will skip the next 99 search matches and select match #100.

The Find Nth Next item will ask you for the number of the match you want to find. If you enter 42, EditPad will skip the next 41 search matches, and highlight the 42nd.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Find Previous


Search|Find Previous

Click the Previous button on the search panel or select the Find Previous item in the Search menu to find the previous search match. Find Previous starts searching from the current position of the text cursor in the current file. If the " selection only " option is on, Find Previous searches until the start of the search range. If " all files " is on, Find Previous searches until the start of the file and then continues at the end of the previous file until a search match is found. If " all projects " is on, and Find Previous reaches the first file in the current project, Find Previous will continue with the previous project.

If the search term can be found, EditPad will switch to the file it was found in, and select the matched text. If the search term cannot be found, nothing will happen, except that the Previous button will briefly flash its icon to indicate it failed.

The Find Previous command is not available in regular expression mode. Regular expressions cannot search backwards.

In EditPad Pro, the Previous button on the search panel has a drop-down menu. The first item in the drop-down menu is Find in Previous File. When you select this item, EditPad will start searching from the end of the previous file. You can use Find in Previous File even when the " all files " option is off. If the search term cannot be found in the previous file, and one or more of the " all files ", " all projects " and " loop automatically " options are on, EditPad will continue the search just like the Find Previous command itself.

The drop-down menu also has three items that you can use to find a specific search match, counting search matches from the start. The Find 10th Previous item will skip over the next 9 search matches and highlight the 10th. The result is the same as if you had clicked the Previous button 10 times. If there are no 10 preceding search matches, the result is slightly different. Find 10th Previous will then not do anything, except flash the Previous button to indicate failure. Similarly, the Find 100th Previous item will skip the previous 99 search matches and select match #100.

The Find Previous Nth item will ask you for the number of the match you want to find. If you enter 42, EditPad will skip the 41 preceding search matches, and highlight the 42nd.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Find Next


Search|Find Last

Select the Find Last item in the Search menu to find the last search match. If the " selection only " option is on, Find Last starts searching from the end of the search range. If " all files " is on, Find Last starts searching from the end of the last file in the current project . If " all projects " is on, Find Last starts searching from the end of the last file in the first project. If none of these three options are on, Find Last starts searching from the end of the current file. Find Last searches backwards until a match is found.

If the search term can be found, EditPad will switch to the file it was found in, and select the matched text. If the search term cannot be found, nothing will happen, except that the First button on the search panel will briefly flash its icon to indicate it failed. Since there's no Last button, the First button flashes instead.

In EditPad Pro, the Find Last command is also available through the drop-down menu of the First button on the search panel's toolbar.

The Find Last command is also available in regular expression mode, even though regular expressions cannot search backwards. Instead of starting at the end of the file, EditPad Pro starts searching at the start of the file and searches forward, skipping over all regex matches until it finds the last one. This means the Find Last command will be noticeably slower on large files when used with a regular expression rather than a plain search term.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Find First


Search|Replace Current

Click the Replace button on the search panel or select the Replace Current item in the Search menu to replace the selected search match with the replacement text.

See also:

  • Search Menu
  • Search|Show Search Panel


Search|Replace and Find Next

Click the Next button to the right of the Replace button on the search panel or select the Replace and Find Next item in the Search menu to replace the selected search match with the replacement text, and to immediately continue searching for the next search match. This button is a shortcut to clicking the Replace button followed by clicking the Find Next button .

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Replace Current
  • Search|Find Next


Search|Replace and Find Previous

Click the Previous button to the right of the Replace button on the search panel or select the Replace and Find Previous item in the Search menu to replace the selected search match with the replacement text, and to immediately continue searching for the previous search match. This button is a shortcut to clicking the Replace button followed by clicking the Find Previous button .

The Replace and Find Previous command is not available in regular expression mode. Regular expressions cannot search backwards.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Replace Current
  • Search|Find Previous


Search|Replace All

Click the Replace All button on the search panel or select the Replace All item in the Search menu to find the first search match. Replace All starts searching from the beginning just like Find First does. If it finds a match, it replaces it like Replace Current would, and then continues searching like Find Next would, replacing all further search matches.

The only difference between clicking Replace All and using all the individual action buttons is that Replace All is silent. It will simply replace all matches without moving the selection or the text cursor. Even when searching through all projects or all files, the current file will remain active throughout the operation.

If no search matches can be found, EditPad will briefly flash the Replace All button's icon to indicate failure. If you used the keyboard shortcut to do the Replace All with the search panel hidden, check the status bar for the result.

If there are a lot of search matches, replacing them all might take a while. The status bar will indicate EditPad's progress.

In EditPad Pro, the Replace All button on the search panel has a drop-down menu with two items: Replace All Next and Replace All Previous. Replace All Next performs the search-and-replace on the part of file after the position of the text cursor. If a search match is already highlighted, that match is replaced too. Effectively, Replace All Next does in one click what you can do by clicking Replace and Find Next until no further matches can be found.

The Replace All Previous button does the same, except that is searches backwards, performing the search-and-replace on the part of the file before the position of the text cursor. If a search match is already highlighted, that match is replaced too. Replace All Previous is not available in regular expression mode. Regular expressions cannot search backwards.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Replace Current
  • Search|Replace and Find Next
  • Search|Replace and Find Previous


Search|Incremental Search

Search|Incremental Search ( Available in EditPad Pro only )

Click the Incremental button on the search panel or select the Incremental item in the Search menu to toggle incremental search mode on or off. When off, entering a search term has no immediate effect. When on, editing the search term will cause EditPad Pro to immediately start looking for the next search match, starting from the current position of the text cursor.

While you edit the search term in incremental search mode, EditPad Pro remembers previous search matches as you type. If you type "Test", EditPad Pro will search for "T" starting from the position of the text cursor. As you type, it will search for "Te" beginning at the start of the match for "T", then for "Tes" at the start of the match for "Te", and finally for "Test". If there is no search match, nothing happens.

When you press Backspace, EditPad Pro will go back to the previously highlighted match for "Tes". If you continue pressing Backspace, it will go back to the match for "Te", "T", and finally go back to where the search started. So while typing in the search term, you can easily change your mind about the search term you're looking for by backing up with the Backspace key, and typing in the new search term. Backing up does not cause EditPad Pro to forget match positions. If you type in "Joe" after erasing "Test", EditPad Pro will search for "J" until "Joe" beginning from the original starting position. If you then back up again and retype "Test", the match previously found for "Test" is highlighted.

What does cause EditPad Pro to forget previous incremental search matches is taking any action in the main editor, including something as trivial as moving the text cursor or switching to another file. EditPad Pro will then move the starting position for the next incremental search to the new position of the text cursor.

The incremental search mode respects all search options, including " all files ", " selection only ", " loop automatically ", etc.

See also:

  • Search Menu
  • Search|Show Search Panel


Search|Instant Find Next

Search|Instant Find Next ( Available in EditPad Pro only )

The Instant Find Next command doesn't have a button on the search panel because it doesn't use the search term you've entered on the search panel or any of the search options. It is listed in the Search menu , primarily so you can assign it a keyboard shortcut in the Keyboard Preferences . The default shortcut is Ctrl+Alt+ArrowDown, which is the most instant way of doing an Instant Find Next.

Instant Find Next looks for the next occurrence in the current file of the word under the text cursor. When the word is found, Instant Find Next selects it. If there is no word under the text cursor, or it doesn't occur again in the file, nothing happens at all. If some text is selected when you invoke Instant Find Next, and the selection does not span more than one line, Instant Find Next will search for the selected text rather than the word under the cursor.

The purpose of Instant Find Next and Search|Instant Find Previous is to quickly "walk" through the file, stopping at each spot where the word occurs. Since a successful match selects the word that was searched for, you can instantly search for further matches.

See also:

  • Search Menu
  • Search|Instant Find Previous


Search|Instant Find Previous

Search|Instant Find Previous ( Available in EditPad Pro only )

Instant Find Previous works just like Instant Find Next , except that it searches backwards through the current file, starting at the current position of the text cursor, or the start of the selection (if any). If you press Instant Find Previous as many times as you pressed Instant Find Next, or vice versa, you'll be back where you started.

See also:

  • Search Menu
  • Search|Instant Find Next


Search|Highlight All

Search|Highlight All ( Available in EditPad Pro only )

Click the Highlight button on the search panel or select the Highlight All item in the Search menu to turn on the search match highlighting mode. In this mode, all search matches will be highlighted. You can configure the "highlighted search match" color in the Colors Preferences .

When you switch between files, search matches in the newly activated line will be highlighted, regardless of the "all files " setting. To stop highlighting search matches, simply click the Highlight button again.

While search matches are highlighted, live spelling is disabled. Highlighting both search matches and misspelled words would clutter the display. When you turn off the highlighting of search matches, live spelling is automatically re-enabled.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Count Matches
  • Search|Fold Lines
  • Extra|Live Spelling


Search|Count Matches

Search|Count Matches ( Available in EditPad Pro only )

Click the Count button on the search panel or select the Count Matches item in the Search menu to count all search matches. Count Matches starts searching from the beginning just like Find First does. Then it continues searching like Find Next would, until the search fails. None of the search matches will be selected. After the search, Count Matches will tell you how many matches it found.

If there are no search matches at all, EditPad will briefly flash the Count button's icon to indicate failure. If there are a lot of search matches, counting them all might take a while. The status bar will indicate EditPad's progress.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Highlight All
  • Search|Fold Lines


Search|Fold Lines

Search|Fold Lines ( Available in EditPad Pro only )

Click the Fold button on the search panel or select the Fold Lines item in the Search menu to fold all lines in which the search term cannot be found underneath lines in which it can be found. The result is that only lines in which the search term can be found will remain visible. The exception is the very first line in the file, which will remain visible even if it doesn't have any search matches. All lines until the first line with a search match will be folded underneath the very first line in the file.

If there are no search matches at all, EditPad will briefly flash the Count button's icon to indicate failure. If there are a lot of search matches, folding them all might take a while. The status bar will indicate EditPad's progress.

Using Fold Lines together with Highlight All is a very quick way to get a condensed view of all the matches in the file. Unlike the match highlighting mode, Fold Lines is automatically disabled when you switch between files, or edit the search term. Click the Fold button again to refold the current file. Folding a file based on search matches deletes all automatic folding points , and all folding points that you created . When you disable the search match folding, new automatic folding points will appear. Also unlike match highlighting, which instantly updates itself, the folding is not updated as you insert or delete the search term while you edit the file.

After folding the lines with search matches, you can use Fold|Copy Visible Lines to copy the lines with search matches to the clipboard, and Fold|Delete Folded Lines to delete the lines without search matches. However, since folding keeps the first line visible, the very first line in the file will be copied or remain behind, even if it doesn't have any search matches.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Highlight All
  • Search|Count Matches
  • Fold|Copy Visible Lines
  • Fold|Delete Folded Lines


Search|History

Click the History button on the search panel to switch between the currently displayed search term and search options, and the ones you used before. This way you can easily work with two search actions. E.g. if you need to do a search-and-replace in several blocks in a file, and you want to find the block by searching for another word, first search for the word and then do the search-and-replace in the first block. Then click the History button to instantly get back the search term. Find the second block, and click the History button again to get the search-and-replace search term and options.

EditPad's search function remembers up to 16 search settings. You can access them via the History submenu in the Search menu , and via the drop-down menu of the History button on the search panel. Pick a search term from the menu to use it again. All the search options will also be set the way they were when you last used the search term you just picked from the history.

If you only want to recall the search text or the replacement text, without changing any of the search options, right-click on the search box or replace box. The right-click menu will list the last 16 search texts or replacement texts.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|Favorites


Search|Favorites

Search|Favorites ( Available in EditPad Pro only )

If you regularly use a particular search term, you should add it to your search favorites. To do so, select Search|Favorites|Add Search Term in the menu. Or, click on the downward pointing arrow next to the Favorites button on the search panel, and select Add Search Term in the drop-down menu. The search text, replacement text, and all search options will be stored in the favorites.

This is particularly useful for regular expressions , which can be complex and hard to remember. Since you cannot assign a label to search favorites, you should put a comment at the start of the regular expression. E.g. add "(?#comment)regex" instead of "regex" to the favorites. That'll make it easier to remember later what the regular expression was for.

If you click directly on the Favorites button rather than the arrow next to it, the Organize Favorites screen will appear. Select a search term and click on the Use button to set the search text, replacement text and search options to those stored in the favorites item. Click the Remove button to delete a favorite.

With the New Folder and Rename Folder, you can organize your favorite search terms into folders. Organizing favorites into folders makes it easier to retrieve the search term you want. To move favorites into a folder, simply drag-and-drop them with the mouse.

See also:

  • Search Menu
  • Search|Show Search Panel
  • Search|History


Search|RegexBuddy

Search|RegexBuddy ( Available in EditPad Pro only )

Use regular expressions with EditPad Pro's search and replace to automate many editing task that would be tedious to do manually. The regex syntax is quite terse, making complex regular expressions sometimes difficult to interpret.

To alleviate this complexity, we have developed a new product called RegexBuddy. RegexBuddy makes it very easy to write and edit regular expressions. Use RegexBuddy's detailed and descriptive regex tree, and the easy-to-grasp regex building blocks instead of or in combination with the regex syntax to define your search patterns.

Click the RegexBuddy button on the search panel or select the RegexBuddy item in the Search menu to start RegexBuddy. The search and replace texts you entered in EditPad Pro are automatically sent to RegexBuddy for editing. When you have prepared the new regular expression and replacement text, click the Send button in RegexBuddy. RegexBuddy will then close and send the new texts to EditPad Pro. If you change your mind, close RegexBuddy without clicking the Send button.

You can also use RegexBuddy to test your search patterns in a safe and intuitive sandbox. Very handy is the ability to collect your own libraries of regular expressions. Or use RegexBuddy's standard library of regular expressions for common search patterns.

You can use RegexBuddy in combination with EditPad Pro, as well as with any other application you use regular expressions with. If you are a programmer, RegexBuddy has full support for a variety of programming languages and regex libraries.

See http://www.regexbuddy.com for more information about RegexBuddy.

Please note that RegexBuddy is a separate product. If you want to use RegexBuddy with EditPad Pro, you will need to purchase both products.


Search|RegexMagic

Search|RegexMagic ( Available in EditPad Pro only )

Use regular expressions with EditPad Pro's search and replace to automate many editing task that would be tedious to do manually. The regex syntax is quite terse, making complex regular expressions sometimes difficult to interpret.

To make it easy to create regular expressions, we have developed RegexMagic. Instead of dealing with the cryptic regular expression syntax, use RegexMagic's powerful patterns for matching characters, text, numbers, dates, times, email addresses, URLs, card numbers, etc. RegexMagic can detect these patterns when you mark your sample text. You can combine multiple patterns to match exactly what you want.

Click the RegexMagic button on the search panel or select the RegexMagic item in the Search menu to start RegexMagic. When you have generated the new regular expression and replacement text, click the Send button in RegexMagic. RegexMagic will then close and send the new regulare expression to EditPad Pro. If you change your mind, close RegexMagic without clicking the Send button.

Use RegexMagic in combination with EditPad Pro, as well as any other application you use regular expressions with. RegexMagic supports all popular regular expression flavors. If you are a programmer, RegexMagic has full support for a variety of programming languages and regex libraries.

See http://www.regexmagic.com for more information about RegexMagic.

Please note that RegexMagic is a separate product. If you want to use RegexMagic with EditPad Pro, you will need to purchase both products.


Block Menu

Block|Duplicate (Available in EditPad Pro only)

Block|Move (Available in EditPad Pro only)

Block|Indent

Block|Outdent

Block|Move Lines and Columns (Available in EditPad Pro only)

Block|Comment (Available in EditPad Pro only)

Block|Uncomment (Available in EditPad Pro only)

Block|Toggle Comment (Available in EditPad Pro only)

Block|Prefix (Available in EditPad Pro only)

Block|Suffix (Available in EditPad Pro only)

Block|Fill Columns (Available in EditPad Pro only)

Block|Rectangular Selections (Available in EditPad Pro only)

Block|Begin Selection (Available in EditPad Pro only)

Block|End Selection (Available in EditPad Pro only)

Block|Expand Selection (Available in EditPad Pro only)

Block|Go to Beginning (Available in EditPad Pro only)

Block|Go to End (Available in EditPad Pro only)

Block|Insert File

Block|Write

Block|Append

Block|Print

See also:

  • EditPad Pro Main Menu


Search Option: Regular Expression

Search Option: Regular Expression ( Available in EditPad Pro only )

EditPad Pro's search-and-replace module includes a full-featured regular expression engine. Its regular expression flavor is compatible with Perl, Java and .NET. To search using a regular expression, simply turn on the regular expression search option .

When using capturing groups in a regular expression, you can insert the groups' contents in the replacement text using backreferences \0, \1, \2, etc. \0 inserts the whole regex match, while \1 inserts the text matched by the first capturing group, \2 the second group, etc. EditPad Pro supports up to 99 backreferences. If you want to insert a backreference followed by a literal number into the replacement text, use two digits for the backreference. The replacement text \015 will replace the regex match with the contents of the first backreference followed by the digit 5.

Note that the regex engine is very strict about newlines, which are in fact a \r\n pair in Windows and not just \n. I recommend you press Shift+Enter to type in an actual newline instead of using \r and/or \n. EditPad Pro will automatically replace the actual newline with the appropriate line terminator depending on the current file's type.

In EditPad Pro, the caret and dollar always match at the start and the end of a line, in addition to the start and the end of a file. EditPad Pro does not have an option to change this. To match the start or the end of the file only, use \A or \z instead. The behavior of the dot can be changed with the " dot matches newline " option.

See also:

  • Search|Show Search Panel
  • Search Options
  • Search Option: Dot Matches Newline


Search Option: Dot Matches Newline

Search Option: Dot Matches Newline ( Available in EditPad Pro only )

When searching for a regular expression , you can turn on the "dot matches newline" search option to make the dot match any character, including line break characters.

In EditPad Pro, the caret and dollar always match at the start and the end of a line, in addition to the start and the end of a file. EditPad Pro does not have an option to change this. To match the start or the end of the file only, use \A or \z instead.

See also:

  • Search|Show Search Panel
  • Search Options
  • Search Option: Regular Expression


Search Option: Case Sensitive

If you turn on the "case sensitive" search option , the difference between lowercase and uppercase letters is taken into account. E.g. "Dog" will considered to be different from "dog". Otherwise, "dog", "Dog", "DOG", and even "doG" are all the same. Turning on this option also improves the speed at which EditPad can do its search.

See also:

  • Search|Show Search Panel
  • Search Options
  • Search Option: Adapt Case


Search Option: Adapt Case

Search Option: Adapt Case ( Available in EditPad Pro only )

When the " case sensitive " option is off, you can turn on the "adapt case" search option . When you do so, EditPad Pro will adapt the casing of the replacement text to the casing of the search match to be replaced. EditPad Pro recognizes four casings: all uppercase, all lowercase, first letter capitalized, and first letter of each word capitalized. If EditPad Pro doesn't recognize the casing, the replacement text is used exactly as you entered it.

E.g. when searching for "My DoG" and replacing with "My CaT", then "my dog" will be replaced with "my cat" (all lowercase), "MY DOG" with "MY CAT" (all uppercase), "My dog" with "My cat" (first letter capitalized) and "My Dog" with "My Cat" (first letter of each word capitalized). If EditPad Pro doesn't recognize the casing, e.g. "my DOG", then "My CaT" is substituted the way you entered it.

See also:

  • Search|Show Search Panel
  • Search Options
  • Search Option: Case Sensitive


Search Option: Whole Words Only

Turn on the "whole words only" search option if only entire words should be valid search results. If this option is on, when looking for "cat", EditPad will not consider the first three letters of "category" a valid search match. Otherwise, it will.

See also:

  • Search|Show Search Panel
  • Search Options


Search Option: All Files

Turn on the "all files" search option to search through all files in the current project . If a search command cannot find a match in the current file, it will automatically continue with the next file until either a match is found, or all files have been searched through.

The Fold Lines search command always works on the current file only, regardless of the "all files" option. The Highlight All option is a global toggle that will always highlight the current file, even when you switch files, until you turn it off, regardless of the "all files" option. All the other search commands respect the "all files" option as explained above.

See also:

  • Search|Show Search Panel
  • Search Options
  • Search Option: All Projects


Search Option: All Projects

Search Option: All Projects ( Available in EditPad Pro only )

To search through all files in all projects, turn on the "all projects" search option . If a search command cannot find a match in the current file, it will automatically continue with the next file. When all files in the current project have been searched through, EditPad Pro will continue with the first file in the next project. EditPad Pro will continue searching until either a match is found, or all files in all projects have been searched through.

The Fold Lines search command always works on the current file only, regardless of the "all projects" option. The Highlight All option is a global toggle that will always highlight the current file, even when you switch files, until you turn it off, regardless of the "all projects" option. All the other search commands respect the "all projects" option as explained above.

See also:

  • Search|Show Search Panel
  • Search Options
  • Search Option: All Files


Search Option: Selection Only

Turn on the "selection only" search option to search only through the selected part of the current file.

When you invoke a search command like Find First with this option on, the selection will be turned into the search range. The search range is highlighted in a different color than the selection. You can configure both the "selected text" and "search range" colors in the Colors Preferences .

If a search match is found, that search match will become selected. You can then edit the search match or any part of the file inside or outside the search range. As long as you don't turn off the "selection only" search option, the search range will remain highlighted.

When you invoke the next search command, and there already is a search range, EditPad will either search through the existing search range when no text is selected, or when the selection falls entirely inside the search range. If some of the text outside the search range is selected, EditPad will use the selection as the new search range.

In practice, this mechanism is very intuitive. When you search, EditPad selects the search match, which always falls inside the search range. So you can click Search|Find Next and Search|Find Previous without paying much attention to the search range. It will stay put. When you want to search through a different part of the file, simply select it, make sure "selection only" is on, and search. You don't need to check whether there was a search range already. EditPad will search through the block of text that you selected.

See also:

  • Search|Show Search Panel
  • Search Options


Search Option: Loop Automatically

Turn on the "loop automatically" search option if you want Find Next , Find Previous , Replace and Find Next and Replace and Find Previous to automatically restart searching from the start or end of the file when no further search matches can be found. If the " all files " option is on, EditPad will restart from the first file (find next) or last file (find previous) in the project. If "all projects" is also on, EditPad will restart from the first file in the first project (find next), or the last file in the last project (find previous).

When EditPad finds a match after having looped (i.e. restarted from the start or end), then the glyph on the search command button that you clicked will flash briefly, showing a "looped" glyph.

See also:

  • Search|Show Search Panel
  • Search Options


Block|Duplicate

Block|Duplicate ( Available in EditPad Pro only )

Select Duplicate from the Block menu to insert a copy of the selected text at the current position of the text cursor. The newly inserted copy will become the selected text.

This command is intended to be used with persistent selections . Only when selections are persistent, you can move the text cursor without clearing the selection.

Selecting text, moving the text cursor, and invoking Block|Duplicate has the same effect as selecting text, invoking Edit|Copy , moving the text cursor, and invoking Edit|Paste . The only difference is that Block|Duplicate does not use the clipboard, so the contents of the clipboard are preserved.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Block Menu
  • Block|Move
  • Persistent Selections


Block|Move

Block|Move ( Available in EditPad Pro only )

Select Move from the Block menu to delete the selected text and insert it again at the current position of the text cursor. Block|Move will only become enabled when you have enabled persistent selections in the Editor Preferences . Only when selections are persistent, you can move the text cursor without clearing the selection.

Selecting text, moving the text cursor, and invoking Block|Move has the same effect as selecting text, invoking Edit|Cut , moving the text cursor, and invoking Edit|Paste . The only difference is that Block|Move does not use the clipboard, so the contents of the clipboard are preserved.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • EditPad Pro Main Menu
  • Block Menu
  • Block|Duplicate
  • Persistent Selections


Block|Indent

Select Indent from the Block menu to insert a certain number of spaces at the start of each line in the selected portion of the current file. How many spaces are inserted depends on the "block indent" setting for the type of file you are editing. You can change this setting on the Editor page in the file type configuration . If the "block indent" setting is an integer multiple of the "tab size" setting, and the option "tab inserts spaces" is off, Block|Indent will use tab characters instead of spaces to indent the selection.

If the selection spans more than one line, you can also indent it by pressing Tab on the keyboard. The difference between using Block|Indent and the Tab key is that Block|Indent uses the "block indent" setting while Tab uses the "tab size" setting to determine the amount of indent. If "tab inserts spaces" is off, pressing tab will indent the selection by inserting exactly one tab character at the beginning of each paragraph.

Note that if word wrap is on, only the first line of each paragraph will be indented. Wrapped lines are only indented along with the first line if you've turned on Options|Indent Wrapped Lines .

If a rectangular block is selected, Block|Indent works differently. Instead of indenting the selected lines by inserting spaces or tabs at the start of the line, it will insert the spaces immediately before the first column in the selection, effectively shifting the block a number of spaces to the right.

See also:

  • Block Menu
  • Block|Outdent
  • Block|Move Lines and Columns


Block|Outdent

Select Outdent from the Block menu to outdent or unindent each line in the selected portion of the current file. EditPad does this by deleting a certain number of spaces from the start of each line. How many spaces are inserted depends on the "block indent" setting for the type of file you are editing. You can change this setting on the Editor page in the file type configuration . If there are not that many spaces at the beginning of a certain line, all the spaces at the beginning of that line will be deleted. But the other lines will still be outdented by the specified amount.

If the selection spans more than one line, you can also outdent it by pressing Shift+Tab on the keyboard. The difference between using Block|Outdent and the Tab key is that Block|Outdent uses the "block indent" setting while Tab uses the "tab size" setting to determine the amount.

If a rectangular block is selected, Block|Outdent works differently. Instead of deleting spaces or tabs at the start of the line, it will delete spaces and tabs immediately to the left of the first column in the selection, effectively shifting the block a number of spaces to the left. Spaces inside the selected block will not be deleted.

See also:

  • Block Menu
  • Block|Indent
  • Block|Move Lines and Columns


Block|Move Lines and Columns

The Move Lines and Columns submenu of the Block menu lists various commands for shifting blocks of text around.

When you've made a linear selection (a selection that follows the flow of the text), you can only move lines. Lines will be moved entirely. If the first and/or last line in the selection are only partially selected, the selection will first expand itself to include those lines entirely. When moving the block one line up, the block and the line above it will swap places. After the action, the unselected line that was above the block will be below it. Moving the block one line down does the opposite.

When you've made a rectangular selection , only the selected columns are moved. When moving the rectangular block one line up, the columns spanning the width of the selection in the line above the selection are removed. Then the selected block is moved up one line, filling up the space created by removing part of the line that was above the selection. The removed characters are then reinserted in the empty space created on the line that use to be the last line in the selection. If the line above the block did not have any characters to remove, spaces are inserted into the last line instead. The original block will remain selected, now positioned one line higher in the file. Moving a rectangular block one line down does the opposite.

Rectangular selections can also be shifted to the left or the right. When shifting a block to the left, the character immediately to the left of the block on each line partially selected by the block is removed. This character is then reinserted on the same line immediately to the right of the block. The original block will remain selected, now positioned one column closer to the left. When shifting a block to the right, the character immediately to the right of the block is removed, and reinserted to the left of the block. If there is no character to the right of the block on a particular line, a space is inserted to the left of the block instead. You can shift a block as far out to the right as you want.

If no text is selected at all, you can still use the commands to move lines up or down. Then, the line containing the text cursor will be selected and moved.

See also:

  • Block Menu
  • Block|Outdent
  • Block|Indent
  • Block|Outdent


Block|Comment

Block|Comment ( Available in EditPad Pro only )

Select Comment from the Block menu to comment out a piece of code in a source code file.

If the current file is being syntax colored by a syntax coloring scheme that contains a character string for single line comments, Block|Comment will automatically comment out the using those characters. If you've made a selection that flows along with the text, the comment characters will be inserted at the very start of the line. If you've made a rectangular selection, the comment characters will be inserted on each line spanned by the selection, at the leftmost column in the selection. This is exactly what Block|Prefix also does, except that Block|Comment automatically uses the characters to comment out something based on the syntax coloring scheme.

If the syntax coloring scheme does not define characters for single line comments, but does define characters for multi-line comments, Block|Comment will use the characters that open and close a comment on each line in the selection. If the selection is rectangular, they're inserted immediately before and after the selected columns. Otherwise, they're inserted at the start and end of each selected line.

If the current file type does not use a syntax coloring scheme, or the scheme does not define any characters to comment out something, Block|Comment will ask you for the characters to be inserted at the start of each line, just like Block|Prefix would.

If you did not select any text before using the Block|Comment command, or the selection does not span more than one line, Block|Comment will place the comment characters at the very start of the line containing the text cursor. The text cursor is then moved to the next line. If you've assigned a keyboard shortcut to Block|Comment, you can quickly comment out a bunch of lines this way.

To remove the comment characters inserted by Block|Comment, use Block|Uncomment or Block|Toggle Comment .

See also:

  • Block Menu
  • Block|Rectangular Selections
  • Block|Uncomment
  • Block|Toggle Comment


Block|Uncomment

Block|Uncomment ( Available in EditPad Pro only )

Select Uncomment from the Block menu to remove the comment characters added by Block|Comment . When you've made a selection that flows with the text, Block|Uncomment will remove the comment characters from the very start of the line only. Comment characters in the middle of a line are left. When you've made a rectangular selection , only comment characters starting at the first selected column will be removed. Comment characters at other columns are left.

If the syntax coloring scheme does not define opening and closing characters for comments, Block|Uncomment will try to remove the pair from the start and the end of each line when the selection flows with the text. When making a rectangular selection, it should include both the opening characters and closing characters on each line. Only comment characters inside and at the edge of the selected block will be removed.

Though Block|Uncomment requires you to be a bit precise when selecting the block to be uncommented, this makes it possible to comment out blocks that already have comments in them, and then uncomment those blocks while leaving the original comments.

If you did not select any text before using the Block|Uncomment command, or the selection does not span more than one line, Block|Uncomment will attempt to remove comment characters at the very start of the line containing the text cursor. Whether any comment characters were removed or not, it will then move the text cursor to the next line. If you've assigned a keyboard shortcut to Block|Uncomment, you can quickly uncomment a bunch of lines this way.

See also:

  • EditPad Pro Main Menu
  • Block Menu
  • Block|Rectangular Selections
  • Block|Comment
  • Block|Toggle Comment


Block|Toggle Comment

Block|Toggle Comment ( Available in EditPad Pro only )

The Toggle Comment command in the Block menu combines the functionality of Block|Comment and Block|Uncomment . On each line in the selection, it will attempt to remove the comment characters exactly like Block|Uncomment would. If there are no comment characters to be removed, it will add them on that line just like Block|Comment does.

If you did not select any text before using the Block|Toggle Comment command, or the selection does not span more than one line, Block|Toggle Comment will add or remove the comment character at the start of the line containing the text cursor. The text cursor is then moved to the next line. If you've assigned a keyboard shortcut to Block|Uncomment, you can quickly uncomment a bunch of lines this way.

The advantage of Block|Toggle Comment is that it allows you to use the same keyboard shortcut for both commenting and uncommenting lines.

See also:

  • EditPad Pro Main Menu
  • Block Menu
  • Block|Rectangular Selections
  • Block|Comment
  • Block|Toggle Comment


Block|Prefix

Block|Prefix ( Available in EditPad Pro only )

Select Prefix in the Block menu to prefix the selected block with one or more characters. If you've made a selection that flows along with the text, the characters will be inserted at the very start of each line in the selection. If you've made a rectangular selection, the comment characters will be inserted on each line spanned by the selection, at the leftmost column in the selection. The inserted characters will become part of the selection.

See also:

  • Block Menu
  • Block|Rectangular Selections
  • Block|Suffix
  • Block|Fill Columns


Block|Suffix

Block|Suffix ( Available in EditPad Pro only )

Select Suffix in the Block menu to suffix the selected block with one or more characters. If you've made a selection that flows along with the text, the characters will be inserted at the end of each line in the selection. If you've made a rectangular selection, the comment characters will be inserted on each line spanned by the selection, after the rightmost column in the selection. The inserted characters will become part of the selection.

See also:

  • Block Menu
  • Block|Rectangular Selections
  • Block|Prefix
  • Block|Fill Columns


Block|Fill Columns

Block|Fill Columns ( Available in EditPad Pro only )

Select Fill Columns in the Block menu to fill a rectangular block with one or more characters. If you enter less characters than the width of the selection, the characters you entered will be repeated on each line as many times as necessary. If the number of selected columns is not an integer multiple of the number of characters you entered, the last repetition of the inserted characters will be truncated at the last selected column. The same characters will be inserted on each line.

If some of the lines already had text in the selected columns, that text is overwritten by the filled block. If some of the lines were shorter than the selected columns, spaces will be inserted to extent those lines until the filled block.

See also:

  • Block Menu
  • Block|Rectangular Selections
  • Block|Prefix
  • Block|Suffix


Block|Rectangular Selections

Block|Rectangular Selections ( Available in EditPad Pro only )

There are several ways to select text in EditPad using the keyboard or the mouse . Whichever way you choose, it involves marking a starting and an ending position for the selection. All the text between the starting and the ending position becomes selected, following the flow of the text like you would follow it when reading it out loud. This is how almost all Windows programs select text, and is appropriate in most situations.

But in some situations, such as when editing text files with information organized in tables, it is more useful to make a rectangular selection, also called a column selection. A rectangular selection is much like a selection of cells in a spreadsheet application, except that in EditPad you select characters instead of cells.

Before you can make rectangular selections, a few conditions must be met. First, you need to use a fixed-width font such as Courier New. You can change the font in Options|Font . Characters are only properly aligned into columns when using a fixed-width font, a requirement to make rectangular selections.

Second, word wrap must be off. You can turn it off using Options|Word Wrap . When long lines are wrapped, editing a long line will cause the text to be rewrapped. This is not a problem when the selection flows along with the text. But when using rectangular selections, this rewrapping would cause the selection to change.

Many text editors do not support rectangular selections. Those that do, are usually IDEs or editors from the DOS world that do not support word wrapping or variable-width fonts. EditPad is a flexible editor and supports both rectangular selections as well as modern conveniences like word wrap and variable-width fonts, but not at the same time for reasons explained above.

There are two ways to make a rectangular selection. First, you can make it the usual way using the keyboard or the mouse, while keeping the Alt button depressed on the keyboard. Second, you can pick Rectangular Selections from the Block menu . This will invert the meaning of the Alt key while making a selection. After choosing Rectangular Selections in the Block menu, a selection made the normal way will be rectangular, and a selection made while pressing Alt will flow along with the text.

If you did not choose a fixed-width font or turn off word wrap, then the selection will always flow along with the text. If you pick Block|Rectangular Selections from the menu, EditPad Pro will warn you that rectangular selections are presently not possible.

Most commands like copy and paste work just the same when using rectangular selections or text-flow selections. Notable exceptions are Block|Indent and Block|Outdent . Some commands, like Block|Fill Columns only work with rectangular selections.


Block|Begin Selection

Block|Begin Selection ( Available in EditPad Pro only )

Select Begin Selection from the Block menu to tell EditPad Pro to remember the current position of the text cursor. Doing this will not have any visible effect. After using Block|Begin Selection, you can use Block|End Selection to select text starting at the position remembered by Block|Begin Selection. If you have more than one file open in EditPad Pro, Begin Selection will remember the position separately for each file. Selecting Begin Selection when working with one file does not wipe out the position remembered for any other file.

These commands are very useful when you want to make a very large selection, or if you want to perform a search to find the start and the end of the selection. You can do whatever you want between invoking Begin Selection and invoking End Selection, including selecting part of the text in any way. The position stored by Begin Selection is remembered until you use Begin Selection again.

The Begin Selection command works slightly differently when selections are persistent . Then it is possible that part of the file is already selected, without the text cursor being positioned at the end of the selection. In that case, Begin Selection moves the starting position of the selection to the current position of the text cursor, and nothing is remembered. If the new starting position is further away from the ending position than the old one, the selection will be expanded. If the new starting position is below the ending position when the old one was above it, or vice versa, the selection will be pivoted around the ending position. If the new starting position is inside the old selection, the selection will be shrunk.

If there is no selection, Begin Selection remembers the position for use with End Selection, whether selections are persistent or not.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • Block Menu
  • Block|End Selection
  • Block|Expand Selection
  • Block|Rectangular Selections
  • Persistent Selections


Block|End Selection

Block|End Selection ( Available in EditPad Pro only )

After using Block|Begin Selection , you can select End Selection from the Block menu to select the text between the current position of the text cursor and the position stored by Begin Selection. You can use End Selection as many times as you want after using Begin Selection. The selection will continue to start at the same position, until you use Begin Selection again. If you want to make a rectangular selection, select Block|Rectangular Selections from the menu before selecting End Selection.

The End Selection command works slightly differently when selections are persistent . Then it is possible that part of the file is already selected, without the text cursor being positioned at the end of the selection. In that case, End Selection moves the ending position of the selection to the current position of the text cursor, and nothing is remembered. If the new ending position is further away from the starting position, the selection will be expanded. If the new ending position is above the starting position when the old one was below it, or vice versa, the selection will be pivoted around the starting position. If the new ending position is inside the old selection, the selection will be shrunk.

If there is no selection, Begin Selection remembers the position for use with End Selection, whether selections are persistent or not.

If you use the menu item or toolbar button to invoke this command, it will be invoked on EditPad's main editor, where you edit files. If you press the shortcut key on the keyboard , it will be invoked on whichever editor is showing the text cursor (vertical blinking bar), whether that's the main editor, the search box or the replace box.

See also:

  • Block Menu
  • Block|Begin Selection
  • Block|Expand Selection
  • Block|Rectangular Selections
  • Persistent Selections


Block|Expand Selection

Block|Expand Selection ( Available in EditPad Pro only )

The Expand Selection command in the Block menu is only useful when selections are persistent . Persistent selections allow you to move the text cursor away from the end of the selection. The Expand Selection command will create a new selection that includes the old selection, and all text between the old selection and the position of the text cursor. The position of the text cursor will be the new ending point of the selection.

The most significant difference between Block|End Selection and Block|Expand Selection is that End Selection will pivot the selection if you've moved the text cursor above the spot where you started making the selection while you ended the selection below the starting position, or vice versa. This causes the old selection to be completely deselected, as the starting position stays put. Only the text between the old starting position and the new ending position is selection. Expand Selection will always expand the selection. If the new ending position is above the old starting position while the old ending position was below it, or vice versa, Expand Selection simply makes the old ending position the new starting position.

Whether selections are persistent or not, you can achieve the same effect by pressing Shift on the keyboard while clicking with the mouse at the position where the new selection should end. The advantage of Block|Expand Selection is that you can assign it a keyboard shortcut, and expand the selection with the keyboard.

See also:

  • Block Menu
  • Block|Begin Selection
  • Block|End Selection
  • Block|Rectangular Selections
  • Persistent Selections


Block|Go to Beginning

Block|Go to Beginning ( Available in EditPad Pro only )

Select Go to Beginning in the Block menu or press the corresponding keyboard shortcut to quickly move the text cursor to the start of the selection. This command is only useful when selections are persistent, and you've moved the text cursor away from the selection.

See also:

  • Block Menu
  • Block|Go to End
  • Block|Rectangular Selections
  • Persistent Selections


Block|Go to End

Block|Go to End ( Available in EditPad Pro only )

Select Go to End in the Block menu or press the corresponding keyboard shortcut to quickly move the text cursor to the end of the selection. This command is only useful when selections are persistent, and you've moved the text cursor away from the selection.

See also:

  • Block Menu
  • Block|Go to Beginning
  • Block|Rectangular Selections
  • Persistent Selections


Block|Insert File

Select Insert File from the Block menu to insert the contents of another file into the file you are currently editing. You will be asked to select the file. The text will be inserted at the current position of the text cursor.If you select more than one file at the same time, their contents will be inserted in alphabetical order of the names of the files

See also:

  • EditPad Pro Main Menu
  • Block Menu


Block|Write

Select Write from the Block menu to saves the selected portion of the file you are editing into another file. If the other file already exists, EditPad will show a warning and if you confirm, the other file will be overwritten with the selected portion of the current file. If you want to add the selection to the file rather than overwrite it, use Block|Append instead.

If you do not specify an extension for the filename, EditPad will add one depending on the selection you made in the filters (the bottommost drop-down list) in the Block|Write dialog box. If the active filter is "any file" (*.*), no extension will be added. If any other filter is active, the default extension for that file type will be added to the filename. The default extension is the first extension listed in the Extensions setting of the file type's settings .

See also:

  • EditPad Pro Main Menu
  • Block Menu
  • Block|Append


Block|Append

Select Append from the Block menu to saves the selected portion of the file you are editing into another file. If the other file already exists, the selection will be added to the end of that file. If it does not yet exist, it will be created.

See also:

  • EditPad Pro Main Menu
  • Block Menu
  • Block|Write


Block|Print

Select Print from the Block menu to print the selection portion of the current file, rather than the entire file. A preview of the printout will be shown first. It will allow you to make some changes like which font to print with, which pages should be printed. You can also access the printer setup through the preview window.

There are two key differences between selecting Block|Print in the menu, versus selecting File|Print and turning on the "selection only" in the print preview. The checkbox works at the level of a single line. If a line is partially selected, it will be printed entirely. Block|Print, however, sends the exact selection to the print preview, and ultimately the printer. If you want to print a rectangular block , Block|Print is definitely more useful.

Syntax coloring will also be printed differently. Since File|Print sends the whole file to the print preview, the printed lines will be colored the same whether you're only printing the selected lines, or you're printing the whole file. Block|Print only sends the selection to the print preview, and the syntax coloring will treat the selection as if it is a complete file. If your selection cuts through syntactic elements, they won't be colored properly in the printout when using Block|Print. In that case, you can turn off the "syntax coloring" in the print preview to print without syntax coloring.

See also:

  • Block Menu
  • File|Print
  • Print Preview
  • Print Headers


Mark Menu

Mark Menu ( Available in EditPad Pro only )

Mark|Go to Bookmark

Mark|Set Bookmark

Mark|Project-Wide Bookmarks

See also:

  • EditPad Pro Main Menu


Mark|Go to Bookmark

Mark|Go to Bookmark ( Available in EditPad Pro only )

You can quickly jump to any bookmark by pressing Ctrl+1, Ctrl+2, Ctrl+3, etc... on the keyboard. Jumping to a bookmark positions the text cursor on the line on which you set the bookmark with the given number through Mark|Set Bookmark . If the requested bookmark does not exist, nothing happens.

If you remember you set a bookmark but don't remember which number, open the Mark menu. The first 10 items in the menu will display the first few words on the paragraph on which each of the bookmarks is set.

Bookmarks can be either separate for each file, or project-wide. When bookmarks are project-wide, the Go to Bookmark command searches for the bookmark in all files in the active project. If the bookmark is found in another file, it will activate that file. When bookmarks are separate for each file, the Go to Bookmark command will never switch to another file.

See also:

  • Mark Menu
  • Mark|Set Bookmark
  • Mark|Project-Wide Bookmarks


Mark|Set Bookmark

Mark|Set Bookmark ( Available in EditPad Pro only )

You can place up to ten bookmarks in every file open in EditPad Pro. You can quickly do so by pressing Shift+Ctrl+1, Shift+Ctrl+2, etc... on the keyboard. When you place a bookmark, you will see a green square with a white number in the left margin, indicating the bookmark's position. You can remove a bookmark by setting the bookmark again on the same paragraph. Setting a previously set bookmark removes it from its previous location.

Bookmarks are placed on paragraphs. If a paragraph is broken into several lines by the word wrapping , the bookmark image will be displayed next to the first line in the paragraph.

Bookmarks are not saved into a file when you use File|Save . However, EditPad Pro does automatically remember the bookmarks you set for all files that are listed in the reopen menu , and all files you added to your favorites . Projects also store the bookmarks for all the files in the project. When opening files by opening a project, the files' bookmarks are restored from the project file. When opening a file without opening a project, its bookmarks are retrieved from the reopen menu or the favorites if the file is listed there, even if you didn't use the reopen menu or the favorites menu to open the file.

See also:

  • Mark Menu
  • Mark|Go to Bookmark
  • Mark|Set Bookmark


Mark|Project-Wide Bookmarks

By default, bookmarks are separate for each file. You can use Mark|Set Bookmark to set the same bookmark in each file. Mark|Go to Bookmark will only jump to bookmarks in the current file. The Mark menu will list the bookmarks for the current file.

If you select the Project-Wide Bookmarks item in the Mark menu to make bookmarks project-wide, you will only have one set of 10 bookmarks for all files in the current project. The Mark menu will show the bookmarks for the current project. If you set a bookmark, that bookmark will be set at the current paragraph in the current file, and removed from all other files in the project. When jumping to a bookmark, all the files in the current project will be searched through to find the bookmark. The file it was found in will be activated.

If you set the same bookmark in multiple files in the project with project-wide bookmarks turned off, and then turn on project-wide bookmarks, nothing will happen initially. The bookmark will remain set in all the files it is set in. If you try to jump to the bookmark, and it exists in the current file, EditPad Pro will jump to the bookmark in the current file. If not, it will search through the files in the project and jump to the first file it finds. Since this makes it hard to predict where you'll end up if you jump to the bookmark, you should set it again after turning on project-wide bookmarks. Setting the bookmark again will then remove it from all the other files in the project, giving it one place to jump to.

Whether to use separate bookmarks for each file or project-wide bookmarks depends on your personal editing style, and the task at hand. When working with a handful of very large files, using separate bookmarks gives you 10 bookmarks for each file. You can use the tabs to switch between files. When you're working with a very large number of files and you repeatedly need to switch between them, project-wide bookmarks allow you to instantly switch to a particular spot in a particular file.

See also:

  • Mark Menu
  • Mark|Go to Bookmark
  • Mark|Set Bookmark


Fold Menu

Fold Menu ( Available in EditPad Pro only )

Fold|Fold

Fold|Unfold

Fold|Remove Fold

Fold|Fold All

Fold|Unfold All

Fold|Remove All

Fold|Copy Visible Lines

Fold|Delete Folded Lines

See also:

  • EditPad Pro Main Menu


Fold|Fold

Fold|Fold ( Available in EditPad Pro only )

Select Fold in the Fold menu to fold the selected lines. The first line in the selection will remain visible, while the others will be hidden. They are "folded" underneath the first line. A square with a plus symbol in it will appear to the left of the folded line. If you click it, the hidden lines will become visible again. A square with a minus will mark the first line, with a vertical line extending down from it to mark the previously folded range. Click the minus button again to refold the range.

If you did not select part of the text, and the text cursor is inside a foldable range indicated by a vertical line in the left margin, the Fold command will fold that folding range.

While folded lines are invisible, they are still fully part of the file, and still take part in all editing actions. E.g. if you select a block that includes one or more folded sections and copy the block to the clipboard with Edit|Copy , all selected lines, including lines hidden by folding, will be copied to the clipboard. Folding only affects the display. The only editing commands that take the folding into account are Edit|Delete Line , Fold|Copy Visible Lines and Fold|Delete Folded Lines .

On the Syntax & Navigation page in the file type configuration , you can choose if and how EditPad Pro should add automatic folding points. Automatic folding points appear as an unfolded range that you can fold with the mouse or the Fold command.

See also:

  • Fold Menu
  • Fold|Unfold
  • Fold|Remove Fold
  • File Type Syntax & Navigation


Fold|Unfold

Fold|Unfold ( Available in EditPad Pro only )

Select Unfold in the Fold menu to unfold a section previously folded with Fold|Fold . The Unfold command will only become enabled when you've placed the text cursor on the first (still visible) line of a folded section. The unfolded section will remain marked as a folding point, so you can easily re-fold it.

If you've made a selection, then all folding points inside the selection will be unfolded.

If the current file type uses automatic folding points , then unfolded ranges will automatically disappear when you edit the file. They will be replaced by new automatic folding points. Folded ranges will remain folded until you unfold them.

See also:

  • Fold Menu
  • Fold|Fold
  • Fold|Remove Fold
  • File Type Syntax & Navigation


Fold|Remove Fold

Select Remove Unfold in the Fold menu to unfold a section previously folded with Fold|Fold , and delete the folding point in the process. The Remove Fold command will only become enabled when you've placed the text cursor on the first (still visible) line of a folded section.

If you've made a selection, then all folding points inside the selection will be removed.

If the current file type uses automatic folding points , then automatically added folding points that you removed will automatically reappear when you edit the file.

See also:

  • Fold Menu
  • Fold|Fold
  • Fold|Unfold
  • Fold|Remove Fold
  • File Type Syntax & Navigation


Fold|Fold All

Fold|Fold All ( Available in EditPad Pro only )

The Fold All command in the Fold menu will fold all automatic folding points , and any unfolded section still marked with a folding point.

See also:

  • Fold Menu
  • Fold|Unfold All
  • Fold|Remove All
  • File Type Syntax & Navigation


Fold|Unfold All

Fold|Unfold All ( Available in EditPad Pro only )

The Unfold All command in the Fold menu unfolds all sections that you have folded with the Fold command.

See also:

  • Fold Menu
  • Fold|Fold All
  • Fold|Remove All
  • File Type Syntax & Navigation


Fold|Remove All

The Unfold All command in the Fold menu removes all folding points that you added with the Fold command.

See also:

  • Fold Menu
  • Fold|Fold All
  • Fold|Unfold All
  • File Type Syntax & Navigation


Fold|Copy Visible Lines

The Copy Visible Lines item in the Fold menu copies the selected text to the clipboard. There are two key differences between the Copy Visible Lines command, and the regular Copy command in the Edit menu.

If the selection is not rectangular, and certain lines are only partially selected, the Copy Visible Lines command will copy those lines entirely. The Copy command copies partially selected lines partially.

If certain lines were folded, the Copy Visible Lines command will not copy the lines that were made invisible by the folding. The regular Copy command does copy them.

See also:

  • Fold Menu
  • Fold|Delete Folded Lines
  • Search|Fold Lines
  • File Type Syntax & Navigation


Fold|Delete Folded Lines

Select the Delete Folded Lines item in the Fold menu to delete all lines in the current selection that were made invisible by folding them.

See also:

  • Fold Menu
  • Fold|Copy Visible Lines
  • Search|Fold Lines
  • File Type Syntax & Navigation


Tools Menu

Tools Menu ( Available in EditPad Pro only )

The Tools menu lists all the tools that are defined for the file type of the active file. Select one from the menu and it will be run immediately.

Use the Configure Tools item to configure the tools to be added to the Tools menu.

See also:

  • EditPad Pro Main Menu
  • Configure Tools


Macros Menu

Macros Menu ( Available in EditPad Pro only )

Via the Macros menu you can record and play back keystroke macros. With keystroke macros, you can automate repetitive editing tasks.

To record a macro, select the Record Macro item in the Macros menu. EditPad Pro will ask you to enter a name for the macro. When you confirm the macro's properties , recording begins immediately. There are a number of important issues to keep in mind when recording macros . Make sure to review them.

When you're done recording the macro, select the Stop Recording item in the Macros menu. You'll notice it's the only available command during recording. You cannot play back and record macros at the same time.

To play back a macro, simply select it from the Macros menu or press its keyboard shortcut . The macro will be executed once. Select Organize Macros in the Macros menu if you want to run a macro multiple times.

EditPad Pro automatically saves macros. You won't be prompted for a file name. If you want to save a macro into a file so you can share it with other people, use the Export command in the Organize Macros screen.


Macro Properties

The Macro Properties screen appears when you select the Record Macro item in the Macros menu , and when you click the Properties button when organizing macros .

EditPad Pro macros have only two properties: a name, and an optional keyboard shortcut. Each macro must have a unique name. If you start recording a new macro with the same name as an existing macro, the existing macro is automatically and silently replaced.

The keyboard shortcut can either be a single key combination, or a double key combination. Assigning a shortcut to a macro works just like assigning shortcuts in the Keyboard preferences. The procedure is explained in detail in the help topic about Keyboard preferences . If you assign a shortcut to a macro that is already assigned to another macro, the new macro will take over the shortcut from the old macro. You cannot assign a shortcut that's already used for a menu item to a macro.


Organize Macros

Select Organize Macros in the Macros menu to organize, play back and record macros.

Repeated Playback

Playing back a macro via the Organize Macros allows you to play back the same macro many times. Simply enter the number of times the macro should run in the Repeat box, and click the Play Macro button. The macro may run fewer times than you specified, but never more.

If the macro includes a search command, and the search fails to find a match, macro playback will stop immediately. This enables you to record a macro that does something to a search match, and then run that macro on all search matches. Suppose you record a macro that executes the Search|Find Next command and then the Edit|Delete Line command. If you then execute this macro with Repeat set to 100, the macro will delete the lines containing the next 100 search matches. If there are fewer than 100 search matches, all their lines will be deleted, and the macro will stop. You can use the Search|Count Matches command to determine the number of times the macro should run, or you could simply enter a large enough number.

However, there is a reason why you still need to enter an upper limit for the number of times the macro should run. You can't tell EditPad Pro to run the macro until the search fails. The reason is that it's quite possible for a search command to never fail. E.g. a macro that runs Search|Find First but doesn't delete the search match will always find that search match. A macro using Search|Find Next with the " loop automatically " option turned on will loop forever if it doesn't delete search matches. By specifying a reasonable number of times for the macro to repeat itself, you can prevent it from going on forever.

Recording

Click the Record button to record a new macro. EditPad Pro will ask you to enter a name for the macro. When you confirm the macro's properties , the Organize Macros screen closes and recording begins immediately. There are a number of important issues to keep in mind when recording macros . Make sure to review them.

When you're done recording the macro, select the Stop Recording item in the Macros menu. You'll notice it's the only available command during recording. You cannot play back and record macros at the same time.

Organizing Macros

Click the Properties button to rename a macro or to change its shortcut key , or to rename a folder. You can add folders with the New Folder button. To put macros into a folder, simply drag and drop them with the mouse. If you have a lot of macros, organizing them in folders makes it easier to find them later.

Import and Export

EditPad Pro automatically saves all your macros internally along with your preferences, history lists, etc. If you want to share a macro with other people, or copy it from one computer to another, use the Export Macro button. The selected macro is then saved into the file that you specified. You can open the file in EditPad Pro to view its contents if you like. However, macro files are not intended to be edited.

If you've received a macro that you'd like to run in a file, first import it with the Import Macro button. The macro is then added to your list of macros. You can play back imported macros just like macros that you recorded yourself. The macro file is no longer needed once you've imported it.

You can export multiple macros into a single file by selecting multiple macros before clicking the Export Macro button. If you include one or more folders in your selection, all the macros in those folders and their subfolders will be exported. If you click the Export Macro button a second time and select an existing file, EditPad Pro will replace that file rather than append to it. When importing a file that holds more than one macro, all of the macros will be imported. If you wanted to import only some, you can delete the extraneous ones after importing the file.


How EditPad Pro Records Macros

Before you start recording and playing back macros, it's important that you understand exactly what EditPad Pro records. If you understand macros, they're a powerful and quick way to automate otherwise tedious and repetitive editing tasks. If you don't understand macros, they're a quick way to completely mess up your files.

Mouse Clicks Are Not Recorded

Clicks are relative to the position and size of EditPad's windows, to the location where you've scrolled, etc. A click at a certain position on the screen may have a totally different meaning from one situation to the next. Therefore, mouse clicks are not recorded. If you move the mouse over the text editing area, the mouse pointer will indicate you can't click. If you try, the click will have no effect at all.

Menu item commands and button commands are recorded. You can invoke them with the mouse while recording a macro. EditPad Pro will record the command that you clicked on, rather than the click itself.

Only Your Actual Actions Are Recorded

EditPad Pro only records exactly those keystrokes that you type, or exactly those commands that you invoke when running a macro. E.g. if you select the Search|Find Next menu item while recording a macro, the macro only records that you selected Search|Find Next. It does not record the search term, the search options, etc. If you play back the macro, it will simply execute Search|Find Next again. If you've changed the search term or search options since recording the macro, the new term and options will be used for the search.

By recording only your actual actions, you can make generic macros. E.g. if you want a macro that deletes every line with a search match, you can record Search|Find Next and Edit|Delete Line . You can then use that macro to delete the matches of any search term. Simply enter the correct search term before running the macro.

This also applies to any keystrokes you type into the editor, search box or replace box. The macro will record the actual keystrokes. Their effect may be different when you run the macro, depending on the position of the text cursor and if any text was selected. Keep this in mind when recording macros. You may want to press a few extra keys to make sure the macro works well. E.g. instead of requiring a macro to have the cursor at the start of the line, simply press the Home key when you start recording the macro. Even if the cursor was already at the start of the line when you recorded the macro, it will still record that you pressed the Home key.

How to Record Search Terms

If you want to record search terms as part of a macro, you can do so by selecting the search term from the Search|History or Search|Favorites menu. The macro will then record the search text, replace text and all search options. You can temporarily add a search term to the favorites before recording the macro. The macro will store the actual search terms, not the fact that you selected an item from the history or favorites. If you later delete the item from the history or favorites, the macro will still work.

Macros Record Command Options

Some commands in the Extra menu, like Delete Duplicate Lines and Compare Files show a screen with options before doing their work. If you use these commands while recording, the macro will record the state of the options screen when you click the OK button. It will not record whether you toggled any options, but the final result. When you play back the macro, the command will be executed with those options every time, without showing the options screen.

This rule may seem to contradict the "only your actual actions are recorded" rule. However, there's a key difference between the search options and the alphabetic sort options. You can set the search options in EditPad Pro's main window. If you toggle a search option, the option's state is recorded. Therefore, you can "prepare" the search options before playing back a macro that didn't record them. You could even record a macro that does nothing but set search options.

The Delete Duplicate Lines command's options can only be set when you've already told EditPad Pro to delete duplicate lines. You can't prepare the options prior to executing the macro.

The state of options that you can prepare are not recorded by macros, since actions that change the state of options that you can prepare are recorded. Commands with options that you cannot prepare record the state of the options as part of the command.

Failed and Inconsequential Commands Are Recorded

Pressing the Home key on the keyboard while the text cursor is already at the start of the line does nothing. However, macros still record that inconsequential key press. When the macro is played back, it will move the cursor to the start of the line if it isn't there already.

Search commands are special in EditPad Pro. They can fail. If you click the Find Next button and it flashes, that means it failed. There was no next search match. While recording a macro, the Find Next command is still recorded.

Failed Commands Halt Macro Playback

Though not exactly a recording issue, it's important to remember that if a search command fails during macro playback, it will stop the macro immediately. This allows you to run macros that run until failure to process all search terms.


Extra Menu

Extra Menu ( Available in EditPad Pro only )

Extra|Spell Check

Extra|Spell Check Selection

Extra|Spell Check Project

Extra|Spell Check All

Extra|Live Spelling

Extra|Sort Alphabetically A-Z

Extra|Sort Alphabetically Z-A

Extra|Delete Duplicate Lines

Extra|Trim Leading Whitespace

Extra|Trim Trailing Whitespace

Extra|Trim Whitespace

Extra|Compare Files

Extra|Compare with File on Disk

Extra|Next Comparison Mark

Extra|Previous Comparison Mark

Extra|Clear Comparison Marks

Extra|Statistics

Extra|Project Statistics

Extra|Statistics for All Files

See also:

  • EditPad Pro Main Menu


Extra|Spell Check

Extra|Spell Check ( Available in EditPad Pro only )

Select |Spell Check from the Extra menu to check the spelling of the current file. The spell check function always starts from the beginning of the file.

The pane below appears during the spell check process:

When a word is not found in the dictionary, it will be selected in the editor and reported in the upper left area of the spell check pane. EditPad Pro will start searching through the dictionary for words similar to the misspelled one, and show them in the list. As long as "(searching...)" is visible, EditPad Pro is still looking for more possible, correctly spelled substitutions. You do not have to wait until EditPad Pro is finished. You can correct the error right away.

If the word is really misspelled, you can type in the correctly spelled word in the "Replace with" field. You can also click on an item in the list with EditPad Pro's suggestions and it will automatically be placed in the "Replace with" field. If you click on "Suggest similar", EditPad Pro will start looking for words in the dictionary similar to what you typed into the "Replace with" field.

Then you need to click one of the three replace buttons: "Replace" will replace the misspelled word with the replacement just this time. "Replace All" will replace the misspelled word with the replacement every time it is found during the current EditPad Pro session. When you pick File|Exit or switch to a different language, the replacement is forgotten. If you click "Learn Replace", EditPad Pro will always automatically replace the misspelled word with the replacement and remember this even if you quit EditPad Pro.

You can also fix the error directly in the editor. After doing so, you will have to click the "Resume" button to continue to check the spelling of the rest of the file.

If the word is correctly spelled, you can click "Ignore" to accept the word as correct just this time. "Ignore All" will make EditPad Pro ignore all occurrences of this word until you switch languages or close EditPad Pro. "Learn" will make EditPad Pro add the word to its dictionary and will from then on always be accepted as correct.

If you make a mistake, click on "Back" to revert it.

If you switch to the editor to make some changes, you will need to click on "Resume" to continue the spell check from where you left off.

Click "Abort" to stop and close the pane.

The "Word List" button allows you to edit the list of words that you added to the custom dictionary. When you click the button, a new window will appear. The left hand side of the window contains the list of words that you specified as correctly spelt by clicking on the "Learn" button. The right hand side of the window contains pairs of words separated by and equals sign (=). These are the automatic replacements you added by clicking the "Learn Replace" button. Whenever the spell checker finds the word at the left side of the equals sign, it will be replaced with the word at the right of the equals sign.

See also:

  • Extra Menu
  • Extra|Spell Check Selection
  • Extra|Spell Check Project
  • Extra|Spell Check All
  • Extra|Live Spelling
  • Download Spell Check Dictionaries


Extra|Spell Check Selection

Extra|Spell Check Selection ( Available in EditPad Pro only )

Select "Spell Check Selection" from the Extra menu to check the selected portion of the current file for spelling errors. See Extra|Spell Check for a description of the spell check pane.

See also:

  • Extra Menu
  • Extra|Spell Check
  • Extra|Spell Check Project
  • Extra|Spell Check All
  • Extra|Live Spelling
  • Download Spell Check Dictionaries


Extra|Spell Check Project

Extra|Spell Check Project ( Available in EditPad Pro only )

Select "Spell Check Project" from the Extra menu to check all files in the current project for spelling errors. See Extra|Spell Check for a description of the spell check pane.

See also:

  • Extra Menu
  • Extra|Spell Check
  • Extra|Spell Check Selection
  • Extra|Spell Check All
  • Extra|Live Spelling
  • Download Spell Check Dictionaries


Extra|Spell Check All

Extra|Spell Check All ( Available in EditPad Pro only )

Extra|Spell Check All will activate the first file and start the spell check process. When the first file has been completed, the second file will be activated and the spell checker will be invoked on that file, until all files have been checked or you clicked the Abort button on the spell check page.

See Extra|Spell Check for a description of the spell check pane.

See also:

  • Extra Menu
  • Extra|Spell Check
  • Extra|Spell Check Selection
  • Extra|Spell Check Project
  • Extra|Live Spelling
  • Download Spell Check Dictionaries


Extra|Live Spelling

Extra|Live Spelling ( Available in EditPad Pro only )

Pick Live Spelling from the Extra menu to turn on or off live spell checking for the current file. Live spell checking will mark all words that do not appear in the dictionary. By default, they will appear underlined and in red. You can change the look in Colors Preferences . Whether live spelling is on or of by default can be configured for each file type in the file type configuration .

Live spelling, as well as the regular spell check in EditPad Pro, works together with EditPad Pro's syntax coloring. Each syntax coloring scheme can exclude certain parts of the file from the spell check. Schemes for programming languages, such as the C++ and Java schemes, will restrict the spell checker to strings and comments. Those are likely to contain natural language, and therefore words that should appear in the dictionary. Other parts of the file are likely to contain specialized programming syntax, consisting of words and character sequences that are not English words.

If a word is marked as misspelled, you can double click on it to open the spell check pane . The pane will present you with a list of suggested replacements for the word, as well as allow you to ignore the word or add it to the dictionary. As soon as the word has passed the spell check, the spell check pane will close automatically.

Live spelling is automatically disabled when highlighting search matches . As soon as you stop highlighting search matches, misspelled words will be marked again.

See also:

  • Extra Menu
  • Extra|Spell Check
  • Extra|Spell Check Selection
  • Extra|Spell Check Project
  • Extra|Spell Check All
  • Search|Highlight All
  • Configure File Types
  • File Type Syntax & Navigation
  • Download Spell Check Dictionaries


Download Spell Check Dictionaries

Before you can use Extra|Spell Check or Extra|Live Spelling , you need to download and install spell check dictionaries for one or more languages. You can easily do so right within EditPad Pro. Pick Options|Configure File Types from the menu, and click on the Syntax & Navigation tab. Click the button "Download Spell Checker Dictionaries". EditPad Pro will then connect to the Internet to fetch a list of available languages.

If you want, you can choose the folder into which the dictionaries should be installed. If you specify a folder that does not exist, EditPad Pro will create it. All dictionaries must be installed into the same folder. If you already installed some dictionaries, and then install another dictionary into a different folder, EditPad Pro will move the previously installed dictionaries to the new folder.

To install a dictionary, click on the language you want in the list, and click the Install button. EditPad Pro will then automatically download the dictionary, and install it into the folder you specified. A progress meter will appear while downloading.

You can have as many dictionaries installed as you want. There is no need to uninstall dictionaries. However, if you want, you can select a language and click the Uninstall button to delete a spell check dictionary.

If you are behind a proxy server, and EditPad Pro is unable to detect your proxy settings, you can change them by clicking the Settings button.

Due to firewall and other network settings, it is possible that EditPad Pro cannot connect to the Internet directly. In that case, you can manually download and install the dictionaries from http://www.editpadpro.com/spell.html


Extra|Sort Alphabetically A-Z

Extra|Sort Alphabetically A-Z ( Available in EditPad Pro only )

If no part of the active file has been selected, Extra|Sort Alphabetically will sort the entire file alphabetically, paragraph by paragraph.

To sort the entire file on a specific column of text, select that column of text before selecting Extra|Sort Alphabetically first. Make sure that the selection does not span more than one paragraph. All the paragraphs in the file will be sorted, using the selected column as the sort key.

If the selection spans more than one paragraph, then the selected paragraphs will be sorted. If you want to sort only a selected number of paragraphs on a certain column, make a rectangular selection first. The paragraphs that are partially covered by the rectangular selection will be sorted entirely as if the selection was a normal one. However, the sort order will not be determined by their entire paragraph text, but only by the text covered by the selection.

If you are working with a text files that contains information arranged in columns, padded with spaces, you could make a rectangular selection of the third column and then use Extra|Sort Alphabetically. The data will then be sorted on the third column.

The progress meter indicates the percentage of paragraphs that have already been sorted. The sort operation works from top to bottom. If you abort the operation, the paragraphs that have already been sorted will remain sorted, and the unsorted paragraphs will maintain their old position. If you want to cancel the sort altogether and revert its results, use Edit|Undo .

See also:

  • EditPad Pro Main Menu
  • Extra Menu
  • Extra|Sort Alphabetically Z-A


Extra|Sort Alphabetically Z-A

Extra|Sort Alphabetically Z-A ( Available in EditPad Pro only )

Extra|Sort Alphabetically Z-A works just like Extra|Sort Alphabetically A-Z , except that the file or the selected text is sorted in reverse alphabetical order.

See also:

  • EditPad Pro Main Menu
  • Extra Menu
  • Extra|Sort Alphabetically A-Z


Extra|Delete Duplicate Lines

Extra|Delete Duplicate Lines ( Available in EditPad Pro only )

Select the Delete Duplicate Lines item in the Extra menu to delete lines with (nearly) identical text on them. The status bar will indicate how many lines were deleted. You can make a number of choices as to what EditPad Pro will consider a duplicate line.

Scope

If you've selected part of the file before using the Delete Duplicate Lines command, you can limit the command to delete only lines that are selected. If the first and/or last line in the selection are only partially selected, the selection will be expanded to include them entirely. If the selection is rectangular , lines covered by the selection will be deleted entirely.

Proximity of Duplicate Lines

Select "anywhere in the scope" to delete all lines that are duplicated anywhere. The first copy of the line will remain, while all the others will be deleted. If you've set the scope to "selected lines", the lines must be duplicated inside the selection. Lines that are not duplicated inside the selection will not be deleted, even if they have lines outside the selection.

Select "adjacent lines only" if you only want to delete a line's duplicates if they're immediately below the line they duplicate, without any other lines between them. If the file's lines are sorted alphabetically, then the end result of "anywhere in the scope" and "adjacent lines only" will be the same. In a sorted file, all duplicates are sorted together. However, selecting "adjacent lines only" will delete the duplicate lines significantly faster, certainly when the number of lines in the file is large. If you select "anywhere in the scope", EditPad Pro has to compare each line with every other line in the file.

Comparison Options

By turning on one or more comparison options, you can tell EditPad Pro to consider lines as duplicates even when they aren't identical.

The "compare selected columns only" is only available when you've made a selection that does not span more than one line, or when you've made a rectangular selection . With this option, EditPad Pro will only compare the selected columns. E.g. if the selection spans from column 10 to column 20, EditPad Pro will compare columns 10 through 20 of each line. If a line has less than 10 characters it will be considered blank. This has important consequences (see next section).

"Ignore differences in leading spaces and tabs" will treat lines that only differ in the number of spaces and tabs at the start of the line as duplicates. Similarly, "ignore trailing spaces and tabs" ignores differences in spaces and tabs at the end of each line. "Ignore all differences in spaces and tab" is more than a combination of the two previous options. EditPad Pro will then completely ignore all spaces and tabs, including spaces and tabs in the middle of lines.

"Ignore difference in case" compares lines without regard to the difference between upper case and lower case letters.

Blank Lines

Since blank lines are technically all duplicates of each other, EditPad Pro offers you an extra choice for blank lines. You can choose to either delete all blank lines, not to delete any blank lines, or to only delete duplicate blank lines. The "duplicate blank lines" option takes into account the "proximity" setting, deleting either all but the first blank lines ("anywhere in the scope"), or only replacing subsequent blank lines with a single blank line ("adjacent lines only").

If you've turned on the "compare selected columns only" option, a line may be considered blank even when it isn't. If a line is shorter than the leftmost column in the selection, it is considered to be blank, even if it does have text on it.

Lines with only spaces and tabs on them are only considered to be blank if you've turned one of the options to ignore differences in spaces and tabs. On a line with only spaces and tabs, all spaces and tabs are considered to be both leading and trailing at the same time.


Extra|Trim Leading Whitespace

Extra|Trim Leading Whitespace ( Available in EditPad Pro only )

Select Trim Leading Whitespace in the Extra menu to remove whitespace from the start of each line. If you selected part of the file, only lines that area selected will be trimmed. If not, all lines in the file will be trimmed.

If you've made a rectangular selection , EditPad Pro will only delete whitespace inside the rectangular block. Whitespace in the leftmost selected column and adjacent columns to the right will be deleted. This whitespace needn't be at the start of the line

See also:

  • Extra Menu
  • Extra|Trim Trailing Whitespace
  • Extra|Trim Whitespace


Extra|Trim Trailing Whitespace

Extra|Trim Trailing Whitespace ( Available in EditPad Pro only )

Select Trim Trailing Whitespace in the Extra menu to remove whitespace from the end of each line. If you selected part of the file, only lines that area selected will be trimmed. If not, all lines in the file will be trimmed.

If you've made a rectangular selection , EditPad Pro will only delete whitespace inside the rectangular block. Whitespace in the rightmost selected column and adjacent columns to the left will be deleted. This whitespace needn't be at the end of the line. If a line is short and doesn't reach until the rightmost selected column, any whitespace at the end of the line covered by the selection will be deleted.

See also:

  • Extra Menu
  • Extra|Trim Leading Whitespace
  • Extra|Trim Whitespace


Extra|Trim Whitespace

Extra|Trim Whitespace ( Available in EditPad Pro only )

Select Trim Whitespace in the Extra menu to remove whitespace from the start and the end of each line. If you selected part of the file, only lines that area selected will be trimmed. If not, all lines in the file will be trimmed.

If you've made a rectangular selection , EditPad Pro will only delete whitespace inside the rectangular block. Whitespace in the leftmost selected column and adjacent columns to the right will be deleted. Whitespace in the rightmost selected column and adjacent columns to the left will also be deleted.

See also:

  • Extra Menu
  • Extra|Trim Leading Whitespace
  • Extra|Trim Trailing Whitespace


Extra|Compare Files

Extra|Compare Files ( Available in EditPad Pro only )

If you have two versions of the same text file, you can use Extra|Compare Files to visualize the differences between those files. After that, you can edit the generated difference file to merge both versions into a single, new file.

First you need to open the two files you want to compare. The Extra|Compare Files menu item will be grayed out until you have two or more files open.

Selecting Files

To compare the files, first activate the file that contains the original or older version of the document by clicking on its tab. Then select Extra|Compare Files from the menu. In the window that appears, click on the file that contains the newer version of the document, in the list of files that are currently open. The active file is omitted from that list, since you cannot compare a file with itself.

The file that was active at the time you selected Extra|Compare Files in the menu will be considered the "old" file. The file that you select in the file comparison options screen will be considered the "new" file.

How to Compare The Files

You can specify several options when comparing files. The setting for the minimum match size will be explained in detail later. 3 is a good default value.

You can choose to ignore differences in leading spaces and tabs. That is, when comparing two lines, EditPad Pro will ignore any space and tab characters at the start of the lines. Similarly, you can choose to ignore trailing spaces and tabs. That is, spaces and tabs at the end of a line. You can mark both options to ignore both leading and trailing spaces and tabs. If you mark "ignore all differences in spaces and tabs", then EditPad Pro will ignore any spaces and tabs throughout both files when comparing their lines. These options are useful when comparing files where differences in whitespace have little or no meaning.

If you turn on "ignore added and removed blank lines", EditPad Pro will not add blank lines that occur only in one of the two compared files to any new file created by the file comparison. Those lines will also not be highlighted in the original files. Lines with only spaces and tabs will be considered to be blank only if you've turned on one of the options to ignore differences in spaces and tabs.

Finally, "ignore differences in case" tells EditPad Pro to ignore whether a character is uppercase or lowercase, making "A" identical to "a".

What to Display

If you select to highlight changes in the original files, EditPad Pro will mark lines present in the "old" or "original" file in red when they are not present in the "new" or "edited" file. It will also mark lines in the "new" file in green when they are not present in the "old" file. You can configure the "compare files: deleted line" and "compare files: added line" colors in the Colors Preferences .

If you turn on "new file with fully merged contents", EditPad Pro will create a new tab with the two files merged, based on their differences. The tab will be labeled "OldFile compared with NewFile". Lines that are identical in both files are added once and displayed on a normal background. Lines only present in the "old" file are added on a red background, and lines only present in the "new" file are added on a green background. If the text on a line was changed between the "old" and "new" versions of the file, EditPad Pro will first add the old version of the line on a red background, and then the new version of the line on a green background. If consecutive lines where changed, EditPad Pro will first add a block with the old versions of all the consecutive lines, and then the new versions of the consecutive lines.

"New file with removed and added lines" is the same as "new file with fully merged contents", except that lines present in both the "old" and "new" files are not added. Lines are highlighted red and green. Consecutive changed lines are grouped in the same way. The tab will be labeled "Differences between OldFile and NewFile".

"New file with removed lines only" contains a tab with lines that are present in the "old" file, but not in the "new" file. Since all lines are old lines, none of them are highlighted. The tabs label will be "Lines from OldFile removed in NewFile".

Similarly, "new files with added lines only" creates a tab labeled "Lines not in OldFile added to NewFile" with lines present in the "new" file, but not in the "old" file.

Finally, "new file with unchanged lines only" creates a tab labeled "Lines unchanged between OldFile and NewFile". This tab will show all the lines present in both files.

All new tabs with difference output behave like a regular files in EditPad Pro. You can use any editing command on them and save them for later use. If you open the View|File History , it will remind you of the two files that were compared, and which was the "old" or "original" file, and which was the "new" or "edited" file.

See also:

  • Extra Menu
  • Minimum number of lines for matching block
  • Extra|Compare with File on Disk
  • Extra|Next Comparison Mark
  • Extra|Previous Comparison Mark
  • Extra|Clear Comparison Marks
  • View|File History


Minimum number of lines for matching block

When you pick Extra|Compare Files from the menu, EditPad Pro will ask for a file to compare the active one with. Near the bottom of the selection window, you will see the spinner box labeled "minimum number of lines for a matching block".

The default setting is 3, but it can be anything between 1 and 9 inclusive.

This value is used by EditPad Pro in the following situation. While comparing the files, it encounters a section of one or more changed paragraphs. In the difference output, these paragraphs are grouped into a single red block showing the original paragraphs, followed by a single green block with the new paragraphs. This is done because all those paragraphs are most likely to be connected somehow: a chapter in a book that was heavily edited, a source code routine that has been modified, etc. Keeping those paragraphs together maintains their logical connection so you can easily see what happened when inspecting the output of Extra|Compare Files.

To even better maintain the logical structure of the document, you can have EditPad Pro also include a few paragraphs in the block that are identical in both versions of the document. This will happen when you set "minimum number of lines for a matching block" to a number greater than one (1).

The setting indicates the minimum number of consecutive paragraphs that are identical in both files are required for EditPad Pro to stop grouping the modified paragraphs and add the identical paragraphs as an unchanged block. The graphical illustrations below make this clear.

First you see the old and new version of our test document:

Then we use Options|Compare Files, and set "minimum number of lines for a matching block" to one, effectively turning off the feature. This is the result:

You see that EditPad Pro detects the line "Version 2" as being inserted.

It also detects that the lines numbered 3 and 7 are present in both files, and that the blocks 1-2, 4-6 and 8-9 have changed. This is technically exact (it is the optimum solution), but logically it makes no sense. The arrow is broken into pieces.

If we try again and set "minimum number of lines for a matching block" to anything greater than 1, we get the following result:

Much better! The "I created..." line is still included on its own since it does not follow a block of changed paragraphs, but an inserted one.

However, the lines containing the numbers 3 and 7, even though they are present in both files, are displayed in the middle of the changed block as if they had been changed too. This way, our logical structure, the arrow, is kept together nicely and we can instantly see what happened: the arrow's direction was changed. This was not at all so clear in our first comparison attempt.

Since you will not be comparing arrows but real documents such as source code files, the "minimum number of lines for a matching block" can be configured for the task at hand. Many source code files contain lines with nothing but a curly brace or a "begin" or "end". These lines add structure to the source, and not content. When comparing two versions of a piece of source, these lines are likely to be matched all over the place, breaking up the logical structure of the source code in the difference output.

If things don't look right, experiment with the "minimum number of lines for a matching block" setting.

See also:

  • Extra Menu
  • Extra|Compare Files
  • Extra|Compare with File on Disk


Extra|Compare with File on Disk

Extra|Compare with File on Disk ( Available in EditPad Pro only )

The Compare with File on Disk item in the Extra menu works just like the Compare Files item, with one key difference. Whereas Compare Files asks you which file you want to compare the active file with, Compare with File on Disk compares the active file with the same file on disk. If you have made changes to a file in EditPad Pro and you haven't saved those changes yet, you can use Compare with File on Disk to see the changes that you made.

See also:

  • Extra Menu
  • Minimum number of lines for matching block
  • Extra|Compare Files
  • Extra|Next Comparison Mark
  • Extra|Previous Comparison Mark
  • Extra|Clear Comparison Marks


Extra|Next Comparison Mark

Extra|Next Comparison Mark ( Available in EditPad Pro only )

If you have used Extra|Compare Files or Extra|Compare with File on Disk , you can use Extra|Next Comparison Mark to find the block of differing paragraphs after the text cursor's position.

See also:

  • Extra Menu
  • Extra|Previous Comparison Mark
  • Extra|Clear Comparison Marks
  • Extra|Compare Files
  • Extra|Compare with File on Disk


Extra|Previous Comparison Mark

Extra|Previous Comparison Mark ( Available in EditPad Pro only )

If you have used Extra|Compare Files or Extra|Compare with File on Disk , you can use Extra|Previous Comparison Mark to find the block of differing paragraphs before the text cursor's position.

See also:

  • Extra Menu
  • Extra|Next Comparison Mark
  • Extra|Clear Comparison Marks
  • Extra|Compare Files
  • Extra|Compare with File on Disk


Extra|Clear Comparison Marks

Extra|Clear Comparison Marks ( Available in EditPad Pro only )

After you've used Extra|Compare Files or Extra|Compare with File on Disk , the files you compared may have their differences highlighted. If you're done comparing the files but want to continue working with them in EditPad Pro, select Clear Comparison Marks in the Extra menu to remove the red and green highlights.

If you don't want to continue working with the files, simply close them. You don't need to remove the comparison marks first.

See also:

  • Extra Menu
  • Extra|Compare Files
  • Extra|Compare with File on Disk


Extra|Statistics

Extra|Statistics ( Available in EditPad Pro only )

Choose Statistics from the Extra menu to have EditPad Pro compute a bunch of statistics about the file you are currently editing. EditPad Pro will create a new tab to hold the statistics.

An example:

                    Filename: C:\Program Files\EditPadPro\LICENSE.txt

                  Last saved: 24-Jul-2003 5:00

                   File size: 7,600 bytes

              Selection size:   173 bytes

        Number of paragraphs:    46

             Number of words: 1,272

Number of letters and digits: 6,094

        Number of characters: 6,247

              Selected words:    31

Selected letters and digits:   140

         Selected characters:   143

The first two lines indicated under which name the file was saved, and when it was last saved. The third line indicates the size of the file in bytes. The total file size is the total number of characters in the file, including hidden character such as line breaks.

If part of the file was selected before you picked Extra|Statistics from the menu, then the size in bytes of the selection is indicated as well.

"Number of paragraphs" indicates the number of paragraphs in the file. A paragraph is a sequence of characters terminated by pressing Enter on the keyboard, which inserts a hard return into the file. If you turn off word wrapping , then each paragraph is displayed as one line. The number of lines is not indicated in the statistics, because it varies with word wrapping.

Number of words indicates the number of sequences of "letters and digits", separated by sequences of "non-letters". A sequence consisting of a single letter or digit is also considered a word. A "letter or digit" is any character that is matched by the regular expression \w (slash lowercase w). This includes the letters a-z, the digits 0-9, and the underscore. Depending on your computer's regional settings, it will also include letters with diacritics or letters from different scripts. You can test what EditPad Pro considers a letter by picking Edit|Search and Replace from the menu, typing \w into the search box, turning on the option "regular expressions", and clicking the Search button. To search for words, use \w+ (slash lowercase w plus) instead.

Finally, "number of characters" indicates the number of printable characters. This includes all characters except spaces, tabs, line breaks and other control characters.

See also:

  • Extra Menu
  • Extra|Project Statistics
  • Extra|Statistics for All Files


Extra|Project Statistics

Extra|Project Statistics ( Available in EditPad Pro only )

Like Extra|Statistics , Project Statistics will create a new tab with statistics. It will compute the same statistics, but for all files in the current project rather than the current file only. The order of the files in the statistics is the same order as in which they are arranged in EditPad Pro's tabs. If you want the files to be sorted alphabetically, use View|Sort Tabs Alphabetically prior to using Extra|Statistics for All Files.

See also:

  • Extra Menu
  • Extra|Statistics
  • Extra|Project Statistics
  • View|Sort Tabs Alphabetically


Extra|Statistics for All Files

Extra|Statistics for All Files ( Available in EditPad Pro only )

Like Extra|Statistics , Statistics for All Files will create a new tab with statistics. It will compute the same statistics, but for all files in all projects rather than the current file only. The order of the files in the statistics is the same order as in which they are arranged in EditPad Pro's tabs. If you want the files to be sorted alphabetically, use View|Sort Tabs Alphabetically prior to using Extra|Statistics for All Files.

See also:

  • Extra Menu
  • Extra|Statistics
  • Extra|Project Statistics
  • View|Sort Tabs Alphabetically


Convert Menu

Convert|To Uppercase

Convert|To Lowercase

Convert|Initial Caps

Convert|Invert Case

Convert|Wrapping -> Line Breaks (Available in EditPad Pro only)

Convert|Line Breaks -> Wrapping (Available in EditPad Pro only)

Convert|Double -> Single Spacing (Available in EditPad Pro only)

Convert|Single -> Double Spacing (Available in EditPad Pro only)

Convert|Tabs -> Spaces (Available in EditPad Pro only)

Convert|Spaces -> Tabs (Available in EditPad Pro only)

Convert|To Windows (CR LF)

Convert|To UNIX (LF only)

Convert|To Macintosh (CR only)

Convert|Text Encoding

Convert|ROT-13

See also:

  • EditPad Pro Main Menu


Convert|To Uppercase

Converts the current selection to all uppercase letters.

See also:

  • Convert Menu
  • Convert|To Lowercase
  • Convert|Initial Caps
  • Convert|Invert Case


Convert|To Lowercase

Converts the current selection to all lowercase letters.

See also:

  • Convert Menu
  • Convert|To Uppercase
  • Convert|Initial Caps
  • Convert|Invert Case


Convert|Initial Caps

Turns all the letters in the current selection into lowercase letters, except for the first letter of each word which becomes uppercase.

See also:

  • Convert Menu
  • Convert|To Uppercase
  • Convert|To Lowercase
  • Convert|Invert Case


Convert|Invert Case

Turns all uppercase letters in the selection into lowercase letters, and all lowercase letters into uppercase.

If you have been typing with Caps Lock on, you do not have to start over but let this function come to the rescue.

See also:

  • Convert Menu
  • Convert|To Uppercase
  • Convert|To Lowercase
  • Convert|Initial Caps


Convert|Wrapping -> Line Breaks

Convert|Wrapping -> Line Breaks ( Available in EditPad Pro only )

When Options|Word Wrap is on, EditPad will break up long lines to they fit within the width of the EditPad window or are no longer than a certain number of characters. This wrapping is dynamic. It is not saved into the file. Therefore, the file will look different if you change the word wrap settings or open it in another application.

Use Convert|Wrapping -> Line Breaks if you want to solidify a text in its wrapped state. This will convert all soft line breaks introduced by the wrapping into hard line breaks as if you had pressed Enter at each position where a long line is wrapped.

You will also be asked if you want to align the text at the left side only, or if you want to align it at both sides. If you choose to align to the left side only, only line breaks will be inserted, as explained above. If you choose to align to both sides, EditPad Pro will also inserts spaces into each line, so that each line has the same number of characters. The spaces will be distributed evenly across each line. They will be inserted next to spaces already present on the original line. When the file is viewed with a fixed-width font such as Courier New, both the left and the right side of the text will be perfectly aligned.

This function will also turn off word wrap.

If you want to limit the maximum length of each line in the file, you can first set the maximum line length by using the drop-down menu of the word wrap button on the toolbar. Then use Convert|Wrapping->Line Breaks.

You should use Convert|Wrapping -> Lines when you have finished editing a file that will be used by an application or system that does not support word wrapping, or does not support lines longer than a certain number of character. For example, when preparing a message to be posted to a Usenet newsgroup or a message to be sent via email, you should set word wrap to 72 characters and then use Convert|Wrapping -> Lines. There are still a lot of newsreaders and email clients in use that cannot word wrap messages.

See also:

  • Convert Menu
  • Options|Word Wrap
  • Convert|Line Breaks -> Wrapping


Convert|Line Breaks -> Wrapping

Convert|Line Breaks -> Wrapping ( Available in EditPad Pro only )

Convert|Line Breaks -> Wrapping attempts to do the opposite of Convert|Wrapping -> Line Breaks . Email clients and newsreaders, for example, will often limit the maximum line length, inserting additional line breaks into the file that you did not type in by pressing Enter onto the keyboard. This is done because a lot of email and newsgroup software, mostly older software, still cannot handle long lines.

The problem with this is that after the hard line breaks have been inserted, the text becomes difficult to edit. The text will not be nicely and automatically rewrapped when you insert new text into a middle of the paragraph, like EditPad does when word wrap is on. With Convert|Line Breaks -> Wrapping you can tell EditPad Pro to attempt to remove the line breaks that were inserted into the file for the purpose of emulating word wrap. I did say "attempt", because EditPad Pro has no way of detecting whether a line break was automatically inserted to limit the length of the line, or if it was inserted by a person pressing Enter on the keyboard. Technically, there is no difference between the two. But usually, EditPad Pro does a remarkably good job.

See also:

  • Convert Menu
  • Options|Word Wrap
  • Convert|Wrapping -> Line Breaks


Convert|Double -> Single Spacing

Convert|Double -> Single Spacing ( Available in EditPad Pro only )

A text file is double-spaced if there is a blank line between each line of text. Select Double -> Single Spacing from the Convert menu to remove those blank lines. This conversion always affects the entire file.

If you use the double to single spacing conversion on a file that is not double-spaced, EditPad Pro will remove as many alternating blank lines as possible. If part of the file is single spaced and part is double spaced, the whole file will become single spaced. If the entire file is single spaced, but blank lines are used to separate paragraphs, then those blank lines will be removed.

Certain files will appear double-spaced in EditPad, and single-spaced in other applications such as Notepad. This is caused by a different interpretation of line break characters. Usually, those files were incorrectly transferred between a Windows and UNIX system, such as a PC and a web server. This causes incorrect line break characters to be added to the file. You can easily fix such files in EditPad Pro. First, select Convert|Double -> Single Spacing from the menu to remove the unwanted blank lines. Blank lines that appeared in the original file will remain. Then, select Convert|To Windows to make all the line breaks consistent with the Windows format. If Convert|To Windows is grayed out (i.e. unavailable), then the file already uses the correct line breaks.

See also:

  • Convert Menu
  • Convert|Single -> Double Spacing


Convert|Single -> Double Spacing

Convert|Single -> Double Spacing ( Available in EditPad Pro only )

A text file is double-spaced if there is a blank line between each line of text. Select Single -> Double Spacing from the Convert menu to insert a blank line between each line of text, making the current file double spaced. This conversion always affects the entire file.

Note that EditPad Pro will not force you to maintain the double spaced format of the file. Pressing Enter will insert a single line break as usual. Press Enter twice to insert a double line break. You can type text into the blank lines added by the conversion if you want. This could be useful to annotate a manuscript, for example.

See also:

  • Convert Menu
  • Convert|Double -> Single Spacing


Convert|Tabs -> Spaces

Convert|Tabs -> Spaces ( Available in EditPad Pro only )

Converts all tab characters in the active file into spaces. This command will only have its desired effect when using a fixed-width font like Courier New. This conversion always affects the entire file.

See also:

  • Convert Menu
  • Convert|Spaces -> Tabs


Convert|Spaces -> Tabs

Convert|Spaces -> Tabs ( Available in EditPad Pro only )

Converts as many spaces into tab characters as possible, without changing the layout of the file. This function will only have its desired effect when using a fixed-width font like Courier New. This conversion always affects the entire file.

See also:

  • Convert Menu
  • Convert|Tabs -> Spaces


Convert|To Windows (CR LF)

Converts the active file to the format used by Windows, which is also used by DOS and Amiga.

These operating systems terminate each line with a Carriage Return and Line Feed pair.

Only the line termination characters are converted. Anything else remains untouched.

To EditPad, it does not matter whether a file is in Windows, UNIX or Macintosh format. However, it will most likely matter to any other application that may need to work with the files.

See also:

  • Convert Menu
  • Convert|To UNIX (LF only)
  • Convert|To Macintosh (CR only)


Convert|To UNIX (LF only)

Converts the active file to the format used by UNIX and derivatives like Linux, BSD and even OS X. These operating systems terminate each line with a single Line Feed character.

Only the line termination characters are converted. Anything else remains untouched.

To EditPad, it does not matter whether a file is in Windows, UNIX or Macintosh format. However, it will most likely matter to any other application that may need to work with the files.

See also:

  • Convert Menu
  • Convert|To Windows (CR LF)
  • Convert|To Macintosh (CR only)


Convert|To Macintosh (CR only)

Converts the active file to the format used by the Apple Macintosh. On the Macintosh, text files use a single Carriage Return character to terminate a line. Note that OS X applications may use the LF only UNIX format rather than the classic Mac CR only format.

Only the line termination characters are converted. Anything else remains untouched.

To EditPad, it does not matter whether a file is in Windows, UNIX or Macintosh format. However, it will most likely matter to any other application that may need to work with the files.

See also:

  • Convert Menu
  • Convert|To Windows (CR LF)
  • Convert|To UNIX (LF only)


Convert|Text Encoding

Computers deal with numbers, not with characters. When you save a text file, each character is mapped to a number, and the numbers are stored on disk. When you open a text file, the numbers are read and mapped back to characters. When saving a file in one application, and opening the that file in another application, both applications need to use the same character mappings.

Traditional character mappings or code pages use only 8 bits per character. This means that only 256 characters can be represented in any text file. As a result, different character mappings are used for different language and scripts. Since different computer manufacturers had different ideas about how to create character mappings, there's a wide variety of legacy character mappings. EditPad supports a wide range of these.

In addition to conversion problems, the main problem with using traditional character mappings is that it is impossible to create text files written in multiple languages using multiple scripts. You can't mix Chinese, Russian and French in a text file, unless you use Unicode. Unicode is a standard that aims to encompass all traditional character mappings, and all scripts used by current and historical human languages.

How to Make a File Readable in EditPad

If you've received a text file from another person, or opened a file created on another computer, it may not immediately be readable in EditPad. Two things need to be set right. First, you must use a font that contains the characters you want to display. While all fonts contain English characters, far fewer fonts contain Chinese, Japanese or Arabic characters. In EditPad, select Options|Font in the menu. Make sure to select the script you want in the lower right corner of the font selection screen.

If the file still isn't displayed property after you've selected a proper font , the file was saved with a different character encoding than EditPad is using. Select Text Encoding in the Convert menu to change the encoding EditPad uses for that file.

At the top of the screen, you will see part of the file as EditPad interprets it now, along with the encoding used. Make sure the "Interpret the original data as being encoded with another character set" is marked. Then, try selecting a new encoding. The result will appear immediately in the preview at the bottom of the screen. Keep trying different encodings until you find one that produces a readable file.

If the file was created on a computer running Windows, try the Windows encodings first. All Windows computers use one of the Windows encodings as the default. UTF-8 and UTF-16 little endian are also likely, as Unicode is becoming popular among modern Windows applications.

If the file was created on a computer running a UNIX variant such as Linux, try the ISO-8859 encodings. UTF-8 and UTF-16 little endian are also likely.

If the file was created by a old DOS application, try one the DOS character sets. The DOS character sets were used by Microsoft's MS-DOS and DOS versions from other companies. If you know that the file is supposed to contain "line drawing symbols", the DOS character sets are also very likely. The DOS character sets are the only ones that contain line drawing symbols. DOS applications used characters that look like lines, bevels and corners to draw pseudo-graphical interfaces on character-based screens. DOS predates Unicode, so the Unicode formats are unlikely, even if they contain line drawing symbols.

If the file is written in Russian or Ukrainian, the KOI8-R and KOI8-U encodings are very likely candidates, even for files created on Windows or UNIX systems. Particularly ISO-8859-5 has never reached the popularity of KOI8.

If the file was created on an old mainframe or an IBM AS/400 (renamed iSeries) system, try the EBCDIC encodings. EBCDIC was the de facto standard in the days computers used punch cards. If EBCDIC doesn't produce a readable file, try the DOS character sets, which were used by IBM's PC-DOS.

How to Make an EditPad File Readable by Others

To make sure other people can read files you've written in EditPad, simply save it in an encoding that the other person can read. If he or she also uses Windows, you don't need to do anything. EditPad's default text encoding settings save the file in your computer's default Windows code page.

If the file is written in English, you also have little to worry about. English text is encoded the same way in UTF-8, all Windows code pages, all ISO-8859 code pages, all DOS code pages and also KOI8.

If your document uses non-English characters, and you're not sure which encodings the other person can read, the UTF-8 encoding is a safe bet. UTF-8 files start with a byte order marker that identify them. EditPad and many other applications running on Windows, Linux and Mac OS X detect the byte order marker, and automatically interpret the file as UTF-8. Since UTF-8 is a Unicode transformation, it supports all modern human languages. All characters present in any of the non-Unicode code pages supported by EditPad are also present in the Unicode mapping.

To change a file's encoding, select Text Encoding in the Convert menu. Mark the "encode original data with another character set" option and select the encoding you want to convert the file into. If you get a bold red warning that some characters could not be converted, this means that the encoding you are trying to convert the file into cannot represent some characters you've used in the file. Those characters will be replaced by question marks if you proceed with the conversion. The Unicode encodings are the only ones that can represent all characters from all human languages. The others are typically limited to English plus one language (e.g. Chinese) or one group of languages (e.g. Western European languages).


Convert|ROT-13

Applies ROT-13 character rotation to the current selection, making it a little difficult to read. Applying ROT-13 again restores the original text.

Before the Internet went commercial, people had the good habit to use ROT-13 to conceal possible offensive postings in newsgroups and then add a warning message in plain text. This made sure that nobody would read the text by accident and be offended. If one was offended after applying ROT-13, he or she would only have himself or herself to blame for ignoring the warning.

See also:

  • Convert Menu


Options Menu

Options|Auto Indent

Options|Line Numbers

Options|Column Numbers (Available in EditPad Pro only)

Options|Visualize Spaces (Available in EditPad Pro only)

Options|Paragraph Symbols (Available in EditPad Pro only)

Options|Word Wrap

Options|Indent Wrapped Lines (Available in EditPad Pro only)

Options|File Type (Available in EditPad Pro only)

Options|Font

Options|Stay On Top

Options|Configure Toolbar and Menus (Available in EditPad Pro only)

Options|Configure File Types

Options|Preferences

Options|Export Preferences

Options|Import Preferences

See also:

  • EditPad Pro Main Menu
  • Preferences


Options|Auto Indent

Turn on Options|Auto Indent if you want the next line to automatically start at the same column position as the previous line whenever you press Enter on the keyboard while in the editor. EditPad will accomplish this by counting the number of spaces and tabs at the beginning of the previous line and inserting them at the beginning of the new line you created by pressing Enter. This is most useful for writing source code.

Note that "auto indent" is a file type specific setting in EditPad. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Configure File Types


Options|Line Numbers

Turn on Options|Lines Numbers to have EditPad display a number before each line in the left margin.

In File Type Editor Options , you can indicate if you want visible lines or physical lines to be numbered. This setting cannot be changed in the Options menu.

Note that "lines numbers" is a file type specific setting in EditPad. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Options|Column Numbers
  • Configure File Types


Options|Column Numbers

Options|Column Numbers ( Available in EditPad Pro only )

Turn on Options|Column Numbers to have EditPad display a horizontal ruler above the file indicating column numbers. Column numbers are only displayed when using a fixed-width font .

Note that "column numbers" is a file type specific setting in EditPad. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Options|Line Numbers
  • Configure File Types


Options|Visualize Spaces

Turn on Options|Visualize Spaces if you want spaces and tabs to be visualized. Spaces will be indicated by a vertically centered dot. Tabs are indicated by a » character. This option is useful when working with files where extraneous whitespace can lead to problems, or where the difference between tabs and spaces matters.

You can set the color of visualized spaces in the Colors Preferences . If you set a background color other than "default" for whitespace in the preferences, then spaces will always be drawn with that background color, whether you've turned on the option to visualize them or not. Spaces will then appear as colored rectangles, with or without the symbol.

Note that "visualize spaces" is a file type specific setting in EditPad Pro. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Configure File Types
  • Convert|Tabs -> Spaces
  • Convert|Spaces -> Tabs


Options|Paragraph Symbols

Options|Paragraph Symbols ( Available in EditPad Pro only )

Turn on Options|Paragraph Symbols if you always want to see a ¶ character at the end of each paragraph, indicating the invisible line break character(s). Note that if line break characters are selected, the paragraph symbol will always appear to show you that they have indeed been selected. You can set the color of the paragraph symbols in the Colors Preferences .

Note that "paragraph symbols" is a file type specific setting in EditPad Pro. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Configure File Types


Options|Word Wrap

Select Options|Word Wrap from the menu to toggle word wrapping on or off. By default, word wrap takes place at the right edge of the EditPad window. If you want the text to wrap at a certain number of characters, use the drop-down menu of the word wrap button on the toolbar. You can select one of a few commonly used line lengths, or define your own.

Note that "word wrap" is a file type specific setting in EditPad. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Options|Indent Wrapped Lines
  • Configure File Types


Options|Indent Wrapped Lines

Options|Indent Wrapped Lines ( Available in EditPad Pro only )

When word wrap is on, you can select Options|Word Wrap from the menu to toggle wrapping line indentation on or off. When on, lines created by the word wrapping will be indented by the same amount as the line they were broken off from. If you turn it off, wrapped lines will start at the first column regardless of the indentation of the original line. Turning on this option is useful when turning on word wrap for files using nested block structures, such as XML files and various programming languages.

Note that "indent wrapped lines" is a file type specific setting in EditPad. This means that if you change the setting through the Options menu or the toolbar, it will not stick. If you create a new file or open an existing one, the setting made in File Type Editor Options for the type of file you are creating or opening, will be used. Also, when you use File|Save As , and you save the file with a new extension, then the setting for the current file will change into what you specified in File Types Preferences for the file type that corresponds with the file's new extension.

See also:

  • Options Menu
  • Options|Word Wrap
  • Configure File Types


Options|File Type

Options|File Type ( Available in EditPad Pro only )

When you open a file, EditPad looks at the file's extension to see which type of file it is. If you open a file with an extension not associated with any file type in EditPad's file type configuration , you can change the file type through Options|File Type.

Changing the file type will cause EditPad to change the file's settings for auto indent, line numbering, word wrap, etc. to those specified in the File Types Preferences for that file type. It will not change the file's extension, so the next time you open the file, you will need to use Options|File Type again. Use File|Rename and Move to change the file's name and extension.

See also:

  • Options Menu
  • Configure File Types


Options|Font

If you pick Options|Font from the menu or left-click the font button on the toolbar , a font selection window will appear. Select the font you want to use and click OK. This will change the display font for the active file, but not of all the other files you may have open. When you create a new file or open an existing one, the newly opened or created file will use the same font as the active file.

Note that the font setting applies to the entire file, and changes the way it is displayed only. EditPad is a plain text editor and therefore does not support any text formatting.

The Font button on the toolbar maintains a history of recently used fonts. If you click on the downward pointing arrow next to the Font button, you can instantly switch back to a recently used font.

If you want to edit text files in a language that uses characters which not used in English, you will need to select the correct "script" from the drop-down list near the bottom of the font selection window that appears when you select Options|Font from the menu. Not all fonts support all scripts. Particularly scripts like Arabic, Chinese, Japanese or Korean are often supported by few fonts. If you can't find any font with the script you want, you will need to install them from your original Windows CD. You can do so by clicking on the Windows Start button, choosing Settings, and opening the Control Panel. Among the Regional Settings, there are options for enabling support for complex scripts and ideographic scripts.

Some fonts have "Unicode" in their name. Such fonts include "Arial Unicode" and "Lucida Sans Unicode". These fonts contain all characters in all languages that Windows supports. If you use one of these fonts, you never have to worry about using the right font for the right language.

Fonts with Chinese, Japanese and Korean characters are available in two variants: the regular variant (e.g. MS Mincho), and a rotated variant for vertical printing (e.g @MS Mincho). The rotated variant always has the same name as the regular variant, but with an @ symbol in front of it. In Options|Font, you should select the regular variant, so characters will appear upright on the screen. In the print preview , you can select the rotated variant if you want. If you print with the rotated variant, the text will appear printed vertically if you rotate the printed sheet of paper 90 degrees clockwise. If you print with the regular variant, the printed text will flow from left to right, like you edit it in EditPad.

See also:

  • Options Menu


Options|Stay On Top

If you turn on Options|Stay On Top, the EditPad main window will remain visible even when you switch to another application.

See also:

  • Options Menu


Options|Configure Toolbar and Menus

Options|Configure Toolbar and Menus ( Available in EditPad Pro only )

Via the Congigure Toolbar and Menus item in the Options menu you can configure which items from the main menu appear on the toolbar and which items appear on various right-click menus. You can also configure the keyboard shortcuts for all items in the main menu.

  • Configure Toolbar
  • Configure Context Menus
  • Configure Keyboard Shortcuts


Options|Configure File Types

Select Configure File Types in the Options menu to open the file type configuration screen .

See also:

  • Options Menu
  • Configure File Types


Options|Preferences

Opens the preferences window .

See also:

  • Options Menu
  • Colors Preferences
  • Cursors Preferences
  • Editor Preferences
  • Files Preferences
  • Tabs Preferences
  • Statusbar Preferences
  • Keyboard Preferences
  • Shortcuts Preferences
  • Email Preferences
  • System Preferences


Options|Export Preferences

Use Options|Export Preferences to save your preferences into an .ini file. This allows you to transport them to another computer.

See also:

  • Options Menu
  • Options|Preferences
  • Options|Import Preferences


Options|Import Preferences

Imports preferences saved with Options|Export Preferences .

See also:

  • Options Menu
  • Options|Preferences
  • Options|Export Preferences


View Menu

View|Next File

View|Previous File

View|Previously Edited File

View|Sort File Tabs Alphabetically

View|Next Project (Available in EditPad Pro only)

View|Previous Project (Available in EditPad Pro only)

View|Sort Project Tabs Alphabetically (Available in EditPad Pro only)

View|Hexadecimal (Available in EditPad Pro only)

View|Byte Value Editor (Available in EditPad Pro only)

View|Character Map (Available in EditPad Pro only)

View|File Panel (Available in EditPad Pro only)

View|Explorer Panel (Available in EditPad Pro only)

View|FTP Panel (Available in EditPad Pro only)

View|File History (Available in EditPad Pro only)

View|Clip Collection (Available in EditPad Pro only)

View|File Navigator (Available in EditPad Pro only)

View|Browser

View|New Editor

View|Close Panes

View|Focus Editor

Below these menu items you will see a list of files that are currently open. If you click on one of them, that file will become the active one.

If more than 10 files are open, only 10 of them will be listed and the "Show Preceding Tabs" or "Show Following Tabs" menu items will be added. If you click on "Show Preceding Tabs", the View menu will show the files preceding the ones currently listed. Likewise, "Show Following Tabs" will make the View menu show the next tabs. When you do this, you will need to click on View in the menu bar to open the View menu again.

Preceding files are the files whose tabs are positioned to the left on the tab control, while following tabs are positioned to the right.

See also:

  • EditPad Pro Main Menu


View|Next File

The View|Next File menu item will activate the next file tab in the current project . If the last file in the project is active, then the first file will be activated.

This menu item is primarily provided so you can assign a keyboard shortcut to it in the Keyboard Preferences . The default shortcut is F6. The standard Windows key combination Ctrl+Tab for cycling through tabs also works.

If you like to use the mouse, you can quickly switch between files by clicking on their tabs, or by double-clicking on the file's node in the File Panel .

See also:

  • View Menu
  • View|Previous File
  • View|Previously Edited File
  • View|Next Project
  • View|File Panel


View|Previous File

The View|Previous File menu item will activate the previous file tab in the current project . If the first file in the project is active, then the last file will be activated.

This menu item is primarily provided so you can assign a keyboard shortcut to it in the Keyboard Preferences . The default shortcut is Shift+F6. The standard Windows key combination Shift+Ctrl+Tab for cycling backwards through tabs also works.

If you like to use the mouse, you can quickly switch between files by clicking on their tabs, or by double-clicking on the file's node in the File Panel .

See also:

  • View Menu
  • View|Next File
  • View|Previously Edited File
  • View|Previous Project
  • View|File Panel


View|Previously Edited File

Select Previously Editing File in the View Menu to activate the last file that you made a change to. If that file is already active, the file you last made a change to other than the active file will be activated. When you have many files open, you can use this command to quickly go back to the file you were editing after you've looked at other files. E.g. if you want to copy and paste something from another file into the file you're editing, switch to the other file, copy the text you want to paste, and then use View|Previously Edited File to instantly go back to the spot where you want to paste.

If you use the Previously Edited File command a second time right after the first time, or a third time right after the second time, EditPad will activate the file you last edited before the active one.

The fourth time, Previously Edited File will re-activate the file that was active when you first used Previously Edited File. It will do so even if you didn't edit that file at all.

After that, the circle will repeat itself.

See also:

  • View Menu
  • Edit|Go to Previous Editing Position


View|Sort File Tabs Alphabetically

Pick Sort File Tabs Alphabetically from the View menu to sort the tabs of all files in the current project alphabetically by their file names. Note that the tabs will be sorted only at the moment you click on Sort File Tabs Alphabetically. If you open more files, the alphabetical order will not be maintained. Tabs for newly opened files are always placed to the immediate right hand side of the tab that was active when you opened the additional files.

You can also rearrange the tabs in any order you want by dragging them with the mouse. To drag a tab, click on it, hold the mouse button down, and move the mouse to the left or right. The tab will follow the mouse pointer until you release the mouse button. If you drag the tab to the left edge of the leftmost tab, and there are more tabs, presently invisible, to the left of that tab, then all the tabs will scroll to the right, allowing you to move the tab you are dragging further to the left. Similarly, you can drag the tab to the right edge of the rightmost tab to make the tabs scroll to the left.

See also:

  • View Menu
  • View|Sort Project Tabs Alphabetically
  • View|File Panel


View|Next Project

View|Next Project ( Available in EditPad Pro only )

The View|Next Project menu item will activate the next project tab . If the last project is active, then the first project will be activated.

This menu item is primarily provided so you can assign a keyboard shortcut to it in the Keyboard Preferences . The default shortcut is Ctrl+F6.

If you like to use the mouse, you can quickly switch between projects by clicking on their tabs, or by double-clicking on the project's node in the File Panel .

See also:

  • View Menu
  • View|Previous Project
  • View|File Panel


View|Previous Project

View|Previous Project ( Available in EditPad Pro only )

The View|Previous Project menu item will activate the previous project tab . If the first project is active, then the last project will be activated.

This menu item is primarily provided so you can assign a keyboard shortcut to it in the Keyboard Preferences . The default shortcut is Shift+Ctrl+F6.

If you like to use the mouse, you can quickly switch between projects by clicking on their tabs, or by double-clicking on the project's node in the File Panel .

See also:

  • View Menu
  • View|Next Project
  • View|File Panel


View|Sort Project Tabs Alphabetically

View|Sort Project Tabs Alphabetically ( Available in EditPad Pro only )

Pick Sort Project Tabs Alphabetically from the View menu to sort the tabs of all projects alphabetically by their file names. Note that the tabs will be sorted only at the moment you click on Sort Project Tabs Alphabetically. If you open more projects, the alphabetical order will not be maintained. Tabs for newly opened projects are always placed to the immediate right hand side of the tab that was active when you opened the additional files.

You can also rearrange the tabs in any order you want by dragging them with the mouse. To drag a tab, click on it, hold the mouse button down, and move the mouse to the left or right. The tab will follow the mouse pointer until you release the mouse button. If you drag the tab to the left edge of the leftmost tab, and there are more tabs, presently invisible, to the left of that tab, then all the tabs will scroll to the right, allowing you to move the tab you are dragging further to the left. Similarly, you can drag the tab to the right edge of the rightmost tab to make the tabs scroll to the left.

See also:

  • View Menu
  • View|Sort File Tabs Alphabetically
  • View|File Panel


View|Hexadecimal

View|Hexadecimal ( Available in EditPad Pro only )

Switches between text and hexadecimal editing. Note that the undo and redo lists will be cleared whenever you switch.

In hexadecimal mode, the editing area is split into three zones. The left zone is a column with byte offsets. It indicates the offset relative to the start of the file of the first byte on each row in the hex editor. The first file in the byte has offset zero.

The middle area shows all the bytes in the file represented as a hexadecimal number. You can type in the numbers 0 through 9 and the letters A through F to insert bytes. To change some bytes without changing the length of the file, press the Insert key on the keyboard to toggle between Insert and Overwrite mode. In Overwrite mode, the bytes you type in will replace the bytes already present in the file.

The right hand column shows the textual representation of each byte. You can select the code page used to translate the bytes into characters in the Editor Preferences . You can type characters into the text column. EditPad Pro will use the selected code page to translate them into bytes.

If your binary files store integer or floating point numbers that are larger than one byte, you can easily edit those numbers in decimal representation using EditPad Pro's Byte Value Editor while you're in hexadecimal mode.

See also:

  • View Menu
  • View|Byte Value Editor


View|Byte Value Editor

View|Byte Value Editor ( Available in EditPad Pro only )

When editing a file in hexadecimal mode , you can open EditPad Pro's Byte Value Editor. With the Byte Value Editor, you can edit the byte that the text cursor points to in the hexadecimal editor, and up to 7 bytes that follow it. Instead of entering hexadecimal values directly in the hex editor, you can enter decimal numbers in various formats. When you enter a number in one of the formats, EditPad Pro automatically converts the decimal number into 1 to 8 bytes. EditPad Pro uses those bytes to replace the byte pointed to by the cursor and as many following bytes as needed.

The Byte Value Editor works with the main file editing area, as well as with the search and replace boxes. The edit box that was the last one to have keyboard focus is the one the Byte Value Editor is connected to.

The first row of values are unsigned integers of 1, 2, 3, 4, 6 or 8 bytes. Values are directly converted between decimal and hexadecimal.

The second row of values are signed integers of the same sizes. Hexadecimal values are negated using two's complement, like modern microprocessors do. E.g. if you enter -1 in any of the signed integer boxes, all bytes will be set to FF.

The binary box allows you to enter up to 8 bits to edit the current byte as a binary number. This is useful if the byte represents a bit field.

Three floating point boxes allow you to enter floating point numbers of various precisions. The 4-byte floating point number defines a 32-bit single precision floating point number following the IEEE standard. The 8-byte floating point number defines a 64-bit double precision floating point number, also following the IEEE standard. The single precision and double precision floating point numbers are identical to the single and double floating point types in most modern programming languages. You can type in floating point numbers using scientific notation. E.g. 1.5e6 is one and a half million. Positive infinity, negative infinity and "not a number" are represented by Inf, -Inf and NaN respectively.

The 6-byte floating point number is a bit of an odd-ball. It defines a 48-bit floating point number which corresponds with the "Real" type in Turbo Pascal and other Pascal variants. In Delphi, the "Real" type is actually a 64-bit double precision floating point number. The "Real48" type is the Delphi equivalent of the Real type in Turbo Pascal.

The little and big endian options switch the order of the bytes. The decimal value 300 is 0x12C in hexadecimal. In little endian format, the two bytes are ordered 2C 01, starting with the least significant byte. In big endian, the two bytes are ordered 01 2C, starting with the most significant byte. You can see the difference if you type 300 in the "word" field in EditPad Pro. The Intel and AMD processors that Windows run on all use the little endian format natively. The PowerPC processors that the Apple Macintosh used to run on use the big endian format natively. Recent Macs use little endian Intel processors.

See also:

  • View Menu
  • View|Hexadecimal


View|Character Map

View|Character Map ( Available in EditPad Pro only )

Select Character Map in the view menu to show a grid with all the characters available in the current file's encoding. You can change the encoding with Convert|Text Encoding .

If the current encoding is an 8-bit encoding, the character map will display all characters in the encoding except non-printable control characters. The Windows encodings, except those for Far East languages, and the DOS encodings are encodings with 240 characters and 32 control characters. The ISO-8859 and EBCDIC encodings are encodings with 192 characters and 64 control characters. Some character maps have holes in them indicated with a faint X. These indicate positions in the encoding that do not define any character yet, but may define one in the future.

The various Unicode transformations and the Windows encodings for Korean, Japanese and Chinese define thousands of characters. EditPad Pro's character map will display the characters in the order given to them by the Unicode standard. To make it easier for you to find the character you want, you can filter the map to show only characters of a certain type. Simply select the type you're interested in from the drop-down list. The available types correspond with the character properties defined by the Unicode standard.

When you hover the mouse over a character in the map, its decimal and hexadecimal number in the encoding will be shown in the status bar. Double-click on a character to insert it into the file.

If certain characters appear as squares, that means the character cannot be displayed using the current font. You can select a different font with Options|Font . Particularly when showing all Unicode characters, you will see a lot of squares. While Unicode tries to define characters for all human languages and scripts, most fonts only support one script, or one group of closely related scripts. Microsoft supplies a font called "Arial Unicode" with recent versions of Windows. This font can display nearly all Unicode characters.

See also:

  • View Menu
  • Convert|Text Encoding


View|File Panel

View|File Panel ( Available in EditPad Pro only )

The File Panel is a panel that sits docked at the left side of EditPad's window. You can make it visible by selecting File Panel in the View menu .

The File Panel shows a collapsible tree of the projects and files you have open in EditPad Pro. All project nodes in the tree sit under the EditPad Workspace root node. Files that are saved in the same folder as the project itself are added directly under the project node. For files saved in a subfolder of the project's folder, a folder node for the subfolder is added to the project node, and the files are added to the folder node. For files saved in a completely different folder, folder nodes are added showing the files' complete paths. Projects, folders and files are always sorted alphabetically in the file panel.

The File Panel offers several commands that you can execute by clicking on the panel's toolbar button, or via the right-click menu. The key difference between these commands and their equivalents that you find in EditPad Pro's main menu is that these commands work on the files and projects that you have selected in the File Panel, rather than the active project or active file.

Edit

Double-click on a file node to activate the file for editing. If the file's project isn't active yet, it will be activated too. Double-click on a project node to activate the project, and the file last active in that project.

Save

If you've selected one or more files, those files will be saved just like File|Save would do. If you've selected a project, that project is saved like Project|Save Project As would do. Saving a project does not save the files in that project.

Close

Closes the selected files or projects like File|Close and Project|Close Project would do.

Rename and Move

If you selected one file or one project, you will be asked for a new name and folder for that file or project, just like the File|Rename and Move and Project|Rename and Move Project do for the active file or project.

If you selected several files, you will be asked for a folder to move the files into. All selected files will be moved into that folder, without being renamed. This way you can quickly move a bunch of files to a different location.

If you selected several projects, you can choose whether to move the .epp files into which the projects themselves are saved, or whether you want to move the document files held by the projects, or both. All those files will be moved into the folder you select under the names they already have.

Save Copy As

If you selected one file or one project, you will be asked in which folder and under which name you want to save the copy of the file or project. This works just like File|Save Copy As and Project|Save Copy of Project As do for the current file or project.

If you selected several files, you will be asked for a folder to copy the files into. All selected files will be copied into that folder under the names they already have. This way you can quickly copy a bunch of files.

If you selected several projects, you can choose whether to copy the .epp files into which the projects themselves are saved, or whether you want to copy the document files held by the projects, or both. All those files will be copied into the folder you select under the names they already have.

New Project

Creates a new untitled project. If one or more files are selected, they will be moved into the newly created project. This is a quick way to split a project with many files into multiple projects with a manageable number of files. If no files are selected, the new project will have one untitled blank file.

Select Active File

When you switch between files in EditPad, the File Panel will automatically select the file you just switched to, unless you previously selected more than one file in the File Panel. In that case, or if you changed the selection, you can click the Select Active File button to make the File Panel select the file you're currently editing.


View|Explorer Panel

View|Explorer Panel ( Available in EditPad Pro only )

The Explorer Panel is a panel that sits docked at the left side of EditPad's window. You can make it visible by selecting Explorer Panel in the View menu .

The Explorer Panel functions as a miniature version of Windows Explorer, the file manager that is part of Windows. With EditPad Pro's Explorer panel, you can easily open files without having to go through File|Open . You can also copy, move and delete files, even if you didn't open those files in EditPad Pro. The copy, move and delete commands in the Explorer Panel work on the files that you've selected in the Explorer panel, rather than the files you have opened in EditPad Pro.

By default, the Explorer Panel shows a tree of all drives, folders and files on your computer. Since the list of files may be too long to work comfortably, you can apply various filters to make the Explorer Panel show only those files you're interested in.

Open

If you've selected one or more files, the Open button will open those files into the current project , just like File|Open would do. If you've selected one or more folders, the Open button will open all files in all the selected folders and all the subfolders of the selected folders. However, only files passing the Explorer Panel's filter will be opened, since those are the only files visible in the Explorer Panel.

Select Active File

If the file you're editing in EditPad Pro has a file name (i.e. you've saved it), you can click the Select Active File button to select that file in the Explorer Panel. Drives and folders in the Explorer Panel's tree will be expanded as needed. If the file you're editing is not visible in the Explorer Panel because you've filtered it out , then the folder containing the file will be selected instead.

Up Folder

The Up Folder button is a quick way to select the folder that contains the currently selected file or folder. If the home folder is selected when you click the Up Folder button, EditPad Pro will make the home folder's parent folder the new home folder. If the home folder is a drive, then the desktop space becomes the new home folder.

Favorite Folders

To add a folder to your favorite folders, click on the downward pointing arrow next to the Favorite Folders button, and click on the Add Selected Folder item. You can then quickly select that folder in the Explorer Panel by clicking on the downward pointing arrow next to the Favorite Folders button, and clicking on the folder you want to select.

Set Home Folder

Click the Set Home Folder button to make the currently selected folder the root folder of the Explorer Panel. Any folders above the home folder will be invisible. If you save all your text files on a particular drive or in a particular folder, setting that drive or folder as the home folder will make the Explorer Panel easier to navigate. EditPad Pro will remember your home folder next time you run it. The Explorer Panel will then load much faster, as it only has to scan the home folder that you specified, rather than all drives and network resources connected to your PC.

Copy

If you selected one file, the Copy button will ask you for a folder where to save the file, and a name to save it under. With one file, the Copy command works like File|Save Copy As , except that it copies the file you selected in the Explorer Panel rather than the active file.

If you selected more than one file, or you selected one or more folders, the Copy button will ask you for a folder to copy all the selected files and folders into. Folders will be copied entirely, including all their files and all their subfolders. All files will be copied, including files that are invisible in the Explorer Panel because of the file filter .

Rename and Move

If you selected one file, the Copy button will ask you for the folder you want to move the file into, and the new name you want to give it. With one file, the Rename and Move command works like File|Rename and Move , except that it renames and/or moves the file you selected in the Explorer Panel rather than the active file.

If you selected more than one file, or you selected one or more folders, the Rename and Move button will ask you for a folder to move all the selected files and folders into. The files and folders will be moved only, not renamed. Folders will be moved entirely, including all their files and all their subfolders. All files in the selected folders will be moved, including files that are invisible in the Explorer Panel because of the file filter .

Delete

Click the Delete button to delete the selected files and folders. When deleting files and folders from the hard disk, they will be moved into the Windows Recycle Bin.


File Filter

File Filter ( Available in EditPad Pro only )

EditPad Pro's Explorer Panel and FTP Panel allow you to filter the files they display. Showing only the files you're interested in makes it easier to work with folders containing large numbers of files.

The Explorer and FTP panels are not updated instantly while you edit the filters. To update the panel, either click on it with the mouse or press Enter while one of the filter drop-down lists has keyboard focus.

You can filter files based on their names in four ways:

  • Show any type of file: Do not filter files based on their names.
  • Show files of type: Shows the files that match the file mask of the file types you've configured . Select the file type you want from the drop-down list.
  • Files matching a file mask: Shows the files that match the file mask you type into the drop-down list. You can enter multiple masks delimited by semicolons.
  • Show files matching a regex: A file will only be shown if the regular expression you type into the drop-down list matches the file's name. If you enter multiple regular expressions delimited by semicolon, a file will be shown if at least one of the regular expressions matches.

In addition to filtering files based on their names, you can also filter files based on the date and time they were last modified.

  • Show files modified at any time: Do not filter files based on their last modification date.
  • Last modified during the past...: Only show files that have been last modified in a certain number of past hours, days, weeks, months or years.
  • Not last modified during the past...: Only show files that were not last modified in a certain number of past hours, days, weeks, months or years.
  • Last modified since...: Only show files last modified on or after a specific date. Files last modified on the date you specify are shown.
  • Not last modified since...: Only show files that were last modified before a specific date. Files last modified on the date you specify are shown.

When specifying a time period, EditPad Pro starts counting from the start of the current period. E.g. if you tell EditPad Pro to show files modified during the last two hours at half past three, EditPad Pro will show files modified at or after one o'clock, two hours before the start of the current hour.

Weeks start on Monday. If you tell EditPad Pro to show files modified during the last week on Wednesday the 14th, EditPad Pro will show files modified on or after Monday the 5th. The only exception to this rule is when you filter the files by a number of weeks on a Sunday. Then, EditPad Pro starts counting from the next Monday. The same filter on Sunday the 18th will have EditPad Pro show files modified on or after Monday the 12th.


View|FTP Panel

View|FTP Panel ( Available in EditPad Pro only )

The FTP Panel is a panel that sits docked at the left side of EditPad's window. You can make it visible by selecting FTP Panel in the View menu .

EditPad Pro's FTP Panel provides basic FTP functionality. It is not intended to replace a stand-alone FTP client. Rather, the FTP Panel offers a quick way to open a file from an FTP server, or to save a file onto an FTP server.

FTP Panel Layout

The tree view at the top of the FTP Panel shows all the FTP servers EditPad Pro is currently connected to. EditPad Pro can be connected to any number of FTP servers at the same time. You can transfer files between your PC and all the connected servers simultaneously. Obviously, this will only be practical with a high-speed Internet connection. The tree at the top also shows an upload and download queue for each server below the server's node. You can resize the server tree by dragging the (invisible) splitter bar immediately below the server tree, above the toolbar with the open, download and upload buttons.

The tree at the bottom shows the folder structure of the FTP server you selected in the list of servers at the top. If you click on another server, the folder view will be replaced instantly. You can do so at any time, even when EditPad Pro is still retrieving part of the folder structure. The retrieval will continue in the background.

By default, the FTP Panel shows all folders and files on the selected FTP server. Since the list of files may be too long to work comfortably, you can apply various filters to make the FTP Panel show only those files you're interested in.

Ascii and Binary Mode

Many FTP client have a switch that lets you choose whether to upload and download files in ascii or binary mode. In binary mode, the FTP client uploads or downloads an identical copy of the file. In ascii mode, the FTP client and server will attempt to convert the file between the client and server operating systems. E.g. when using a Windows FTP client to upload a text file to a Linux server, Windows-style line breaks will be converted to UNIX-style line breaks when uploading a file, and the other way around when downloading a file.

EditPad Pro always uploads and downloads files in binary mode. You'll always get an exact copy of what's on the server, and you'll always put an exact copy of the file back onto the server. Unlike many other applications, EditPad Pro transparently handles Windows, UNIX and Macintosh text files. Still, you should be careful when uploading files to Linux or UNIX servers. E.g. a CGI script may abort with a mysterious 500 server error if you upload it with Windows-style line breaks onto a web server running Linux. The solution is to select Convert|To UNIX (LF only) in EditPad Pro's menu before uploading the file. You can also save the file on your Windows PC with UNIX-style line breaks, so you need to do the conversion only once. You can also set the default for new files in the File Type Encoding settings.

Connect to FTP

Click the Connect to FTP button to connect to an FTP server. Enter the server's host name (e.g. ftp.mydomain.com), port (usually 21), your login or user name and your password. You can also choose whether EditPad Pro should remember your password.

Optionally, you can also enter a description for the FTP server. This description will appear in history lists instead of the default username@hostname. The initial directory is the directory that EditPad Pro navigates to when you first connect to the FTP server. If you don't specify an initial directory, EditPad Pro will let the FTP server choose the initial directory. If you turn on the option "use initial directory as root", you will only be able to access the initial directory and its subdirectories. You won't be able to access the directory's parent or sibling directories. This option is available whether you specified the initial directory or not. If you have a slow internet connection, you can tell EditPad Pro to keep a cached copy of the FTP server's directory listings. This will speed up future connections to the same server. You may want to turn off this feature if you often modify files on the FTP server outside of EditPad Pro, as that will cause the cached listings to be out of date, which may be confusing. If EditPad Pro cannot retrieve an FTP server's directory listings, try toggling the "passive FTP" option. While passive FTP is usually preferred, not all servers support it. If a server times out the connection quickly, you can tell EditPad Pro to send "no operation (NOOP)" commands to the server every 30 seconds. Not all servers will reset the time-out in response to NOOP commands.

In the "translate FTP folders into HTTP URLs" box, you can enter a list of FTP folder paths and their corresponding HTTP URLs. Enter one folder=URL pair per line, separating the folder and URL with an equals sign. The folder must be a full path. When you select the View|Browser command when you're editing a file in that folder, EditPad Pro will replace the folder path in the file's path with the URL. E.g. if you specify /usr/home/me/public_html/=http://www.mydomain.com and you're editing the file /usr/home/me/public_html/subfolder/file.html then EditPad Pro will open the URL http://www.mydomain.com/subfolder/file.html

When you want to connect to the same server again, you can select it from the Connect button's drop-down menu. If the password was remembered, EditPad Pro will connect to the server instantly. Otherwise, it will ask you for the password.

You can connect to as many servers as you like. Connecting to another server does not break previous connections. Simply click on a connection in the top half of the FTP panel to see the file listings. You can also connect to the same server more than once if you use a different login name. Since a server may restrict the number of connections from a single computer, you may have to disconnect from the server before reconnecting with a different login. EditPad Pro does not impose any restrictions on the number of simultaneous connections to an FTP server.

Disconnect from FTP

Click the Disconnect from FTP button to break EditPad Pro's connection with the selected FTP server. Any pending uploads or downloads will be aborted. The server will be removed from the list of servers in the top half of the FTP panel.

If the FTP server or a network outage breaks the connection, the server will remain listed in the FTP panel. EditPad Pro won't notice that the connection was broken until you try to upload or download another file. When you do, EditPad Pro will automatically try to reconnect to the server every 10 seconds until it either succeeds, or you click the Disconnect button.

Favorites

The Connect to FTP button will automatically keep a history of the last 16 FTP servers that you connected to. If you connect to lots of FTP servers, and use some more frequently than others, you can add the FTP servers you use frequently to your list of favorite FTP servers. To add a server to the list, connect to it. Then click on the downward pointing arrow next to the Favorites button, and click on the Add Connected FTP Server item. To connect to a favorite FTP server, select it from the Favorites button's drop-down menu.

Abort

Aborts all uploads and downloads to and from the selected server that are currently pending or in progress.

Open from FTP

Click the Open from FTP button to open all selected files for editing. EditPad Pro will instantly create new, empty tabs for the files. The files are added to the FTP server's download queue. While a file downloads, its text will appear in EditPad Pro bit by bit. You can start editing the downloaded portion right away. The remainder of the file will be appended as it is downloaded. If you close a tab before the file is downloaded, that file's download will be aborted.

You cannot open entire folders from FTP like you can open entire folders in the Explorer Panel . If you click Open from FTP with a folder selected, that folder's node will simply be expanded. EditPad Pro will retrieve the list of subfolders and files, but won't actually download the files themselves.

EditPad Pro will remember that you opened the files from FTP. When you use File|Save or File|Save All , or you confirm the save question asked by File|Close and similar commands, EditPad Pro will automatically upload the file back to the FTP server, overwriting the original file. To save the file on your computer, use File|Save As instead. Once you save the file on your own computer, EditPad Pro will not automatically upload it to the FTP server when you save.

Download

Click the Download button to download the selected files to disk, without opening them for editing in EditPad Pro. If you selected one file, EditPad Pro will ask you where and with which name you want to save it. If you selected more than one file, EditPad Pro will ask you for the folder where you want to save the selected files. All files will be downloaded with the same name as they have on the FTP server.

Upload File

Click the Upload File button to upload the file you're currently editing to the FTP server. If you selected a folder in the FTP panel, the file will be uploaded into that folder. If you selected a file in the FTP panel, the file you're editing will be uploaded into the same folder as the selected file. EditPad Pro will ask you which name you want the uploaded file to have on the FTP server.

If the file you're uploading was untitled, EditPad Pro will change the tab's caption to the file name you used to upload the file. If you later modify the file and use File|Save or File|Save All , or you confirm the save question asked by File|Close and similar commands, EditPad Pro will automatically upload the file back to the FTP server, overwriting the original file. To save the file on your computer, use File|Save As instead. Once you save the file on your own computer, or if it already had been saved on your own computer before you uploaded it, EditPad Pro will not automatically upload it to the FTP server when you save.

Upload Project

Click on the downward pointing arrow next to the Upload File button and select Upload Project from the drop-down menu to upload all files in the current project. If you selected a folder in the FTP panel, the files will be uploaded into that folder. If you selected a file in the FTP panel, the project's files will be uploaded into the same folder as the selected file.

If one or more of the files in the project are untitled, EditPad Pro will ask you for a name for those files. Files that were previously uploaded or saved will be uploaded with the name they already have. Files that were untitled when you uploaded them will be automatically uploaded when you save them, just like when uploading a single untitled file.

Upload from Disk

Click on the downward pointing arrow next to the Upload File button and select Upload Project from the drop-down menu to upload files that you aren't editing in EditPad Pro. EditPad Pro will show an open file dialog to select the files to upload. You can select multiple files to be uploaded. If you selected a folder in the FTP panel, the files will be uploaded into that folder. If you selected a file in the FTP panel, the files will be uploaded into the same folder as the selected file.

Create Folder

Click the Create Folder button to create a new folder on the FTP server. If you selected a folder in the FTP panel, the new folder will become a subfolder of the selected folder. If you selected a file in the FTP panel, the folder will become a subfolder of the folder that holds the selected file.

Delete

To delete a file or folder, right-click on it and select Delete in the context menu. Most FTP servers will not allow you to delete a folder until you've deleted all of its files and subfolders. You can delete multiple files and folders by selecting them all, and then right-clicking on one of the selected items.


View|File History

View|File History ( Available in EditPad Pro only )

The File History is a panel that sits docked at the left side of EditPad's window. You can make it visible by selecting File History in the View menu .

The File History shows a list of all backup files that exist for the file you're currently editing in EditPad Pro. To determine which files are backups, the File History uses the "backup copies" setting in the Files Preferences . The File History will only show files that follow the naming method you selected in the Files Preferences. To make the File History useful, you should select one of the "multi backup" options or the "hidden history" option. These are the only backup methods that can keep more than one backup copy of any given file.

The File History will display two dates for each backup file: the modification date and the backup date. When creating a backup copy, EditPad Pro sets the backup's last modification time stamp to that of the original file. E.g. Today, December 1st, you open a file last modified on November 27th. When you save the file, EditPad Pro will create a backup copy with a modification date of November 27th. The original file will get a modification date of December 1st. When you view the contents of the backup folder in Windows Explorer, the backup file's date will show the November 27 modification date.

The backup date indicates the date that the backup copy was made. In the example above, that would be December 1st. If you right-click on the file in Windows Explorer and select properties, the file's creation date will indicate the date the backup copy was made.

Compare

Select one of the backup copies and click the Compare button to show the differences between the backup copy and the state the file currently has in EditPad Pro. You will be asked for the same file comparison options used by Extra|Compare Files . The backup copy will be highlighted as the "old" file, and the file you're editing in EditPad pro as the "new" file.

To compare two backup copies with each other, first open the younger copy of the two. Then, select the older copy and click the Compare button. The backup copy you've opened in EditPad Pro will always be highlighted as the "new" file, because it takes the role of the file you're currently editing. Therefore, you should open the younger copy of the two you want to compare. This will avoid confusion as to which is which.

When the active tab has file comparison highlights, the File History will show the full paths of the files that were compared along with their colors. The color for the original file, or the "old" file, is used to highlight lines only present in that file. The color for the edited file, or the "new" file, is used to highlight lines only present in that file. Lines present in both files are not highlighted.

Open

Select a backup file and click the Open button to open the file in a tab for viewing or editing. The tab will indicate the file name of the backup file. If you try to save the backup file with File|Save , EditPad Pro will prompt you for a file name. You should save the file under a new name rather than overwriting a backup file. If you overwrite a backup file, EditPad Pro will make a backup of the backup, which can get confusing.

If you open a backup copy via the File History, the File History will continue to display the backup copies of the original file. You should not use File|Open or other commands to open backup copies outside the File History, because then the link between the backup and the original won't be established.

Save Milestone

The Save Milestone button saves the file you're editing in EditPad Pro. However, it does not overwrite the original file. Instead, it creates a separate "milestone" copy. The milestone copy will appear among the backup files in the File History. The difference between a milestone copy and a backup copy is that EditPad Pro will automatically delete backup copies when they exceed the number and age limits you specified in the Files Preferences . Milestone copies are never automatically deleted. They function as a more permanent backup. You should make a milestone copy whenever you're embarking on a more involved editing task that you might want to undo entirely.

If you forgot to save a milestone copy, you can do so afterwards as long as there's still a backup copy of the file in the state it had when you should have saved the milestone. Simply open that backup copy via the File History, and click the Save Milestone button. When you save a milestone of a backup file that you've opened via the File History, EditPad Pro will make a copy of that backup file, and turn it into a milestone of the original file.

Save Milestone for All Files in Project

The Save Milestone for All Files in Project button will create a milestone copy of each file in the current project, just like the Save Milestone button does for the current file.

Revert

Click the revert button to replace the original file with the selected backup file. EditPad Pro will first create a new backup copy from the original file, and then replace the original file with the selected backup file. The selected backup file is deleted in the process.


View|Clip Collection

View|Clip Collection ( Available in EditPad Pro only )

Select Clip Collection from the View menu to open EditPad Pro's Clip Collection pane. There you can store common blocks of text and templates for quick repeated reuse. When editing complex documents, move chunks of text into the collection for temporary storage. The Clip Collection is also a great place to jot down notes and ideas, and to keep important information at your fingertips.

AceText, a product available separately, is specifically designed to enable you to very flexibly work with large numbers of text snippets. If you have installed AceText, EditPad Pro will use AceText's Clip Collection functionality, and display the collection that is active in AceText. EditPad Pro and AceText will automatically keep the collection synchronized when you edit it in AceText or EditPad Pro.

If you do not have AceText, EditPad Pro will manage the collection of clips by itself. You may want to check out the free evaluation version of AceText , since AceText offers a lot of extra functionality. Most importantly, AceText enables you to use your clip collections in combination with applications other than EditPad Pro. AceText cooperates with almost all Windows software.

Adding Text to The Collection

To add text to the collection, simply select it in the editor and click the "New Clip" button in the toolbar above the Clip Collection. You can also drag and drop the selection from the editor into the collection. Drag and drop clips inside the collection to rearrange them.

You can edit a clip's label or view and edit the text it holds by clicking the Edit Clip button. If you use AceText, this will activate the AceText Editor. If not, you can edit the clip directly in EditPad Pro.

If you want to add many clips to a collection, organize them in folder to make it easier to find the right clip later. Simply click the New Folder button to create a new folder. Add clips to the folder by selecting the folder before clicking the New Clip button. You can also drag and drop text or clips onto the folder.

Using Clips from The Collection

To insert the contents of a clip into the file you are editing, simply double-click it or drag-and-drop it onto the spot where you want to insert it. If the clip holds before and after text , it will be placed around the text you selected in the editor. If you did not select any text, the before and after texts are inserted right next to each other, and the text cursor is placed between them. Before and after text makes it very easy to insert common text blocks that have an opening and closing part, such as HTML or XML tags.

Opening and Saving Collections

If you are not using AceText, EditPad Pro will automatically save Clip Collections. This way, you never have to worry about losing any clips. The Save button allows you to save the collection under a different name. To open a collection later, click the Open button and select the file, or click the downward pointing arrow next to the Open button to select a collection you recently worked with.

To make Clip Collections even more transparent, you can assign a default collection to each file type in the file type configuration . That collection is then automatically opened whenever you switch to a file of that type. E.g. you can assign a collection with HTML tags to the HTML file type. That way, the clip collection will always be ready for inserting HTML tags whenever you edit an HTML file.

EditPad Pro can also import TextPad Collection Library files (*.tcl files). After clicking the Open button on the Clip Collection pane's toolbar, select the "TextPad Collection Libraries" file type in the drop-down list at the bottom of the file selection screen. EditPad Pro cannot save TextPad Collection Library files.

Sharing Collections

Click the Share Collections button to download Clip Collections shared by others, or to upload your own collections. A new window will pop up. EditPad Pro will connect to the Internet immediately to download the list of available collections. If your computer can only access the internet via a proxy server, click the Settings button in the lower left corner of the screen to enter your proxy server's settings.

The Download tab shows all available collections, including the ones you uploaded. The list shows the collection's title, the file name used by the author, how many clips it contains, who shared it, when it was first shared and when it was last updated. Click on a collection to get a more detailed description, and the author's name and email address (if provided by the author). Click the Download button to download the selected scheme.

The Share tab shows the collections that you previously uploaded. EditPad Pro automatically uses your EditPad Pro license to identify you. You can check your license details in the about box. To share a collection, select its file, and enter a title and your name. You can also enter your email address and web site URL if you want. In the Description box, explain what your collection is about. Click the Upload button to upload it. If you select a collection you previously uploaded, EditPad Pro will fill out all the fields with what you entered when you uploaded that collection. This way you can easily update a previously shared collection, or use the same details for another one. If you upload a collection with the same file name as a collection you already shared, the newly uploaded collection will replace the old one. If you upload a collection with another file name, it will be added as a new collection, even if you give it the same title or description as another one. Click the Delete button to stop sharing a collection.

EditPad Pro downloads and uploads in the background. The Progress tab shows all collections in the queue, and recently completed transfers. If an error occurs, EditPad Pro will not pop up a message box. The Progress tab will indicate the error.


Edit Clip

Edit Clip ( Available in EditPad Pro only )

To edit a clip in the Clip Collection , select the clip, and click the Edit Clip button in the Clip Collection toolbar.

A clip consists of the following parts:

Label: The label that identifies the clip in the collection. If you do not type in a label, the start of the text itself is used as the label.

Kind: EditPad Pro supports different kinds of clips. "Plain text" clips hold ordinary text. A word, a sentence, several paragraphs, or a complete text document of any size. "Rectangular text block" clips hold a rectangular selection . "Binary data" clips hold data in hexadecimal format. If you create a clip while EditPad Pro is in hexadecimal mode , the clip will hold "binary data".

"Before and after text" are a special, very useful kind of clip. You cannot create such a clip by dragging and dropping some text onto the Clip Collection. You can only create them by editing a clip, or by clicking the New Clip button when no text is selected. These clips are very useful to insert frequently used bits of text that consist of an opening and a closing part, such as HTML tags. The before part is placed before the cursor or selection, and the after part is placed behind it.

Indent: Turn on the indent option for "plain text" and "before and after text" clips, if the clip consists of multiple lines, and you want the second and subsequent lines to be lined up with the first line. E.g. source code is often indented to indicate block structure. Turn on the "indent" option for clips holding source code snippets, and they will be properly indented when you use them.

Text: The text stored by the clip. You can use all text editing keyboard shortcuts and mouse actions to edit the text of a clip.


View|File Navigator

View|File Navigator ( Available in EditPad Pro only )

The File Navigator is a panel that sits docked at the left side of EditPad's window. You can make it visible by selecting File Navigator in the View menu .

The File Navigator requires a file navigation scheme to be functional. Without such a scheme, the File Navigator will remain empty. You can select a file navigation scheme for each file type on the Syntax & Navigation tab in the file type configuration .

Based on the file navigation scheme, the File Navigator displays the structure of the file in a collapsible tree. By clicking on items in the tree, you can quickly navigate to various parts of the file. Some items may be linked to more than one part in the file. If you click the same item repeatedly, the file navigator will cycle through all the parts the item is linked to.

When you click an item, the File Navigator will keep keyboard focus. To give the editor keyboard focus, double-click an item or press Enter while the File Navigator has keyboard focus.

To select the part of the file an item is linked to, press the Shift key on the keyboard while you click on the item. If you press Shift and double-click, the part will be selected and the editor will receive keyboard focus. If you prefer to use the keyboard, keep Shift depressed while you navigate with the arrow keys. Press Shift+Enter to select the part and activate the editor.

If an item is linked to multiple parts of the file, those parts become linked in an additional way. If the cursor is already inside one of the parts, you can press Alt+Arrow Up and Alt+Arrow Down on the keyboard to cycle through the linked parts while the editor has keyboard focus. E.g. the Delphi scheme links method declarations from the interface section of a unit and the method implementations from the implementation section into a single node representing the method. When the text cursor is inside a method declaration, you can press Alt+Up or Alt+Down to jump to the implementation, and back.


View|Browser

Select Browser in the View menu to open the active file in a web browser. If the file is modified, EditPad will save it first.

If this feature does not work, EditPad is either unable to detect your computer's default web browser, or you've incorrectly configured the browser setting in the System Preferences .

See also:

  • EditPad Pro Main Menu
  • View Menu


View|New Editor

When you try to start a new instance of EditPad through the Windows Start menu or a desktop shortcut, EditPad will simply activate the instance that was already running. Any files that the new instance should have opened will be opened by the existing instance. Since EditPad is designed to make it easy to work with large numbers of files, you can easily work with all your documents in one location, without cluttering your desktop.

If you do want to have multiple instances of EditPad running, simply select the New Editor item in the View menu. This can be useful if you want to view two files side by side. You can configure the placement of the new instance in the Editor Preferences . There you will also find an option to make the new instance open the active file.

If you want to start a second EditPad instance from a shortcut, script or application, you can do so with the /newinstance command line parameter .

See also:

  • EditPad Pro Main Menu
  • View Menu


View|Close Panes

Press the Esc key on the keyboard to close the active pane. The active pane is the one that has keyboard focus. When the pane is closed, keyboard focus is automatically given to the main editor.

If none of the open panes has keyboard focus, all of them will be closed. To quickly close all panes at any times, simply press the Esc key twice.

See also:

  • View Menu
  • View|Focus Editor


View|Focus Editor

The keyboard shortcut associated with the Focus Editor item in the View menu is a quick way to set the keyboard focus to the main editor. Doing so will make the text cursor (blinking vertical bar) visible in the main editor allowing you to continue editing the file.

Using the Focus Editor keyboard shortcut allows you to quickly switch back and forth between the main editor and other panes. E.g. while working with the search and replace pane, you can press Tab on the keyboard to cycle through the various controls on the search and replace pane. To switch to the main editor, press F9. To switch back to the search and replace pane, press Ctrl+F.

See also:

  • View Menu
  • View|Close All Panes


Help Menu

Help|Contents

Help|Keyboard Shortcuts

Help|EditPad Web Site

Help|Check for New Version

Help|Technical Support

Help|Feedback

See also:

  • EditPad Pro Main Menu


Help|Create Portable Installation

The Create Portable Installation item in the Help menu makes it easy to create a portable copy of EditPad Pro on a removable disk, USB stick or flash memory card. You can run EditPad off the removable device on any computer, without leaving any traces of EditPad on that computer.

If the capacity of the device you want to install EditPad onto is limited, you can choose not to install certain parts of EditPad on the device. The only part that is not optional is the "main application" part, which is EditPad itself. You can select if you want to copy over the help file, the syntax coloring schemes , and the file navigation schemes . If you installed one or more spell check dictionaries , you can choose which ones you want to make available on the device.

Note that the Create Portable Installation command will not delete any files from the device. If you use the Create Portable Installation command a second time, and select fewer parts than the first time, EditPad will not remove the deselected parts from the device.

EditPad will show you the complete list of devices that Windows reports as removable devices. External hard disks often report themselves as being hard disks rather than being removable devices. If you want to install EditPad in a portable manner on such a device, turn on the option to treat all drives as removable drives. EditPad will then create a file RemovableDrive.sys on the destination drive. This file act as a token to tell EditPad not to touch the host computer.

To proceed with the installation, click on the device you want to intall onto, and click the Install button. The label showing the amount of disk space needed will indicate the parts being copied to the removable drive. Once the operation is complete, the Install onto Removable Drive screen will close automatically.

EditPad will copy itself to a fixed EditPadLite or EditPadPro subfolder off the root on the device. If you like more complex folder structures, you can move the complete EditPadLite or EditPadPro folder into a different parent folder on the device.


Help|EditPad Web Site

Launches your web browser to open http://www.editpadpro.com/

See also:

  • EditPad Pro Main Menu
  • Help Menu


Help|Check for New Version

Launches your web browser to show a page that will tell you if the version of EditPad you are currently using, is the most recent one or not.

If a newer version is available, it will tell you where to get it.

See also:

  • EditPad Pro Main Menu
  • Help Menu


Help|Technical Support

Send an email to support@editpadpro.com for EditPad Pro and support@editpadlite.com for EditPad Lite if you need technical support.

If you have purchased EditPad Pro, you are entitled to free technical support be email. If you are using EditPad Lite, we do appreciate your input, but we cannot promise a personal reply.

Please use Help|Check for New Version to see if you are using the latest version, before asking for technical support.

See also:

  • EditPad Pro Main Menu
  • Help Menu


Help|Feedback

Send an email to support@editpadpro.com for EditPad Pro and support@editpadlite.com for EditPad Lite if you have any comments or questions.

Please use Help|Check for New Version to see if you are using the latest version, before sending feedback.

See also:

  • EditPad Pro Main Menu
  • Help Menu


Preferences

When you pick Options|Preferences from the menu, the EditPad Preferences screen appears. Since there are a lot of things you can configure, the available settings are split into several tabbed pages.

EditPad Pro is very configurable, and the number of choices may seem a bit overwhelming. Fortunately, if a certain option seems meaningless to you, you can simply leave it in its default state. The default settings have been carefully chosen so that EditPad is fully functional even if you do not make any changes in the Preferences screen at all. In its default configuration, EditPad will work like most Windows text editors.

All the options you can set in the Preferences screen are global settings, affecting EditPad Pro's overall behavior. Many editing and diplay settings are available through the file type configuration , allowing you to use different settings for different kinds of files.

The available pages are:

  • Colors
  • Cursors
  • Editor
  • Files
  • Tabs (Available in EditPad Pro only)
  • Statusbar (Available in EditPad Pro only)
  • Shortcuts
  • Email (Available in EditPad Pro only)
  • System

Toolbars, context menus and keyboard shortcuts can be configured through Options|Configure Toolbar and Menus . External tools that appear in the tools menu can be configured through Tools|Configure Tools .


Regex Tutorial - Literal Characters and Special Characters

Literal Characters

The most basic regular expression consists of a single literal character, e.g.: "a". It will match the first occurrence of that character in the string. If the string is "Jack is a boy", it will match the "a" after the "J". The fact that this "a" is in the middle of the word does not matter to the regex engine. If it matters to you, you will need to tell that to the regex engine by using word boundaries . We will get to that later.

This regex can match the second "a" too. It will only do so when you tell the regex engine to start searching through the string after the first match. In a text editor, you can do so by using its "Find Next" or "Search Forward" function. In a programming language, there is usually a separate function that you can call to continue searching through the string after the previous match.

Similarly, the regex "cat" will match "cat" in "About cats and dogs". This regular expression consists of a series of three literal characters. This is like saying to the regex engine: find a "c", immediately followed by an "a", immediately followed by a "t".

Note that regex engines are case sensitive by default. "cat" does not match "Cat", unless you tell the regex engine to ignore differences in case.

Special Characters

Because we want to do more than simply search for literal pieces of text, we need to reserve certain characters for special use. In the regex flavors discussed in this tutorial , there are 11 characters with special meanings: the opening square bracket "[", the backslash "\", the caret "^", the dollar sign "$", the period or dot ".",the vertical bar or pipe symbol "|", the question mark "?", the asterisk or star "*", the plus sign "+", the opening round bracket "(" and the closing round bracket ")".These special characters are often called "metacharacters".

If you want to use any of these characters as a literal in a regex, you need to escape them with a backslash. If you want to match "1+1=2", the correct regex is "1\+1=2". Otherwise, the plus sign will have a special meaning.

Note that "1+1=2", with the backslash omitted, is a valid regex. So you will not get an error message. But it will not match "1+1=2". It would match "111=2" in "123+111=234", due to the special meaning of the plus character .

If you forget to escape a special character where its use is not allowed, such as in "+1", then you will get an error message.

All other characters should not be escaped with a backslash. That is because the backslash is also a special character. The backslash in combination with a literal character can create a regex token with a special meaning. E.g. "\d" will match a single digit from 0 to 9.

Special Characters and Programming Languages

If you are a programmer, you may be surprised that characters like the single quote and double quote are not special characters. That is correct. When using a regular expression or grep tool like PowerGREP or the search function of a text editor like EditPad Pro, you should not escape or repeat the quote characters like you do in a programming language.

In your source code, you have to keep in mind which characters get special treatment inside strings by your programming language. That is because those characters will be processed by the compiler, before the regex library sees the string. So the regex "1\+1=2" must be written as "1\\+1=2" in C++ code.The C++ compiler will turn the escaped backslash in the source code into a single backslash in the string that is passed on to the regex library. To match "c:\temp", you need to use the regex "c:\\temp". As a string in C++ source code, this regex becomes "c:\\\\temp". Four backslashes to match a single one indeed.

See the tools and languages section of this help file for more information on how to use regular expressions in various programming languages.

Non-Printable Characters

You can use special character sequences to put non-printable characters in your regular expression. Use"\t" to match a tab character (ASCII 0x09),"\r" for carriage return (0x0D)and "\n" for line feed (0x0A). More exotic non-printables are "\a" (bell, 0x07), "\e" (escape, 0x1B), "\f" (form feed, 0x0C) and "\v" (vertical tab, 0x0B).Remember that Windows text files use "\r\n" to terminate lines, while UNIX text files use "\n".

You can include any character in your regular expression if you know its hexadecimal ASCII or ANSI code for the character set that you are working with. In the Latin-1 character set, the copyright symbol is character 0xA9. So to search for the copyright symbol, you can use "\xA9". Another way to search for a tab is to use "\x09". Note that the leading zero is required.

If your regular expression engine supports Unicode , use "\uFFFF" rather than "\xFF" to insert a Unicode character. The euro currency sign occupies code point 0x20A0. If you cannot type it on your keyboard, you can insert it into a regular expression with "\u20A0".


How a Regex Engine Works Internally

First Look at How a Regex Engine Works Internally

Knowing how the regex engine works will enable you to craft better regexes more easily. It will help you understand quickly why a particular regex does not do what you initially expected. This will save you lots of guesswork and head scratching when you need to write more complex regexes.

There are two kinds of regular expression engines: text-directed engines, and regex-directed engines. Jeffrey Friedl calls them DFA and NFA engines, respectively. All the regex flavors treated in this tutorial are based on regex-directed engines. This is because certain very useful features, such as lazy quantifiers and backreferences , can only be implemented in regex-directed engines. No surprise that this kind of engine is more popular.

Notable tools that use text-directed engines are awk, egrep, flex, lex, MySQL and Procmail. For awk and egrep, there are a few versions of these tools that use a regex-directed engine.

You can easily find out whether the regex flavor you intend to use has a text-directed or regex-directed engine. If backreferences and/or lazy quantifiers are available, you can be certain the engine is regex-directed. You can do the test by applying the regex "regex|regex not" to the string "regex not". If the resulting match is only "regex", the engine is regex-directed. If the result is "regex not", then it is text-directed. The reason behind this is that the regex-directed engine is "eager".

In this tutorial, after introducing a new regex token, I will explain step by step how the regex engine actually processes that token. This inside look may seem a bit long-winded at certain times. But understanding how the regex engine works will enable you to use its full power and help you avoid common mistakes.

The Regex-Directed Engine Always Returns the Leftmost Match

This is a very important point to understand: a regex-directed engine will always return the leftmost match, even if a "better" match could be found later. When applying a regex to a string, the engine will start at the first character of the string. It will try all possible permutations of the regular expression at the first character. Only if all possibilities have been tried and found to fail, will the engine continue with the second character in the text. Again, it will try all possible permutations of the regex, in exactly the same order. The result is that the regex-directed engine will return the leftmost match.

When applying "cat" to "He captured a catfish for his cat.", the engine will try to match the first token in the regex "c" to the first character in the match "H". This fails. There are no other possible permutations of this regex, because it merely consists of a sequence of literal characters. So the regex engine tries to match the "c" with the "e". This fails too, as does matching the "c" with the space. Arriving at the 4th character in the match, "c" matches "c". The engine will then try to match the second token "a" to the 5th character, "a". This succeeds too. But then, "t" fails to match "p". At that point, the engine knows the regex cannot be matched starting at the 4th character in the match. So it will continue with the 5th: "a". Again, "c" fails to match here and the engine carries on. At the 15th character in the match, "c" again matches "c". The engine then proceeds to attempt to match the remainder of the regex at character 15 and finds that "a" matches "a" and "t" matches "t".

The entire regular expression could be matched starting at character 15. The engine is "eager" to report a match. It will therefore report the first three letters of catfish as a valid match. The engine never proceeds beyond this point to see if there are any "better" matches. The first match is considered good enough.

In this first example of the engine's internals, our regex engine simply appears to work like a regular text search routine. A text-directed engine would have returned the same result too. However, it is important that you can follow the steps the engine takes in your mind. In following examples, the way the engine works will have a profound impact on the matches it will find. Some of the results may be surprising. But they are always logical and predetermined, once you know how the engine works.


Regexp Tutorial - Character Classes or Character Sets

Character Classes or Character Sets

With a "character class", also called "character set", you can tell the regex engine to match only one out of several characters. Simply place the characters you want to match between square brackets. If you want to match an a or an e, use "[ae]". You could use this in "gr[ae]y" to match either "gray" or "grey". Very useful if you do not know whether the document you are searching through is written in American or British English.

A character class matches only a single character. "gr[ae]y" will not match "graay", "graey" or any such thing. The order of the characters inside a character class does not matter. The results are identical.

You can use a hyphen inside a character class to specify a range of characters. "[0-9]" matches a single digit between 0 and 9. You can use more than one range. "[0-9a-fA-F]" matches a single hexadecimal digit, case insensitively. You can combine ranges and single characters. "[0-9a-fxA-FX]" matches a hexadecimal digit or the letter X. Again, the order of the characters and the ranges does not matter.

Useful Applications

Find a word, even if it is misspelled, such as "sep[ae]r[ae]te" or "li[cs]en[cs]e".

Find an identifier in a programming language with "[A-Za-z_][A-Za-z_0-9]*".

Find a C-style hexadecimal number with "0[xX][A-Fa-f0-9]+".

Negated Character Classes

Typing a caret after the opening square bracket will negate the character class. The result is that the character class will match any character that is not in the character class. Unlike the dot , negated character classes also match (invisible) line break characters.

It is important to remember that a negated character class still must match a character. "q[^u]" does not mean: "a q not followed by a u". It means: "a q followed by a character that is not a u". It will not match the q in the string "Iraq". It will match the q and the space after the q in "Iraq is a country". Indeed: the space will be part of the overall match, because it is the "character that is not a u" that is matched by the negated character class in the above regexp. If you want the regex to match the q, and only the q, in both strings, you need to use negative lookahead : "q(?!u)". But we will get to that later.

Metacharacters Inside Character Classes

Note that the only special characters or metacharacters inside a character class are the closing bracket (]), the backslash (\), the caret (^) and the hyphen (-). The usual metacharacters are normal characters inside a character class, and do not need to be escaped by a backslash. To search for a star or plus, use "[+*]". Your regex will work fine if you escape the regular metacharacters inside a character class, but doing so significantly reduces readability.

To include a backslash as a character without any special meaning inside a character class, you have to escape it with another backslash. "[\\x]" matches a backslash or an x. The closing bracket (]), the caret (^) and the hyphen (-) can be included by escaping them with a backslash, or by placing them in a position where they do not take on their special meaning. I recommend the latter method, since it improves readability. To include a caret, place it anywhere except right after the opening bracket. "[x^]" matches an x or a caret. You can put the closing bracket right after the opening bracket, or the negating caret. "[]x]" matches a closing bracket or an x. "[^]x]" matches any character that is not a closing bracket or an x. The hyphen can be included right after the opening bracket, or right before the closing bracket, or right after the negating caret. Both "[-x]" and "[x-]" match an x or a hyphen.

You can use non-printable characters in character classes just like you can use them outside of character classes. E.g. "[$\u20A0]" matches a dollar or euro sign, assuming your regex flavor supports Unicode .

Shorthand Character Classes

Since certain character classes are used often, a series of shorthand character classes are available. "\d" is short for "[0-9]".

"\w" stands for "word character". Exactly which characters it matches differs between regex flavors. In all flavors, it will include "[A-Za-z]". In most, the underscore and digits are also included. In some flavors, word characters from other languages may also match. The best way to find out is to do a couple of tests with the regex flavor you are using. In the screen shot, you can see the characters matched by "\w" in RegexBuddy using various scripts.

"\s" stands for "whitespace character". Again, which characters this actually includes, depends on the regex flavor. In all flavors discussed in this tutorial, it includes "[ \t]". That is: "\s" will match a space or a tab. In most flavors, it also includes a carriage return or a line feed as in "[ \t\r\n]". Some flavors include additional, rarely used non-printable characters such as vertical tab and form feed.

Shorthand character classes can be used both inside and outside the square brackets. "\s\d" matches a whitespace character followed by a digit. "[\s\d]" matches a single character that is either whitespace or a digit. When applied to "1 + 2 = 3", the former regex will match " 2" (space two), while the latter matches "1" (one). "[\da-fA-F]" matches a hexadecimal digit, and is equivalent to "[0-9a-fA-F]".

Negated Shorthand Character Classes

The above three shorthands also have negated versions. "\D" is the same as "[^\d]", "\W" is short for "[^\w]" and "\S" is the equivalent of "[^\s]".

Be careful when using the negated shorthands inside square brackets. "[\D\S]" is not the same as "[^\d\s]". The latter will match any character that is not a digit or whitespace. So it will match "x", but not "8". The former, however, will match any character that is either not a digit, or is not whitespace. Because a digit is not whitespace, and whitespace is not a digit, "[\D\S]" will match any character, digit, whitespace or otherwise.

Repeating Character Classes

If you repeat a character class by using the "?", "*" or "+" operators, you will repeat the entire character class, and not just the character that it matched. The regex "[0-9]+" can match "837" as well as "222".

If you want to repeat the matched character, rather than the class, you will need to use backreferences. "([0-9])\1+" will match "222" but not "837". When applied to the string "833337", it will match "3333" in the middle of this string. If you do not want that, you need to use lookahead and lookbehind.

But I digress. I did not yet explain how character classes work inside the regex engine. Let us take a look at that first.

Looking Inside The Regex Engine

As I already said: the order of the characters inside a character class does not matter. "gr[ae]y" will match "grey" in "Is his hair grey or gray?", because that is the leftmost match. We already saw how the engine applies a regex consisting only of literal characters . Below, I will explain how it applies a regex that has more than one permutation. That is: "gr[ae]y" can match both "gray" and "grey".

Nothing noteworthy happens for the first twelve characters in the string. The engine will fail to match "g" at every step, and continue with the next character in the string. When the engine arrives at the 13th character, "g" is matched. The engine will then try to match the remainder of the regex with the text. The next token in the regex is the literal "r", which matches the next character in the text. So the third token, "[ae]" is attempted at the next character in the text ("e"). The character class gives the engine two options: match "a" or match "e". It will first attempt to match "a", and fail.

But because we are using a regex-directed engine, it must continue trying to match all the other permutations of the regex pattern before deciding that the regex cannot be matched with the text starting at character 13. So it will continue with the other option, and find that "e" matches "e". The last regex token is "y", which can be matched with the following character as well. The engine has found a complete match with the text starting at character 13. It will return "grey" as the match result, and look no further. Again, the leftmost match was returned, even though we put the "a" first in the character class, and "gray" could have been matched in the string. But the engine simply did not get that far, because another equally valid match was found to the left of it.


Regex Tutorial - The Dot Matches (Almost) Any Character

The Dot Matches (Almost) Any Character

In regular expressions, the dot or period is one of the most commonly used metacharacters . Unfortunately, it is also the most commonly misused metacharacter.

The dot matches a single character, without caring what that character is. The only exception are newline characters. In all regex flavors discussed in this tutorial, the dot will not match a newline character by default. So by default, the dot is short for the negated character class "[^\n]" (UNIX regex flavors) or "[^\r\n]" (Windows regex flavors).

This exception exists mostly because of historic reasons. The first tools that used regular expressions were line-based. They would read a file line by line, and apply the regular expression separately to each line. The effect is that with these tools, the string could never contain newlines, so the dot could never match them.

Modern tools and languages can apply regular expressions to very large strings or even entire files. All regex flavors discussed here have an option to make the dot match all characters, including newlines. In RegexBuddy, EditPad Pro or PowerGREP, you simply tick the checkbox labeled "dot matches newline".

In Perl, the mode where the dot also matches newlines is called "single-line mode". This is a bit unfortunate, because it is easy to mix up this term with "multi-line mode". Multi-line mode only affects anchors , and single-line mode only affects the dot. You can activate single-line mode by adding an s after the regex code, like this: m/^regex$/s;.

Other languages and regex libraries have adopted Perl's terminology. When using the regex classes of the .NET framework, you activate this mode by specifying RegexOptions.Singleline, such as in Regex.Match("string", "regex", RegexOptions.Singleline).

In all programming languages and regex libraries I know, activating single-line mode has no effect other than making the dot match newlines. So if you expose this option to your users, please give it a clearer label like was done in RegexBuddy, EditPad Pro and PowerGREP.

Use The Dot Sparingly

The dot is a very powerful regex metacharacter. It allows you to be lazy. Put in a dot, and everything will match just fine when you test the regex on valid data. The problem is that the regex will also match in cases where it should not match. If you are new to regular expressions, some of these cases may not be so obvious at first.

I will illustrate this with a simple example. Let's say we want to match a date in mm/dd/yy format, but we want to leave the user the choice of date separators. The quick solution is "\d\d.\d\d.\d\d". Seems fine at first. It will match a date like "02/12/03" just fine. Trouble is: "02512703" is also considered a valid date by this regular expression. In this match, the first dot matched "5", and the second matched "7". Obviously not what we intended.

"\d\d[- /.]\d\d[- /.]\d\d" is a better solution. This regex allows a dash, space, dot and forward slash as date separators. Remember that the dot is not a metacharacter inside a character class , so we do not need to escape it with a backslash.

This regex is still far from perfect. It matches "99/99/99" as a valid date. "[0-1]\d[- /.][0-3]\d[- /.]\d\d" is a step ahead, though it will still match "19/39/99". How perfect you want your regex to be depends on what you want to do with it. If you are validating user input, it has to be perfect. If you are parsing data files from a known source that generates its files in the same way every time, our last attempt is probably more than sufficient to parse the data without errors. You can find a better regex to match dates in the example section.

Use Negated Character Sets Instead of the Dot

I will explain this in depth when I present you the repeat operators star and plus , but the warning is important enough to mention it here as well. I will illustrate with an example.

Suppose you want to match a double-quoted string. Sounds easy. We can have any number of any character between the double quotes, so "".*"" seems to do the trick just fine. The dot matches any character, and the star allows the dot to be repeated any number of times, including zero. If you test this regex on "Put a "string" between double quotes", it will match ""string"" just fine. Now go ahead and test it on "Houston, we have a problem with "string one" and "string two".  Please respond."

Ouch. The regex matches ""string one" and "string two"". Definitely not what we intended. The reason for this is that the star is greedy.

In the date-matching example, we improved our regex by replacing the dot with a character class. Here, we will do the same. Our original definition of a double-quoted string was faulty. We do not want any number of any character between the quotes. We want any number of characters that are not double quotes or newlines between the quotes. So the proper regex is ""[^"\r\n]*"".


Regex Tutorial - Start and End of String or Line Anchors

Start of String and End of String Anchors

Thus far, I have explained literal characters and character classes . In both cases, putting one in a regex will cause the regex engine to try to match a single character.

Anchors are a different breed. They do not match any character at all. Instead, they match a position before, after or between characters. They can be used to "anchor" the regex match at a certain position. The caret "^" matches the position before the first character in the string. Applying "^a" to "abc" matches "a". "^b" will not match "abc" at all, because the "b" cannot be matched right after the start of the string, matched by "^". See below for the inside view of the regex engine.

Similarly, "$" matches right after the last character in the string. "c$" matches "c" in "abc", while "a$" does not match at all.

Useful Applications

When using regular expressions in a programming language to validate user input, using anchors is very important. If you use the code if ($input =~ m/\d+/) in a Perl script to see if the user entered an integer number, it will accept the input even if the user entered "qsdf4ghjk", because "\d+" matches the 4. The correct regex to use is "^\d+$". Because "start of string" must be matched before the match of "\d+", and "end of string" must be matched right after it, the entire string must consist of digits for "^\d+$" to be able to match.

It is easy for the user to accidentally type in a space. When Perl reads from a line from a text file, the line break will also be stored in the variable. So before validating input, it is good practice to trim leading and trailing whitespace . "^\s+" matches leading whitespace and "\s+$" matches trailing whitespace. In Perl, you could use $input =~ s/^\s+|\s+$//g. Handy use of alternation and /g allows us to do this in a single line of code.

Using ^ and $ as Start of Line and End of Line Anchors

If you have a string consisting of multiple lines, like "first line\nsecond line" (where \n indicates a line break), it is often desirable to work with lines, rather than the entire string. Therefore, all the regex engines discussed in this tutorial have the option to expand the meaning of both anchors. "^" can then match at the start of the string (before the "f" in the above string), as well as after each line break (between "\n" and "s"). Likewise, "$" will still match at the end of the string (after the last "e"), and also before every line break (between "e" and "\n").

In text editors like EditPad Pro or GNU Emacs, and regex tools like PowerGREP, the caret and dollar always match at the start and end of each line. This makes sense because those applications are designed to work with entire files, rather than short strings.

In all programming languages and libraries discussed in this help file, except Ruby, you have to explicitly activate this extended functionality. It is traditionally called "multi-line mode". In Perl, you do this by adding an m after the regex code, like this: m/^regex$/m;. In .NET, the anchors match before and after newlines when you specify RegexOptions.Multiline, such as in Regex.Match("string", "regex", RegexOptions.Multiline).

Permanent Start of String and End of String Anchors

"\A" only ever matches at the start of the string. Likewise, "\Z" only ever matches at the end of the string. These two tokens never match at line breaks. This is true in all regex flavors discussed in this tutorial, even when you turn on "multiline mode". In EditPad Pro and PowerGREP, where the caret and dollar always match at the start and end of lines, "\A" and "\Z" only match at the start and the end of the entire file.

Zero-Length Matches

We saw that the anchors match at a position, rather than matching a character. This means that when a regex only consists of one or more anchors, it can result in a zero-length match. Depending on the situation, this can be very useful or undesirable. Using "^\d*$" to test if the user entered a number (notice the use of the star instead of the plus ), would cause the script to accept an empty string as a valid input. See below.

However, matching only a position can be very useful. In email, for example, it is common to prepend a "greater than" symbol and a space to each line of the quoted message. In VB.NET, we can easily do this with Dim Quoted as String = Regex.Replace(Original, "^", "> ", RegexOptions.Multiline). We are using multi-line mode, so the regex "^" matches at the start of the quoted message, and after each newline. The Regex.Replace method will remove the regex match from the string, and insert the replacement string (greater than symbol and a space). Since the match does not include any characters, nothing is deleted. However, the match does include a starting position, and the replacement string is inserted there, just like we want it.

Strings Ending with a Line Break

Even though "\Z" and "$" only match at the end of the string (when the option for the caret and dollar to match at embedded line breaks is off), there is one exception. If the string ends with a line break, then "\Z" and "$" will match at the position before that line break, rather than at the very end of the string. This "enhancement" was introduced by Perl, and is copied by many regex flavors, including Java, .NET and PCRE. In Perl, when reading a line from a file, the resulting string will end with a line break. Reading a line from a file with the text "joe" results in the string "joe\n". When applied to this string, both "^[a-z]+$" and "\A[a-z]+\Z" will match "joe".

If you only want a match at the absolute very end of the string, use "\z" (lower case z instead of upper case Z). "\A[a-z]+\z" does not match "joe\n". "\z" matches after the line break, which is not matched by the character class .

Looking Inside the Regex Engine

Let's see what happens when we try to match "^4$" to "749\n486\n4" (where \n represents a newline character) in multi-line mode. As usual, the regex engine starts at the first character: "7". The first token in the regular expression is "^". Since this token is a zero-width token, the engine does not try to match it with the character, but rather with the position before the character that the regex engine has reached so far. "^" indeed matches the position before "7". The engine then advances to the next regex token: "4". Since the previous token was zero-width, the regex engine does not advance to the next character in the string. It remains at "7". "4" is a literal character, which does not match "7". There are no other permutations of the regex, so the engine starts again with the first regex token, at the next character: "4". This time, "^" cannot match at the position before the 4. This position is preceded by a character, and that character is not a newline. The engine continues at "9", and fails again. The next attempt, at "\n", also fails. Again, the position before "\n" is preceded by a character, "9", and that character is not a newline.

Then, the regex engine arrives at the second "4" in the string. The "^" can match at the position before the "4", because it is preceded by a newline character. Again, the regex engine advances to the next regex token, "4", but does not advance the character position in the string. "4" matches "4", and the engine advances both the regex token and the string character. Now the engine attempts to match "$" at the position before (indeed: before) the "8". The dollar cannot match here, because this position is followed by a character, and that character is not a newline.

Yet again, the engine must try to match the first token again. Previously, it was successfully matched at the second "4", so the engine continues at the next character, "8", where the caret does not match. Same at the six and the newline.

Finally, the regex engine tries to match the first token at the third "4" in the string. With success. After that, the engine successfully matches "4" with "4". The current regex token is advanced to "$", and the current character is advanced to the very last position in the string: the void after the string. No regex token that needs a character to match can match here. Not even a negated character class . However, we are trying to match a dollar sign, and the mighty dollar is a strange beast. It is zero-width, so it will try to match the position before the current character. It does not matter that this "character" is the void after the string. In fact, the dollar will check the current character. It must be either a newline, or the void after the string, for "$" to match the position before the current character. Since that is the case after the example, the dollar matches successfully.

Since "$" was the last token in the regex, the engine has found a successful match: the last "4" in the string.

Another Inside Look

Earlier I mentioned that "^\d*$" would successfully match an empty string. Let's see why.

There is only one "character" position in an empty string: the void after the string. The first token in the regex is "^". It matches the position before the void after the string, because it is preceded by the void before the string. The next token is "\d*". As we will see later, one of the star 's effects is that it makes the "\d", in this case, optional. The engine will try to match "\d" with the void after the string. That fails, but the star turns the failure of the "\d" into a zero-width success. The engine will proceed with the next regex token, without advancing the position in the string. So the engine arrives at "$", and the void after the string. We already saw that those match. At this point, the entire regex has matched the empty string, and the engine reports success.

Caution for Programmers

A regular expression such as "$" all by itself can indeed match after the string. If you would query the engine for the character position, it would return the length of the string if string indices are zero-based, or the length+1 if string indices are one-based in your programming language. If you would query the engine for the length of the match, it would return zero.

What you have to watch out for is that String[Regex.MatchPosition] may cause an access violation or segmentation fault, because MatchPosition can point to the void after the string. This can also happen with "^" and "^$" if the last character in the string is a newline.


Regex Tutorial - \b Word Boundaries

Word Boundaries

The metacharacter "\b" is an anchor like the caret and the dollar sign. It matches at a position that is called a "word boundary". This match is zero-length.

There are four different positions that qualify as word boundaries:

  • Before the first character in the string, if the first character is a word character.
  • After the last character in the string, if the last character is a word character.
  • Between a word character and a non-word character following right after the word character.
  • Between a non-word character and a word character following right after the non-word character.

Simply put: "\b" allows you to perform a "whole words only" search using a regular expression in the form of "\bword\b". A "word character" is a character that can be used to form words. All characters that are not "word characters" are "non-word characters". The exact list of characters is different for each regex flavor, but all word characters are always matched by the short-hand character class "\w". All non-word characters are always matched by "\W".

In Perl and the other regex flavors discussed in this tutorial, there is only one metacharacter that matches both before a word and after a word. This is because any position between characters can never be both at the start and at the end of a word. Using only one operator makes things easier for you.

Note that "\w" usually also matches digits. So "\b4\b" can be used to match a 4 that is not part of a larger number. This regex will not match "44 sheets of a4". So saying ""\b" matches before and after an alphanumeric sequence" is more exact than saying "before and after a word".

Negated Word Boundary

"\B" is the negated version of "\b". "\B" matches at every position where "\b" does not. Effectively, "\B" matches at any position between two word characters as well as at any position between two non-word characters.

Looking Inside the Regex Engine

Let's see what happens when we apply the regex "\bis\b" to the string "This island is beautiful". The engine starts with the first token "\b" at the first character "T". Since this token is zero-length, the position before the character is inspected. "\b" matches here, because the T is a word character and the character before it is the void before the start of the string. The engine continues with the next token: the literal "i". The engine does not advance to the next character in the string, because the previous regex token was zero-width. "i" does not match "T", so the engine retries the first token at the next character position.

"\b" cannot match at the position between the "T" and the "h". It cannot match between the "h" and the "i" either, and neither between the "i" and the "s".

The next character in the string is a space. "\b" matches here because the space is not a word character, and the preceding character is. Again, the engine continues with the "i" which does not match with the space.

Advancing a character and restarting with the first regex token, "\b" matches between the space and the second "i" in the string. Continuing, the regex engine finds that "i" matches "i" and "s" matches "s". Now, the engine tries to match the second "\b" at the position before the "l". This fails because this position is between two word characters. The engine reverts to the start of the regex and advances one character to the "s" in "island". Again, the "\b" fails to match and continues to do so until the second space is reached. It matches there, but matching the "i" fails.

But "\b" matches at the position before the third "i" in the string. The engine continues, and finds that "i" matches "i" and "s" matches "s". The last token in the regex, "\b", also matches at the position before the second space in the string because the space is not a word character, and the character before it is.

The engine has successfully matched the word "is" in our string, skipping the two earlier occurrences of the characters i and s. If we had used the regular expression "is", it would have matched the "is" in "This".


Regex Tutorial - Alternation with The Vertical Bar

Alternation with The Vertical Bar or Pipe Symbol

I already explained how you can use character classes to match a single character out of several possible characters. Alternation is similar. You can use alternation to match a single regular expression out of several possible regular expressions.

If you want to search for the literal text "cat" or "dog", separate both options with a vertical bar or pipe symbol: "cat|dog". If you want more options, simply expand the list: "cat|dog|mouse|fish" .

The alternation operator has the lowest precedence of all regex operators. That is, it tells the regex engine to match either everything to the left of the vertical bar, or everything to the right of the vertical bar. If you want to limit the reach of the alternation, you will need to use round brackets for grouping. If we want to improve the first example to match whole words only, we would need to use "\b(cat|dog)\b". This tells the regex engine to find a word boundary , then either "cat" or "dog", and then another word boundary. If we had omitted the round brackets, the regex engine would have searched for "a word boundary followed by cat", or, "dog followed by a word boundary.

Remember That The Regex Engine Is Eager

I already explained that the regex engine is eager . It will stop searching as soon as it finds a valid match. The consequence is that in certain situations, the order of the alternatives matters. Suppose you want to use a regex to match a list of function names in a programming language: Get, GetValue, Set or SetValue. The obvious solution is "Get|GetValue|Set|SetValue". Let's see how this works out when the string is "SetValue".

The regex engine starts at the first token in the regex, "G", and at the first character in the string, "S". The match fails. However, the regex engine studied the entire regular expression before starting. So it knows that this regular expression uses alternation, and that the entire regex has not failed yet. So it continues with the second option, being the second "G" in the regex. The match fails again. The next token is the first "S" in the regex. The match succeeds, and the engine continues with the next character in the string, as well as the next token in the regex. The next token in the regex is the "e" after the "S" that just successfully matched. "e" matches "e". The next token, "t" matches "t".

At this point, the third option in the alternation has been successfully matched. Because the regex engine is eager, it considers the entire alternation to have been successfully matched as soon as one of the options has. In this example, there are no other tokens in the regex outside the alternation, so the entire regex has successfully matched "Set" in "SetValue".

Contrary to what we intended, the regex did not match the entire string. There are several solutions. One option is to take into account that the regex engine is eager, and change the order of the options. If we use "GetValue|Get|SetValue|Set", "SetValue" will be attempted before "Set", and the engine will match the entire string. We could also combine the four options into two and use the question mark to make part of them optional: "Get(Value)?|Set(Value)?". Because the question mark is greedy, "SetValue" will be attempted before "Set".

The best option is probably to express the fact that we only want to match complete words. We do not want to match Set or SetValue if the string is "SetValueFunction". So the solution is "\b(Get|GetValue|Set|SetValue)\b" or "\b(Get(Value)?|Set(Value)?)\b". Since all options have the same end, we can optimize this further to "\b(Get|Set)(Value)?\b" .


Regex Tutorial - The Question Mark Makes the Preceding Token Optional

Optional Items

The question mark makes the preceding token in the regular expression optional. E.g.: "colou?r" matches both "colour" and "color".

You can make several tokens optional by grouping them together using round brackets, and placing the question mark after the closing bracket. E.g.: "Nov(ember)?" will match "Nov" and "November".

You can write a regular expression that matches many alternatives by including more than one question mark. "Feb(ruary)? 23(rd)?" matches "February 23rd", "February 23", "Feb 23rd" and "Feb 23".

Important Regex Concept: Greediness

With the question mark, I have introduced the first metacharacter that is greedy. The question mark gives the regex engine two choices: try to match the part the question mark applies to, or do not try to match it. The engine will always try to match that part. Only if this causes the entire regular expression to fail, will the engine try ignoring the part the question mark applies to.

The effect is that if you apply the regex "Feb 23(rd)?" to the string "Today is Feb 23rd, 2003", the match will always be "Feb 23rd" and not "Feb 23". You can make the question mark lazy (i.e. turn off the greediness) by putting a second question mark after the first.

I will say a lot more about greediness when discussing the other repetition operators.

Looking Inside The Regex Engine

Let's apply the regular expression "colou?r" to the string "The colonel likes the color green".

The first token in the regex is the literal "c". The first position where it matches successfully is the "c" in "colonel". The engine continues, and finds that "o" matches "o", "l" matches "l" and another "o" matches "o". Then the engine checks whether "u" matches "n". This fails. However, the question mark tells the regex engine that failing to match "u" is acceptable. Therefore, the engine will skip ahead to the next regex token: "r". But this fails to match "n" as well. Now, the engine can only conclude that the entire regular expression cannot be matched starting at the "c" in "colonel". Therefore, the engine starts again trying to match "c" to the first o in "colonel".

After a series of failures, "c" will match with the "c" in "color", and "o", "l" and "o" match the following characters. Now the engine checks whether "u" matches "r". This fails. Again: no problem. The question mark allows the engine to continue with "r". This matches "r" and the engine reports that the regex successfully matched "color" in our string.


Regex Tutorial - Repetition with Star and Plus

Repetition with Star and Plus

I already introduced one repetition operator or quantifier: the question mark . It tells the engine to attempt match the preceding token zero times or once, in effect making it optional.

The asterisk or star tells the engine to attempt to match the preceding token zero or more times. The plus tells the engine to attempt to match the preceding token once or more. "<[A-Za-z][A-Za-z0-9]*>" matches an HTML tag without any attributes. The sharp brackets are literals . The first character class matches a letter. The second character class matches a letter or digit. The star repeats the second character class. Because we used the star, it's OK if the second character class matches nothing. So our regex will match a tag like "<B>". When matching "<HTML>", the first character class will match "H". The star will cause the second character class to be repeated three times, matching "T", "M" and "L" with each step.

I could also have used "<[A-Za-z0-9]+>". I did not, because this regex would match "<1>", which is not a valid HTML tag. But this regex may be sufficient if you know the string you are searching through does not contain any such invalid tags.

Limiting Repetition

Modern regex flavors, like those discussed in this tutorial, have an additional repetition operator that allows you to specify how many times a token can be repeated. The syntax is {min,max}, where min is a positive integer number indicating the minimum number of matches, and max is an integer equal to or greater than min indicating the maximum number of matches. If the comma is present but max is omitted, the maximum number of matches is infinite. So "{0,}" is the same as "*", and "{1,}" is the same as "+". Omitting both the comma and max tells the engine to repeat the token exactly min times.

You could use "\b[1-9][0-9]{3}\b" to match a number between 1000 and 9999. "\b[1-9][0-9]{2,4}\b" matches a number between 100 and 99999. Notice the use of the word boundaries .

Watch Out for The Greediness!

Suppose you want to use a regex to match an HTML tag. You know that the input will be a valid HTML file, so the regular expression does not need to exclude any invalid use of sharp brackets. If it sits between sharp brackets, it is an HTML tag.

Most people new to regular expressions will attempt to use "<.+>". They will be surprised when they test it on a string like "This is a <EM>first</EM> test". You might expect the regex to match "<EM>" and when continuing after that match, "</EM>".

But it does not. The regex will match "<EM>first</EM>". Obviously not what we wanted. The reason is that the plus is greedy. That is, the plus causes the regex engine to repeat the preceding token as often as possible. Only if that causes the entire regex to fail, will the regex engine backtrack. That is, it will go back to the plus, make it give up the last iteration, and proceed with the remainder of the regex. Let's take a look inside the regex engine to see in detail how this works and why this causes our regex to fail. After that, I will present you with two possible solutions.

Like the plus, the star and the repetition using curly braces are greedy.

Looking Inside The Regex Engine

The first token in the regex is "<". This is a literal . As we already know, the first place where it will match is the first "<" in the string. The next token is the dot, which matches any character except newlines. The dot is repeated by the plus. The plus is greedy. Therefore, the engine will repeat the dot as many times as it can. The dot matches "E", so the regex continues to try to match the dot with the next character. "M" is matched, and the dot is repeated once more. The next character is the ">". You should see the problem by now. The dot matches the ">", and the engine continues repeating the dot. The dot will match all remaining characters in the string. The dot fails when the engine has reached the void after the end of the string. Only at this point does the regex engine continue with the next token: ">".

So far, "<.+" has matched "<EM>first</EM> test" and the engine has arrived at the end of the string. ">" cannot match here. The engine remembers that the plus has repeated the dot more often than is required. (Remember that the plus requires the dot to match only once.) Rather than admitting failure, the engine will backtrack. It will reduce the repetition of the plus by one, and then continue trying the remainder of the regex.

So the match of ".+" is reduced to "EM>first</EM> tes". The next token in the regex is still ">". But now the next character in the string is the last "t". Again, these cannot match, causing the engine to backtrack further. The total match so far is reduced to "<EM>first</EM> te". But ">" still cannot match. So the engine continues backtracking until the match of ".+" is reduced to "EM>first</EM". Now, ">" can match the next character in the string. The last token in the regex has been matched. The engine reports that "<EM>first</EM>" has been successfully matched.

Remember that the regex engine is eager to return a match. It will not continue backtracking further to see if there is another possible match. It will report the first valid match it finds. Because of greediness, this is the leftmost longest match.

Laziness Instead of Greediness

The quick fix to this problem is to make the plus lazy instead of greedy. You can do that by putting a question mark behind the plus in the regex. You can do the same with the star, the curly braces and the question mark itself. So our example becomes "<.+?>". Let's have another look inside the regex engine.

Again, "<" matches the first "<" in the string. The next token is the dot, this time repeated by a lazy plus. This tells the regex engine to repeat the dot as few times as possible. The minimum is one. So the engine matches the dot with "E". The requirement has been met, and the engine continues with ">" and "M". This fails. Again, the engine will backtrack. But this time, the backtracking will force the lazy plus to expand rather than reduce its reach. So the match of ".+" is expanded to "EM", and the engine tries again to continue with ">". Now, ">" is matched successfully. The last token in the regex has been matched. The engine reports that "<EM>" has been successfully matched. That's more like it.

An Alternative to Laziness

In this case, there is a better option than making the plus lazy. We can use a greedy plus and a negated character class : "<[^>]+>". The reason why this is better is because of the backtracking. When using the lazy plus, the engine has to backtrack for each character in the HTML tag that it is trying to match. When using the negated character class, no backtracking occurs at all when the string contains valid HTML code. Backtracking slows down the regex engine. You will not notice the difference when doing a single search in a text editor. But you will save plenty of CPU cycles when using such a regex is used repeatedly in a tight loop in a script that you are writing, or perhaps in a custom syntax coloring scheme for EditPad Pro.

Finally, remember that this tutorial only talks about regex-directed engines . Text-directed engines do not backtrack. They do not get the speed penalty, but they also do not support lazy repetition operators.


Regex Tutorial - Round Brackets for Grouping and Backreferences

Use Round Brackets for Grouping

By placing part of a regular expression inside round brackets or parentheses, you can group that part of the regular expression together. This allows you to apply a regex operator, e.g. a repetition operator , to the entire group. I have already used round brackets for this purpose in previous topics throughout this tutorial.

Note that only round brackets can be used for grouping. Square brackets define a character class , and curly braces are used by a special repetition operator .

Round Brackets Create a Backreference

Besides grouping part of a regular expression together, round brackets also create a "backreference". A backreference stores the part of the string matched by the part of the regular expression inside the parentheses.

That is, unless you use non-capturing parentheses. Remembering part of the regex match in a backreference, slows down the regex engine because it has more work to do. If you do not use the backreference, you can speed things up by using non-capturing parentheses, at the expense of making your regular expression slightly harder to read.

The regex "Set(Value)?" matches "Set" or "SetValue". In the first case, the first backreference will be empty, because it did not match anything. In the second case, the first backreference will contain "Value".

If you do not use the backreference, you can optimize this regular expression into "Set(?:Value)?". The question mark and the colon after the opening round bracket are the special syntax that you can use to tell the regex engine that this pair of brackets should not create a backreference. Note the question mark after the opening bracket is unrelated to the question mark at the end of the regex. That question mark is the regex operator that makes the previous token optional . This operator cannot appear after an opening round bracket, because an opening bracket by itself is not a valid regex token. Therefore, there is no confusion between the question mark as an operator to make a token optional, and the question mark as a character to change the properties of a pair of round brackets. The colon indicates that the change we want to make is to turn off capturing the backreference.

How to Use Backreferences

Backreferences allow you to reuse part of the regex match. You can reuse it inside the regular expression (see below), or afterwards. What you can do with it afterwards, depends on the tool you are using. In EditPad Pro or PowerGREP, you can use the backreference in the replacement text during a search-and-replace operation by typing \1 (backslash one) into the replacement text. If you searched for "EditPad (Lite|Pro)" and use "\1 version" as the replacement, the actual replacement will be "Lite version" in case "EditPad Lite" was matched, and "Pro version" in case "EditPad Pro" was matched.

EditPad Pro and PowerGREP have a unique feature that allows you to change the case of the backreference. \U1 inserts the first backreference in uppercase, \L1 in lowercase and \F1 with the first character in uppercase and the remainder in lowercase. Finally, \I1 inserts it with the first letter of each word capitalized, and the other letters in lowercase.

Regex libraries in programming languages also provide access to the backreference. In Perl, you can use the magic variables $1, $2, etc. to access the part of the string matched by the backreference. In .NET (dot net), you can use the Match object that is returned by the Match method of the Regex class. This object has a property called Groups, which is a collection of Group objects. To get the string matched by the third backreference in C#, you can use MyMatch.Groups[3].Value.

The .NET (dot net) Regex class also has a method Replace that can do a regex-based search-and-replace on a string. In the replacement text, you can use $1, $2, etc. to insert backreferences.

To figure out the number of a particular backreference, scan the regular expression from left to right and count the opening round brackets. The first bracket starts backreference number one, the second number two, etc. Non-capturing parentheses are not counted. This fact means that non-capturing parentheses have another benefit: you can insert them into a regular expression without changing the numbers assigned to the backreferences. This can be very useful when modifying a complex regular expression.

The Entire Regex Match As Backreference Zero

Certain tools make the entire regex match available as backreference zero. In EditPad Pro or PowerGREP, you can use the entire regex match in the replacement text during a search and replace operation by typing \0 (backslash zero) into the replacement text. In Perl, the magic variable $& holds the entire regex match. Libraries like .NET (dot net) where backreferences are made available as an array or numbered list, the item with index zero holds the entire regex match. Using backreference zero is more efficient than putting an extra pair of round brackets around the entire regex, because that would force the engine to continuously keep an extra copy of the entire regex match.

Using Backreferences in The Regular Expression

Backreferences can not only be used after a match has been found, but also during the match. Suppose you want to match a pair of opening and closing HTML tags, and the text in between. By putting the opening tag into a backreference, we can reuse the name of the tag for the closing tag. Here's how: "<([A-Z][A-Z0-9]*)[^>]*>.*?</\1>" . This regex contains only one pair of parentheses, which capture the string matched by "[A-Z][A-Z0-9]*" into the first backreference. This backreference is reused with "\1" (backslash one). The "/" before it is simply the forward slash in the closing HTML tag that we are trying to match.

You can reuse the same backreference more than once. "([a-c])x\1x\1" will match "axaxa", "bxbxb" and "cxcxc". If a backreference was not used in a particular match attempt (such as in the first example where the question mark made the first backreference optional), it is simply empty. Using an empty backreference in the regex is perfectly fine. It will simply be replaced with nothingness.

A backreference cannot be used inside itself. "([abc]\1)" will not work. Depending on your regex flavor, it will either give an error message, or it will fail to match anything without an error message. Therefore, \0 cannot be used inside a regex, only in the replacement.

Looking Inside The Regex Engine

Let's see how the regex engine applies the above regex to the string "Testing <B><I>bold italic</I></B> text". The first token in the regex is the literal "<". The regex engine will traverse the string until it can match at the first "<" in the string. The next token is "[A-Z]". The regex engine also takes note that it is now inside the first pair of capturing parentheses. "[A-Z]" matches "B". The engine advances to "[A-Z0-9]" and ">". This match fails. However, because of the star , that's perfectly fine. The position in the string remains at ">". The position in the regex is advanced to "[^>]".

This step crosses the closing bracket of the first pair of capturing parentheses. This prompts the regex engine to store what was matched inside them into the first backreference. In this case, "B" is stored.

After storing the backreference, the engine proceeds with the match attempt. "[^>]" does not match ">". Again, because of another star, this is not a problem. The position in the string remains at ">", and position in the regex is advanced to ">". These obviously match. The next token is a dot, repeated by a lazy star. Because of the laziness, the regex engine will initially skip this token, taking note that it should backtrack in case the remainder of the regex fails.

The engine has now arrived at the second "<" in the regex, and the second "<" in the string. These match. The next token is "/". This does not match "I", and the engine is forced to backtrack to the dot. The dot matches the second "<" in the string. The star is still lazy, so the engine again takes note of the available backtracking position and advances to "<" and "I". These do not match, so the engine again backtracks.

The backtracking continues until the dot has consumed "<I>bold italic". At this point, "<" matches the third "<" in the string, and the next token is "/" which matches "/". The next token is "\1". Note that the token the backreference, and not "B". The engine does not substitute the backreference in the regular expression. Every time the engine arrives at the backreference, it will read the value that was stored. This means that if the engine had backtracked beyond the first pair of capturing parentheses before arriving the second time at "\1", the new value stored in the first backreference would be used. But this did not happen here, so "B" it is. This fails to match at "I", so the engine backtracks again, and the dot consumes the third "<" in the string.

Backtracking continues again until the dot has consumed "<I>bold italic</I>". At this point, "<" matches "<" and "/" matches "/". The engine arrives again at "\1". The backreference still holds "B". "B" matches "B". The last token in the regex, ">" matches ">". A complete match has been found: "<B><I>bold italic</I></B>".

Repetition and Backreferences

As I mentioned in the above inside look, the regex engine does not permanently substitute backreferences in the regular expression. It will use the last match saved into the backreference each time it needs to be used. If a new match is found by capturing parentheses, the previously saved match is overwritten. There is a clear difference between "([abc]+)" and "([abc])+". Though both successfully match "cab", the first regex will put "cab" into the first backreference, while the second regex will only store "b". That is because in the second regex, the plus caused the pair of parentheses to repeat three times. The first time, "c" was stored. The second time "a" and the third time "b". Each time, the previous value was overwritten, so "b" remains.

This also means that "([abc]+)=\1" will match "cab=cab", and that "([abc])+=\1" will not. The reason is that when the engine arrives at "\1", it holds "b" which fails to match "c". Obvious when you look at a simple example like this one, but a common cause of difficulty with regular expressions nonetheless. When using backreferences, always double check that you are really capturing what you want.

Useful Example: Checking for Doubled Words

When editing text, doubled words such as "the the" easily creep in. Using the regex "\b(\w+)\s+\1\b" in your text editor, you can easily find them. To delete the second word, simply type in "\1" as the replacement text and click the Replace button.

Parentheses and Backreferences Cannot Be Used Inside Character Classes

Round brackets cannot be used inside character classes , at least not as metacharacters. When you put a round bracket in a character class, it is treated as a literal character. So the regex "[(a)b]" matches "a", "b", "(" and ")".

Backreferences also cannot be used inside a character class. The \1 in regex like "(a)[\1b]" will be interpreted as an octal escape in most regex flavors. So this regex will match an "a" followed by either "\x01" or a "b".


Regex Tutorial - Named Capturing Groups - Backreference Names

Named Capturing Groups

All modern regular expression engines support capturing groups , which are numbered from left to right, starting with one. The numbers can then be used in backreferences to match the same text again in the regular expression, or to use part of the regex match for further processing. In a complex regular expression with many capturing groups, the numbering can get a little confusing.

Named Capture with Python, PCRE and PHP

Python's regex module was the first to offer a solution: named capture. By assigning a name to a capturing group, you can easily reference it by name. "(?P<name>group)" captures the match of "group" into the backreference "name". You can reference the contents of the group with the numbered backreference "\1" or the named backreference "(?P=name)".

The open source PCRE library has followed Python's example, and offers named capture using the same syntax. The PHP preg functions offer the same functionality, since they are based on PCRE.

Python's sub() function allows you to reference a named group as "\1" or "\g<name>". This does not work in PHP. In PHP, you can use double-quoted string interpolation with the $regs parameter you passed to pcre_match(): "$regs['name']".

Named Capture with .NET's System.Text.RegularExpressions

The regular expression classes of the .NET framework also support named capture. Unfortunately, the Microsoft developers decided to invent their own syntax, rather than follow the one pioneered by Python. Currently, no other regex flavor supports Microsoft's version of named capture.

Here is an example with two capturing groups in .NET style: "(?<first>group)(?'second'group)". As you can see, .NET offers two syntaxes to create a capturing group: one using sharp brackets, and the other using single quotes. The first syntax is preferable in strings, where single quotes may need to be escaped. The second syntax is preferable in ASP code, where the sharp brackets are used for HTML tags. You can use the pointy bracket flavor and the quoted flavors interchangeably.

To reference a capturing group inside the regex, use "\k<name>" or "\k'name'". Again, you can use the two syntactic variations interchangeably.

When doing a search-and-replace, you can reference the named group with the familiar dollar sign syntax: "${name}". Simply use a name instead of a number between the curly braces.

Names and Numbers for Capturing Groups

Here is where things get a bit ugly. Python and PCRE treat named capturing groups just like unnamed capturing groups, and number both kinds from left to right, starting with one. The regex "(a)(?P<x>b)(c)(?P<y>d)" matches "abcd" as expected. If you do a search-and-replace with this regex and the replacement "\1\2\3\4", you will get "abcd". All four groups were numbered from left to right, from one till four. Easy and logical.

Things are quite a bit more complicated with the .NET framework. The regex "(a)(?<x>b)(c)(?<y>d)" again matches "abcd". However, if you do a search-and-replace with "$1$2$3$4" as the replacement, you will get "acbd". Probably not what you expected.

The .NET framework does number named capturing groups from left to right, but numbers them after all the unnamed groups have been numbered. So the unnamed groups "(a)" and "(c)" get numbered first, from left to right, starting at one. Then the named groups "(?<x>b)" and "(?<y>d)" get their numbers, continuing from the unnamed groups, in this case: three.

To make things simple, when using .NET's regex support, just assume that named groups do not get numbered at all, and reference them by name exclusively. To keep things compatible across regex flavors, I strongly recommend that you do not mix named and unnamed capturing groups at all. Either give a group a name, or make it non-capturing as in "(?:nocapture)". Non-capturing groups are more efficient, since the regex engine does not need to keep track of their matches.

Other Regex Flavors

EditPad Pro and PowerGREP support both the Python syntax and the .NET syntax for named capture. However, they will number named groups along with unnamed capturing groups, just like Python does.

RegexBuddy also supports both Python's and Microsoft's style. RegexBuddy will convert one flavor of named capture into the other when generating source code snippets for Python, PHP/preg, PHP, or one of the .NET languages.

None of the other regex flavors discussed in this help file support named capture.


Regex Tutorial - Unicode Characters and Properties

Unicode Regular Expressions

Unicode is a character set that aims to define all characters and glyphs from all human languages, living and dead. With more and more software being required to support multiple languages, or even just any language, Unicode has been strongly gaining popularity in recent years. Using different character sets for different languages is simply too cumbersome for programmers and users.

Unfortunately, Unicode brings its own requirements and pitfalls when it comes to regular expressions. Of the regex flavors discussed in this tutorial, Java and the .NET framework use Unicode-based regex engines. Perl supports Unicode starting with version 5.6.

RegexBuddy's regex engine is fully Unicode-based starting with version 2.0.0. RegexBuddy 1.x.x did not support Unicode at all. PowerGREP uses the same Unicode regex engine starting with version 3.0.0. Earlier versions would convert Unicode files to ANSI prior to grepping with an 8-bit (i.e. non-Unicode) regex engine.

Characters, Code Points and Graphemes or How Unicode Makes a Mess of Things

Most people would consider "&#x00E0;" a single character. Unfortunately, it need not be depending on the meaning of the word "character".

All regex engines discussed in this tutorial treat any single Unicode code point as a single character. When this tutorial tells you that the dot matches any single character , this translates into Unicode parlance as "the dot matches any single Unicode code point". In Unicode, "&#x00E0;" can be encoded as two code points: U+0061 (a) followed by U+0300 (grave accent). In this situation, "." applied to "&#x00E0;" will match "a" without the accent. "^.$" will fail to match, since the string consists of two code points. "^..$" matches "&#x00E0;".

The Unicode code point U+0300 (grave accent) is a combining mark. Any code point that is not a combining mark can be followed by any number of combining marks. This sequence, like U+0061 U+0300 above, is displayed as a single grapheme on the screen.

Unfortunately, "&#x00E0;" can also be encoded with the single Unicode code point U+00E0 (a with grave accent). The reason for this duality is that many historical character sets encode "a with grave accent" as a single character. Unicode's designers thought it would be useful to have a one-on-one mapping with popular legacy character sets, in addition to the Unicode way of separating marks and base letters (which makes arbitrary combinations not supported by legacy character sets possible).

How to Match a Single Unicode Grapheme

Matching a single grapheme, whether it's encoded as a single code point, or as multiple code points using combining marks, is easy in Perl, RegexBuddy and PowerGREP: simply use "\X". You can consider "\X" the Unicode version of the dot in regex engines that use plain ASCII. There is one difference, though: "\X" always matches line break characters, whereas the dot does not match line break characters unless you enable the dot matches newline matching mode .

Java and .NET unfortunately do not support "\X" (yet). Use "\P{M}\p{M}*" as a substitute. To match any number of graphemes, use "(?:\P{M}\p{M}*)+" instead of "\X+".

Unicode Character Properties

In addition to complications, Unicode also brings new possibilities. One is that each Unicode character belongs to a certain category. You can match a single character belonging to a particular category with "\p{}". You can match a single character not belonging to a particular category with "\P{}".

Again, "character" really means "Unicode code point". "\p{L}" matches a single code point in the category "letter". If your input string is "&#x00E0;" encoded as U+0061 U+0300, it matches "a" without the accent. If the input is "&#x00E0;" encoded as U+00E0</TT>, it matches "&#x00E0;" with the accent. The reason is that both the code points U+0061 (a) and U+00E0 (&#x00E0;) are in the category "letter", while U+0300 is in the category "mark".

You should now understand why "\P{M}\p{M}*" is the equivalent of "\X". "\P{M}" matches a code point that is not a combining mark, while "\p{M}*" matches zero or more code points that are combining marks. To match a letter including any diacritics, use "\p{L}\p{M}*". This last regex will always match "&#x00E0;", regardless of how it is encoded.

In addition to the standard notation, "\p{L}", Java, Perl, RegexBuddy and PowerGREP allow you to use the shorthand "\pL". In addition to that, Perl, RegexBuddy and PowerGREP also support the longhand "\p{Letter}".

  • "\p{L}" or "\p{Letter}": any kind of letter from any language.
  • "\p{Ll}" or "\p{Lowercase_Letter}": a lowercase letter that has an uppercase variant.
  • "\p{Lu}" or "\p{Uppercase_Letter}": an uppercase letter that has a lowercase variant.
  • "\p{Lt}" or "\p{Titlecase_Letter}": a letter that appears at the start of a word when only the first letter of the word is capitalized.
  • "\p{L&}" or "\p{Letter&}": a letter that exists in lowercase and uppercase variants (combination of Ll, Lu and Lt).
  • "\p{Lm}" or "\p{Modifier_Letter}": a special character that is used like a letter.
  • "\p{Lo}" or "\p{Other_Letter}": a letter or ideograph that does not have lowercase and uppercase variants.

"\p{M}" or "\p{Mark}": a character intended to be combined with another character (e.g. accents, umlauts, enclosing boxes, etc.).

  • "\p{Mn}" or "\p{Non_Spacing_Mark}": a character intended to be combined with another character that does not take up extra space (e.g. accents, umlauts, etc.).
  • "\p{Mc}" or "\p{Spacing_Combining_Mark}": a character intended to be combined with another character that takes up extra space (vowel signs in many Eastern languages).
  • "\p{Me}" or "\p{Enclosing_Mark}": a character that encloses the character is is combined with (circle, square, keycap, etc.).

"\p{Z}" or "\p{Separator}": any kind of whitespace or invisible separator.

  • "\p{Zs}" or "\p{Space_Separator}": a whitespace character that is invisible, but does take up space.
  • "\p{Zl}" or "\p{Line_Separator}": line separator character U+2028.
  • "\p{Zp}" or "\p{Paragraph_Separator}": paragraph separator character U+2029.

"\p{S}" or "\p{Symbol}": math symbols, currency signs, dingbats, box-drawing characters, etc..

  • "\p{Sm}" or "\p{Math_Symbol}": any mathematical symbol.
  • "\p{Sc}" or "\p{Currency_Symbol}": any currency sign.
  • "\p{Sk}" or "\p{Modifier_Symbol}": a combining character (mark) as a full character on its own.
  • "\p{So}" or "\p{Other_Symbol}": various symbols that are not math symbols, currency signs, or combining characters.

"\p{N}" or "\p{Number}": any kind of numeric character in any script.

  • "\p{Nd}" or "\p{Decimal_Digit_Number}": a digit zero through nine in any script except ideographic scripts.
  • "\p{Nl}" or "\p{Letter_Number}": a number that looks like a letter, such as a Roman numeral.
  • "\p{No}" or "\p{Other_Number}": a superscript or subscript digit, or a number that is not a digit 0..9 (excluding numbers from ideographic scripts).

"\p{P}" or "\p{Punctuation}": any kind of punctuation character.

  • "\p{Pd}" or "\p{Dash_Punctuation}": any kind of hyphen or dash.
  • "\p{Ps}" or "\p{Open_Punctuation}": any kind of opening bracket.
  • "\p{Pe}" or "\p{Close_Punctuation}": any kind of closing bracket.
  • "\p{Pi}" or "\p{Initial_Punctuation}": any kind of opening quote.
  • "\p{Pf}" or "\p{Final_Punctuation}": any kind of closing quote.
  • "\p{Pc}" or "\p{Connector_Punctuation}": a punctuation character such as an underscore that connects words.
  • "\p{Po}" or "\p{Other_Punctuation}": any kind of punctuation character that is not a dash, bracket, quote or connector.

"\p{C}" or "\p{Other}": invisible control characters and unused code points.

  • "\p{Cc}" or "\p{Control}": an ASCII 0x00..0x1F or Latin-1 0x80..0x9F control character.
  • "\p{Cf}" or "\p{Format}": invisible formatting indicator.
  • "\p{Co}" or "\p{Private_Use}": any code point reserved for private use.
  • "\p{Cs}" or "\p{Surrogate}": one half of a surrogate pair in UTF-16 encoding.
  • "\p{Cn}" or "\p{Unassigned}": any code point to which no character has been assigned.

Do You Need To Worry About Different Encodings?

While you should always keep in mind the pitfalls created by the different ways in which accented characters can be encoded, you don't always have to worry about them. If you know that your input string and your regex use the same style, then you don't have to worry about it at all. This process is called Unicode normalization. All programming languages with native Unicode support, such as Java, C# and VB.NET, have library routines for normalizing strings. If you normalize both the subject and regex before attempting the match, there won't be any inconsistencies.

If you are using Java, you can pass the CANON_EQ flag as the second parameter to Pattern.compile(). This tells the Java regex engine to consider canonically equivalent characters as identical. E.g. the regex "&#x00E0;" encoded as U+00E0 will match "&#x00E0;" encoded as U+0061 U+0300, and vice versa. None of the other regex engines currently support canonical equivalence while matching.

If you type the &#x00E0; key on the keyboard, all word processors that I know of will insert the code point U+00E0 into the file. So if you're working with text that you typed in yourself, any regex that you type in yourself will match in the same way.

Finally, if you're using PowerGREP to search through text files encoded using a traditional Windows (often called "ANSI") or ISO-8859 code page, PowerGREP will always use the one-on-one substitution. Since all the Windows or ISO-8859 code pages encode accented characters as a single code point, all software that I know of will use a single Unicode code point for each character when converting the file to Unicode.

Matching a Specific Code Point

To match a specific Unicode code point, use "\uFFFF" where FFFF is the hexadecimal number of the code point you want to match. E.g. "\u00E0" matches "&#x00E0;", but only when encoded as a single code point U+00E0.

In Java, the regex token "\uFFFF" only matches the specified code point, even when you turned on canonical equivalence. However, the same syntax \uFFFF is also used to insert Unicode characters into literal strings in the Java source code. Pattern.compile("\u00E0") will match both the single-code-point and double-code-point encodings of "&#x00E0;", while Pattern.compile("\\u00E0") matches only the single-code-point version. Remember that when writing a regex as a Java string literal, backslashes must be escaped. The former Java code compiles the regex "&#x00E0;", while the latter compiles "\u00E0". Depending on what you're doing, the difference may be significant.


Regex Tutorial - Turning Modes On and Off for Only Part of The Regular Expression

Regex Matching Modes

Most regular expression engines discussed in this tutorial support the following three matching modes:

  • /i makes the regex match case insensitive.
  • /s enables "single-line mode". In this mode, the dot matches newlines .
  • /m enables "multi-line mode". In this mode, the caret and dollar match before and after newlines in the subject string.

Two languages that don't support the above three are JavaScript and Ruby. Many regex flavors also have additional modes or options that have single letter equivalents. These differ widely.

Most tools that support regular expressions have checkboxes or similar controls that you can use to turn these modes on or off. Most programming languages allow you to pass option flags when constructing the regex object. E.g. in Perl, m/regex/i turns on case insensitivity, while Pattern.compile("regex", Pattern.CASE_INSENSITIVE) does the same in Java.

Specifying Modes Inside The Regular Expression

Sometimes, the tool or language does not provide the ability to specify matching options. E.g. the handy String.matches() method in Java does not take a parameter for matching options like Pattern.compile() does.

In that situation, you can add a mode modifier to the start of the regex. E.g. (?i) turns on case insensitivity, while (?ism) turns on all three options.

Turning Modes On and Off for Only Part of The Regular Expression

Modern regex flavors allow you to apply modifiers to only part of the regular expression. If you insert the modifier (?ism) in the middle of the regex, the modifier only applies to the part of the regex to the right of the modifier. You can turn off modes by preceding them with a minus sign. All modes after the minus sign will be turned off. E.g. (?i-sm) turns on case insensitivity, and turns off both single-line mode and multi-line mode.

Not all regex flavors support this. The latest versions of all tools and languages discussed in this help file do. Older regex flavors usually apply the option to the entire regular expression, no matter where you placed it.

You can quickly test this. The regex "(?i)te(?-i)st" should match "test" and "TEst", but not "teST" or "TEST".

Modifier Spans

Instead of using two modifiers, one to turn an option on, and one to turn it off, you use a modifier span. "(?i)ignorecase(?-i)casesensitive(?i)ignorecase" is equivalent to "(?i)ignorecase(?-i:casesensitive)ignorecase". You have probably noticed the resemblance between the modifier span and the non-capturing group "(?:group)". Technically, the non-capturing group is a modifier span that does not change any modifiers. It is obvious that the modifier span does not create a backreference .


Regex Tutorial - Atomic Grouping and Possessive Quantifiers

Atomic Grouping and Possessive Quantifiers

When discussing the repetition operators or quantifiers , I explained the difference between greedy and lazy repetition. Greediness and laziness determine the order in which the regex engine tries the possible permutations of the regex pattern. A greedy quantifier will first try to repeat the token as many times as possible, and gradually give up matches as the engine backtracks to find an overall match. A lazy quantifier will first repeat the token as few times as required, and gradually expand the match as the engine backtracks through the regex to find an overall match.

Because greediness and laziness change the order in which permutations are tried, they can change the overall regex match. However, they do not change the fact that the regex engine will backtrack to try all possible permutations of the regular expression in case no match can be found. First, let's see why backtracking can lead to problems.

Catastrophic Backtracking

Recently I got a complaint from a customer that EditPad Pro hung (i.e. it stopped responding) when trying to find lines in a comma-delimited text file where the 12th item on a line started with a "P". The customer was using the regexp "^(.*?,){11}P" .

At first sight, this regex looks like it should do the job just fine. The lazy dot and comma match a single comma-delimited field, and the {11} skips the first 11 fields. Finally, the P checks if the 12th field indeed starts with P. In fact, this is exactly what will happen when the 12th field indeed starts with a P.

The problem rears its ugly head when the 12th field does not start with a P. Let's say the string is "1,2,3,4,5,6,7,8,9,10,11,12,13". At that point, the regex engine will backtrack. It will backtrack to the point where "^(.*?,){11}" had consumed "1,2,3,4,5,6,7,8,9,10,11", giving up the last match of the comma. The next token is again the dot. The dot matches a comma. The dot matches the comma! However, the comma does not match the "1" in the 12th field, so the dot continues until the 11th iteration of ".*?," has consumed "11,12,". You can already see the root of the problem: the part of the regex (the dot) matching the contents of the field also matches the delimiter (the comma). Because of the double repetition (star inside {11}), this leads to a catastrophic amount of backtracking.

The regex engine now checks whether the 13th field starts with a P. It does not. Since there is no comma after the 13th field, the regex engine can no longer match the 11th iteration of ".*?,". But it does not give up there. It backtracks to the 10th iteration, expanding the match of the 10th iteration to "10,11,". Since there is still no P, the 10th iteration is expanded to "10,11,12,". Reaching the end of the string again, the same story starts with the 9th iteration, subsequently expanding it to "9,10,", "9,10,11,", "9,10,11,12,". But between each expansion, there are more possiblities to be tried. When the 9th iteration consumes "9,10,", the 10th could match just "11," as well as "11,12,". Continuously failing, the engine backtracks to the 8th iteration, again trying all possible combinations for the 9th, 10th, and 11th iterations.

You get the idea: the possible number of combinations that the regex engine will try for each line where the 12th field does not start with a P is huge. This causes software like EditPad Pro to stop responding longer than your patience lasts. Other applications may even crash as the regex engine runs out of memory trying to remember all backtracking positions.

If you try this example with RegexBuddy's debugger, you will see that it needs 48,096 steps to conclude there regex cannot match. If the string is "1,2,3,4,5,6,7,8,9,10,11,12,13,14", just 3 characters more, the number of steps jumps to 96,857. It's not too hard to imagine that at this kind of exponential rate, attempting this regex on a large file with long lines could easily take forever. RegexBuddy's debugger will abort the attempt after 100,000 steps, to prevent it from running out of memory.

Preventing Catastrophic Backtracking

The solution is simple. When nesting repetition operators, make absolutely sure that there is only one way to match the same match. If repeating the inner loop 4 times and the outer loop 7 times results in the same overall match as repeating the inner loop 6 times and the outer loop 2 times, you can be sure that the regex engine will try all those combinations.

In our example, the solution is to be more exact about what we want to match. We want to match 11 comma-delimited fields. The fields must not contain comma's. So the regex becomes: "^([^,\r\n]*,){11}P" . If the P cannot be found, the engine will still backtrack. But it will backtrack only 11 times, and each time the "[^,\r\n]" is not able to expand beyond the comma, forcing the regex engine to the previous one of the 11 iterations immediately, without trying further options.

Atomic Grouping and Possessive Quantifiers

Recent regex flavors have introduced two additional solutions to this problem: atomic grouping and possessive quantifiers. Their purpose is to prevent backtracking, allowing the regex engine to fail faster.

In the above example, we could easily reduce the amount of backtracking to a very low level by better specifying what we wanted. But that is not always possible in such a straightforward manner. In that case, you should use atomic grouping to prevent the regex engine from backtracking.

Using atomic grouping, the above regex becomes "^(?>(.*?,){11})P". Everything between (?>) is treated as one single token by the regex engine, once the regex engine leaves the group. Because the entire group is one token, no backtracking can take place once the regex engine has found a match for the group. If backtracking is required, the engine has to backtrack to the regex token before the group (the caret in our example). If there is no token before the group, the regex must retry the entire regex at the next position in the string.

Possessive quantifiers are a limited form of atomic grouping with a cleaner notation. To make a quantifier possessive, place a plus after it. "x++" is the same as "(?>x+)". Similarly, you can use "x*+", "x?+" and "x{m,n}+". Note that you cannot make a lazy quantifier possessive. It would match the minimum number of matches and never expand the match because backtracking is not allowed.

Tool and Language Support for Atomic Grouping and Possessive Quantifiers

Atomic grouping is a recent addition to the regex scene, and only supported by the latest versions of most regex flavors. Perl supports it starting with version 5.6. The Java supports it starting with JDK version 1.4.2, though the JDK documentation uses the term "independent group" rather than "atomic group". All versions of .NET support atomic grouping, as do recent versions of PCRE, PHP's pgreg functions and Ruby. Python does not support atomic grouping.

At this time, possessive quantifiers are only supported by the Java JDK 1.4.0 and later, and PCRE version 4 and later.

The latest versions of EditPad Pro and PowerGREP support both atomic grouping and possessive quantifiers, as do all versions of RegexBuddy.

Atomic Grouping Inside The Regex Engine

Let's see how "^(?>(.*?,){11})P" is applied to "1,2,3,4,5,6,7,8,9,10,11,12,13". The caret matches at the start of the string and the engine enters the atomic group. The star is lazy, so the dot is initially skipped. But the comma does not match "1", so the engine backtracks to the dot. That's right: backtracking is allowed here. The star is not possessive, and is not immediately enclosed by an atomic group. That is, the regex engine did not cross the closing round bracket of the atomic group. The dot matches "1", and the comma matches too. "{11}" causes further repetition until the atomic group has matched "1,2,3,4,5,6,7,8,9,10,11,".

Now, the engine leaves the atomic group. Because the group is atomic, all backtracking information is discarded and the group is now considered a single token. The engine now tries to match "P" to the "1" in the 12th field. This fails.

So far, everything happened just like in the original, troublesome regular expression. Now comes the difference. "P" failed to match, so the engine backtracks. The previous token is an atomic group, so the group's entire match is discarded and the engine backtracks further to the caret. The engine now tries to match the caret at the next position in the string, which fails. The engine walks through the string until the end, and declares failure. Failure is declared after 30 attempts to match the caret, and just one attempt to match the atomic group, rather than after 30 attempts to match the caret and a huge number of attempts to try all combinations of both quantifiers in the regex.

That is what atomic grouping and possessive quantifiers are for: efficiency by disallowing backtracking. The most efficient regex for our problem at hand would be "^(?>((?>[^,\r\n]*),){11})P" , since possessive, greedy repetition of the star is faster than a backtracking lazy dot. If possessive quantifiers are available, you can reduce clutter by writing "^(?>([^,\r\n]*+,){11})P" .

When To Use Atomic Grouping or Possessive Quantifiers

Atomic grouping and possessive quantifiers speed up failure by eliminating backtracking. They do not speed up success, only failure. When nesting quantifiers like in the above example, you really should use atomic grouping and/or possessive quantifiers whenever possible. While "x[^x]*+x" and "x(?>[^x]*)x" fail faster than "x[^x]*x", the increase in speed is minimal. If the final x in the regex cannot be matched, the regex engine backtracks once for each character matched by the star. With simple repetition, the amount of time wasted with pointless backtracking increases in a linear fashion to the length of the string. With combined repetition, the amount of time wasted increases exponentially and will very quickly exhaust the capabilities of your computer. Still, if you are smart about combined repetition, you often can avoid the problem without atomic grouping as in the example above.

If you are simply doing a search in a text editor, using simple repetition, you will not earn back the extra time to type in the characters for the atomic grouping. If the regex will be used in a tight loop in an application, or process huge amounts of data, then atomic grouping may make a difference.

Note that atomic grouping and possessive quantifiers can alter the outcome of the regular expression match. "\d+6" will match "123456" in "123456789". "\d++6" will not match at all. "\d+" will match the entire string. With the former regex, the engine backtracks until the 6 can be matched. In the latter case, no backtracking is allowed, and the match fails. Again, the cause of this is that the token "\d" that is repeated can also match the delimiter "6". Sometimes this is desirable, often it is not.

This shows again that understanding how the regex engine works on the inside will enable you to avoid many pitfalls and craft efficient regular expressions that match exactly what you want.


Regex Tutorial - Lookahead and Lookbehind Zero-Width Assertions

Lookahead and Lookbehind Zero-Width Assertions

Perl 5 introduced two very powerful constructs: "lookahead" and "lookbehind". Collectively, these are called "lookaround". They are also called "zero-width assertions". They are zero-width just like the start and end of line , and start and end of word anchors that I already explained. The difference is that lookarounds will actually match characters, but then give up the match and only return the result: match or no match. That is why they are called "assertions". They do not consume characters in the string, but only assert whether a match is possible or not.

Lookarounds allow you to create regular expressions that are impossible to create without them, or that would get very longwinded without them. All regex flavors discussed in this help file support lookaround. The exception is JavaScript, which supports lookahead but not lookbehind.

Positive and Negative Lookahead

Negative lookahead is indispensable if you want to match something not followed by something else. When explaining character classes , I already explained why you cannot use a negated character class to match a "q" not followed by a "u". Negative lookahead provides the solution: "q(?!u)". The negative lookahead construct is the pair of round brackets, with the opening bracket followed by a question mark and an exclamation point. Inside the lookahead, we have the trivial regex "u".

Positive lookahead works just the same. "q(?=u)" matches a q that is followed by a u, without making the u part of the match. The positive lookahead construct is a pair of round brackets, with the opening bracket followed by a question mark and an equals sign.

You can use any regular expression inside the lookahead. (Note that this is not the case with lookbehind. I will explain why below.) Any valid regular expression can be used inside the lookahead. If it contains capturing parentheses, the backreferences will be saved. Note that the lookahead itself does not create a backreference. So it is not included in the count towards numbering the backreferences. If you want to store the match of the regex inside a backreference, you have to put capturing parentheses around the regex inside the lookahead, like this: "(?=(regex))". The other way around will not work, because the lookahead will already have discarded the regex match by the time the backreference is to be saved.

Regex Engine Internals

First, let's see how the engine applies "q(?!u)" to the string "Iraq". The first token in the regex is the literal "q". As we already know, this will cause the engine to traverse the string until the "q" in the string is matched. The position in the string is now the void behind the string. The next token is the lookahead. The engine takes note that it is inside a lookahead construct now, and begins matching the regex inside the lookahead. So the next token is "u". This does not match the void behind the string. The engine notes that the regex inside the lookahead failed. Because the lookahead is negative, this means that the lookahead has successfully matched at the current position. At this point, the entire regex has matched, and "q" is returned as the match.

Let's try applying the same regex to "quit". "q" matches "q". The next token is the "u" inside the lookahead. The next character is the "u". These match. The engine advances to the next character: "i". However, it is done with the regex inside the lookahead. The engine notes success, and discards the regex match. This causes the engine to step back in the string to "u".

Because the lookahead is negative, the successful match inside it causes the lookahead to fail. Since there are no other permutations of this regex, the engine has to start again at the beginning. Since "q" cannot match anywhere else, the engine reports failure.

Let's take one more look inside, to make sure you understand the implications of the lookahead. Let's apply "q(?=u)i" to "quit". I have made the lookahead positive, and put a token after it. Again, "q" matches "q" and "u" matches "u". Again, the match from the lookahead must be discarded, so the engine steps back from "i" in the string to "u". To lookahead was successful, so the engine continues with "i". But "i" cannot match "u". So this match attempt fails. All remaining attempts will fail as well, because there are no more q's in the string.

Positive and Negative Lookbehind

Lookbehind has the same effect, but works backwards. It tells the regex engine to temporarily step backwards in the string, to check if the text inside the lookbehind can be matched there. "(?<!a)b" matches a "b" that is not preceded by an "a", using negative lookbehind. It will not match "cab", but will match the "b" (and only the "b") in "bed" or "debt". "(?<=a)b" (positive lookbehind) matches the "b" (and only the "b") in "cab", but does not match "bed" or "debt".

The construct for positive lookbehind is "(?<=text)": a pair of round brackets, with the opening bracket followed by a question mark, "less than" symbol and an equals sign. Negative lookbehind is written as "(?<!text)", using an exclamation point instead of an equals sign.

More Regex Engine Internals

Let's apply "(?<=a)b" to "thingamabob". The engine starts with the lookbehind and the first character in the string. In this case, the lookbehind tells the engine to step back one character, and see if an "a" can be matched there. The engine cannot step back one character because there are no characters before the "t". So the lookbehind fails, and the engine starts again at the next character, the "h". (Note that a negative lookbehind would have succeeded here.) Again, the engine temporarily steps back one character to check if an "a" can be found there. It finds a "t", so the positive lookbehind fails again.

The lookbehind continues to fail until the regex reaches the "m" in the string. The engine again steps back one character, and notices that the "a" can be matched there. The positive lookbehind matches. Because it is zero-width, the current position in the string remains at the "m". The next token is "b", which cannot match here. The next character is the second "a" in the string. The engine steps back, and finds out that the "m" does not match "a".

The next character is the first "b" in the string. The engine steps back and finds out that "a" satisfies the lookbehind. "b" matches "b", and the entire regex has been matched successfully. It matches one character: the first "b" in the string.

Important Notes About Lookbehind

The good news is that you can use lookbehind anywhere in the regex, not only at the start. If you want to find a word not ending with an "s", you could use "\b\w+(?<!s)\b". This is definitely not the same as "\b\w+[^s]\b". When applied to "John's", the former will match "John" and the latter "John'" (including the apostrophe). I will leave it up to you to figure out why. (Hint: "\b" matches between the apostrophe and the "s"). The latter will also not match single-letter words like "a" or "I". The correct regex without using lookbehind is "\b\w*[^s\W]\b" (star instead of plus, and \W in the character class). Personally, I find the lookbehind easier to understand. The last regex, which works correctly, has a double negation (the \W in the negated character class). Double negations tend to be confusing to humans. Not to regex engines, though.

The bad news is that most regex flavors do not allow you to use just any regex inside a lookbehind, because they cannot apply a regular expression backwards. Therefore, the regular expression engine needs to be able to figure out how many steps to step back before checking the lookbehind.

Therefore, many regex flavors, including those used by Perl 5 and Python, only allow fixed-length strings. You can use any regex of which the length of the match can be predetermined. This means you can use literal text and character classes . You cannot use repetition or optional items . You can use alternation , but only if all options in the alternation have the same length.

Some regex flavors support the above, plus alternation with strings of different lengths. But each string in the alternation must still be of fixed length, so only literals and character classes can be used. This includes PCRE and PHP.

More advanced flavors support the above, plus finite repetition. This means you can still not use the star or plus , but you can use the question mark and the curly braces with the max parameter specified. These regex flavors recognize the fact that finite repetition can be rewritten as an alternation of strings with different, but fixed lengths. The only regex flavor that I know of that currently supports this is Sun's regex package in the JDK 1.4.

The only regex flavors that allow you to use a full regular expression inside lookbehind are those used by EditPad Pro (6.0.0 and later), RegexBuddy (2.0.3 and later), PowerGREP (3.0.0 and later), and the .NET framework (all versions).

Finally, JavaScript and Ruby do not support lookbehind at all.

Lookaround Is Atomic

The fact that lookaround is zero-width automatically makes it atomic . As soon as the lookaround condition is satisfied, the regex engine forgets about everything inside the lookaround. It will not backtrack inside the lookaround to try different permutations.

The only situation in which this makes any difference is when you use capturing groups inside the lookaround. Since the regex engine does not backtrack into the lookaround, it will not try different permutations of the capturing groups.

For this reason, the regex "(?=(\d+))\w+\1" will never match "123x12". First the lookaround captures "123" into "\1". "\w+" then matches the whole string and backtracks until it matches only "1". Finally, "\w+" fails since "\1" cannot be matched at any position. Now, the regex engine has nothing to backtrack to, and the overall regex fails. The backtracking steps created by "\d+" have been discarded. It never gets to the point where the lookahead captures only "12".

Obviously, the regex engine does try further positions in the string. If we change the subject string, the regex "(?=(\d+))\w+\1" will match "56x56" in "456x56".

If you don't use capturing groups inside lookaround, then all this doesn't matter. Either the lookaround condition can be satisfied or it cannot be. In how many ways it can be satisfied is irrelevant.


Regex to Test The Same Part of The String for More Than One Requirement

Testing The Same Part of The String for More Than One Requirement

Lookaround, which I introduced in detail in the previous topic , is a very powerful concept. Unfortunately, it is often underused by people new to regular expressions, because lookaround is a bit confusing. The confusing part is that the lookaround is zero-width. So if you have a regex in which a lookahead is followed by another piece of regex, or a lookbehind is preceded by another piece of regex, then the regex will traverse part of the string twice.

To make this clear, I would like to give you another, a bit more practical example. Let's say we want to find a word that is six letters long and contains the three subsequent letters "cat". Actually, we can match this without lookaround. We just specify all the options and hump them together using alternation : "cat\w{3}|\wcat\w{2}|\w{2}cat\w|\w{3}cat". Easy enough. But this method gets unwieldy if you want to find any word between 6 and 12 letters long containing either "cat", "dog" or "mouse".

Lookaround to The Rescue

In this example, we basically have two requirements for a successful match. First, we want a word that is 6 letters long. Second, the word we found must contain the word "cat".

Matching a 6-letter word is easy with "\b\w{6}\b". Matching a word containing "cat" is equally easy: "\b\w*cat\w*\b".

Combining the two, we get: "(?=\b\w{6}\b)\b\w*cat\w*\b" . Easy! Here's how this works. At each character position in the string where the regex is attempted, the engine will first attempt the regex inside the positive lookahead. This sub-regex, and therefore the lookahead, matches only when the current character position in the string is at the start of a 6-letter word in the string. If not, the lookahead will fail, and the engine will continue trying the regex from the start at the next character position in the string.

The lookahead is zero-width. So when the regex inside the lookahead has found the 6-letter word, the current position in the string is still at the beginning of the 6-letter word. At this position will the regex engine attempt the remainder of the regex. Because we already know that a 6-letter word can be matched at the current position, we know that "\b" matches and that the first "\w*" will match 6 times. The engine will then backtrack, reducing the number of characters matched by "\w*", until "cat" can be matched. If "cat" cannot be matched, the engine has no other choice but to restart at the beginning of the regex, at the next character position in the string. This is at the second letter in the 6-letter word we just found, where the lookahead will fail, causing the engine to advance character by character until the next 6-letter word.

If "cat" can be successfully matched, the second "\w*" will consume the remaining letters, if any, in the 6-letter word. After that, the last "\b" in the regex is guaranteed to match where the second "\b" inside the lookahead matched. Our double-requirement-regex has matched successfully.

Optimizing Our Solution

While the above regex works just fine, it is not the most optimal solution. This is not a problem if you are just doing a search in a text editor. But optimizing things is a good idea if this regex will be used repeatedly and/or on large chunks of data in an application you are developing.

You can discover these optimizations by yourself if you carefully examine the regex and follow how the regex engine applies it, as I did above. I said the third and last "\b" are guaranteed to match. Since it is zero-width, and therefore does not change the result returned by the regex engine, we can remove them, leaving: "(?=\b\w{6}\b)\w*cat\w*". Though the last "\w*" is also guaranteed to match, we cannot remove it because it adds characters to the regex match. Remember that the lookahead discards its match, so it does not contribute to the match returned by the regex engine. If we omitted the "\w*", the resulting match would be the start of a 6-letter word containing "cat", up to and including "cat", instead of the entire word.

But we can optimize the first "\w*". As it stands, it will match 6 letters and then backtrack. But we know that in a successful match, there can never be more than 3 letters before "cat". So we can optimize this to "\w{0,3}". Note that making the asterisk lazy would not have optimized this sufficiently. The lazy asterisk would find a successful match sooner, but if a 6-letter word does not contain "cat", it would still cause the regex engine to try matching "cat" at the last two letters, at the last single letter, and even at one character beyond the 6-letter word.

So we have "(?=\b\w{6}\b)\w{0,3}cat\w*". One last, minor, optimization involves the first "\b". Since it is zero-width itself, there's no need to put it inside the lookahead. So the final regex is: "\b(?=\w{6}\b)\w{0,3}cat\w*" .

A More Complex Problem

So, what would you use to find any word between 6 and 12 letters long containing either "cat", "dog" or "mouse"? Again we have two requirements, which we can easily combine using a lookahead: " \b(?=\w{6,12}\b)\w{0,9}(cat|dog|mouse)\w*" . Very easy, once you get the hang of it. This regex will also put "cat", "dog" or "mouse" into the first backreference.


Regex Tutorial - Continuing at The End of The Previous Match

Continuing at The End of The Previous Match

The anchor "\G" matches at the position where the previous match ended. During the first match attempt, "\G" matches at the start of the string in the way "\A" does.

Applying "\G\w" to the string "test string" matches "t". Applying it again matches "e". The 3rd attempt yields "s" and the 4th attempt matches the second "t" in the string. The fifth attempt fails. During the fifth attempt, the only place in the string where "\G" matches is after the second t. But that position is not followed by a word character, so the match fails.

End of The Previous Match vs Start of The Match Attempt

With some regex flavors or tools, "\G" matches at the start of the match attempt, rather than at the end of the previous match result. This is the case with EditPad Pro, where "\G" matches at the position of the text cursor, rather than the end of the previous match. When a match is found, EditPad Pro will select the match, and move the text cursor to the end of the match. The result is that "\G" matches at the end of the previous match result only when you do not move the text cursor between two searches. All in all, this makes a lot of sense in the context of a text editor.

\G Magic with Perl

In Perl, the position where the last match ended is a "magical" value that is remembered separately for each string variable. The position is not associated with any regular expression. This means that you can use "\G" to make a regex continue in a subject string where another regex left off.

If a match attempt fails, the stored position for "\G" is reset to the start of the string. To avoid this, specify the continuation modifier /c.

All this is very useful to make several regular expressions work together. E.g. you could parse an HTML file in the following fashion:

while ($string =~ m/</g) {

  if ($string =~ m/\GB>/c) {

    # Bold

  } elsif ($string =~ m/\GI>/c) {

    # Italics

  } else {

    # ...etc...

  }

}

The regex in the while loop searches for the tag's opening bracket, and the regexes inside the loop check which tag we found. This way you can parse the tags in the file in the order they appear in the file, without having to write a single big regex that matches all tags you are interested in.

\G in Other Programming Langauges

This flexibility is not available with most other programming languages. E.g. in Java, the position for "\G" is remembered by the Matcher object. The Matcher is strictly associated with a single regular expression and a single subject string. What you can do though is to add a line of code to make the match attempt of the second Matcher start where the match of the first Matcher ended. "\G" will then match at this position.


Regex Tutorial - If-Then-Else Conditionals

If-Then-Else Conditionals in Regular Expressions

A special construct "(?ifthen|else)" allows you to create conditional regular expressions. If the if part evaluates to true, then the regex engine will attempt to match the then part. Otherwise, the else part is attempted instead. The syntax consists of a pair of round brackets. The opening bracket must be followed by a question mark, immediately followed by the if part, immediately followed by the then part. This part can be followed by a vertical bar and the else part. You may omit the else part, and the vertical bar with it.

For the if part, you can use the lookahead and lookbehind constructs. Using positive lookahead, the syntax becomes "(?(?=regex)then|else)". Because the lookahead has its own parentheses, the if and then parts are clearly separated.

Remember that the lookaround constructs do not consume any characters. If you use a lookahead as the if part, then the regex engine will attempt to match the then or else part (depending on the outcome of the lookahead) at the same position where the if was attempted.

Alternatively, you can check in the if part whether a capturing group has taken part in the match thus far. Place the number of the capturing group inside round brackets, and use that as the if part. Note that although the syntax for a conditional check on a backreference is the same as a number inside a capturing groups, no capturing groups is created. The number and the brackets are part of the if-then-else syntax started with "(?".

The regex "(a)?b(?(1)c|d)" matches "bd" and "abc". If the a can be matched, the first capturing group takes part in the match. The conditional then uses the then part "c". Otherwise, the else part "d" is used.

For the then and else, you can use any regular expression. If you want to use alternation , you will have to group the then or else together using parentheses , like in "(?(?=condition)(then1|then2|then3)|(else1|else2|else3))". Otherwise, there is no need to use parentheses around the then and else parts.

Regex Flavors

Conditionals are supported by PCRE, the PHP preg functions and the .NET framework. The latest versions of EditPad Pro, PowerGREP and RegexBuddy also support them.

The .NET framework allows you to use the name of a named capturing group for the if test, e.g.: "(?<test>a)?b(?(test)c|d)". None of the other flavors, though they all support named capture, allow the name of a group as a conditional test. You have to use the number.

Example: Extract Email Headers

The regex "^((From|To)|Subject): ((?(2)\w+@\w+\.[a-z]+|.+))" extracts the From, To, and Subject headers from an email message. The name of the header is captured into the first backreference. If the header is the From or To header, it is captured into the second backreference as well.

The second part of the pattern is the if-then-else conditional "(?(2)\w+@\w+\.[a-z]+|.+))". The if part checks if the second capturing group took part in the match thus far. It will have if the header is the From or To header. In that case, we the then part of the conditional "\w+@\w+\.[a-z]+" tries to match an email address. To keep the example simple, we use an overly simple regex to match the email address, and we don't try to match the display name that is usually also part of the From or To header.

If the second capturing group did not participate in the match this far, the else part ".+" is attempted instead.

Finally, we place an extra pair of round brackets around the conditional. This captures the contents of the email header matched by the conditional into the third backreference. The conditional itself does not capture anything.


Regex Tutorial - Commenting Regular Expressions

Adding Comments to Regular Expressions

If you have worked through the entire tutorial, I guess you will agree that regular expressions can quickly become rather cryptic. Therefore, many modern regex flavors allow you to insert comments into regexes. The syntax is "(?#comment)" where "comment" can be whatever you want, as long as it does not contain a closing round bracket. The regex engine ignores everything after the "(?#" until the first closing round bracket.

E.g. I could clarify the regex to match a valid date by writing it as "(?#year)(19|20)\d\d[- /.](?#month)(0[1-9]|1[012])[- /.](?#day)(0[1-9]|[12][0-9]|3[01])" . Now it is instantly obvious that this regex matches a date in yyyy-mm-dd format. Some software, such as RegexBuddy, EditPad Pro and PowerGREP can apply syntax coloring to regular expressions while you write them. That makes the comments really stand out, enabling the right comment in the right spot to make a complex regular expression much easier to understand.


Regular Expression Examples

Sample Regular Expressions

Below, you will find many example patterns that you can use for and adapt to your own purposes. Key techniques used in crafting each regex are explained, with links to the corresponding pages in the tutorial where these concepts and techniques are explained in great detail.

If you are new to regular expressions, you can take a look at these examples to see what is possible. Regular expressions are very powerful. They do take some time to learn. But you will earn back that time quickly when using regular expressions to automate searching or editing tasks in EditPad Pro or PowerGREP, or when writing scripts or applications in a variety of languages.

RegexBuddy offers the fastest way to get up to speed with regular expressions. RegexBuddy will analyze any regular expression and present it to you in a clearly to understand, detailed outline. The outline links to RegexBuddy's regex tutorial (the same one you find on this web site), where you can always get in-depth information with a single click.

Oh, and you definitely do not need to be a programmer to take advantage of regular expressions!

Grabbing HTML Tags

"<TAG[^>]*>(.*?)</TAG>" matches the opening and closing pair of a specific HTML tag. Anything between the tags is captured into the first backreference . The question mark in the regex makes the star lazy , to make sure it stops before the first closing tag rather than before the last, like a greedy star would do. This regex will not properly match tags nested inside themselves, like in "<TAG>one<TAG>two</TAG>one</TAG>".

"<([A-Z][A-Z0-9]*)[^>]*>(.*?)</\1>" will match the opening and closing pair of any HTML tag. Be sure to turn off case sensitivity. The key in this solution is the use of the backreference "\1" in the regex. Anything between the tags is captured into the second backreference. This solution will also not match tags nested in themselves.

Trimming Whitespace

You can easily trim unnecessary whitespace from the start and the end of a string or the lines in a text file by doing a regex search-and-replace. Search for "^[ \t]+" and replace with nothing to delete leading whitespace (spaces and tabs). Search for "[ \t]+$" to trim trailing whitespace. Do both by combining the regular expressions into "^[ \t]+|[ \t]+$" . Instead of [ \t] which matches a space or a tab, you can expand the character class into "[ \t\r\n]" if you also want to strip line breaks. Or you can use the shorthand "\s" instead.

IP Addresses

Matching an IP address is another good example of a trade-off between regex complexity and exactness. "\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b" will match any IP address just fine, but will also match "999.999.999.999" as if it were a valid IP address. Whether this is a problem depends on the files or data you intend to apply the regex to. To restrict all 4 numbers in the IP address to 0..255, you can use this complex beast: "\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.""(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.""(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.""(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b" (everything on a single line). The long regex stores each of the 4 numbers of the IP address into a capturing group . You can use these groups to further process the IP number.

If you don't need access to the individual numbers, you can shorten the regex with a quantifier to: "\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}""(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b" . Similarly, you can shorten the quick regex to "\b(?:\d{1,3}\.){3}\d{1,3}\b"

More Detailed Examples

Matching a Floating Point Number. Also illustrates the common mistake of making everything in a regular expression optional.

Matching Valid Dates. A regular expression that matches 31-12-1999 but not 31-13-1999.

Matching Complete Lines. Shows how to match complete lines in a text file rather than just the part of the line that satisfies a certain requirement.

Removing Duplicate Lines or Items. Illustrates simple yet clever use of capturing parentheses or backreferences.

Regex Examples for Processing Source Code. How to match common programming language syntax such as comments, strings, numbers, etc.

Two Words Near Each Other. Shows how to use a regular expression to emulate the "near" operator that some tools have.


Example: Matching Floating Point Numbers with a Regular Expression

Matching Floating Point Numbers with a Regular Expression

In this example, I will show you how you can avoid a common mistake often made by people inexperienced with regular expressions. As an example, we will try to build a regular expression that can match any floating point number. Our regex should also match integers, and floating point numbers where the integer part is not given (i.e. zero). We will not try to match numbers with an exponent, such as 1.5e8 (150 million in scientific notation).

At first thought, the following regex seems to do the trick: "[-+]?[0-9]*\.?[0-9]*". This defines a floating point number as an optional sign, followed by an optional series of digits (integer part), followed by an optional dot, followed by another optional series of digits (fraction part).

Spelling out the regex in words makes it obvious: everything in this regular expression is optional. This regular expression will consider a sign by itself or a dot by itself as a valid floating point number. In fact, it will even consider an empty string as a valid floating point number. This regular expression can cause serious trouble if it is used in a scripting language like Perl or PHP to verify user input.

Not escaping the dot is also a common mistake. A dot that is not escaped will match any character, including a dot. If we had not escaped the dot, "4.4" would be considered a floating point number, and "4X4" too.

When creating a regular expression, it is more important to consider what it should not match, than what it should. The above regex will indeed match a proper floating point number, because the regex engine is greedy. But it will also match many things we do not want, which we have to exclude.

Here is a better attempt: "[-+]?([0-9]*\.[0-9]+|[0-9]+)". This regular expression will match an optional sign, that is either followed by zero or more digits followed by a dot and one or more digits (a floating point number with optional integer part), or followed by one or more digits (an integer).

This is a far better definition. Any match will include at least one digit, because there is no way around the "[0-9]+" part. We have successfully excluded the matches we do not want: those without digits.

We can optimize this regular expression as: "[-+]?[0-9]*\.?[0-9]+" .

If you also want to match numbers with exponents, you can use: "[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?" . Notice how I made the entire exponent part optional by grouping it together, rather than making each element in the exponent optional.


Example: Regular Expression Matching a Valid Date

Matching a Valid Date

"(19|20)\d\d[- /.](0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])" matches a date in yyyy-mm-dd format from between 1900-01-01 and 2099-12-31, with a choice of four separators. The year is matched by "(19|20)\d\d". I used alternation to allow the first two digits to be 19 or 20. The round brackets are mandatory. Had I omitted them, the regex engine would go looking for 19 or the remainder of the regular expression, which matches a date between 2000-01-01 and 2099-12-31. Round brackets are the only way to stop the vertical bar from splitting up the entire regular expression into two options.

The month is matched by "0[1-9]|1[012]", again enclosed by round brackets to keep the two options together. By using character classes , the first option matches a number between 01 and 09, and the second matches 10, 11 or 12.

The last part of the regex consists of three options. The first matches the numbers 01 through 09, the second 10 through 29, and the third matches 30 or 31.

Smart use of alternation allows us to exclude invalid dates such as 2000-00-00 that could not have been excluded without using alternation. To be really perfectionist, you would have to split up the month into various options to take into account the length of the month. The above regex still matches 2003-02-31, which is not a valid date. Making leading zeros optional could be another enhancement.

If you want to require the delimiters to be consistent, you could use a backreference . "(19|20)\d\d([- /.])(0[1-9]|1[012])\2(0[1-9]|[12][0-9]|3[01])" will match "1999-01-01" but not "1999/01-01".

Again, how complex you want to make your regular expression depends on the data you are using it on, and how big a problem it is if an unwanted match slips through. If you are validating the user's input of a date in a script, it is probably easier to do certain checks outside of the regex. For example, excluding February 29th when the year is not a leap year is far easier to do in a scripting language. It is far easier to check if a year is divisible by 4 (and not divisible by 100 unless divisible by 400) using simple arithmetic than using regular expressions.

Here is how you could check a valid date in Perl. Note that I added anchors to make sure the entire variable is a date, and not a piece of text containing a date. I also added round brackets to capture the year into a backreference.

sub isvaliddate {

  my $input = shift;

  if ($input =~ m!^((?:19|20)\d\d)[- /.](0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])$!) {

    # At this point, $1 holds the year, $2 the month and $3 the day of the date entered

    if ($3 == 31 and ($2 == 4 or $2 == 6 or $2 == 9 or $2 == 11)) {

      return 0; # 31st of a month with 30 days

    } elsif ($3 >= 30 and $2 == 2) {

      return 0; # February 30th or 31st

    } elsif ($2 == 2 and $3 == 29 and not ($1 % 4 == 0 and ($1 % 100 <> 0 or $1 % 400 == 0))) {

      return 0; # February 29th outside a leap year

    } else {

      return 1; # Valid date

    }

  } else {

    return 0; # Not a date

  }

}

To match a date in mm/dd/yyyy format, rearrange the regular expression to "(0[1-9]|1[012])[- /.](0[1-9]|[12][0-9]|3[01])[- /.](19|20)\d\d" . For dd-mm-yyyy format, use "(0[1-9]|[12][0-9]|3[01])[- /.](0[1-9]|1[012])[- /.](19|20)\d\d" .


Regex Examples: Matching Whole Lines of Text That Satisfy Certain Requirements

Matching Whole Lines of Text

Often, you want to match complete lines in a text file rather than just the part of the line that satisfies a certain requirement. This is useful if you want to delete entire lines in a search-and-replace in a text editor, or collect entire lines in an information retrieval tool.

To keep this example simple, let's say we want to match lines containing the word "John". The regex "John" makes it easy enough to locate those lines. But the software will only indicate "John" as the match, not the entire line containing the word.

The solution is fairly simple. To specify that we need an entire line, we will use the caret and dollar sign and turn on the option to make them match at embedded newlines. In software aimed at working with text files like EditPad Pro and PowerGREP, the anchors always match at embedded newlines. To match the parts of the line before and after the match of our original regular expression "John", we simply use the dot and the star . Be sure to turn off the option for the dot to match newlines.

The resulting regex is: "^.*John.*$". You can use the same method to expand the match of any regular expression to an entire line, or a block of complete lines. In some cases, such as when using alternation , you will need to group the original regex together using round brackets .

Finding Lines Containing or Not Containing Certain Words

If a line can meet any out of series of requirements, simply use alternation in the regular expression. "^.*\b(one|two|three)\b.*$" matches a complete line of text that contains any of the words "one", "two" or "three". The first backreference will contain the word the line actually contains. If it contains more than one of the words, then the last (rightmost) word will be captured into the first backreference. This is because the star is greedy . If we make the first star lazy, like in "^.*?\b(one|two|three)\b.*$", then the backreference will contain the first (leftmost) word.

If a line must satisfy all of multiple requirements, we need to use lookahead . "^(?=.*?\bone\b)(?=.*?\btwo\b)(?=.*?\bthree\b).*$" matches a complete line of text that contains all of the words "one", "two" and "three". Again, the anchors must match at the start and end of a line and the dot must not match line breaks. Because of the caret , and the fact that lookahead is zero-width, all of the three lookaheads are attempted at the start of the each line. Each lookahead will match any piece of text on a single line (".*?") followed by one of the words. All three must match successfully for the entire regex to match. Note that instead of words like "\bword\b", you can put any regular expression, no matter how complex, inside the lookahead. Finally, ".*$" causes the regex to actually match the line, after the lookaheads have determined it meets the requirements.

If your condition is that a line should not contain something, use negative lookahead. "^((?!regexp).)*$" matches a complete line that does not match "regexp". Notice that unlike before, when using positive lookahead, I repeated both the negative lookahead and the dot together. For the positive lookahead, we only need to find one location where it can match. But the negative lookahead must be tested at each and every character position in the line. We must test that "regexp" fails everywhere, not just somewhere.

Finally, you can combine multiple positive and negative requirements as follows: "^(?=.*?\bmust-have\b)(?=.*?\bmandatory\b)((?!avoid|illegal).)*$" . When checking multiple positive requirements, the ".*" at the end of the regular expression full of zero-width assertions made sure that we actually matched something. Since the negative requirement must match the entire line, it is easy to replace the ".*" with the negative test.


Regexp Example: Deleting Duplicate Lines or Items with Regular Expressions

Deleting Duplicate Lines From a File

If you have a file in which all lines are sorted (alphabetically or otherwise), you can easily delete (subsequent) duplicate lines. Simply open the file in your favorite text editor, and do a search-and-replace searching for "^(.*)(\r?\n\1)+$" and replacing with "\1". For this to work, the anchors need to match before and after line breaks (and not just at the start and the end of the file or string), and the dot must not match newlines.

Here is how this works. The caret will match only at the start of a line. So the regex engine will only attempt to match the remainder of the regex there. The dot and star combination simply matches an entire line, whatever its contents, if any. The round brackets store the matched line into the first backreference.

Next we will match the line separator. I put the question mark into "\r?\n" to make this regex work with both Windows (\r\n) and UNIX (\n) text files. So up to this point we matched a line and the following line break.

Now we need to check if this combination is followed by a duplicate of that same line. We do this simply with "\1". This is the first backreference which holds the line we matched. The backreference will match that very same text.

If the backreference fails to match, the regex match and the backreference are discarded, and the regex engine tries again at the start of the next line. If the backreference succeeds, the plus symbol in the regular expression will try to match additional copies of the line. Finally, the dollar symbol forces the regex engine to check if the text matched by the backreference is a complete line. We already know the text matched by the backreference is preceded by a line break (matched by "\r?\n"). Therefore, we now check if it is also followed by a line break or if it is at the end of the file using the dollar sign .

The entire match becomes "line\nline" (or "line\nline\nline" etc.). Because we are doing a search and replace, the line, its duplicates, and the line breaks in between them, are all deleted from the file. Since we want to keep the original line, but not the duplicates, we use "\1" as the replacement text to put the original line back in.

Removing Duplicate Items From a String

We can generalize the above example to afterseparator(item)(separator\1)+beforeseparator, where afterseparator and beforeseparator are zero-width. So if you want to remove subsequent duplicates from a comma-delimited list, you could use "(?<=,|^)([^,]*)(,\1)+(?=,|$)" .

The positive lookbehind "(?<=,|^)" forces the regex engine to start matching at the start of the string or after a comma. "([^,]*)" captures the item. "(,\1)+" matches subsequent duplicate items. Finally, the positive lookahead "(?=,|$)" checks if the duplicate items are complete items by checking for a comma or the end of the string.


Various Regex Examples for Programmers - Source Code Syntax

Example Regexes to Match Common Programming Language Constructs

Regular expressions are very useful to manipulate source code in a text editor or in a regex-based text processing tool. Most programming languages use similar constructs like keywords, comments and strings. But often there are subtle differences that make it tricky to use the correct regex. When picking a regex from the list of examples below, be sure to read the description with each regex to make sure you are picking the correct one.

Unless otherwise indicated, all examples below assume that the dot does not match newlines and that the caret and dollar do match at embedded line breaks. In many programming languages, this means that single line mode must be off, and multi line mode must be on.

When used by themselves, these regular expressions may not have the intended result. If a comment appears inside a string, the comment regex will consider the text inside the string as a comment. The string regex will also match strings inside comments. The solution is to use more than one regular expression, like in this pseudo-code:

GlobalStartPosition := 0;

while GlobalStartPosition < LengthOfText do

  GlobalMatchPosition := LengthOfText;

  MatchedRegEx := NULL;

  foreach RegEx in RegExList do

    RegEx.StartPosition := GlobalStartPosition;

    if RegEx.Match and RegEx.MatchPosition < GlobalMatchPosition then

      MatchedRegEx := RegEx;

      GlobalMatchPosition := RegEx.MatchPosition;

    endif

  endforeach

  if MatchedRegEx <> NULL then

    // At this point, MatchedRegEx indicates which regex matched

    // and you can do whatever processing you want depending on

    // which regex actually matched.

  endif

  GlobalStartPosition := GlobalMatchPosition;

endwhile

If you put a regex matching a comment and a regex matching a string in RegExList, then you can be sure that the comment regex will not match comments inside strings, and vice versa.

An alternative solution is to combine regexes: "(comment)|(string)". The alternation has the same effect as the code snipped above. Using backreferences, you can figure out which part of the regex actually matched. The drawback of this solution is that the combined regular expression quickly becomes difficult to read or maintain.

Comments

"#.*$" matches a single-line comment starting with a "#" and continuing until the end of the line . Similarly, "//.*$" matches a single-line comment starting with "//".

If the comment must appear at the start of the line , use "^#.*$" . If only whitespace is allowed between the start of the line and the comment, use "^\s*#.*$" . Compiler directives or pragmas in C can be matched this way. Note that in this last example, any leading whitespace will be part of the regex match. Use capturing parentheses to separate the whitespace and the comment.

"/\*.*?\*/" matches a C-style multi-line comment if you turn on the option for the dot to match newlines. The general syntax is "begin.*?end". C-style comments do not allow nesting. If the "begin" part appears inside the comment, it is ignored. As soon as the "end" part if found, the comment is closed.

If your programming language allows nested comments, there is no straightforward way to match them using a regular expression, since regular expressions cannot count. Additional logic is required.

Strings

""[^"\r\n]*"" matches a single-line string that does not allow the quote character to appear inside the string. Using the negated character class is more efficient than using a lazy dot. ""[^"]*"" allows the string to span across multiple lines.

""[^"\\\r\n]*(\\.[^"\\\r\n]*)*"" matches a single-line string in which the quote character can appear if it is escaped by a backslash. Though this regular expression may seem more complicated than it needs to be, it is much faster than simpler solutions which can cause a whole lot of backtracking in case a double quote appears somewhere all by itself rather than part of a string. ""[^"\\]*(\\.[^"\\]*)*"" allows the string to span multiple lines.

You can adapt the above regexes to match any sequence delimited by two (possibly different) characters. If we use "b" for the starting character, "e" and the end, and "x" as the escape character, the version without escape becomes "b[^e\r\n]*e", and the version with escape becomes "b[^ex\r\n]*(x.[^ex\r\n]*)*"".

Numbers

"\b\d+\b" matches a positive integer number. Do not forget the word boundaries ! "[-+]?\b\d+\b" allows for a sign.

"\b0[xX][0-9a-fA-F]+\b" matches a C-style hexadecimal number.

"((\b[0-9]+)?\.)?[0-9]+\b" matches an integer number as well as a floating point number with optional integer part. "(\b[0-9]+\.([0-9]+\b)?|\.[0-9]+\b)" matches a floating point number with optional integer as well as optional fractional part, but does not match an integer number.

"((\b[0-9]+)?\.)?\b[0-9]+([eE][-+]?[0-9]+)?\b" matches a number in scientific notation. The mantissa can be an integer or floating point number with optional integer part. The exponent is optional.

"\b[0-9]+(\.[0-9]+)?(e[+-]?[0-9]+)?\b" also matches a number in scientific notation. The difference with the previous example is that if the mantissa is a floating point number, the integer part is mandatory.

If you read through the floating point number example , you will notice that the above regexes are different from what is used there. The above regexes are more stringent. They use word boundaries to exclude numbers that are part of other things like identifiers. You can prepend "[-+]?" to all of the above regexes to include an optional sign in the regex. I did not do so above because in programming languages, the + and - are usually considered operators rather than signs.

Reserved Words or Keywords

Matching reserved words is easy. Simply use alternation to string them together: "\b(first|second|third|etc)\b" Again, do not forget the word boundaries .


Find Two Words Near Each Other

Some search tools that use boolean operators also have a special operator called "near". Searching for "term1 near term2" finds all occurrences of term1 and term2 that occur within a certain "distance" from each other. The distance is a number of words. The actual number depends on the search tool, and is often configurable.

You can easily perform the same task with the proper regular expression.

Emulating "near" with a Regular Expression

With regular expressions you can describe almost any text pattern, including a pattern that matches two words near each other. This pattern is relatively simple, consisting of three parts: the first word, a certain number of unspecified words, and the second word. An unspecified word can be matched with the shorthand character class "\w+". The spaces and other characters between the words can be matched with "\W+" (uppercase W this time).

The complete regular expression becomes "\bword1\W+(?:\w+\W+){1,6}word2\b" . The quantifier "{1,6}" makes the regex require at least one word between "word1" and "word2", and allow at most six words.

If the words may also occur in reverse order, we need to specify the opposite pattern as well: "\b(?:word1\W+(?:\w+\W+){1,6}word2|word2\W+(?:\w+\W+){1,6}word1)\b"